/*! Copyright Elasticsearch B.V. and/or license to Elasticsearch B.V. under one or more contributor license agreements
 * Licensed under the Elastic License; you may not use this file except in compliance with the Elastic License. */
webpackJsonp([6],{1494:function(module,exports,__webpack_require__){0,factory=function(exports){"use strict";function bisect(f,a,b,parameters){parameters=parameters||{};var maxIterations=parameters.maxIterations||100,tolerance=parameters.tolerance||1e-10,fA=f(a),fB=f(b),delta=b-a;if(fA*fB>0)throw"Initial bisect points must have opposite signs";if(0===fA)return a;if(0===fB)return b;for(var i=0;i<maxIterations;++i){delta/=2;var mid=a+delta,fMid=f(mid);fMid*fA>=0&&(a=mid);if(Math.abs(delta)<tolerance||0===fMid)return mid}return a+delta}function zeros(x){var r=new Array(x);for(var i=0;i<x;++i)r[i]=0;return r}function zerosM(x,y){return zeros(x).map(function(){return zeros(y)})}function dot(a,b){var ret=0;for(var i=0;i<a.length;++i)ret+=a[i]*b[i];return ret}function norm2(a){return Math.sqrt(dot(a,a))}function multiplyBy(a,c){for(var i=0;i<a.length;++i)a[i]*=c}function weightedSum(ret,w1,v1,w2,v2){for(var j=0;j<ret.length;++j)ret[j]=w1*v1[j]+w2*v2[j]}function fmin(f,x0,parameters){parameters=parameters||{};var temp,maxIterations=parameters.maxIterations||200*x0.length,nonZeroDelta=parameters.nonZeroDelta||1.1,zeroDelta=parameters.zeroDelta||.001,minErrorDelta=parameters.minErrorDelta||1e-6,rho=parameters.rho||1,chi=parameters.chi||2,psi=parameters.psi||-.5,sigma=parameters.sigma||.5,callback=parameters.callback;var N=x0.length,simplex=new Array(N+1);simplex[0]=x0;simplex[0].fx=f(x0);for(var i=0;i<N;++i){var point=x0.slice();point[i]=point[i]?point[i]*nonZeroDelta:zeroDelta;simplex[i+1]=point;simplex[i+1].fx=f(point)}var sortOrder=function(a,b){return a.fx-b.fx};var centroid=x0.slice(),reflected=x0.slice(),contracted=x0.slice(),expanded=x0.slice();for(var iteration=0;iteration<maxIterations;++iteration){simplex.sort(sortOrder);callback&&callback(simplex);if(Math.abs(simplex[0].fx-simplex[N].fx)<minErrorDelta)break;for(i=0;i<N;++i){centroid[i]=0;for(var j=0;j<N;++j)centroid[i]+=simplex[j][i];centroid[i]/=N}var worst=simplex[N];weightedSum(reflected,1+rho,centroid,-rho,worst);reflected.fx=f(reflected);if(reflected.fx<=simplex[0].fx){weightedSum(expanded,1+chi,centroid,-chi,worst);expanded.fx=f(expanded);if(expanded.fx<reflected.fx){temp=simplex[N];simplex[N]=expanded;expanded=temp}else{temp=simplex[N];simplex[N]=reflected;reflected=temp}}else if(reflected.fx>=simplex[N-1].fx){var shouldReduce=false;if(reflected.fx<=worst.fx){weightedSum(contracted,1+psi,centroid,-psi,worst);contracted.fx=f(contracted);if(contracted.fx<worst.fx){temp=simplex[N];simplex[N]=contracted;contracted=temp}else shouldReduce=true}else{weightedSum(contracted,1-psi*rho,centroid,psi*rho,worst);contracted.fx=f(contracted);if(contracted.fx<=reflected.fx){temp=simplex[N];simplex[N]=contracted;contracted=temp}else shouldReduce=true}if(shouldReduce)for(i=1;i<simplex.length;++i){weightedSum(simplex[i],1-sigma,simplex[0],sigma-1,simplex[i]);simplex[i].fx=f(simplex[i])}}else{temp=simplex[N];simplex[N]=reflected;reflected=temp}}simplex.sort(sortOrder);return{f:simplex[0].fx,solution:simplex[0]}}function minimizeConjugateGradient(f,initial,params){var pk,temp,maxIterations,current={x:initial.slice(),fx:0,fxprime:initial.slice()},next={x:initial.slice(),fx:0,fxprime:initial.slice()},yk=initial.slice(),a=1;params=params||{};maxIterations=params.maxIterations||5*initial.length;current.fx=f(current.x,current.fxprime);pk=current.fxprime.slice();multiplyBy(pk,-1);for(var i=0;i<maxIterations;++i){params.history&&params.history.push({x:current.x.slice(),fx:current.fx,fxprime:current.fxprime.slice()});a=wolfeLineSearch(f,pk,current,next,a);if(a){weightedSum(yk,1,next.fxprime,-1,current.fxprime);var delta_k=dot(current.fxprime,current.fxprime),beta_k=Math.max(0,dot(yk,next.fxprime)/delta_k);weightedSum(pk,beta_k,pk,-1,next.fxprime);temp=current;current=next;next=temp}else for(var j=0;j<pk.length;++j)pk[j]=-1*current.fxprime[j];if(norm2(current.fxprime)<=1e-5)break}params.history&&params.history.push({x:current.x.slice(),fx:current.fx,fxprime:current.fxprime.slice()});return current}var c1=1e-6;var c2=.1;function wolfeLineSearch(f,pk,current,next,a){var phi0=current.fx,phiPrime0=dot(current.fxprime,pk),phi=phi0,phi_old=phi0,phiPrime=phiPrime0,a0=0;a=a||1;function zoom(a_lo,a_high,phi_lo){for(var iteration=0;iteration<16;++iteration){a=(a_lo+a_high)/2;weightedSum(next.x,1,current.x,a,pk);phi=next.fx=f(next.x,next.fxprime);phiPrime=dot(next.fxprime,pk);if(phi>phi0+c1*a*phiPrime0||phi>=phi_lo)a_high=a;else{if(Math.abs(phiPrime)<=-c2*phiPrime0)return a;phiPrime*(a_high-a_lo)>=0&&(a_high=a_lo);a_lo=a;phi_lo=phi}}return 0}for(var iteration=0;iteration<10;++iteration){weightedSum(next.x,1,current.x,a,pk);phi=next.fx=f(next.x,next.fxprime);phiPrime=dot(next.fxprime,pk);if(phi>phi0+c1*a*phiPrime0||iteration&&phi>=phi_old)return zoom(a0,a,phi_old);if(Math.abs(phiPrime)<=-c2*phiPrime0)return a;if(phiPrime>=0)return zoom(a,a0,phi);phi_old=phi;a0=a;a*=2}return 0}var SMALL=1e-10;function intersectionArea(circles,stats){var intersectionPoints=getIntersectionPoints(circles);var innerPoints=intersectionPoints.filter(function(p){return containedInCircles(p,circles)});var i,arcArea=0,polygonArea=0,arcs=[];if(innerPoints.length>1){var center=getCenter(innerPoints);for(i=0;i<innerPoints.length;++i){var p=innerPoints[i];p.angle=Math.atan2(p.x-center.x,p.y-center.y)}innerPoints.sort(function(a,b){return b.angle-a.angle});var p2=innerPoints[innerPoints.length-1];for(i=0;i<innerPoints.length;++i){var p1=innerPoints[i];polygonArea+=(p2.x+p1.x)*(p1.y-p2.y);var midPoint={x:(p1.x+p2.x)/2,y:(p1.y+p2.y)/2},arc=null;for(var j=0;j<p1.parentIndex.length;++j)if(p2.parentIndex.indexOf(p1.parentIndex[j])>-1){var circle=circles[p1.parentIndex[j]],a1=Math.atan2(p1.x-circle.x,p1.y-circle.y),a2=Math.atan2(p2.x-circle.x,p2.y-circle.y);var angleDiff=a2-a1;angleDiff<0&&(angleDiff+=2*Math.PI);var a=a2-angleDiff/2,width=distance(midPoint,{x:circle.x+circle.radius*Math.sin(a),y:circle.y+circle.radius*Math.cos(a)});(null===arc||arc.width>width)&&(arc={circle:circle,width:width,p1:p1,p2:p2})}arcs.push(arc);arcArea+=circleArea(arc.circle.radius,arc.width);p2=p1}}else{var smallest=circles[0];for(i=1;i<circles.length;++i)circles[i].radius<smallest.radius&&(smallest=circles[i]);var disjoint=false;for(i=0;i<circles.length;++i)if(distance(circles[i],smallest)>Math.abs(smallest.radius-circles[i].radius)){disjoint=true;break}if(disjoint)arcArea=polygonArea=0;else{arcArea=smallest.radius*smallest.radius*Math.PI;arcs.push({circle:smallest,p1:{x:smallest.x,y:smallest.y+smallest.radius},p2:{x:smallest.x-SMALL,y:smallest.y+smallest.radius},width:2*smallest.radius})}}polygonArea/=2;if(stats){stats.area=arcArea+polygonArea;stats.arcArea=arcArea;stats.polygonArea=polygonArea;stats.arcs=arcs;stats.innerPoints=innerPoints;stats.intersectionPoints=intersectionPoints}return arcArea+polygonArea}function containedInCircles(point,circles){for(var i=0;i<circles.length;++i)if(distance(point,circles[i])>circles[i].radius+SMALL)return false;return true}function getIntersectionPoints(circles){var ret=[];for(var i=0;i<circles.length;++i)for(var j=i+1;j<circles.length;++j){var intersect=circleCircleIntersection(circles[i],circles[j]);for(var k=0;k<intersect.length;++k){var p=intersect[k];p.parentIndex=[i,j];ret.push(p)}}return ret}function circleIntegral(r,x){var y=Math.sqrt(r*r-x*x);return x*y+r*r*Math.atan2(x,y)}function circleArea(r,width){return circleIntegral(r,width-r)-circleIntegral(r,-r)}function distance(p1,p2){return Math.sqrt((p1.x-p2.x)*(p1.x-p2.x)+(p1.y-p2.y)*(p1.y-p2.y))}function circleOverlap(r1,r2,d){if(d>=r1+r2)return 0;if(d<=Math.abs(r1-r2))return Math.PI*Math.min(r1,r2)*Math.min(r1,r2);var w1=r1-(d*d-r2*r2+r1*r1)/(2*d),w2=r2-(d*d-r1*r1+r2*r2)/(2*d);return circleArea(r1,w1)+circleArea(r2,w2)}function circleCircleIntersection(p1,p2){var d=distance(p1,p2),r1=p1.radius,r2=p2.radius;if(d>=r1+r2||d<=Math.abs(r1-r2))return[];var a=(r1*r1-r2*r2+d*d)/(2*d),h=Math.sqrt(r1*r1-a*a),x0=p1.x+a*(p2.x-p1.x)/d,y0=p1.y+a*(p2.y-p1.y)/d,rx=-(p2.y-p1.y)*(h/d),ry=-(p2.x-p1.x)*(h/d);return[{x:x0+rx,y:y0-ry},{x:x0-rx,y:y0+ry}]}function getCenter(points){var center={x:0,y:0};for(var i=0;i<points.length;++i){center.x+=points[i].x;center.y+=points[i].y}center.x/=points.length;center.y/=points.length;return center}function venn(areas,parameters){parameters=parameters||{};parameters.maxIterations=parameters.maxIterations||500;var initialLayout=parameters.initialLayout||bestInitialLayout;areas=addMissingAreas(areas);var circles=initialLayout(areas);var setid,initial=[],setids=[];for(setid in circles)if(circles.hasOwnProperty(setid)){initial.push(circles[setid].x);initial.push(circles[setid].y);setids.push(setid)}var totalFunctionCalls=0;var solution=fmin(function(values){totalFunctionCalls+=1;var current={};for(var i=0;i<setids.length;++i){var setid=setids[i];current[setid]={x:values[2*i],y:values[2*i+1],radius:circles[setid].radius}}return lossFunction(current,areas)},initial,parameters);var positions=solution.solution;for(var i=0;i<setids.length;++i){setid=setids[i];circles[setid].x=positions[2*i];circles[setid].y=positions[2*i+1]}return circles}var SMALL$1=1e-10;function distanceFromIntersectArea(r1,r2,overlap){if(Math.min(r1,r2)*Math.min(r1,r2)*Math.PI<=overlap+SMALL$1)return Math.abs(r1-r2);return bisect(function(distance){return circleOverlap(r1,r2,distance)-overlap},0,r1+r2)}function addMissingAreas(areas){areas=areas.slice();var i,j,a,b,ids=[],pairs={};for(i=0;i<areas.length;++i){var area=areas[i];if(1==area.sets.length)ids.push(area.sets[0]);else if(2==area.sets.length){a=area.sets[0];b=area.sets[1];pairs[[a,b]]=true;pairs[[b,a]]=true}}ids.sort(function(a,b){return a>b});for(i=0;i<ids.length;++i){a=ids[i];for(j=i+1;j<ids.length;++j){b=ids[j];[a,b]in pairs||areas.push({sets:[a,b],size:0})}}return areas}function getDistanceMatrices(areas,sets,setids){var distances=zerosM(sets.length,sets.length),constraints=zerosM(sets.length,sets.length);areas.filter(function(x){return 2==x.sets.length}).map(function(current){var left=setids[current.sets[0]],right=setids[current.sets[1]],r1=Math.sqrt(sets[left].size/Math.PI),r2=Math.sqrt(sets[right].size/Math.PI),distance=distanceFromIntersectArea(r1,r2,current.size);distances[left][right]=distances[right][left]=distance;var c=0;current.size+1e-10>=Math.min(sets[left].size,sets[right].size)?c=1:current.size<=1e-10&&(c=-1);constraints[left][right]=constraints[right][left]=c});return{distances:distances,constraints:constraints}}function constrainedMDSGradient(x,fxprime,distances,constraints){var i,loss=0;for(i=0;i<fxprime.length;++i)fxprime[i]=0;for(i=0;i<distances.length;++i){var xi=x[2*i],yi=x[2*i+1];for(var j=i+1;j<distances.length;++j){var xj=x[2*j],yj=x[2*j+1],dij=distances[i][j],constraint=constraints[i][j];var squaredDistance=(xj-xi)*(xj-xi)+(yj-yi)*(yj-yi),distance=Math.sqrt(squaredDistance),delta=squaredDistance-dij*dij;if(constraint>0&&distance<=dij||constraint<0&&distance>=dij)continue;loss+=2*delta*delta;fxprime[2*i]+=4*delta*(xi-xj);fxprime[2*i+1]+=4*delta*(yi-yj);fxprime[2*j]+=4*delta*(xj-xi);fxprime[2*j+1]+=4*delta*(yj-yi)}}return loss}function bestInitialLayout(areas,params){var initial=greedyLayout(areas,params);if(areas.length>=8){var constrained=constrainedMDSLayout(areas,params),constrainedLoss=lossFunction(constrained,areas),greedyLoss=lossFunction(initial,areas);constrainedLoss+1e-8<greedyLoss&&(initial=constrained)}return initial}function constrainedMDSLayout(areas,params){params=params||{};var restarts=params.restarts||10;var i,sets=[],setids={};for(i=0;i<areas.length;++i){var area=areas[i];if(1==area.sets.length){setids[area.sets[0]]=sets.length;sets.push(area)}}var matrices=getDistanceMatrices(areas,sets,setids),distances=matrices.distances,constraints=matrices.constraints;var norm=norm2(distances.map(norm2))/distances.length;distances=distances.map(function(row){return row.map(function(value){return value/norm})});var obj=function(x,fxprime){return constrainedMDSGradient(x,fxprime,distances,constraints)};var best,current;for(i=0;i<restarts;++i){var initial=zeros(2*distances.length).map(Math.random);current=minimizeConjugateGradient(obj,initial,params);(!best||current.fx<best.fx)&&(best=current)}var positions=best.x;var circles={};for(i=0;i<sets.length;++i){var set=sets[i];circles[set.sets[0]]={x:positions[2*i]*norm,y:positions[2*i+1]*norm,radius:Math.sqrt(set.size/Math.PI)}}if(params.history)for(i=0;i<params.history.length;++i)multiplyBy(params.history[i].x,norm);return circles}function greedyLayout(areas){var set,circles={},setOverlaps={};for(var i=0;i<areas.length;++i){var area=areas[i];if(1==area.sets.length){set=area.sets[0];circles[set]={x:1e10,y:1e10,rowid:circles.length,size:area.size,radius:Math.sqrt(area.size/Math.PI)};setOverlaps[set]=[]}}areas=areas.filter(function(a){return 2==a.sets.length});for(i=0;i<areas.length;++i){var current=areas[i];var weight=current.hasOwnProperty("weight")?current.weight:1;var left=current.sets[0],right=current.sets[1];current.size+SMALL$1>=Math.min(circles[left].size,circles[right].size)&&(weight=0);setOverlaps[left].push({set:right,size:current.size,weight:weight});setOverlaps[right].push({set:left,size:current.size,weight:weight})}var mostOverlapped=[];for(set in setOverlaps)if(setOverlaps.hasOwnProperty(set)){var size=0;for(i=0;i<setOverlaps[set].length;++i)size+=setOverlaps[set][i].size*setOverlaps[set][i].weight;mostOverlapped.push({set:set,size:size})}function sortOrder(a,b){return b.size-a.size}mostOverlapped.sort(sortOrder);var positioned={};function isPositioned(element){return element.set in positioned}function positionSet(point,index){circles[index].x=point.x;circles[index].y=point.y;positioned[index]=true}positionSet({x:0,y:0},mostOverlapped[0].set);for(i=1;i<mostOverlapped.length;++i){var setIndex=mostOverlapped[i].set,overlap=setOverlaps[setIndex].filter(isPositioned);set=circles[setIndex];overlap.sort(sortOrder);if(0===overlap.length)throw"ERROR: missing pairwise overlap information";var points=[];for(var j=0;j<overlap.length;++j){var p1=circles[overlap[j].set],d1=distanceFromIntersectArea(set.radius,p1.radius,overlap[j].size);points.push({x:p1.x+d1,y:p1.y});points.push({x:p1.x-d1,y:p1.y});points.push({y:p1.y+d1,x:p1.x});points.push({y:p1.y-d1,x:p1.x});for(var k=j+1;k<overlap.length;++k){var p2=circles[overlap[k].set],d2=distanceFromIntersectArea(set.radius,p2.radius,overlap[k].size);var extraPoints=circleCircleIntersection({x:p1.x,y:p1.y,radius:d1},{x:p2.x,y:p2.y,radius:d2});for(var l=0;l<extraPoints.length;++l)points.push(extraPoints[l])}}var bestLoss=1e50,bestPoint=points[0];for(j=0;j<points.length;++j){circles[setIndex].x=points[j].x;circles[setIndex].y=points[j].y;var loss=lossFunction(circles,areas);if(loss<bestLoss){bestLoss=loss;bestPoint=points[j]}}positionSet(bestPoint,setIndex)}return circles}function lossFunction(sets,overlaps){var output=0;function getCircles(indices){return indices.map(function(i){return sets[i]})}for(var i=0;i<overlaps.length;++i){var overlap,area=overlaps[i];if(1==area.sets.length)continue;if(2==area.sets.length){var left=sets[area.sets[0]],right=sets[area.sets[1]];overlap=circleOverlap(left.radius,right.radius,distance(left,right))}else overlap=intersectionArea(getCircles(area.sets));var weight=area.hasOwnProperty("weight")?area.weight:1;output+=weight*(overlap-area.size)*(overlap-area.size)}return output}function orientateCircles(circles,orientation,orientationOrder){null===orientationOrder?circles.sort(function(a,b){return b.radius-a.radius}):circles.sort(orientationOrder);var i;if(circles.length>0){var largestX=circles[0].x,largestY=circles[0].y;for(i=0;i<circles.length;++i){circles[i].x-=largestX;circles[i].y-=largestY}}if(circles.length>1){var x,y,rotation=Math.atan2(circles[1].x,circles[1].y)-orientation,c=Math.cos(rotation),s=Math.sin(rotation);for(i=0;i<circles.length;++i){x=circles[i].x;y=circles[i].y;circles[i].x=c*x-s*y;circles[i].y=s*x+c*y}}if(circles.length>2){var angle=Math.atan2(circles[2].x,circles[2].y)-orientation;while(angle<0)angle+=2*Math.PI;while(angle>2*Math.PI)angle-=2*Math.PI;if(angle>Math.PI){var slope=circles[1].y/(1e-10+circles[1].x);for(i=0;i<circles.length;++i){var d=(circles[i].x+slope*circles[i].y)/(1+slope*slope);circles[i].x=2*d-circles[i].x;circles[i].y=2*d*slope-circles[i].y}}}}function disjointCluster(circles){circles.map(function(circle){circle.parent=circle});function find(circle){circle.parent!==circle&&(circle.parent=find(circle.parent));return circle.parent}function union(x,y){var xRoot=find(x),yRoot=find(y);xRoot.parent=yRoot}for(var i=0;i<circles.length;++i)for(var j=i+1;j<circles.length;++j){var maxDistance=circles[i].radius+circles[j].radius;distance(circles[i],circles[j])+1e-10<maxDistance&&union(circles[j],circles[i])}var setid,disjointClusters={};for(i=0;i<circles.length;++i){setid=find(circles[i]).parent.setid;setid in disjointClusters||(disjointClusters[setid]=[]);disjointClusters[setid].push(circles[i])}circles.map(function(circle){delete circle.parent});var ret=[];for(setid in disjointClusters)disjointClusters.hasOwnProperty(setid)&&ret.push(disjointClusters[setid]);return ret}function getBoundingBox(circles){var minMax=function(d){var hi=Math.max.apply(null,circles.map(function(c){return c[d]+c.radius})),lo=Math.min.apply(null,circles.map(function(c){return c[d]-c.radius}));return{max:hi,min:lo}};return{xRange:minMax("x"),yRange:minMax("y")}}function normalizeSolution(solution,orientation,orientationOrder){null===orientation&&(orientation=Math.PI/2);var i,setid,circles=[];for(setid in solution)if(solution.hasOwnProperty(setid)){var previous=solution[setid];circles.push({x:previous.x,y:previous.y,radius:previous.radius,setid:setid})}var clusters=disjointCluster(circles);for(i=0;i<clusters.length;++i){orientateCircles(clusters[i],orientation,orientationOrder);var bounds=getBoundingBox(clusters[i]);clusters[i].size=(bounds.xRange.max-bounds.xRange.min)*(bounds.yRange.max-bounds.yRange.min);clusters[i].bounds=bounds}clusters.sort(function(a,b){return b.size-a.size});circles=clusters[0];var returnBounds=circles.bounds;var spacing=(returnBounds.xRange.max-returnBounds.xRange.min)/50;function addCluster(cluster,right,bottom){if(!cluster)return;var xOffset,yOffset,centreing,bounds=cluster.bounds;if(right)xOffset=returnBounds.xRange.max-bounds.xRange.min+spacing;else{xOffset=returnBounds.xRange.max-bounds.xRange.max;centreing=(bounds.xRange.max-bounds.xRange.min)/2-(returnBounds.xRange.max-returnBounds.xRange.min)/2;centreing<0&&(xOffset+=centreing)}if(bottom)yOffset=returnBounds.yRange.max-bounds.yRange.min+spacing;else{yOffset=returnBounds.yRange.max-bounds.yRange.max;centreing=(bounds.yRange.max-bounds.yRange.min)/2-(returnBounds.yRange.max-returnBounds.yRange.min)/2;centreing<0&&(yOffset+=centreing)}for(var j=0;j<cluster.length;++j){cluster[j].x+=xOffset;cluster[j].y+=yOffset;circles.push(cluster[j])}}var index=1;while(index<clusters.length){addCluster(clusters[index],true,false);addCluster(clusters[index+1],false,true);addCluster(clusters[index+2],true,true);index+=3;returnBounds=getBoundingBox(circles)}var ret={};for(i=0;i<circles.length;++i)ret[circles[i].setid]=circles[i];return ret}function scaleSolution(solution,width,height,padding){var circles=[],setids=[];for(var setid in solution)if(solution.hasOwnProperty(setid)){setids.push(setid);circles.push(solution[setid])}width-=2*padding;height-=2*padding;var bounds=getBoundingBox(circles),xRange=bounds.xRange,yRange=bounds.yRange,xScaling=width/(xRange.max-xRange.min),yScaling=height/(yRange.max-yRange.min),scaling=Math.min(yScaling,xScaling),xOffset=(width-(xRange.max-xRange.min)*scaling)/2,yOffset=(height-(yRange.max-yRange.min)*scaling)/2;var scaled={};for(var i=0;i<circles.length;++i){var circle=circles[i];scaled[setids[i]]={radius:scaling*circle.radius,x:padding+xOffset+(circle.x-xRange.min)*scaling,y:padding+yOffset+(circle.y-yRange.min)*scaling}}return scaled}function VennDiagram(){var width=600,height=350,padding=15,duration=1e3,orientation=Math.PI/2,normalize=true,wrap=true,styled=true,fontSize=null,orientationOrder=null,colours=d3.scale.category10(),layoutFunction=venn;function chart(selection){var data=selection.datum();var solution=layoutFunction(data);normalize&&(solution=normalizeSolution(solution,orientation,orientationOrder));var circles=scaleSolution(solution,width,height,padding);var textCentres=computeTextCentres(circles,data);var svg=selection.selectAll("svg").data([circles]);svg.enter().append("svg");svg.attr("width",width).attr("height",height);var previous={},hasPrevious=false;svg.selectAll("g").each(function(d){var path=d3.select(this).select("path").attr("d");if(1==d.sets.length&&path){hasPrevious=true;previous[d.sets[0]]=circleFromPath(path)}});var pathTween=function(d){return function(t){var c=d.sets.map(function(set){var start=previous[set],end=circles[set];start||(start={x:width/2,y:height/2,radius:1});end||(end={x:width/2,y:height/2,radius:1});return{x:start.x*(1-t)+end.x*t,y:start.y*(1-t)+end.y*t,radius:start.radius*(1-t)+end.radius*t}});return intersectionAreaPath(c)}};var nodes=svg.selectAll("g").data(data,function(d){return d.sets});var enter=nodes.enter().append("g").attr("class",function(d){return"venn-area venn-"+(1==d.sets.length?"circle":"intersection")}).attr("data-venn-sets",function(d){return d.sets.join("_")});var enterPath=enter.append("path"),enterText=enter.append("text").attr("class","label").text(function(d){return label(d)}).attr("text-anchor","middle").attr("dy",".35em").attr("x",width/2).attr("y",height/2);if(styled){enterPath.style("fill-opacity","0").filter(function(d){return 1==d.sets.length}).style("fill",function(d){return colours(label(d))}).style("fill-opacity",".25");enterText.style("fill",function(d){return 1==d.sets.length?colours(label(d)):"#444"})}var update=nodes.transition("venn").duration(hasPrevious?duration:0);update.select("path").attrTween("d",pathTween);var updateText=update.select("text").text(function(d){return label(d)}).attr("x",function(d){return Math.floor(textCentres[d.sets].x)}).attr("y",function(d){return Math.floor(textCentres[d.sets].y)});wrap&&updateText.each("end",wrapText(circles,label));var exit=nodes.exit().transition("venn").duration(duration).remove();exit.select("path").attrTween("d",pathTween);var exitText=exit.select("text").text(function(d){return label(d)}).attr("x",width/2).attr("y",height/2);if(null!==fontSize){enterText.style("font-size","0px");updateText.style("font-size",fontSize);exitText.style("font-size","0px")}return{circles:circles,textCentres:textCentres,nodes:nodes,enter:enter,update:update,exit:exit}}function label(d){if(d.label)return d.label;if(1==d.sets.length)return""+d.sets[0]}chart.wrap=function(_){if(!arguments.length)return wrap;wrap=_;return chart};chart.width=function(_){if(!arguments.length)return width;width=_;return chart};chart.height=function(_){if(!arguments.length)return height;height=_;return chart};chart.padding=function(_){if(!arguments.length)return padding;padding=_;return chart};chart.colours=function(_){if(!arguments.length)return colours;colours=_;return chart};chart.fontSize=function(_){if(!arguments.length)return fontSize;fontSize=_;return chart};chart.duration=function(_){if(!arguments.length)return duration;duration=_;return chart};chart.layoutFunction=function(_){if(!arguments.length)return layoutFunction;layoutFunction=_;return chart};chart.normalize=function(_){if(!arguments.length)return normalize;normalize=_;return chart};chart.styled=function(_){if(!arguments.length)return styled;styled=_;return chart};chart.orientation=function(_){if(!arguments.length)return orientation;orientation=_;return chart};chart.orientationOrder=function(_){if(!arguments.length)return orientationOrder;orientationOrder=_;return chart};return chart}function wrapText(circles,labeller){return function(){var text=d3.select(this),data=text.datum(),width=circles[data.sets[0]].radius||50,label=labeller(data)||"";var joined,words=label.split(/\s+/).reverse(),maxLines=3,minChars=(label.length+words.length)/maxLines,word=words.pop(),line=[word],lineNumber=0,lineHeight=1.1,tspan=text.text(null).append("tspan").text(word);while(true){word=words.pop();if(!word)break;line.push(word);joined=line.join(" ");tspan.text(joined);if(joined.length>minChars&&tspan.node().getComputedTextLength()>width){line.pop();tspan.text(line.join(" "));line=[word];tspan=text.append("tspan").text(word);lineNumber++}}var initial=.35-lineNumber*lineHeight/2,x=text.attr("x"),y=text.attr("y");text.selectAll("tspan").attr("x",x).attr("y",y).attr("dy",function(d,i){return initial+i*lineHeight+"em"})}}function circleMargin(current,interior,exterior){var i,m,margin=interior[0].radius-distance(interior[0],current);for(i=1;i<interior.length;++i){m=interior[i].radius-distance(interior[i],current);m<=margin&&(margin=m)}for(i=0;i<exterior.length;++i){m=distance(exterior[i],current)-exterior[i].radius;m<=margin&&(margin=m)}return margin}function computeTextCentre(interior,exterior){var i,points=[];for(i=0;i<interior.length;++i){var c=interior[i];points.push({x:c.x,y:c.y});points.push({x:c.x+c.radius/2,y:c.y});points.push({x:c.x-c.radius/2,y:c.y});points.push({x:c.x,y:c.y+c.radius/2});points.push({x:c.x,y:c.y-c.radius/2})}var initial=points[0],margin=circleMargin(points[0],interior,exterior);for(i=1;i<points.length;++i){var m=circleMargin(points[i],interior,exterior);if(m>=margin){initial=points[i];margin=m}}var solution=fmin(function(p){return-1*circleMargin({x:p[0],y:p[1]},interior,exterior)},[initial.x,initial.y],{maxIterations:500,minErrorDelta:1e-10}).solution;var ret={x:solution[0],y:solution[1]};var valid=true;for(i=0;i<interior.length;++i)if(distance(ret,interior[i])>interior[i].radius){valid=false;break}for(i=0;i<exterior.length;++i)if(distance(ret,exterior[i])<exterior[i].radius){valid=false;break}if(!valid)if(1==interior.length)ret={x:interior[0].x,y:interior[0].y};else{var areaStats={};intersectionArea(interior,areaStats);ret=0===areaStats.arcs.length?{x:0,y:-1e3,disjoint:true}:1==areaStats.arcs.length?{x:areaStats.arcs[0].circle.x,y:areaStats.arcs[0].circle.y}:exterior.length?computeTextCentre(interior,[]):getCenter(areaStats.arcs.map(function(a){return a.p1}))}return ret}function getOverlappingCircles(circles){var ret={},circleids=[];for(var circleid in circles){circleids.push(circleid);ret[circleid]=[]}for(var i=0;i<circleids.length;i++){var a=circles[circleids[i]];for(var j=i+1;j<circleids.length;++j){var b=circles[circleids[j]],d=distance(a,b);d+b.radius<=a.radius+1e-10?ret[circleids[j]].push(circleids[i]):d+a.radius<=b.radius+1e-10&&ret[circleids[i]].push(circleids[j])}}return ret}function computeTextCentres(circles,areas){var ret={},overlapped=getOverlappingCircles(circles);for(var i=0;i<areas.length;++i){var area=areas[i].sets,areaids={},exclude={};for(var j=0;j<area.length;++j){areaids[area[j]]=true;var overlaps=overlapped[area[j]];for(var k=0;k<overlaps.length;++k)exclude[overlaps[k]]=true}var interior=[],exterior=[];for(var setid in circles)setid in areaids?interior.push(circles[setid]):setid in exclude||exterior.push(circles[setid]);var centre=computeTextCentre(interior,exterior);ret[area]=centre;centre.disjoint&&areas[i].size>0&&console.log("WARNING: area "+area+" not represented on screen")}return ret}function sortAreas(div,relativeTo){var overlaps=getOverlappingCircles(div.selectAll("svg").datum());var exclude={};for(var i=0;i<relativeTo.sets.length;++i){var check=relativeTo.sets[i];for(var setid in overlaps){var overlap=overlaps[setid];for(var j=0;j<overlap.length;++j)if(overlap[j]==check){exclude[setid]=true;break}}}function shouldExclude(sets){for(var i=0;i<sets.length;++i)if(!(sets[i]in exclude))return false;return true}div.selectAll("g").sort(function(a,b){if(a.sets.length!=b.sets.length)return a.sets.length-b.sets.length;if(a==relativeTo)return shouldExclude(b.sets)?-1:1;if(b==relativeTo)return shouldExclude(a.sets)?1:-1;return b.size-a.size})}function circlePath(x,y,r){var ret=[];ret.push("\nM",x,y);ret.push("\nm",-r,0);ret.push("\na",r,r,0,1,0,2*r,0);ret.push("\na",r,r,0,1,0,2*-r,0);return ret.join(" ")}function circleFromPath(path){var tokens=path.split(" ");return{x:parseFloat(tokens[1]),y:parseFloat(tokens[2]),radius:-parseFloat(tokens[4])}}function intersectionAreaPath(circles){var stats={};intersectionArea(circles,stats);var arcs=stats.arcs;if(0===arcs.length)return"M 0 0";if(1==arcs.length){var circle=arcs[0].circle;return circlePath(circle.x,circle.y,circle.radius)}var ret=["\nM",arcs[0].p2.x,arcs[0].p2.y];for(var i=0;i<arcs.length;++i){var arc=arcs[i],r=arc.circle.radius,wide=arc.width>r;ret.push("\nA",r,r,0,wide?1:0,1,arc.p1.x,arc.p1.y)}return ret.join(" ")}var version="0.2.9";exports.version=version;exports.fmin=fmin;exports.minimizeConjugateGradient=minimizeConjugateGradient;exports.bisect=bisect;exports.intersectionArea=intersectionArea;exports.circleCircleIntersection=circleCircleIntersection;exports.circleOverlap=circleOverlap;exports.circleArea=circleArea;exports.distance=distance;exports.circleIntegral=circleIntegral;exports.venn=venn;exports.greedyLayout=greedyLayout;exports.scaleSolution=scaleSolution;exports.normalizeSolution=normalizeSolution;exports.bestInitialLayout=bestInitialLayout;exports.lossFunction=lossFunction;exports.disjointCluster=disjointCluster;exports.distanceFromIntersectArea=distanceFromIntersectArea;exports.VennDiagram=VennDiagram;exports.wrapText=wrapText;exports.computeTextCentres=computeTextCentres;exports.computeTextCentre=computeTextCentre;exports.sortAreas=sortAreas;exports.circlePath=circlePath;exports.circleFromPath=circleFromPath;exports.intersectionAreaPath=intersectionAreaPath},void factory(exports);var factory},4173:function(module,exports,__webpack_require__){"use strict";__webpack_require__(150);__webpack_require__(153);__webpack_require__(154);__webpack_require__(155);__webpack_require__(156);__webpack_require__(157);__webpack_require__(158);__webpack_require__(159);__webpack_require__(160);__webpack_require__(161);__webpack_require__(162);__webpack_require__(163);__webpack_require__(164);__webpack_require__(165);__webpack_require__(166);__webpack_require__(167);__webpack_require__(168);__webpack_require__(169);__webpack_require__(170);__webpack_require__(171);__webpack_require__(172);__webpack_require__(173);__webpack_require__(174);__webpack_require__(175);__webpack_require__(176);__webpack_require__(177);__webpack_require__(178);__webpack_require__(179);__webpack_require__(180);__webpack_require__(181);__webpack_require__(182);__webpack_require__(183);__webpack_require__(184);__webpack_require__(185);__webpack_require__(186);__webpack_require__(187);__webpack_require__(188);__webpack_require__(189);__webpack_require__(190);__webpack_require__(191);__webpack_require__(192);__webpack_require__(193);__webpack_require__(194);__webpack_require__(195);__webpack_require__(196);__webpack_require__(197);__webpack_require__(198);__webpack_require__(199);__webpack_require__(200);__webpack_require__(201);__webpack_require__(202);__webpack_require__(123);__webpack_require__(203);__webpack_require__(204);__webpack_require__(205);__webpack_require__(206);__webpack_require__(207);__webpack_require__(208);__webpack_require__(209);__webpack_require__(210);__webpack_require__(211);__webpack_require__(212);__webpack_require__(213);__webpack_require__(214);__webpack_require__(215);__webpack_require__(216);__webpack_require__(217);__webpack_require__(218);__webpack_require__(219);__webpack_require__(220);__webpack_require__(221);__webpack_require__(222);__webpack_require__(223);__webpack_require__(224);__webpack_require__(225);__webpack_require__(226);__webpack_require__(227);__webpack_require__(228);__webpack_require__(229);__webpack_require__(230);__webpack_require__(231);__webpack_require__(232);__webpack_require__(233);__webpack_require__(234);__webpack_require__(235);__webpack_require__(236);__webpack_require__(237);__webpack_require__(238);__webpack_require__(239);__webpack_require__(240);var _kibanaCore__=__webpack_require__(241);new _kibanaCore__.CoreSystem({injectedMetadata:JSON.parse(document.querySelector("kbn-injected-metadata").getAttribute("data")),rootDomElement:document.body,requireLegacyFiles:function requireLegacyFiles(){__webpack_require__(4174)}}).start()},4174:function(module,exports,__webpack_require__){"use strict";var _d=__webpack_require__(18);var _d2=_interopRequireDefault(_d);__webpack_require__(117);var _risonNode=__webpack_require__(253);var _risonNode2=_interopRequireDefault(_risonNode);var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);__webpack_require__(480);__webpack_require__(481);__webpack_require__(296);__webpack_require__(865);var _chrome=__webpack_require__(8);var _chrome2=_interopRequireDefault(_chrome);var _modules=__webpack_require__(2);var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _notify=__webpack_require__(9);var _index_patterns=__webpack_require__(818);var _saved_objects=__webpack_require__(56);var _kibana_parsed_url=__webpack_require__(809);var _xpack_info=__webpack_require__(58);__webpack_require__(4175);var _index=__webpack_require__(4176);var _index2=_interopRequireDefault(_index);__webpack_require__(4177);var _graphClientWorkspace=__webpack_require__(4178);var _graphClientWorkspace2=_interopRequireDefault(_graphClientWorkspace);var _utils=__webpack_require__(4179);var _utils2=_interopRequireDefault(_utils);var _saved_workspaces=__webpack_require__(4180);var _style_choices=__webpack_require__(4182);var _outlink_encoders=__webpack_require__(4183);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var app=_modules.uiModules.get("app/graph");function checkLicense(Private,Promise,kbnBaseUrl){var xpackInfo=Private(_xpack_info.XPackInfoProvider);var licenseAllowsToShowThisPage=xpackInfo.get("features.graph.showAppLink")&&xpackInfo.get("features.graph.enableAppLink");if(!licenseAllowsToShowThisPage){var message=xpackInfo.get("features.graph.message");var queryString="?"+_notify.Notifier.QS_PARAM_LOCATION+"=Graph&"+_notify.Notifier.QS_PARAM_LEVEL+"=error&"+_notify.Notifier.QS_PARAM_MESSAGE+"="+message;var url=_chrome2.default.addBasePath(kbnBaseUrl)+"#"+queryString;window.location.href=url;return Promise.halt()}return Promise.resolve()}app.directive("focusOn",function(){return function(scope,elem,attr){scope.$on(attr.focusOn,function(){elem[0].focus()})}});_routes2.default.enable&&_routes2.default.enable();_routes2.default.when("/home",{template:_index2.default,resolve:{indexPatterns:function indexPatterns(Private){var savedObjectsClient=Private(_saved_objects.SavedObjectsClientProvider);return savedObjectsClient.find({type:"index-pattern",fields:["title"],perPage:1e4}).then(function(response){return response.savedObjects})},GetIndexPatternProvider:function GetIndexPatternProvider(Private){return Private(_index_patterns.IndexPatternsProvider)},SavedWorkspacesProvider:function SavedWorkspacesProvider(Private){return Private(_saved_workspaces.SavedWorkspacesProvider)},CheckLicense:checkLicense}}).when("/workspace/:id",{template:_index2.default,resolve:{savedWorkspace:function savedWorkspace(savedGraphWorkspaces,courier,$route){return savedGraphWorkspaces.get($route.current.params.id).catch(function(){_notify.notify.error("Missing workspace")})},indexPatterns:function indexPatterns(Private){var savedObjectsClient=Private(_saved_objects.SavedObjectsClientProvider);return savedObjectsClient.find({type:"index-pattern",fields:["title"],perPage:1e4}).then(function(response){return response.savedObjects})},GetIndexPatternProvider:function GetIndexPatternProvider(Private){return Private(_index_patterns.IndexPatternsProvider)},SavedWorkspacesProvider:function SavedWorkspacesProvider(Private){return Private(_saved_workspaces.SavedWorkspacesProvider)},CheckLicense:checkLicense}}).otherwise({redirectTo:"/home"});app.controller("graphuiPlugin",function($scope,$route,$interval,$http,kbnUrl,Private,Promise,confirmModal,kbnBaseUrl){function handleSuccess(data){return checkLicense(Private,Promise,kbnBaseUrl).then(function(){return data})}function handleError(err){return checkLicense(Private,Promise,kbnBaseUrl).then(function(){return _notify.notify.error(err)})}$scope.title="Graph";$scope.spymode="request";$scope.iconChoices=_style_choices.iconChoices;$scope.drillDownIconChoices=_style_choices.drillDownIconChoices;$scope.colors=_style_choices.colorChoices;$scope.iconChoicesByClass=_style_choices.iconChoicesByClass;$scope.outlinkEncoders=_outlink_encoders.outlinkEncoders;$scope.fields=[];$scope.canEditDrillDownUrls=_chrome2.default.getInjected("canEditDrillDownUrls");$scope.graphSavePolicy=_chrome2.default.getInjected("graphSavePolicy");$scope.allSavingDisabled="none"===$scope.graphSavePolicy;$scope.searchTerm="";$scope.grr=$scope;$scope.applyColor=function(fieldDef,color){fieldDef.color=color;$scope.workspace&&$scope.workspace.nodes.forEach(function(node){node.data.field===fieldDef.name&&(node.color=color)})};$scope.applyIcon=function(fieldDef,icon){fieldDef.icon=icon;$scope.workspace&&$scope.workspace.nodes.forEach(function(node){node.data.field===fieldDef.name&&(node.icon=icon)})};$scope.toggleDrillDownIcon=function(urlTemplate,icon){urlTemplate.icon===icon?urlTemplate.icon=null:urlTemplate.icon=icon};$scope.openSavedWorkspace=function(savedWorkspace){kbnUrl.change("/workspace/{{id}}",{id:savedWorkspace.id})};$scope.nodeClick=function(n,$event){if(!$event.shiftKey){var prevSelection=n.isSelected;$scope.workspace.selectNone();n.isSelected=prevSelection}$scope.workspace.toggleNodeSelection(n)?$scope.selectSelected(n):$scope.detail=null};$scope.updateLiveResponseFields=function(){$scope.liveResponseFields=$scope.selectedFields.filter(function(fieldDef){return fieldDef.hopSize>0&&fieldDef.selected})};$scope.selectedFieldConfigHopSizeChanged=function(){$scope.updateLiveResponseFields()};$scope.hideAllConfigPanels=function(){$scope.selectedFieldConfig=null;$scope.kbnTopNav.close()};$scope.setAllFieldStatesToDefault=function(){$scope.selectedFields=[];$scope.basicModeSelectedSingleField=null;$scope.liveResponseFields=[];$scope.allFields.forEach(function(fieldDef){fieldDef.selected=false})};$scope.addFieldToSelection=function(){$scope.selectedField.selected=true;$scope.selectedFields.indexOf($scope.selectedField)<0&&$scope.selectedFields.push($scope.selectedField);$scope.updateLiveResponseFields();$scope.clickVertexFieldIcon($scope.selectedField)};$scope.clickVertexFieldIcon=function(field,$event){if($event&&field&&$event.shiftKey){if(0===field.hopSize)field.hopSize=field.lastValidHopSize?field.lastValidHopSize:5;else{field.lastValidHopSize=field.hopSize;field.hopSize=0}$scope.updateLiveResponseFields();return}if("fieldConfig"===$scope.kbnTopNav.currentKey&&field===$scope.selectedFieldConfig){$scope.hideAllConfigPanels();return}$scope.hideAllConfigPanels();$scope.selectedFieldConfig=field;$scope.kbnTopNav.currentKey="fieldConfig"};function canWipeWorkspace(yesFn,noFn){if(0===$scope.selectedFields.length&&null===$scope.workspace){yesFn();return}var confirmModalOptions={onConfirm:yesFn,onCancel:noFn,confirmButtonText:"Clear workspace"};confirmModal("This will clear the workspace - are you sure?",confirmModalOptions)}$scope.uiSelectIndex=function(){canWipeWorkspace(function(){$scope.indexSelected($scope.proposedIndex)},function(){$scope.proposedIndex=$scope.selectedIndex})};$scope.indexSelected=function(selectedIndex,postInitHandler){$scope.clearWorkspace();$scope.allFields=[];$scope.selectedFields=[];$scope.basicModeSelectedSingleField=null;$scope.selectedField=null;$scope.selectedFieldConfig=null;$scope.selectedIndex=selectedIndex;$scope.proposedIndex=selectedIndex;var promise=$route.current.locals.GetIndexPatternProvider.get(selectedIndex.id);promise.then(handleSuccess).then(function(indexPattern){var patternFields=indexPattern.getNonScriptedFields();var blockedFieldNames=["_id","_index","_score","_source","_type"];patternFields.forEach(function(field,index){if(blockedFieldNames.indexOf(field.name)>=0)return;var graphFieldDef={name:field.name};$scope.allFields.push(graphFieldDef);graphFieldDef.hopSize=5;graphFieldDef.lastValidHopSize=graphFieldDef.hopSize;graphFieldDef.icon=$scope.iconChoices[0];for(var i=0;i<$scope.iconChoices.length;i++){var icon=$scope.iconChoices[i];for(var p=0;p<icon.patterns.length;p++){var pattern=icon.patterns[p];if(pattern.test(graphFieldDef.name)){graphFieldDef.icon=icon;break}}}graphFieldDef.color=$scope.colors[index%$scope.colors.length]});$scope.setAllFieldStatesToDefault();$scope.allFields.sort(function(a,b){if(a.name<b.name)return-1;if(a.name>b.name)return 1;return 0});$scope.filteredFields=$scope.allFields;$scope.allFields.length>0&&($scope.selectedField=$scope.allFields[0]);postInitHandler&&postInitHandler()},handleError)};$scope.clickEdge=function(edge){edge.inferred?$scope.setDetail({inferredEdge:edge}):$scope.workspace.getAllIntersections($scope.handleMergeCandidatesCallback,[edge.topSrc,edge.topTarget])};function callNodeProxy(indexName,query,responseHandler){var request={index:indexName,query:query};return $http.post("../api/graph/graphExplore",request).then(function(resp){resp.data.resp.timed_out&&_notify.toastNotifications.addWarning("Exploration timed out");responseHandler(resp.data.resp)}).catch(handleError)}var callSearchNodeProxy=function callSearchNodeProxy(indexName,query,responseHandler){var request={index:indexName,body:query};$http.post("../api/graph/searchProxy",request).then(function(resp){responseHandler(resp.data.resp)}).catch(handleError)};$scope.submit=function(){$scope.hideAllConfigPanels();initWorkspaceIfRequired();var numHops=2;if($scope.searchTerm.startsWith("{")){try{var query=JSON.parse($scope.searchTerm);query.vertices?$scope.workspace.callElasticsearch(query):$scope.workspace.search(query,$scope.liveResponseFields,numHops)}catch(err){handleError(err)}return}$scope.workspace.simpleSearch($scope.searchTerm,$scope.liveResponseFields,numHops)};$scope.clearWorkspace=function(){$scope.workspace=null;$scope.detail=null;$scope.kbnTopNav&&$scope.kbnTopNav.close()};$scope.toggleShowAdvancedFieldsConfig=function(){if("fields"!==$scope.kbnTopNav.currentKey){$scope.kbnTopNav.close();$scope.kbnTopNav.currentKey="fields";$scope.selectedField=null;$scope.filteredFields=$scope.allFields.filter(function(fieldDef){return!fieldDef.selected});$scope.filteredFields.length>0&&($scope.selectedField=$scope.filteredFields[0])}else $scope.hideAllConfigPanels()};$scope.removeVertexFieldSelection=function(){$scope.selectedFieldConfig.selected=false;var i=$scope.selectedFields.indexOf($scope.selectedFieldConfig);-1!==i&&$scope.selectedFields.splice(i,1);$scope.updateLiveResponseFields();$scope.hideAllConfigPanels()};$scope.selectSelected=function(node){$scope.detail={latestNodeSelection:node};return $scope.selectedSelectedVertex=node};$scope.isSelectedSelected=function(node){return $scope.selectedSelectedVertex===node};$scope.filterFieldsKeyDown=function(){var lcFilter=$scope.fieldNamesFilterString.toLowerCase();$scope.filteredFields=$scope.allFields.filter(function(fieldDef){return!fieldDef.selected&&(!lcFilter||""===lcFilter||fieldDef.name.toLowerCase().indexOf(lcFilter)>=0)})};var defaultKibanaQuery=",query:(query_string:(analyze_wildcard:!t,query:'*'))";var drillDownRegex=/\{\{gquery\}\}/;$scope.checkForKibanaUrl=function(){$scope.suggestTemplateFix=$scope.newUrlTemplate.url===$scope.lastPastedURL&&$scope.newUrlTemplate.url.indexOf(defaultKibanaQuery)>0};$scope.replaceKibanaUrlParam=function(){$scope.newUrlTemplate.url=$scope.newUrlTemplate.url.replace(defaultKibanaQuery,",query:{{gquery}}");$scope.lastPastedURL=null;$scope.checkForKibanaUrl()};$scope.rejectKibanaUrlSuggestion=function(){$scope.lastPastedURL=null;$scope.checkForKibanaUrl()};function detectKibanaUrlPaste(url){$scope.lastPastedURL=url;$scope.checkForKibanaUrl()}$scope.handleUrlTemplatePaste=function($event){window.setTimeout(function(){detectKibanaUrlPaste(angular.element($event.currentTarget).val());$scope.$digest()},0)};$scope.resetNewUrlTemplate=function(){$scope.newUrlTemplate={url:null,description:null,encoder:$scope.outlinkEncoders[0]}};$scope.editUrlTemplate=function(urlTemplate){Object.assign($scope.newUrlTemplate,urlTemplate,{templateBeingEdited:urlTemplate})};$scope.saveUrlTemplate=function(){var found=$scope.newUrlTemplate.url.search(drillDownRegex)>-1;if(!found){_notify.toastNotifications.addWarning({title:"Invalid URL",text:"The URL must contain a {{gquery}} string"});return}if($scope.newUrlTemplate.templateBeingEdited&&$scope.urlTemplates.indexOf($scope.newUrlTemplate.templateBeingEdited)>=0){Object.assign($scope.newUrlTemplate.templateBeingEdited,$scope.newUrlTemplate);return}$scope.urlTemplates.push($scope.newUrlTemplate);$scope.resetNewUrlTemplate()};$scope.removeUrlTemplate=function(urlTemplate){var i=$scope.urlTemplates.indexOf(urlTemplate);-1!=i&&confirmModal('Remove "'+urlTemplate.description+'" drill-down?',{onConfirm:function onConfirm(){return $scope.urlTemplates.splice(i,1)},confirmButtonText:"Remove drill-down"})};$scope.openUrlTemplate=function(template){var url=template.url;var newUrl=url.replace(drillDownRegex,template.encoder.encode($scope.workspace));window.open(newUrl,"_blank")};$scope.resetWorkspace=function(){$scope.clearWorkspace();$scope.userHasConfirmedSaveWorkspaceData=false;$scope.selectedIndex=null;$scope.proposedIndex=null;$scope.detail=null;$scope.selectedSelectedVertex=null;$scope.selectedField=null;$scope.description=null;$scope.allFields=[];$scope.urlTemplates=[];$scope.resetNewUrlTemplate();$scope.fieldNamesFilterString=null;$scope.filteredFields=[];$scope.selectedFields=[];$scope.configPanel="settings";$scope.liveResponseFields=[];$scope.exploreControls={useSignificance:true,sampleSize:2e3,timeoutMillis:5e3,sampleDiversityField:null,maxValuesPerDoc:1,minDocCount:3}};function initWorkspaceIfRequired(){if($scope.workspace)return;var options={indexName:$scope.selectedIndex.attributes.title,vertex_fields:$scope.selectedFields,nodeLabeller:function nodeLabeller(){},changeHandler:function changeHandler(){$scope.$apply()},graphExploreProxy:callNodeProxy,searchProxy:callSearchNodeProxy,exploreControls:$scope.exploreControls};$scope.workspace=_graphClientWorkspace2.default.createWorkspace(options);$scope.detail=null;if(0===$scope.urlTemplates.length){var tag="{{gquery}}";var kUrl=new _kibana_parsed_url.KibanaParsedUrl({appId:"kibana",basePath:_chrome2.default.getBasePath(),appPath:"/discover"});kUrl.addQueryParameter("_a",_risonNode2.default.encode({columns:["_source"],index:$scope.selectedIndex.id,interval:"auto",query:tag,sort:["_score","desc"]}));var discoverUrl=kUrl.getRootRelativePath().replace(encodeURIComponent(tag),tag);$scope.urlTemplates.push({url:discoverUrl,description:"Raw documents",encoder:$scope.outlinkEncoders[0]})}}$scope.indices=$route.current.locals.indexPatterns;$scope.setDetail=function(data){$scope.detail=data};$scope.performMerge=function(parentId,childId){var found=true;while(found){found=false;for(var i in $scope.detail.mergeCandidates){var mc=$scope.detail.mergeCandidates[i];if(mc.id1===childId||mc.id2===childId){$scope.detail.mergeCandidates.splice(i,1);found=true;break}}}$scope.workspace.mergeIds(parentId,childId);$scope.detail=null};$scope.handleMergeCandidatesCallback=function(termIntersects){$scope.detail={mergeCandidates:_utils2.default.getMergeSuggestionObjects(termIntersects)}};var redraw=function redraw(){_d2.default.select("#svgRootGroup").attr("transform","translate("+_d2.default.event.translate+")scale("+_d2.default.event.scale+")").attr("style","stroke-width: "+1/_d2.default.event.scale);if($scope.zoomLevel!==_d2.default.event.scale){$scope.zoomLevel=_d2.default.event.scale;$scope.$apply()}};$scope.resetWorkspace();var blockScroll=function blockScroll(){_d2.default.event.preventDefault()};_d2.default.select("#graphSvg").on("mousewheel",blockScroll).on("DOMMouseScroll",blockScroll).call(_d2.default.behavior.zoom().on("zoom",redraw));var managementUrl=_chrome2.default.getNavLinkById("kibana:management").url;var url=managementUrl+"/kibana/indices";0===$scope.indices.length&&_notify.toastNotifications.addWarning({title:"No data source",text:_react2.default.createElement("p",null,"Go to ",_react2.default.createElement("a",{href:url},"Management > Index Patterns")," and create an index pattern")});$scope.topNavMenu=[];$scope.topNavMenu.push({key:"new",description:"New Workspace",tooltip:"Create a new workspace",run:function run(){canWipeWorkspace(function(){kbnUrl.change("/home",{})})}});$scope.allSavingDisabled?$scope.topNavMenu.push({key:"save",description:"Save Workspace",tooltip:"No changes to saved workspaces are permitted by the current save policy",disableButton:true}):$scope.topNavMenu.push({key:"save",description:"Save Workspace",tooltip:"Save this workspace",disableButton:function disableButton(){return 0===$scope.selectedFields.length},template:__webpack_require__(4184)});$scope.topNavMenu.push({key:"open",description:"Load Saved Workspace",tooltip:"Load a saved workspace",template:__webpack_require__(4185)});$scope.allSavingDisabled?$scope.topNavMenu.push({key:"delete",disableButton:true,description:"Delete Saved Workspace",tooltip:"No changes to saved workspaces are permitted by the current save policy"}):$scope.topNavMenu.push({key:"delete",disableButton:function disableButton(){return void 0===$route.current.locals||void 0===$route.current.locals.savedWorkspace},description:"Delete Saved Workspace",tooltip:"Delete this workspace",run:function run(){var title=$route.current.locals.savedWorkspace.title;function doDelete(){$route.current.locals.SavedWorkspacesProvider.delete($route.current.locals.savedWorkspace.id);kbnUrl.change("/home",{});_notify.toastNotifications.addSuccess("Deleted '"+title+"'")}var confirmModalOptions={onConfirm:doDelete,confirmButtonText:"Delete workspace"};confirmModal("Are you sure you want to delete the workspace "+title+" ?",confirmModalOptions)}});$scope.topNavMenu.push({key:"settings",disableButton:function disableButton(){return null===$scope.selectedIndex},description:"Settings",template:__webpack_require__(4186)});if($route.current.locals.savedWorkspace){var wsObj=JSON.parse($route.current.locals.savedWorkspace.wsState);$scope.savedWorkspace=$route.current.locals.savedWorkspace;$scope.description=$route.current.locals.savedWorkspace.description;wsObj.urlTemplates.forEach(function(urlTemplate){var encoder=$scope.outlinkEncoders.find(function(outlinkEncoder){return outlinkEncoder.id===urlTemplate.encoderID});if(encoder){var template={url:urlTemplate.url,description:urlTemplate.description,encoder:encoder};urlTemplate.iconClass&&(template.icon=_style_choices.drillDownIconChoicesByClass[urlTemplate.iconClass]);$scope.urlTemplates.push(template)}});var savedObjectIndexPattern=null;$scope.indices.forEach(function(savedObject){savedObject.attributes.title===wsObj.indexPattern&&(savedObjectIndexPattern=savedObject)});if(!savedObjectIndexPattern){_notify.notify.error("Missing index pattern:"+wsObj.indexPattern);return}$scope.indexSelected(savedObjectIndexPattern,function(){Object.assign($scope.exploreControls,wsObj.exploreControls);$scope.exploreControls.sampleDiversityField&&($scope.exploreControls.sampleDiversityField=$scope.allFields.find(function(field){return $scope.exploreControls.sampleDiversityField.name===field.name}));for(var i in wsObj.selectedFields){var savedField=wsObj.selectedFields[i];for(var f in $scope.allFields){var field=$scope.allFields[f];if(savedField.name===field.name){field.hopSize=savedField.hopSize;field.lastValidHopSize=savedField.lastValidHopSize;field.color=savedField.color;field.icon=$scope.iconChoicesByClass[savedField.iconClass];field.selected=true;$scope.selectedFields.push(field);break}}}$scope.updateLiveResponseFields();initWorkspaceIfRequired();var graph={nodes:[],edges:[]};for(var _i in wsObj.vertices){var vertex=wsObj.vertices[_i];var node={field:vertex.field,term:vertex.term,label:vertex.label,color:vertex.color,icon:$scope.allFields.filter(function(fieldDef){return vertex.field===fieldDef.name})[0].icon,data:{}};graph.nodes.push(node)}for(var _i2 in wsObj.blacklist){vertex=wsObj.vertices[_i2];var fieldDef=$scope.allFields.filter(function(fieldDef){return vertex.field===fieldDef.name})[0];if(fieldDef){var _node={field:vertex.field,term:vertex.term,label:vertex.label,color:vertex.color,icon:fieldDef.icon,data:{field:vertex.field,term:vertex.term}};$scope.workspace.blacklistedNodes.push(_node)}}for(var _i3 in wsObj.links){var link=wsObj.links[_i3];graph.edges.push({source:link.source,target:link.target,inferred:link.inferred,label:link.label,term:vertex.term,width:link.width,weight:link.weight})}$scope.workspace.mergeGraph(graph);for(var _i4 in wsObj.vertices){var _vertex=wsObj.vertices[_i4];var vId=$scope.workspace.makeNodeId(_vertex.field,_vertex.term);var visNode=$scope.workspace.nodesMap[vId];visNode.x=_vertex.x;visNode.y=_vertex.y;if(null!==_vertex.parent){var parentSavedObj=graph.nodes[_vertex.parent];var parentId=$scope.workspace.makeNodeId(parentSavedObj.field,parentSavedObj.term);visNode.parent=$scope.workspace.nodesMap[parentId]}}$scope.workspace.runLayout();if($route.current.params.query){$scope.searchTerm=$route.current.params.query;$scope.submit()}})}else $route.current.locals.SavedWorkspacesProvider.get().then(function(newWorkspace){$scope.savedWorkspace=newWorkspace});$scope.saveWorkspace=function(){if($scope.allSavingDisabled){_notify.toastNotifications.addWarning("Saving is disabled");return}initWorkspaceIfRequired();var canSaveData="configAndData"===$scope.graphSavePolicy||"configAndDataWithConsent"===$scope.graphSavePolicy&&$scope.userHasConfirmedSaveWorkspaceData;var blacklist=[];var vertices=[];var links=[];if(canSaveData){blacklist=$scope.workspace.blacklistedNodes.map(function(node){return{x:node.x,y:node.y,field:node.data.field,term:node.data.term,label:node.label,color:node.color,parent:null,weight:node.weight,size:node.scaledSize}});vertices=$scope.workspace.nodes.map(function(node){return{x:node.x,y:node.y,field:node.data.field,term:node.data.term,label:node.label,color:node.color,parent:node.parent?$scope.workspace.nodes.indexOf(node.parent):null,weight:node.weight,size:node.scaledSize}});links=$scope.workspace.edges.map(function(edge){return{weight:edge.weight,width:edge.width,inferred:edge.inferred,label:edge.label,source:$scope.workspace.nodes.indexOf(edge.source),target:$scope.workspace.nodes.indexOf(edge.target)}})}var urlTemplates=$scope.urlTemplates.map(function(template){var result={url:template.url,description:template.description,encoderID:template.encoder.id};template.icon&&(result.iconClass=template.icon.class);return result});$scope.savedWorkspace.wsState=JSON.stringify({indexPattern:$scope.selectedIndex.attributes.title,selectedFields:$scope.selectedFields.map(function(field){return{name:field.name,lastValidHopSize:field.lastValidHopSize,color:field.color,iconClass:field.icon.class,hopSize:field.hopSize}}),blacklist:blacklist,vertices:vertices,links:links,urlTemplates:urlTemplates,exploreControls:$scope.exploreControls});$scope.savedWorkspace.numVertices=vertices.length;$scope.savedWorkspace.numLinks=links.length;$scope.savedWorkspace.description=$scope.description;$scope.savedWorkspace.save().then(function(id){$scope.kbnTopNav.close("save");$scope.userHasConfirmedSaveWorkspaceData=false;if(id){var title='Saved "'+$scope.savedWorkspace.title+'"';var text=void 0;!canSaveData&&$scope.workspace.nodes.length>0&&(text="The configuration was saved, but the data was not saved");_notify.toastNotifications.addSuccess({title:title,text:text,"data-test-subj":"saveGraphSuccess"});if($scope.savedWorkspace.id===$route.current.params.id)return;$scope.openSavedWorkspace($scope.savedWorkspace)}},_notify.fatalError)}})},4175:function(module,exports){},4176:function(module,exports){module.exports='<div id="graphBasic" ng-controller="graphuiPlugin">\n  \x3c!-- Local nav. --\x3e\n  <kbn-top-nav name="workspacesTopNav" config="topNavMenu">\n    \x3c!-- Transcluded elements. --\x3e\n    <div data-transclude-slots>\n      \x3c!-- Title. --\x3e\n      <div data-transclude-slot="topLeftCorner" class="kuiLocalTitle">\n        <strong>{{ savedWorkspace.lastSavedTitle || \'New Graph Workspace\' }}</strong>\n      </div>\n\n      <div data-transclude-slot="bottomRow" class="flexGroup">\n        \x3c!-- Select index pattern. --\x3e\n        <select\n          class="form-control indexDropDown"\n          name="mySelect"\n          ng-change="uiSelectIndex()"\n          ng-class="{pulseControl:selectedIndex === null}"\n          ng-options="option.attributes.title for option in indices"\n          ng-model="grr.proposedIndex"\n        >\n          <option value="">Select index pattern...</option>\n        </select>\n\n        \x3c!-- Added fields. --\x3e\n        <span\n          class="noUserSelect"\n          ng-repeat="f in selectedFields"\n          ng-attr-tooltip="Shift + click to toggle if search returns {{f.name}}"\n        >\n          <svg\n            width="30"\n            height="30"\n            ng-click="clickVertexFieldIcon(f, $event)"\n            ng-class="{disabledField:f.hopSize<=0}"\n          >\n            <circle\n              class="nodeCircle"\n              r="13"\n              cx="15"\n              cy="15"\n              ng-class="{selectedNode:kbnTopNav.currentKey === \'fieldConfig\'&&f === selectedFieldConfig}"\n              ng-attr-style="fill:{{f.color}}"\n            />\n            <text ng-if="f.icon" class="SvgIconFont" text-anchor="middle" x="15" y="20">\n              {{f.icon.code}}\n            </text>\n          </svg>\n        </span>\n\n        \x3c!-- Add field button. --\x3e\n        <span class="noUserSelect" ng-attr-tooltip="Add a field source for vertices">\n          <button\n            class="graphPlusButton"\n            ng-disabled="selectedIndex === null"\n            aria-label="Add a field"\n            id="addVertexFieldButton"\n            ng-class="{pulseControl:selectedIndex !== null&&selectedFields.length === 0}"\n            ng-click="toggleShowAdvancedFieldsConfig()"\n          >\n            <span aria-hidden="true" class="kuiIcon fa-plus"></span>\n          </button>\n        </span>\n\n        \x3c!-- Search. --\x3e\n        <form\n          ng-submit="submit()"\n          name="graphBasicSearch"\n          class="flexGroup__filler"\n          style="width: 100%"\n        >\n          <div class="kuiLocalSearch">\n            <input\n              name="searchTerm"\n              type="text"\n              class="kuiLocalSearchInput"\n              ng-model="grr.searchTerm"\n              ng-disabled="liveResponseFields.length === 0"\n              ng-focus="kbnTopNav.close()"\n              placeholder="foo AND bar NOT baz"\n              autocomplete="off"\n            >\n            <button\n              class="kuiLocalSearchButton"\n              type="submit"\n              ng-disabled="liveResponseFields.length === 0"\n              aria-label="Search"\n            >\n              <span aria-hidden="true" class="kuiIcon fa-search"></span>\n            </button>\n          </div>\n        </form>\n      </div>\n    </div>\n  </kbn-top-nav>\n\n  <div class="config" ng-show="kbnTopNav.currentKey === \'fields\'" data-test-subj="fieldSelectionList">\n    <div class="config">\n      <div class="container-fluid no-margin-bottom">\n        <label >Add a field source for vertices</label>\n              <form>\n                <div class="input-group form-group finder-form " style="width:100%">\n                  <span class="input-group-addon "\n                    id="fieldFinderIcon">\n                    <span class="kuiIcon fa-search"></span>\n                  </span>\n                    <input\n                      id="fieldFinderInput"\n                      input-focus\n                      ng-model="fieldNamesFilterString"\n                      placeholder="Filter..."\n                      ng-change="filterFieldsKeyDown()"\n                      class="form-control"\n                      name="filter"\n                      type="text"\n                      autocomplete="off" />\n                </div>\n            </form>\n\n             <select\n              class="kuiVerticalRhythm"\n              id="fieldList"\n              size="7"\n              ng-options="item as item.name for item in filteredFields"\n              ng-dblclick="addFieldToSelection()"\n              ng-model="selectedField"\n            ></select>\n\n             <div class="kuiVerticalRhythm">\n              \x3c!-- TODO look at the field chooser directive in Discover to give type icons etc to\n              field types. This may filter out indexed-only fields though? --\x3e\n              <button\n                ng-disabled="!selectedField"\n                ng-click="addFieldToSelection()"\n                class="kuiButton kuiButton--primary"\n              >\n                Add\n              </button>\n            </div>\n      </div>\n\n       <button\n        class="kuiLocalDropdownCloseButton"\n        ng-click="kbnTopNav.close()"\n        aria-label="Close"\n      >\n        <span class="kuiIcon fa-chevron-circle-up"></span>\n      </button>\n    </div>\n  </div>\n\n  <div class="config"  ng-show="kbnTopNav.currentKey === \'fieldConfig\'">\n    <div class="config">\n      <div class="container-fluid no-margin-bottom">\n\n              <div >\n                <form class="form-horizontal" >\n\n                  <div class="form-group">\n                    <div class="col-sm-offset-4 col-sm-8">\n                      <strong>{{selectedFieldConfig.name}}</strong>\n                    </div>\n                  </div>\n\n                  <div class="form-group form-group-sm small-graph-form">\n                    <label for="colorPicker" class="col-sm-4 control-label"> Color</label>\n                    <div class="col-sm-6">\n                      <span class="legend-value-container" id="colorPicker">\n                        <span class="legend-value-color-picker">\n                          <span ng-repeat="c in colors"  ng-click="applyColor(selectedFieldConfig,c)" ng-class="c === selectedFieldConfig.color ? \'fa-circle-o\' : \'fa-circle\'" ng-style="{color: c}" class="kuiIcon dot">\n                                                </span>\n                        </span>\n                      </span>\n                    </div>\n                  </div>\n\n                  <div class="form-group form-group-sm small-graph-form">\n                    <label for="iconPicker" class="col-sm-4 control-label"> Icon</label>\n                    <div class="col-sm-5">\n                      <span class="legend-value-icon-picker">\n                        <span ng-repeat="i in iconChoices"  ng-click="applyIcon(selectedFieldConfig,i)" ng-class="{selectedNode:i==selectedFieldConfig.icon}" class="kuiIcon icon noUserSelect">\n                                            {{i.code}}</span>\n                      </span>\n                    </div>\n                  </div>\n\n                  <div class="form-group form-group-sm small-graph-form">\n                    <label for="qHopSize" class="col-sm-4 control-label">Max terms per hop</label>\n                    <div class="col-sm-6">\n                      <input\n                             ng-change="selectedFieldConfigHopSizeChanged()"\n                              type="number" class="input-sm" min="0" max="100" step="1" id="qHopSize" ng-model="selectedFieldConfig.hopSize">\n                      <div class="help-block">\n                        <div class="euiText">\n                          <p>Controls the number of terms returned each search step.</p>\n                        </div>\n\n                        <div class="hintbox">\n                          <span class="kuiIcon fa-info text-info"></span> Shift-clicking the field icons in the menu bar provides a quick way to toggle this number to zero and back\n                        </div>\n\n                      </div>\n                    </div>\n                  </div>\n\n                  <div class="form-group">\n                    <div class="col-sm-offset-4 col-sm-8">\n                      <div>\n                         <button\n                           ng-click="removeVertexFieldSelection()"\n                           class="kuiButton kuiButton--danger"\n                          >\n                            Remove\n                          </button>\n                       </div>\n                    </div>\n                  </div>\n\n                </form>\n\n              </div>\n\n\n      </div>\n\n      <div class="config-close remove" ng-click="kbnTopNav.close()">\n        <span class="kuiIcon fa-chevron-circle-up"></span>\n      </div>\n\n    </div>\n  </div>\n\n\n  <div id="GraphSvgContainer">\n    <svg width="100%" height="100%" pointer-events="all" id="graphSvg" ng-click="hideAllConfigPanels()">\n      <g id="svgRootGroup">\n        <g>\n          <line ng-repeat="edge in workspace.edges" class="edge" ng-attr-x1="{{edge.topSrc.kx}}" ng-attr-y1="{{edge.topSrc.ky}}" ng-attr-x2="{{edge.topTarget.kx}}" ng-attr-y2="{{edge.topTarget.ky}}" ng-click="clickEdge(edge)"\n          ng-class="{selectedEdge:edge.isSelected, inferredEdge:edge.inferred}" , ng-attr-style="stroke-width:{{edge.width}}px" stroke-linecap="round" />\n        </g>\n        <g ng-repeat="n in workspace.nodes" ng-if="!n.parent">\n          <circle class="nodeCircle" ng-attr-r="{{n.scaledSize}}" ng-attr-cx="{{n.kx}}" ng-attr-cy="{{n.ky}}" ng-click="nodeClick(n, $event)"\n           ng-class="{selectedNode:n.isSelected}"\n           ng-attr-style="fill:{{n.color}}"\n          />\n          <text class="SvgIconFont lowOpacitySvgText" transform="translate(0,5)" text-anchor="middle" ng-attr-x="{{n.kx}}" ng-attr-y="{{n.ky}}" ng-if="n.icon" ng-click="nodeClick(n, $event)">{{n.icon.code}}</text>\n\n          \x3c!-- Using 2 strategies for rendering labels - small text uses SVG for performance,\n            larger text uses HTML for word-wrapping capabilities but can be jittery.\n          --\x3e\n\n          <text ng-if="n.label.length<30" class="nodeSvgText" text-anchor="middle" transform="translate(0,22)" ng-attr-x="{{n.kx}}" ng-attr-y="{{n.ky}}" ng-click="nodeClick(n, $event)">\n            {{n.label}}\n          </text>\n          <foreignObject ng-if="n.label.length>=30" width="100" height="20" transform="translate(-50,15)" ng-attr-x="{{n.kx}}" ng-attr-y="{{n.ky}}"\n            ng-click="nodeClick(n, $event)">\n                <body xmlns="http://www.w3.org/1999/xhtml">\n                  <p class="nodeHtmlLabel noUserSelect">{{n.label}}</p>\n                </body>\n          </foreignObject>\n\n          <g ng-if="n.numChildren>0">\n            <circle r="5" class="nodeMarkerCircle" transform="translate(10,10)" ng-attr-cx="{{n.kx}}" ng-attr-cy="{{n.ky}}" ng-click="nodeClick(n, $event)" />\n            <text class="nodeMarkerText" text-anchor="middle" transform="translate(10,11)" ng-attr-x="{{n.kx}}" ng-attr-y="{{n.ky}}" ng-click="nodeClick(n, $event)">{{n.numChildren}}\n            </text>\n\n          </g>\n        </g>\n      </g>\n    </svg>\n\n    \x3c!--\n            Experiment with group/ungroup buttons that reveal-on-zoom on nodes.\n\n     <g ng-if="workspace.selectedNodes.length>1||(workspace.selectedNodes.length>0&&workspace.selectedNodes[0] !== n)">\n      <g ng-if="zoomLevel>10" transform="translate(-1,-7)">\n        <rect class="SvgZoomedIconButton" ng-attr-x="{{n.kx}}" ng-attr-y="{{n.ky}}" transform="translate(-1.5,-1.2)" ng-click="workspace.groupSelections(n)" width="6.5" height="2.2" rx="0.2" ry="0.2" />\n        <text class="SvgZoomedButtonText" transform="translate(3,0.3)" text-anchor="middle" ng-attr-x="{{n.kx}}" ng-attr-y="{{n.ky}}" ng-click="workspace.groupSelections(n)">group</text>\n        <text class="SvgZoomedIconButtonText" transform="translate(-0.2,0.6)" text-anchor="middle" ng-attr-x="{{n.kx}}" ng-attr-y="{{n.ky}}" ng-click="workspace.groupSelections(n)">&#xf247</text>\n      </g>\n    </g>\n    <g ng-if="zoomLevel>10" transform="translate(8,12.5)">\n      <rect class="SvgZoomedIconButton" ng-attr-x="{{n.kx}}" ng-attr-y="{{n.ky}}" transform="translate(-1.5,-1.2)" ng-click="workspace.ungroup(n)" width="7" height="2" rx="0.2" ry="0.2" />\n      <text class="SvgZoomedButtonText" transform="translate(3,0.3)" text-anchor="middle" ng-attr-x="{{n.kx}}" ng-attr-y="{{n.ky}}" ng-click="workspace.ungroup(n)">ungroup</text>\n      <text class="SvgZoomedIconButtonText" transform="translate(-0.4,0.6)" text-anchor="middle" ng-attr-x="{{n.kx}}" ng-attr-y="{{n.ky}}" ng-click="workspace.ungroup(n)">&#xf09c</text>\n    </g>\n\n  --\x3e\n\n    <div id="sidebar" ng-if="workspace !== null">\n      <div class="sidebarPanel">\n\n        <div class="vertexSelectionActionBar">\n          <button\n            class="kuiButton kuiButton--basic kuiButton--small"\n            tooltip="Undo"\n            type="button"\n            ng-click="workspace.undo()"\n            ng-disabled="workspace === null||workspace.undoLog.length <1"\n          >\n            <span class="kuiIcon fa-history"></span>\n          </button>\n\n          <button\n            class="kuiButton kuiButton--basic kuiButton--small"\n            tooltip="Redo"\n            type="button"\n            ng-disabled="workspace === null ||workspace.redoLog.length === 0" ng-click="workspace.redo()"\n          >\n            <span class="kuiIcon fa-repeat"></span>\n          </button>\n\n          <button\n            class="kuiButton kuiButton--basic kuiButton--small"\n            ng-disabled="workspace === null ||liveResponseFields.length === 0||workspace.nodes.length === 0"\n            tooltip="Expand selection"\n            ng-click="setDetail(null);workspace.expandSelecteds({toFields:liveResponseFields});"\n          >\n            <span class="kuiIcon fa-plus"></span>\n          </button>\n\n          <button\n            class="kuiButton kuiButton--basic kuiButton--small"\n            ng-disabled="workspace === null ||workspace.nodes.length === 0"\n            tooltip="Add links between existing terms"\n            ng-click="workspace.fillInGraph();"\n          >\n            <span class="kuiIcon fa-link"></span>\n          </button>\n\n          <button\n            class="kuiButton kuiButton--basic kuiButton--small"\n            ng-disabled="workspace === null ||workspace.nodes.length === 0"\n            tooltip="Remove vertices from workspace"\n            ng-click="setDetail(null);workspace.deleteSelection();"\n          >\n            <span class="kuiIcon fa-trash"></span>\n          </button>\n\n          <button\n            class="kuiButton kuiButton--basic kuiButton--small"\n            ng-disabled="workspace === null ||workspace.selectedNodes.length === 0"\n            tooltip="Blacklist selection from return to workspace"\n            ng-click="workspace.blacklistSelection();"\n            >\n              <span class="kuiIcon fa-ban"></span>\n          </button>\n\n          <button\n            class="kuiButton kuiButton--basic kuiButton--small"\n            ng-disabled="workspace === null ||workspace.selectedNodes.length === 0"\n            tooltip="Custom style selected vertices"\n            ng-click="setDetail({showStyle:true})"\n          >\n            <span class="kuiIcon fa-paint-brush"></span>\n          </button>\n\n          <button\n            class="kuiButton kuiButton--basic kuiButton--small"\n            ng-disabled="workspace === null||workspace.nodes.length === 0"\n            tooltip="Drill down"\n            ng-click="setDetail({showDrillDowns:true})"\n          >\n            <span class="kuiIcon fa-info"></span>\n          </button>\n\n          <button\n            class="kuiButton kuiButton--basic kuiButton--small"\n            ng-disabled="workspace.nodes.length === 0"\n            ng-if="workspace.nodes.length === 0||workspace.force === null"\n            tooltip="Run layout"\n            ng-click="workspace.runLayout()"\n          >\n            <span class="kuiIcon fa-play"></span>\n          </button>\n\n          <button\n            class="kuiButton kuiButton--basic kuiButton--small"\n            ng-if="workspace.force !== null&&workspace.nodes.length>0"\n            tooltip="Pause layout"\n            ng-click="workspace.stopLayout()"\n          >\n            <span class="kuiIcon fa-pause"></span>\n          </button>\n        </div>\n\n\n      <div>\n            <div class="detailHeader">\n              <span class="kuiIcon fa-shopping-cart"></span> Selections\n            </div>\n\n            <div id="vertexSelectionTypesBar">\n              <button\n                tooltip="Select all"\n                type="button"\n                class="kuiButton kuiButton--basic kuiButton--small selButton"\n                ng-disabled="workspace.nodes.length === 0"\n                ng-click="setDetail(null);workspace.selectAll()"\n              >\n                all\n              </button>\n\n              <button\n                tooltip="Select none"\n                type="button"\n                class="kuiButton kuiButton--basic kuiButton--small selButton"\n                ng-disabled="workspace.nodes.length === 0"\n                ng-click="setDetail(null);workspace.selectNone()"\n              >\n                none\n              </button>\n\n              <button\n                tooltip="Invert selection"\n                type="button"\n                class="kuiButton kuiButton--basic kuiButton--small selButton"\n                ng-disabled="workspace.nodes.length === 0"\n                ng-click="setDetail(null);workspace.selectInvert()"\n              >\n                invert\n              </button>\n\n              <button\n                tooltip="Select neighbours"\n                type="button"\n                class="kuiButton kuiButton--basic kuiButton--small selButton"\n                ng-disabled="workspace.selectedNodes.length === 0"\n                ng-click="setDetail(null);workspace.selectNeighbours()"\n              >\n                linked\n              </button>\n            </div>\n\n            <div class="selectionList">\n              <p ng-if="workspace.selectedNodes.length === 0" class="help-block">No selections. Click on vertices to add</p>\n\n              <div ng-repeat="n in workspace.selectedNodes" ng-class="{\'selectedFieldLine\': isSelectedSelected(n)}" ng-click="selectSelected(n)" style="line-height: 24px;">\n                <svg width="24" height="24">\n                  <circle class="nodeCircle " r="10" cx="12" cy="12" ng-class="{selectedNode:n.isSelected}"\n                  ng-attr-style="fill:{{n.color}}"\n                  ng-click="workspace.deselectNode(n)" />\n\n                  <text ng-if="n.icon" class="SvgIconFont" text-anchor="middle" x="12" y="16" ng-click="workspace.deselectNode(n)">{{n.icon.code}}</text>\n                </svg>\n                <span style="vertical-align: top;">{{n.label}}</span>\n                <span style="vertical-align: top;" ng-if="n.numChildren>0"> (+{{n.numChildren}})</span>\n\n              </div>\n            </div>\n        </div>\n\n        \x3c!-- Any drill-downs with a choice of button icon appear here for quick access --\x3e\n        <div ng-if="(urlTemplates | filter:{icon: {class:\'\'}}).length > 0" >\n          <button\n            ng-repeat="urlTemplate in urlTemplates  | filter:{icon: {class:\'\'}}"\n            class="kuiButton kuiButton--basic kuiButton--small selButton"\n            tooltip="{{urlTemplate.description}}"\n            type="button"\n            ng-disabled="workspace === null ||workspace.nodes.length === 0"\n            ng-click="openUrlTemplate(urlTemplate)"\n          >\n            <span class="kuiIcon" ng-class="urlTemplate.icon.class"></span>\n          </button>\n        </div>\n\n        <div ng-if="detail.showDrillDowns">\n          <div class="detailHeader">\n            <span class="kuiIcon fa-info"></span> Drill-downs\n          </div>\n\n          <div class="detailPanel">\n            <p ng-if="urlTemplates.length === 0" class="help-block">\n              Configure drill-downs from the settings menu\n            </p>\n\n            <ul ng-repeat="urlTemplate in urlTemplates" class="li-striped list-group list-group-menu">\n              <li class="list-group-item">\n                <span ng-if="urlTemplate.icon" class="kuiIcon icon noUserSelect">\n                                    {{urlTemplate.icon.code}}</span>\n                  <a ng-click="openUrlTemplate(urlTemplate)">{{urlTemplate.description}}</a>\n              </li>\n            </ul>\n          </div>\n        </div>\n\n        <div class="detailPanel" ng-if="(detail.showStyle)&&(workspace.selectedNodes.length>0)">\n          <div class="detailHeader">\n            <span class="kuiIcon fa-paint-brush"></span> Style selected vertices\n          </div>\n\n          <div class="form-group form-group-sm small-graph-form">\n            <div class="col-sm-10">\n              <span class="legend-value-container" >\n                <span class="legend-value-color-picker">\n                  <span ng-repeat="c in colors" ng-disabled="!selectedField.selected" ng-click="workspace.colorSelected(c)" ng-style="{color: c}" class="kuiIcon dot fa-circle">\n                        </span>\n                </span>\n              </span>\n            </div>\n          </div>\n        </div>\n\n        <div class="detailPanel" ng-if="detail.latestNodeSelection">\n          <div class="detailHeader">\n            <span class="kuiIcon {{detail.latestNodeSelection.icon.class}}" ng-if="detail.latestNodeSelection.icon"></span> {{detail.latestNodeSelection.data.field}} {{detail.latestNodeSelection.data.term}}\n          </div>\n\n          <button\n            class="kuiButton kuiButton--basic kuiButton--iconText kuiButton--small"\n            ng-if="workspace.selectedNodes.length>1||(workspace.selectedNodes.length>0&&workspace.selectedNodes[0] !== detail.latestNodeSelection)"\n            tooltip="group the currently selected items into {{detail.latestNodeSelection.label}}"\n            ng-click="workspace.groupSelections(detail.latestNodeSelection)"\n          >\n            <span class="kuiButton__icon kuiIcon fa-object-group"></span>\n            <span>group</span>\n          </button>\n\n          <button\n            class="kuiButton kuiButton--basic kuiButton--iconText kuiButton--small"\n            ng-if="detail.latestNodeSelection.numChildren>0"\n            tooltip="ungroup {{detail.latestNodeSelection.label}}"\n            ng-click="workspace.ungroup(detail.latestNodeSelection)"\n          >\n            <span class="kuiIcon fa-object-ungroup"></span>\n            <span>ungroup</span>\n          </button>\n\n          <form class="form-horizontal">\n            <div class="form-group form-group-sm small-graph-form">\n              <label for="labelEdit" class="col-sm-3 control-label">Display label</label>\n              <div class="col-sm-9">\n                <input type="text" id="labelEdit" class="form-control input-sm" ng-model="detail.latestNodeSelection.label">\n                <div class="help-block">Change the label for this vertex</div>\n              </div>\n            </div>\n          </form>\n        </div>\n\n        <div ng-if="detail.mergeCandidates.length>0" class="detailPanel">\n          <div class="detailHeader">\n            <span class="kuiIcon fa-link"></span> Link summary\n          </div>\n          <div ng-repeat="mc in detail.mergeCandidates">\n            <span>\n              <button\n                tooltip="Merge {{mc.term1}} into {{mc.term2}}"\n                type="button"\n                ng-attr-style="opacity:{{0.2+(mc.overlap/mc.v1)}};"\n                class="kuiButton kuiButton--basic kuiButton--small"\n                ng-click="performMerge(mc.id2, mc.id1)"\n              >\n                <span class="kuiIcon fa-chevron-circle-right"></span>\n              </button>\n\n              <span class="vennTerm1">{{mc.term1}}</span>\n              <span class="vennTerm2">{{mc.term2}}</span>\n\n              <button\n                tooltip="Merge {{mc.term2}} into {{mc.term1}}"\n                type="button"\n                class="kuiButton kuiButton--basic kuiButton--small"\n                ng-attr-style="opacity:{{0.2+(mc.overlap/mc.v2)}};"\n                ng-click="performMerge(mc.id1, mc.id2)"\n              >\n                <span class="kuiIcon fa-chevron-circle-left"></span>\n              </button>\n            </span>\n\n            \x3c!-- Venn diagram of term/shared doc intersections --\x3e\n            <div venn="mc"></div>\n\n            <small class="vennTerm1" tooltip="{{mc.v1}} documents have term {{mc.term1}}">{{mc.v1}}</small>\n            <small class="vennTerm12" tooltip="{{mc.overlap}} documents have both terms">&nbsp;({{mc.overlap}})&nbsp;</small>\n            <small class="vennTerm2" tooltip="{{mc.v2}} documents have term {{mc.term2}}">{{mc.v2}}</small>\n          </div>\n\n\n\n          <div class="detailPanel" ng-if="(detail.inferredEdge)">\n            <div class="detailHeader">\n              <span class="kuiIcon fa-cog"></span> Similar labels\n            </div>\n\n            <div class="form-group form-group-sm small-graph-form">\n                <div  style="line-height: 24px;">\n                  <button\n                    tooltip="Merge {{detail.inferredEdge.topTarget.label}} into {{detail.inferredEdge.topSrc.label}}"\n                    type="button"\n                    style="vertical-align: top;"\n                    class="kuiButton kuiButton--basic kuiButton--small"\n                    ng-click="performMerge(detail.inferredEdge.topTarget.id, detail.inferredEdge.topSrc.id)"\n                  >\n                    <span class="kui fa-chevron-circle-down"></span>\n                  </button>\n                  <svg width="24" height="24">\n                    <circle class="nodeCircle " r="10" cx="12" cy="12"\n                    ng-attr-style="fill:{{detail.inferredEdge.topSrc.color}}"/>\n\n                    <text ng-if="detail.inferredEdge.topSrc.icon" class="SvgIconFont" text-anchor="middle" x="12" y="16" >{{detail.inferredEdge.topSrc.icon.code}}</text>\n                  </svg>\n                  <span style="vertical-align: top;">{{detail.inferredEdge.topSrc.label}}</span>\n                </div>\n                <div  style="line-height: 24px;">\n                  <button\n                    tooltip="Merge {{detail.inferredEdge.topSrc.label}} into {{detail.inferredEdge.topTarget.label}}"\n                    type="button"\n                    style="vertical-align: top;"\n                    class="kuiButton kuiButton--basic kuiButton--small"\n                    ng-click="performMerge(detail.inferredEdge.topSrc.id, detail.inferredEdge.topTarget.id)"\n                  >\n                    <span class="kuiIcon fa-chevron-circle-up"></span>\n                  </button>\n\n                  <svg width="24" height="24">\n                    <circle class="nodeCircle " r="10" cx="12" cy="12"\n                    ng-attr-style="fill:{{detail.inferredEdge.topTarget.color}}"/>\n\n                    <text ng-if="detail.inferredEdge.topTarget.icon" class="SvgIconFont" text-anchor="middle" x="12" y="16" >{{detail.inferredEdge.topTarget.icon.code}}</text>\n                  </svg>\n                  <span style="vertical-align: top;">{{detail.inferredEdge.topTarget.label}}</span>\n\n                </div>\n\n              <div class="col-sm-10">\n                Key terms: <small> {{detail.inferredEdge.label}}\n              </div>\n            </div>\n          </div>\n        </div>\n        \x3c!-- end edge-merge detail panel --\x3e\n\n      </div>\n\n\n\n    </div>\n    \x3c!-- end sidebarPanel --\x3e\n\n  </div>\n  \x3c!--end svg container--\x3e\n\n</div>\n'},4177:function(module,exports,__webpack_require__){"use strict";var _d=__webpack_require__(18);_interopRequireDefault(_d);var _venn=__webpack_require__(1494);var _modules=__webpack_require__(2);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}_modules.uiModules.get("app/graph").directive("venn",function(){return{scope:{venn:"=",vennKey:"=?",vennKeySize:"=?",vennMap:"=?"},restrict:"AE",controller:function controller($scope,$element){$scope.$watch("venn",function(){var element=$element[0];while(element.firstChild)element.removeChild(element.firstChild);var params=$scope.venn;if(!params)return;var height=params.height?params.height:"50px";var width=params.width?params.width:"200px";var v1=params.v1?params.v1:10;var v2=params.v2?params.v2:10;var overlap=params.overlap?params.overlap:5;var v1Class=params.v1Class?params.v1Class:"venn1";var v2Class=params.v2Class?params.v2Class:"venn2";var r1=Math.sqrt(v1/Math.PI);var r2=Math.sqrt(v2/Math.PI);var maxR=Math.max(r1,r2);var x1=r1;var y1=maxR;var x2=x1+(0,_venn.distanceFromIntersectArea)(r1,r2,overlap);var y2=maxR;var imageWidth=4*maxR;var blankRight=imageWidth-(x2+r2);x1+=blankRight/2;x2+=blankRight/2;var viewBoxDims="0 0 "+imageWidth+" "+2*maxR;var svg=document.createElementNS("http://www.w3.org/2000/svg","svg");svg.setAttribute("width",width);svg.setAttribute("height",height);svg.setAttribute("viewBox",viewBoxDims);var g=document.createElementNS("http://www.w3.org/2000/svg","g");var circle1=document.createElementNS("http://www.w3.org/2000/svg","ellipse");circle1.setAttribute("cx",x1);circle1.setAttribute("cy",y1);circle1.setAttribute("rx",r1);circle1.setAttribute("ry",r1);circle1.setAttribute("class",v1Class);g.appendChild(circle1);var circle2=document.createElementNS("http://www.w3.org/2000/svg","ellipse");circle2.setAttribute("cx",x2);circle2.setAttribute("cy",y2);circle2.setAttribute("rx",r2);circle2.setAttribute("ry",r2);circle2.setAttribute("class",v2Class);g.appendChild(circle2);svg.appendChild(g);element.appendChild(svg)},true)}}})},4178:function(module,exports,__webpack_require__){"use strict";var d3=__webpack_require__(18);module.exports=function(){var graphExplorer=function graphExplorer(indexName,typeName,request,responseHandler){var dataForServer=JSON.stringify(request);$.ajax({type:"POST",url:"http://localhost:9200/"+indexName+"/_xpack/graph/_explore",dataType:"json",contentType:"application/json;charset=utf-8",async:true,data:dataForServer,success:function success(data){responseHandler(data)}})};var searcher=function searcher(indexName,request,responseHandler){var dataForServer=JSON.stringify(request);$.ajax({type:"POST",url:"http://localhost:9200/"+indexName+"/_search",dataType:"json",contentType:"application/json;charset=utf-8",async:true,data:dataForServer,success:function success(data){responseHandler(data)}})};function AddNodeOperation(node,owner){var self=this;var vm=owner;self.node=node;self.undo=function(){vm.arrRemove(vm.nodes,self.node);vm.arrRemove(vm.selectedNodes,self.node);self.node.isSelected=false;delete vm.nodesMap[self.node.id]};self.redo=function(){vm.nodes.push(self.node);vm.nodesMap[self.node.id]=self.node}}function AddEdgeOperation(edge,owner){var self=this;var vm=owner;self.edge=edge;self.undo=function(){vm.arrRemove(vm.edges,self.edge);delete vm.edgesMap[self.edge.id]};self.redo=function(){vm.edges.push(self.edge);vm.edgesMap[self.edge.id]=self.edge}}function ReverseOperation(operation){var self=this;var reverseOperation=operation;self.undo=reverseOperation.redo;self.redo=reverseOperation.undo}function GroupOperation(receiver,orphan,vm){var self=this;self.receiver=receiver;self.orphan=orphan;self.undo=function(){self.orphan.parent=void 0};self.redo=function(){self.orphan.parent=self.receiver}}function UnGroupOperation(parent,child,vm){var self=this;self.parent=parent;self.child=child;self.undo=function(){self.child.parent=self.parent};self.redo=function(){self.child.parent=void 0}}function createWorkspace(options){return new GraphWorkspace(options)}function GraphWorkspace(options){var self=this;this.blacklistedNodes=[];this.options=options;this.undoLog=[];this.redoLog=[];this.selectedNodes=[];options||(this.options={});this.nodesMap={};this.edgesMap={};this.searchTerm="";this.seqNumber=0;this.nodes=[];this.edges=[];this.lastRequest=null;this.lastResponse=null;this.changeHandler=options.changeHandler;options.graphExploreProxy&&(graphExplorer=options.graphExploreProxy);options.searchProxy&&(searcher=options.searchProxy);this.addUndoLogEntry=function(undoOperations){self.undoLog.push(undoOperations);self.undoLog.length>50&&self.undoLog.splice(0,1);self.redoLog=[]};this.undo=function(){var lastOps=this.undoLog.pop();if(lastOps){this.stopLayout();this.redoLog.push(lastOps);for(var i in lastOps)lastOps[i].undo();this.runLayout()}};this.redo=function(){var lastOps=this.redoLog.pop();if(lastOps){this.stopLayout();this.undoLog.push(lastOps);for(var i in lastOps)lastOps[i].redo();this.runLayout()}};this.areLinked=function(a,b){if(a==b)return true;var allEdges=this.edges;for(var e in allEdges){if(e.source==a&&e.target==b)return true;if(e.source==b&&e.target==a)return true}return false};this.selectAll=function(){self.selectedNodes=[];for(var n in self.nodes){var node=self.nodes[n];if(void 0==node.parent){node.isSelected=true;self.selectedNodes.push(node)}else node.isSelected=false}};this.selectNone=function(){self.selectedNodes=[];for(var n in self.nodes){var node=self.nodes[n];node.isSelected=false}};this.selectInvert=function(){self.selectedNodes=[];for(var n in self.nodes){var node=self.nodes[n];if(void 0!=node.parent)continue;node.isSelected=!node.isSelected;node.isSelected&&self.selectedNodes.push(node)}};this.selectNodes=function(nodes){for(var n in nodes){var node=nodes[n];node.isSelected=true;self.selectedNodes.indexOf(node)<0&&self.selectedNodes.push(node)}};this.selectNode=function(node){node.isSelected=true;self.selectedNodes.indexOf(node)<0&&self.selectedNodes.push(node)};this.deleteSelection=function(){var allAndGrouped=self.returnUnpackedGroupeds(self.selectedNodes);0==allAndGrouped.length&&(allAndGrouped=self.nodes.slice(0));var undoOperations=[];for(var i in allAndGrouped){var node=allAndGrouped[i];node.isSelected=false;delete self.nodesMap[node.id];undoOperations.push(new ReverseOperation(new AddNodeOperation(node,self)))}self.arrRemoveAll(self.nodes,allAndGrouped);self.arrRemoveAll(self.selectedNodes,allAndGrouped);var danglingEdges=self.edges.filter(function(edge){return self.nodes.indexOf(edge.source)<0||self.nodes.indexOf(edge.target)<0});for(var _i in danglingEdges){var edge=danglingEdges[_i];delete self.edgesMap[edge.id];undoOperations.push(new ReverseOperation(new AddEdgeOperation(edge,self)))}self.addUndoLogEntry(undoOperations);self.arrRemoveAll(self.edges,danglingEdges);self.runLayout()};this.selectNeighbours=function(){var newSelections=[];for(var n in self.edges){var edge=self.edges[n];edge.topSrc.isSelected||self.selectedNodes.indexOf(edge.topTarget)>=0&&newSelections.indexOf(edge.topSrc)<0&&newSelections.push(edge.topSrc);edge.topTarget.isSelected||self.selectedNodes.indexOf(edge.topSrc)>=0&&newSelections.indexOf(edge.topTarget)<0&&newSelections.push(edge.topTarget)}for(var i in newSelections){var newlySelectedNode=newSelections[i];self.selectedNodes.push(newlySelectedNode);newlySelectedNode.isSelected=true}};this.selectNone=function(){for(var n in self.selectedNodes)self.selectedNodes[n].isSelected=false;self.selectedNodes=[]};this.deselectNode=function(node){node.isSelected=false;self.arrRemove(self.selectedNodes,node)};this.getAllSelectedNodes=function(){return this.returnUnpackedGroupeds(self.selectedNodes)};this.colorSelected=function(colorNum){var selections=self.getAllSelectedNodes();for(var i in selections)selections[i].color=colorNum};this.getSelectionsThatAreGrouped=function(){var result=[];var selections=self.selectedNodes;for(var i in selections){var node=selections[i];node.numChildren>0&&result.push(node)}return result};this.ungroupSelection=function(){var selections=self.getSelectionsThatAreGrouped();for(var i in selections){var node=selections[i];self.ungroup(node)}};this.toggleNodeSelection=function(node){if(node.isSelected)self.deselectNode(node);else{node.isSelected=true;self.selectedNodes.push(node)}return node.isSelected};this.returnUnpackedGroupeds=function(topLevelNodeArray){var result=topLevelNodeArray.slice();var edges=this.edges;for(var i=0;i<edges.length;i++){var edge=edges[i];var topLevelSource=edge.topSrc;var topLevelTarget=edge.topTarget;if(result.indexOf(topLevelTarget)>=0){var target=edge.target;while(void 0!=target.parent){result.indexOf(target)<0&&result.push(target);target=target.parent}}if(result.indexOf(topLevelSource)>=0){var source=edge.source;while(void 0!=source.parent){result.indexOf(source)<0&&result.push(source);source=source.parent}}}return result};this.clearGraph=function(){this.stopLayout();this.nodes=[];this.edges=[];this.undoLog=[];this.redoLog=[];this.nodesMap={};this.edgesMap={};this.blacklistedNodes=[];this.selectedNodes=[];this.lastResponse=null};this.arrRemoveAll=function remove(arr,items){for(var i=items.length;i--;)self.arrRemove(arr,items[i])};this.arrRemove=function remove(arr,item){for(var i=arr.length;i--;)arr[i]===item&&arr.splice(i,1)};this.getNeighbours=function(node){var neighbourNodes=[];for(var e in self.edges){var edge=self.edges[e];if(edge.topSrc==edge.topTarget)continue;edge.topSrc==node&&neighbourNodes.indexOf(edge.topTarget)<0&&neighbourNodes.push(edge.topTarget);edge.topTarget==node&&neighbourNodes.indexOf(edge.topSrc)<0&&neighbourNodes.push(edge.topSrc)}return neighbourNodes};this.buildNodeQuery=function(topLevelNode){var containedNodes=[topLevelNode];containedNodes=self.returnUnpackedGroupeds(containedNodes);if(1==containedNodes.length){var tq={};tq[topLevelNode.data.field]=topLevelNode.data.term;return{term:tq}}var termsByField={};for(var i in containedNodes){var node=containedNodes[i];var termsList=termsByField[node.data.field];if(!termsList){termsList=[];termsByField[node.data.field]=termsList}termsList.push(node.data.term)}if(1==Object.keys(termsByField).length)return{terms:termsByField};var q={bool:{should:[]}};for(var field in termsByField){var _tq={};_tq[field]=termsByField[field];q.bool.should.push({terms:_tq})}return q};this.stopLayout=function(){this.force&&this.force.stop();this.force=null};this.runLayout=function(){this.stopLayout();var effectiveEdges=[];var edges=self.edges;for(var e in edges){var edge=edges[e];var topSrc=edge.source;var topTarget=edge.target;while(void 0!=topSrc.parent)topSrc=topSrc.parent;while(void 0!=topTarget.parent)topTarget=topTarget.parent;edge.topSrc=topSrc;edge.topTarget=topTarget;topSrc!=topTarget&&effectiveEdges.push({source:topSrc,target:topTarget})}var visibleNodes=self.nodes.filter(function(n){return void 0==n.parent});var allNodes=self.nodes;for(var n in allNodes){var node=allNodes[n];node.numChildren=0}for(var _n in allNodes){var _node=allNodes[_n];while(void 0!=_node.parent){_node=_node.parent;_node.numChildren=_node.numChildren+1}}this.force=d3.layout.force().nodes(visibleNodes).links(effectiveEdges).friction(.8).linkDistance(100).charge(-1500).gravity(.15).theta(.99).alpha(.5).size([800,600]).on("tick",function(e){var nodeArray=self.nodes;var hasRollups=false;for(var i in nodeArray){var _n2=nodeArray[i];if(void 0==_n2.parent){_n2.kx=_n2.x;_n2.ky=_n2.y}else hasRollups=true}if(hasRollups)for(var _i2 in nodeArray){var _n3=nodeArray[_i2];if(void 0!=_n3.parent){var topLevelNode=_n3.parent;while(void 0!=topLevelNode.parent)topLevelNode=topLevelNode.parent;_n3.kx=topLevelNode.x;_n3.ky=topLevelNode.y}}self.changeHandler&&self.changeHandler()});this.force.start()};this.groupSelections=function(node){var ops=[];self.nodes.forEach(function(otherNode){if(otherNode!=node&&otherNode.isSelected&&void 0==otherNode.parent){otherNode.parent=node;otherNode.isSelected=false;self.arrRemove(self.selectedNodes,otherNode);ops.push(new GroupOperation(node,otherNode,self))}});self.selectNone();self.selectNode(node);self.addUndoLogEntry(ops);self.runLayout()};this.mergeNeighbours=function(node){var neighbours=self.getNeighbours(node);var ops=[];neighbours.forEach(function(otherNode){if(otherNode!=node&&void 0==otherNode.parent){otherNode.parent=node;otherNode.isSelected=false;self.arrRemove(self.selectedNodes,otherNode);ops.push(new GroupOperation(node,otherNode,self))}});self.addUndoLogEntry(ops);self.runLayout()};this.mergeSelections=function(targetNode){if(!targetNode){console.log("Error - merge called on undefined target");return}var selClone=self.selectedNodes.slice();var ops=[];selClone.forEach(function(otherNode){if(otherNode!=targetNode&&void 0==otherNode.parent){otherNode.parent=targetNode;otherNode.isSelected=false;self.arrRemove(self.selectedNodes,otherNode);ops.push(new GroupOperation(targetNode,otherNode,self))}});self.addUndoLogEntry(ops);self.runLayout()};this.ungroup=function(node){var ops=[];self.nodes.forEach(function(other){if(other.parent==node){other.parent=void 0;ops.push(new UnGroupOperation(node,other,self))}});self.addUndoLogEntry(ops);self.runLayout()};this.unblacklist=function(node){self.arrRemove(self.blacklistedNodes,node)};this.blacklistSelection=function(){var selection=self.getAllSelectedNodes();var danglingEdges=[];self.edges.forEach(function(edge){if(selection.indexOf(edge.source)>=0||selection.indexOf(edge.target)>=0){delete self.edgesMap[edge.id];danglingEdges.push(edge)}});for(var n in selection){var node=selection[n];delete self.nodesMap[node.id];self.blacklistedNodes.push(node);node.isSelected=false}self.arrRemoveAll(self.nodes,selection);self.arrRemoveAll(self.edges,danglingEdges);self.selectedNodes=[];self.runLayout()};this.simpleSearch=function(searchTerm,fieldsChoice,numHops){var qs={query_string:{query:searchTerm}};return this.search(qs,fieldsChoice,numHops)};this.search=function(query,fieldsChoice,numHops){fieldsChoice||(fieldsChoice=self.options.vertex_fields);var step={};var excludeNodesByField={};var nots=[];var avoidNodes=this.blacklistedNodes;for(var i=0;i<avoidNodes.length;i++){var n=avoidNodes[i];var arr=excludeNodesByField[n.data.field];if(!arr){arr=[];excludeNodesByField[n.data.field]=arr}arr.push(n.data.term);var tq={};tq[n.data.field]=n.data.term;nots.push({term:tq})}var rootStep=step;for(var hopNum=0;hopNum<numHops;hopNum++){var _arr=[];for(var f in fieldsChoice){var field=fieldsChoice[f].name;var hopSize=fieldsChoice[f].hopSize;var excludes=excludeNodesByField[field];var stepField={field:field,size:hopSize,min_doc_count:parseInt(self.options.exploreControls.minDocCount)};excludes&&(stepField.exclude=excludes);_arr.push(stepField)}step.vertices=_arr;if(hopNum<numHops-1){var nextStep={};step.connections=nextStep;step=nextStep}}nots.length>0&&(query={bool:{must:[query],must_not:nots}});var request={query:query,controls:self.buildControls(),connections:rootStep.connections,vertices:rootStep.vertices};self.callElasticsearch(request)};this.buildControls=function(){var guiSettingsObj=self.options.exploreControls;var controls={use_significance:guiSettingsObj.useSignificance,sample_size:guiSettingsObj.sampleSize,timeout:parseInt(guiSettingsObj.timeoutMillis)};null!=guiSettingsObj.sampleDiversityField&&(controls.sample_diversity={field:guiSettingsObj.sampleDiversityField.name,max_docs_per_value:guiSettingsObj.maxValuesPerDoc});return controls};this.makeNodeId=function(field,term){return field+".."+term};this.makeEdgeId=function(srcId,targetId){var id=srcId+"->"+targetId;srcId>targetId&&(id=targetId+"->"+srcId);return id};this.mergeGraph=function(newData){this.stopLayout();newData.nodes||(newData.nodes=[]);var lastOps=[];var dedupedNodes=[];for(var o in newData.nodes){var node=newData.nodes[o];node.id=self.makeNodeId(node.field,node.term);if(!this.nodesMap[node.id]){node.label||(node.label=node.term);dedupedNodes.push(node)}}dedupedNodes.length>0&&this.options.nodeLabeller&&this.options.nodeLabeller(dedupedNodes);for(var _o in dedupedNodes){var dedupedNode=dedupedNodes[_o];var label=dedupedNode.term;dedupedNode.label&&(label=dedupedNode.label);var _node2={x:1,y:1,numChildren:0,parent:void 0,isSelected:false,id:dedupedNode.id,label:label,color:dedupedNode.color,icon:dedupedNode.icon,data:dedupedNode};_node2.scaledSize=15;_node2.seqNumber=this.seqNumber++;this.nodes.push(_node2);lastOps.push(new AddNodeOperation(_node2,self));this.nodesMap[_node2.id]=_node2}for(var _o2 in newData.edges){var edge=newData.edges[_o2];var src=newData.nodes[edge.source];var target=newData.nodes[edge.target];edge.id=this.makeEdgeId(src.id,target.id);var srcWrapperObj=this.nodesMap[src.id];var targetWrapperObj=this.nodesMap[target.id];var existingEdge=this.edgesMap[edge.id];if(existingEdge){existingEdge.weight=Math.max(existingEdge.weight,edge.weight);existingEdge.doc_count=Math.max(existingEdge.doc_count,edge.doc_count);continue}var inferred=!!edge.inferred;var newEdge={source:srcWrapperObj,target:targetWrapperObj,weight:edge.weight,width:edge.width,id:edge.id,doc_count:edge.doc_count,inferred:inferred};edge.label&&(newEdge.label=edge.label);this.edgesMap[newEdge.id]=newEdge;this.edges.push(newEdge);lastOps.push(new AddEdgeOperation(newEdge,self))}lastOps.length>0&&self.addUndoLogEntry(lastOps);this.runLayout()};this.mergeIds=function(parentId,childId){var parent=self.getNode(parentId);var child=self.getNode(childId);if(child.isSelected){child.isSelected=false;self.arrRemove(self.selectedNodes,child)}child.parent=parent;self.addUndoLogEntry([new GroupOperation(parent,child,self)]);self.runLayout()};this.getNode=function(nodeId){return this.nodesMap[nodeId]};this.getEdge=function(edgeId){return this.edgesMap[edgeId]};this.expandSelecteds=function(){var targetOptions=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};var startNodes=self.getAllSelectedNodes();0==startNodes.length&&(startNodes=self.nodes);var clone=startNodes.slice();self.expand(clone,targetOptions)};this.expandGraph=function(){self.expandSelecteds()};this.expandNode=function(node){self.expand(self.returnUnpackedGroupeds([node]),{})};this.expand=function(startNodes,targetOptions){var nodesByField={};var excludeNodesByField={};var avoidNodes=this.blacklistedNodes;for(var i=0;i<avoidNodes.length;i++){var n=avoidNodes[i];var arr=excludeNodesByField[n.data.field];if(!arr){arr=[];excludeNodesByField[n.data.field]=arr}arr.indexOf(n.data.term)<0&&arr.push(n.data.term)}var allExistingNodes=this.nodes;for(var _i3=0;_i3<allExistingNodes.length;_i3++){var _n4=allExistingNodes[_i3];var _arr2=excludeNodesByField[_n4.data.field];if(!_arr2){_arr2=[];excludeNodesByField[_n4.data.field]=_arr2}_arr2.push(_n4.data.term)}for(var _i4=0;_i4<startNodes.length;_i4++){var _n5=startNodes[_i4];var _arr3=nodesByField[_n5.data.field];if(!_arr3){_arr3=[];nodesByField[_n5.data.field]=_arr3}_arr3.push({term:_n5.data.term,boost:_n5.data.weight});_arr3=excludeNodesByField[_n5.data.field];if(!_arr3){_arr3=[];excludeNodesByField[_n5.data.field]=_arr3}_arr3.indexOf(_n5.data.term)<0&&_arr3.push(_n5.data.term)}var primaryVertices=[];var secondaryVertices=[];for(var fieldName in nodesByField)primaryVertices.push({field:fieldName,include:nodesByField[fieldName],min_doc_count:parseInt(self.options.exploreControls.minDocCount)});var targetFields=this.options.vertex_fields;targetOptions.toFields&&(targetFields=targetOptions.toFields);for(var f in targetFields){var _fieldName=targetFields[f].name;var hopSize=targetFields[f].hopSize>0?targetFields[f].hopSize:targetFields[f].lastValidHopSize;var fieldHop={field:_fieldName,size:hopSize,min_doc_count:parseInt(self.options.exploreControls.minDocCount)};fieldHop.exclude=excludeNodesByField[_fieldName];secondaryVertices.push(fieldHop)}var request={controls:self.buildControls(),vertices:primaryVertices,connections:{vertices:secondaryVertices}};self.lastRequest=JSON.stringify(request,null,"\t");graphExplorer(self.options.indexName,request,function(data){self.lastResponse=JSON.stringify(data,null,"\t");var edges=[];for(var _n6 in data.vertices){var node=data.vertices[_n6];for(var _f in targetFields){var fieldDef=targetFields[_f];if(node.field==fieldDef.name){node.color=fieldDef.color;node.icon=fieldDef.icon;node.fieldDef=fieldDef;break}}}var minLineSize=2;var maxLineSize=10;var maxEdgeWeight=1e-8;for(var e in data.connections){var edge=data.connections[e];maxEdgeWeight=Math.max(maxEdgeWeight,edge.weight)}for(var _e in data.connections){var _edge=data.connections[_e];edges.push({source:_edge.source,target:_edge.target,doc_count:_edge.doc_count,weight:_edge.weight,width:Math.max(minLineSize,_edge.weight/maxEdgeWeight*maxLineSize)})}self.mergeGraph({nodes:data.vertices,edges:edges})})};this.trimExcessNewEdges=function(newNodes,newEdges){var trimmedEdges=[];var maxNumEdgesToReturn=5;for(var o in newEdges){var edge=newEdges[o];var src=newNodes[edge.source];var target=newNodes[edge.target];var srcId=src.field+".."+src.term;var targetId=target.field+".."+target.term;var id=this.makeEdgeId(srcId,targetId);var existingSrcNode=self.nodesMap[srcId];var existingTargetNode=self.nodesMap[targetId];if(null==existingSrcNode||null==existingTargetNode){console.log("Error? Missing nodes "+srcId+" or "+targetId,self.nodesMap);continue}if(void 0!=existingSrcNode.parent&&void 0!=existingTargetNode.parent)continue;var existingEdge=self.edgesMap[id];if(existingEdge){existingEdge.weight=Math.max(existingEdge.weight,edge.weight);existingEdge.doc_count=Math.max(existingEdge.doc_count,edge.doc_count);continue}trimmedEdges.push(edge)}if(trimmedEdges.length>maxNumEdgesToReturn){trimmedEdges.sort(function(a,b){return b.weight-a.weight});trimmedEdges=trimmedEdges.splice(0,maxNumEdgesToReturn)}return trimmedEdges};this.getQuery=function(startNodes,loose){var shoulds=[];var nodes=startNodes;startNodes||(nodes=self.nodes);for(var bs in nodes){var node=nodes[bs];void 0==node.parent&&shoulds.push(self.buildNodeQuery(node))}return{bool:{should:shoulds,minimum_should_match:Math.min(shoulds.length,loose?1:2)}}};this.getSelectedOrAllNodes=function(){var startNodes=self.getAllSelectedNodes();0===startNodes.length&&(startNodes=self.nodes);return startNodes};this.getSelectedOrAllTopNodes=function(){return self.getSelectedOrAllNodes().filter(function(node){return void 0===node.parent})};function addTermToFieldList(map,field,term){var arr=map[field];if(!arr){arr=[];map[field]=arr}arr.push(term)}this.fillInGraph=function(){var nodesForLinking=self.getSelectedOrAllTopNodes();var maxNewEdges=10;var maxNumVerticesSearchable=100;if(nodesForLinking.length>maxNumVerticesSearchable){for(var i=0;i<maxNumVerticesSearchable;i++){var oldNode=nodesForLinking[i];var randomIndex=Math.floor(Math.random()*(nodesForLinking.length-i))+i;nodesForLinking[i]=nodesForLinking[randomIndex];nodesForLinking[randomIndex]=oldNode}nodesForLinking=nodesForLinking.slice(0,maxNumVerticesSearchable-1)}var shoulds=[];var filterMap={};nodesForLinking.forEach(function(node,nodeNum){var nodeQuery=self.buildNodeQuery(node);shoulds.push(nodeQuery);filterMap[nodeNum]=nodeQuery});var searchReq={size:0,query:{bool:{minimum_should_match:2,should:shoulds}},aggs:{matrix:{adjacency_matrix:{separator:"|",filters:filterMap}}}};searcher(self.options.indexName,searchReq,function(data){var numDocsMatched=data.hits.total;var buckets=data.aggregations.matrix.buckets;var vertices=nodesForLinking.map(function(existingNode){return{field:existingNode.data.field,term:existingNode.data.term,weight:1,depth:0}});var connections=[];var maxEdgeWeight=0;var keyedBuckets={};buckets.forEach(function(bucket){keyedBuckets[bucket.key]=bucket});buckets.forEach(function(bucket){var ids=bucket.key.split("|");if(2===ids.length){if(self.options.exploreControls.useSignificance){var t1=keyedBuckets[ids[0]].doc_count;var t2=keyedBuckets[ids[1]].doc_count;var t1AndT2=bucket.doc_count;bucket.weight=self.JLHScore(t1AndT2,Math.max(t1,t2),Math.min(t1,t2),numDocsMatched)}else bucket.weight=bucket.doc_count;maxEdgeWeight=Math.max(maxEdgeWeight,bucket.weight)}});var backFilledMinLineSize=2;var backFilledMaxLineSize=5;buckets.forEach(function(bucket){if(bucket.doc_count<parseInt(self.options.exploreControls.minDocCount))return;var ids=bucket.key.split("|");if(2==ids.length){var srcNode=nodesForLinking[ids[0]];var targetNode=nodesForLinking[ids[1]];var edgeId=self.makeEdgeId(srcNode.id,targetNode.id);var existingEdge=self.edgesMap[edgeId];existingEdge?existingEdge.doc_count=Math.max(existingEdge.doc_count,bucket.doc_count):connections.push({source:parseInt(ids[0]),target:parseInt(ids[1]),weight:bucket.weight,width:Math.max(backFilledMinLineSize,bucket.weight/maxEdgeWeight*backFilledMaxLineSize),doc_count:bucket.doc_count})}});if(connections.length>maxNewEdges){connections=connections.sort(function(a,b){return b.weight-a.weight});connections=connections.slice(0,maxNewEdges)}self.mergeGraph({nodes:vertices,edges:connections})})};this.getLikeThisButNotThisQuery=function(startNodes){var likeQueries=[];var txtsByFieldType={};startNodes.forEach(function(node){var txt=txtsByFieldType[node.data.field];txt=txt?txt+" "+node.label:node.label;txtsByFieldType[node.data.field]=txt});for(var field in txtsByFieldType)likeQueries.push({more_like_this:{like:txtsByFieldType[field],min_term_freq:1,minimum_should_match:"20%",min_doc_freq:1,boost_terms:2,max_query_terms:25}});var excludeNodesByField={};var allExistingNodes=self.nodes;allExistingNodes.forEach(function(existingNode){addTermToFieldList(excludeNodesByField,existingNode.data.field,existingNode.data.term)});var blacklistedNodes=self.blacklistedNodes;blacklistedNodes.forEach(function(blacklistedNode){addTermToFieldList(excludeNodesByField,blacklistedNode.data.field,blacklistedNode.data.term)});var notExistingNodes=[];Object.keys(excludeNodesByField).forEach(function(fieldName){var termsQuery={};termsQuery[fieldName]=excludeNodesByField[fieldName];notExistingNodes.push({terms:termsQuery})});var result={boosting:{negative_boost:1e-4,negative:{bool:{should:notExistingNodes}},positive:{bool:{should:likeQueries}}}};return result};this.getSelectedIntersections=function(callback){if(0==self.selectedNodes.length)return self.getAllIntersections(callback,self.nodes);if(1==self.selectedNodes.length){var selectedNode=self.selectedNodes[0];var neighbourNodes=self.getNeighbours(selectedNode);neighbourNodes.push(selectedNode);return self.getAllIntersections(callback,neighbourNodes)}return self.getAllIntersections(callback,self.getAllSelectedNodes())};this.JLHScore=function(subsetFreq,subsetSize,supersetFreq,supersetSize){var subsetProbability=subsetFreq/subsetSize;var supersetProbability=supersetFreq/supersetSize;var absoluteProbabilityChange=subsetProbability-supersetProbability;if(absoluteProbabilityChange<=0)return 0;var relativeProbabilityChange=subsetProbability/supersetProbability;return absoluteProbabilityChange*relativeProbabilityChange};this.getAllIntersections=function(callback,nodes){nodes=nodes.filter(function(n){return void 0==n.parent});var allQueries=nodes.map(function(node){return self.buildNodeQuery(node)});var allQuery={bool:{should:allQueries}};var request={query:allQuery,size:0,aggs:{all:{global:{}},sources:{filters:{filters:{}},aggs:{targets:{filters:{filters:{}}}}}}};for(var n in allQueries){request.aggs.sources.filters.filters["bg"+n]=allQueries[n];request.aggs.sources.aggs.targets.filters.filters["fg"+n]=allQueries[n]}JSON.stringify(request);searcher(self.options.indexName,request,function(data){var termIntersects=[];var fullDocCounts=[];var allDocCount=data.aggregations.all.doc_count;for(var _n7 in nodes)fullDocCounts.push(data.aggregations.sources.buckets["bg"+_n7].doc_count);for(var _n8 in nodes){var rootNode=nodes[_n8];var t1=fullDocCounts[_n8];var baseAgg=data.aggregations.sources.buckets["bg"+_n8].targets.buckets;for(var l in nodes){var t2=fullDocCounts[l];var leafNode=nodes[l];if(l==_n8)continue;if(t1>t2)continue;if(t1==t2&&rootNode.id>leafNode.id)continue;var t1AndT2=baseAgg["fg"+l].doc_count;if(0==t1AndT2)continue;var neighbourNode=nodes[l];var t1Label=rootNode.data.label;rootNode.numChildren>0&&(t1Label+="(+"+rootNode.numChildren+")");var t2Label=neighbourNode.data.label;neighbourNode.numChildren>0&&(t2Label+="(+"+neighbourNode.numChildren+")");var mergeConfidence=self.JLHScore(t1AndT2,t2,t1,allDocCount);var termIntersect={id1:rootNode.id,id2:neighbourNode.id,term1:t1Label,term2:t2Label,v1:t1,v2:t2,mergeLeftConfidence:t1AndT2/t1,mergeRightConfidence:t1AndT2/t2,mergeConfidence:mergeConfidence,overlap:t1AndT2};termIntersects.push(termIntersect)}}termIntersects.sort(function(a,b){if(b.mergeConfidence!=a.mergeConfidence)return b.mergeConfidence-a.mergeConfidence;if(b.overlap!=a.overlap)return b.overlap-a.overlap;return a.v2-b.v2});callback&&callback(termIntersects)})};this.callElasticsearch=function(request){self.lastRequest=JSON.stringify(request,null,"\t");graphExplorer(self.options.indexName,request,function(data){self.lastResponse=JSON.stringify(data,null,"\t");var edges=[];for(var n in data.vertices){var node=data.vertices[n];for(var f in self.options.vertex_fields){var fieldDef=self.options.vertex_fields[f];if(node.field==fieldDef.name){node.color=fieldDef.color;node.icon=fieldDef.icon;node.fieldDef=fieldDef;break}}}var minLineSize=2;var maxLineSize=10;var maxEdgeWeight=1e-8;for(var e in data.connections){var edge=data.connections[e];maxEdgeWeight=Math.max(maxEdgeWeight,edge.weight)}for(var _e2 in data.connections){var _edge2=data.connections[_e2];edges.push({source:_edge2.source,target:_edge2.target,doc_count:_edge2.doc_count,weight:_edge2.weight,width:Math.max(minLineSize,_edge2.weight/maxEdgeWeight*maxLineSize)})}self.mergeGraph({nodes:data.vertices,edges:edges},{labeller:self.options.labeller})})}}return{createWorkspace:createWorkspace}}()},4179:function(module,exports,__webpack_require__){"use strict";__webpack_require__(1494);module.exports=function(){function unwrapFieldNames(obj,path,fields){if(!obj.properties)return;for(var p in obj.properties){var child=obj.properties[p];if(child.properties){path.push(p);unwrapFieldNames(child,path,fields);path.pop()}else{var parentName="";for(var i in path){parentName+=path[i];parentName+="."}fields.push({name:parentName+p,path:path.slice(0),leafName:p});if(child.fields)for(var mfield in child.fields)fields.push({name:parentName+p+"."+mfield,path:path.slice(0),leafName:p})}}}function getMergeSuggestionObjects(termIntersects){var mergeCandidates=[];for(var i in termIntersects){var ti=termIntersects[i];mergeCandidates.push({id1:ti.id1,id2:ti.id2,term1:ti.term1,term2:ti.term2,v1:ti.v1,v2:ti.v2,overlap:ti.overlap,width:100,height:60})}return mergeCandidates}return{unwrapFieldNames:unwrapFieldNames,getMergeSuggestionObjects:getMergeSuggestionObjects}}()},4180:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.SavedWorkspacesProvider=SavedWorkspacesProvider;var _lodash=__webpack_require__(1);var _lodash2=_interopRequireDefault(_lodash);var _modules=__webpack_require__(2);var _chrome=__webpack_require__(8);var _chrome2=_interopRequireDefault(_chrome);var _saved_object_registry=__webpack_require__(293);var _saved_objects=__webpack_require__(56);var _saved_workspace=__webpack_require__(4181);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function SavedWorkspacesProvider(kbnUrl,Private,Promise){var savedObjectsClient=Private(_saved_objects.SavedObjectsClientProvider);var SavedWorkspace=Private(_saved_workspace.SavedWorkspaceProvider);this.type=SavedWorkspace.type;this.Class=SavedWorkspace;this.loaderProperties={name:"Graph workspace",noun:"Graph workspace",nouns:"Graph workspaces"};this.get=function(id){return new SavedWorkspace(id).init()};this.urlFor=function(id){return _chrome2.default.addBasePath(kbnUrl.eval("/app/graph#/workspace/{{id}}",{id:id}))};this.delete=function(ids){ids=_lodash2.default.isArray(ids)?ids:[ids];return Promise.map(ids,function(id){return new SavedWorkspace(id).delete()})};this.mapHits=function(hit){var source=hit.attributes;source.id=hit.id;source.url=this.urlFor(hit.id);source.icon="fa-share-alt";return source};this.find=function(searchString){var _this=this;var size=arguments.length>1&&void 0!==arguments[1]?arguments[1]:100;searchString?{query:{simple_query_string:{query:searchString+"*",fields:["title^3","description"],default_operator:"AND"}}}:{query:{match_all:{}}};return savedObjectsClient.find({type:SavedWorkspace.type,search:searchString?searchString+"*":void 0,perPage:size,searchFields:["title^3","description"]}).then(function(resp){return{total:resp.total,hits:resp.savedObjects.map(function(hit){return _this.mapHits(hit)})}})}}_modules.uiModules.get("app/graph").service("savedGraphWorkspaces",function(Private){return Private(SavedWorkspacesProvider)});_saved_object_registry.SavedObjectRegistryProvider.register(SavedWorkspacesProvider)},4181:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.SavedWorkspaceProvider=SavedWorkspaceProvider;var _modules=__webpack_require__(2);var _courier=__webpack_require__(97);function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}var _module=_modules.uiModules.get("app/dashboard");function SavedWorkspaceProvider(Private){var SavedObject=Private(_courier.SavedObjectProvider);var SavedWorkspace=function(_SavedObject){_inherits(SavedWorkspace,_SavedObject);function SavedWorkspace(id){_classCallCheck(this,SavedWorkspace);var _this=_possibleConstructorReturn(this,(SavedWorkspace.__proto__||Object.getPrototypeOf(SavedWorkspace)).call(this,{type:SavedWorkspace.type,mapping:SavedWorkspace.mapping,searchSource:SavedWorkspace.searchsource,id:id,defaults:{title:"New Graph Workspace",numLinks:0,numVertices:0,wsState:"{}",version:1}}));_this.getDisplayName=function(){return"graph workspace"};return _this}return SavedWorkspace}(SavedObject);SavedWorkspace.type="graph-workspace";SavedWorkspace.mapping={title:"text",description:"text",numLinks:"integer",numVertices:"integer",version:"integer",wsState:"json"};SavedWorkspace.searchsource=false;return SavedWorkspace}_module.factory("SavedGraphWorkspace",function(Private){return Private(SavedWorkspaceProvider)})},4182:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var iconChoices=exports.iconChoices=[{class:"fa-folder-open-o",code:"",patterns:[/category/i,/folder/i,/group/i]},{class:"fa-cube",code:"",patterns:[/prod/i,/sku/i]},{class:"fa-key",code:"",patterns:[/key/i]},{class:"fa-bank",code:"",patterns:[/bank/i,/account/i]},{class:"fa-automobile",code:"",patterns:[/car/i,/veh/i]},{class:"fa-home",code:"",patterns:[/address/i,/home/i]},{class:"fa-question",code:"",patterns:[/query/i,/search/i]},{class:"fa-plane",code:"",patterns:[/flight/i,/plane/i]},{class:"fa-file-o",code:"",patterns:[/file/i,/doc/i]},{class:"fa-user",code:"",patterns:[/user/i,/person/i,/people/i,/owner/i,/cust/i,/participant/i,/party/i,/member/i]},{class:"fa-users",code:"",patterns:[/group/i,/team/i,/meeting/i]},{class:"fa-music",code:"",patterns:[/artist/i,/sound/i,/music/i]},{class:"fa-flag",code:"",patterns:[/country/i,/warn/i,/flag/i]},{class:"fa-tag",code:"",patterns:[/tag/i,/label/i]},{class:"fa-phone",code:"",patterns:[/phone/i]},{class:"fa-desktop",code:"",patterns:[/host/i,/server/i]},{class:"fa-font",code:"",patterns:[/text/i,/title/i,/body/i,/desc/i]},{class:"fa-at",code:"",patterns:[/account/i,/email/i]},{class:"fa-heart",code:"",patterns:[/like/i,/favourite/i,/favorite/i]},{class:"fa-bolt",code:"",patterns:[/action/i]},{class:"fa-map-marker",code:"",patterns:[/location/i,/geo/i,/position/i]},{class:"fa-exclamation",code:"",patterns:[/risk/i,/error/i,/warn/i]},{class:"fa-industry",code:"",patterns:[/business/i,/company/i,/industry/i,/organisation/i]}];var iconChoicesByClass=exports.iconChoicesByClass={};iconChoices.forEach(function(icon){iconChoicesByClass[icon.class]=icon});var drillDownIconChoices=exports.drillDownIconChoices=[{class:"fa-line-chart",code:""},{class:"fa-pie-chart",code:""},{class:"fa-area-chart",code:""},{class:"fa-bar-chart",code:""},{class:"fa-globe",code:""},{class:"fa-file-text-o",code:""},{class:"fa-google",code:""},{class:"fa-eye",code:""},{class:"fa-tachometer",code:""},{class:"fa-info",code:""},{class:"fa-external-link",code:""},{class:"fa-table",code:""},{class:"fa-list",code:""},{class:"fa-share-alt",code:""}];var drillDownIconChoicesByClass=exports.drillDownIconChoicesByClass={};drillDownIconChoices.forEach(function(icon){drillDownIconChoicesByClass[icon.class]=icon});exports.colorChoices=["#99bde7","#e3d754","#8ee684","#e7974c","#e4878d","#67adab","#43ebcc","#e4b4ea","#a1a655","#78b36e"]},4183:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.outlinkEncoders=void 0;var _risonNode=__webpack_require__(253);var _risonNode2=_interopRequireDefault(_risonNode);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}exports.outlinkEncoders=[{id:"esq-rison-loose",title:"elasticsearch OR query (rison encoded)",description:"rison-encoded JSON, minimum_should_match=1, compatible with most Kibana URLs",encode:function encode(workspace){return encodeURIComponent(_risonNode2.default.encode(workspace.getQuery(workspace.getSelectedOrAllNodes(),true)))}},{id:"esq-rison",title:"elasticsearch AND query (rison encoded)",description:"rison-encoded JSON, minimum_should_match=2, compatible with most Kibana URLs",encode:function encode(workspace){return encodeURIComponent(_risonNode2.default.encode(workspace.getQuery(workspace.getSelectedOrAllNodes())))}},{id:"esq-similar-rison",title:"elasticsearch more like this query (rison encoded)",description:'rison-encoded JSON, "like this but not this" type query to find missing docs',encode:function encode(workspace){return encodeURIComponent(_risonNode2.default.encode(workspace.getLikeThisButNotThisQuery(workspace.getSelectedOrAllNodes())))}},{id:"esq-plain",title:"elasticsearch query (plain encoding)",description:"JSON encoded using standard url encoding",encode:function encode(workspace){return encodeURIComponent(JSON.stringify(workspace.getQuery(workspace.getSelectedOrAllNodes())))}},{id:"text-plain",title:"plain text",description:"Text of selected vertex labels as a plain url-encoded string",encode:function encode(workspace){var q="";var nodes=workspace.getSelectedOrAllNodes();for(var i=0;i<nodes.length;i++){var node=nodes[i];i>0&&(q+=" ");q+=node.label}return encodeURIComponent(q)}},{id:"text-lucene",title:"Lucene-escaped text",description:"Text of selected vertex labels with any Lucene special characters encoded",encode:function encode(workspace){var q="";var nodes=workspace.getSelectedOrAllNodes();for(var i=0;i<nodes.length;i++){var node=nodes[i];i>0&&(q+=" ");q+=node.label}var luceneChars='+-&|!(){}[]^"~*?:\\';q=q.split("").map(function(char){return luceneChars.includes(char)?"\\"+char:char}).join("");return encodeURIComponent(q)}}]},4184:function(module,exports){module.exports='<form ng-submit="saveWorkspace()" role="form">\n  <div class="kuiLocalDropdownTitle">Save Workspace</div>\n  <div class="form-group">\n    <label for="workspaceTitle">Name</label>\n    <input id="workspaceTitle" type="text" ng-model="savedWorkspace.title" class="form-control" placeholder="Graph workspace name" input-focus="select">\n  </div>\n  <saved-object-save-as-check-box saved-object="savedWorkspace"></saved-object-save-as-check-box>\n  <div class="form-group">\n    <label for="workspaceTitle">Description</label>\n    <textarea class="form-control input-sm" rows="5" id="notesEdit" placeholder="Any notes.."  ng-model="grr.description"></textarea>\n  </div>\n  <div class="text-warning " ng-if="workspace.nodes.length>0 && !grr.userHasConfirmedSaveWorkspaceData && graphSavePolicy==\'configAndDataWithConsent\'">\n    <i class="fa fa-warning"></i> The data in this workspace will be cleared and only the configuration will be saved\n  </div>\n  <div class="noUserSelect checkbox" ng-if="graphSavePolicy==\'configAndDataWithConsent\'">\n    <label>\n      <input type="checkbox" ng-model="grr.userHasConfirmedSaveWorkspaceData"> Save Graph Content\n    </label>\n  </div>\n\n  <button\n    type="submit"\n    ng-disabled="!savedWorkspace.title"\n    class="kuiButton kuiButton--primary"\n    aria-label="Save workspace"\n  >\n    Save\n  </button>\n\n  <div class="dialogFooterText" ng-if="workspace.nodes.length>0 && graphSavePolicy==\'config\'">\n    <span class="text-info" >\n      <i class="fa fa-info"></i> The data in this workspace will be cleared and only the configuration will be saved\n    </span>\n  </div>\n\n</form>\n'},4185:function(module,exports){module.exports='<div class="kuiLocalDropdownTitle">Open Workspace</div>\n\n<saved-object-finder\n  title="Saved Workspaces"\n  type="Graph workspace"\n  use-local-management="true"\n  on-choose="openSavedWorkspace"\n></saved-object-finder>\n'},4186:function(module,exports){module.exports='<div class="kuiLocalDropdownTitle">Settings</div>\n\n\x3c!-- Tabs. --\x3e\n<ul class="nav nav-tabs" ng-show="selectedIndex !== null">\n  <li ng-show="workspace" ng-class="{active: configPanel === \'lastRequest\'}">\n    <a class="navbar-link" ng-click="configPanel=\'lastRequest\'">Last request</a>\n  </li>\n  <li ng-show="workspace" ng-class="{active: configPanel ===\'blacklist\'}">\n    <a class="navbar-link" ng-click="configPanel=\'blacklist\'">Blacklist</a>\n  </li>\n  <li ng-class="{active: configPanel === \'settings\'}">\n    <a class="navbar-link" ng-click="configPanel=\'settings\'">Advanced settings</a>\n  </li>\n  <li ng-show="canEditDrillDownUrls" ng-class="{active: configPanel === \'drillDowns\'}">\n    <a class="navbar-link" ng-click="configPanel=\'drillDowns\'">Drill-downs</a>\n  </li>\n</ul>\n\n\x3c!--========= Begin config =========== --\x3e\n\n    \x3c!-- ====== start Spy ====== --\x3e\n    <div class="list-group-item list-group-item--noBorder" ng-if="(workspace !== null)&&(configPanel === \'lastRequest\')">\n      <div>\n        <small class="help-block">http://host:port/{{selectedIndex.name}}/_xpack/graph/_explore</small>\n        <ul class="nav nav-tabs">\n          <li ng-class="{active: spymode === \'request\'}"><a ng-click="spymode=\'request\'">Request</a></li>\n          <li ng-class="{active: spymode === \'response\'}"><a ng-click="spymode=\'response\'">Response</a></li>\n        </ul>\n\n        <div ng-show="spymode == \'request\'" ui-ace="{ onLoad: aceLoaded, mode: \'json\', advanced: { readOnly: true } }" ng-model="workspace.lastRequest" class="requestJsonView"></div>\n        <div ng-show="spymode == \'response\'" ui-ace="{ onLoad: aceLoaded, mode: \'json\', advanced: { readOnly: true } }" ng-model="workspace.lastResponse" class="requestJsonView"></div>\n      </div>\n    </div>\n    <div>\n      \x3c!-- ====== end spy ======== --\x3e\n\n\n\n      \x3c!-- ====== start blacklist ====== --\x3e\n      <div class="list-group-item list-group-item--noBorder" ng-if="(workspace!==null)&&(configPanel===\'blacklist\')">\n        <p class="help-block">These terms are currently blacklisted from re-appearing in the workspace</p>\n\n        <div class="selectionList kuiVerticalRhythm">\n          <div\n            ng-repeat="n in workspace.blacklistedNodes"\n            class="kuiFieldGroup"\n          >\n            <div class="kuiFieldGroupSection">\n              <button\n                class="kuiButton kuiButton--hollow"\n                ng-click="workspace.unblacklist(n)"\n              >\n                <span class="kuiIcon fa-times"></span>\n              </button>\n            </div>\n\n            <div class="kuiFieldGroupSection kuiFieldGroupSection--wide">\n              <p class="kuiText">\n                {{n.label}}\n              </p>\n            </div>\n          </div>\n        </div>\n\n        <button\n          type="button"\n          class="kuiButton kuiButton--danger kuiButton--iconText kuiVerticalRhythm"\n          ng-click="workspace.blacklistedNodes=[]"\n          ng-disabled="workspace.blacklistedNodes.length === 0"\n        >\n          <span class="kuiButton__icon kuiIcon fa-trash"></span>\n          <span>Clear</span>\n        </button>\n      </div>\n      \x3c!-- ====== end blacklist ======== --\x3e\n\n      \x3c!-- ====== start drill-downs ====== --\x3e\n      <div class="list-group-item list-group-item--noBorder" ng-if="configPanel===\'drillDowns\'">\n\n        <form ng-submit="saveUrlTemplate()" role="form" class="form-horizontal">\n          <div class="form-group">\n            <div class="col-sm-1 control-label">\n              <label for="urlTemplateUrl">URL</label>\n            </div>\n            <div class="col-sm-11">\n              <input id="urlTemplateUrl" ng-change="checkForKibanaUrl()" ng-paste="handleUrlTemplatePaste($event)" autocomplete="off" type="text" ng-model="newUrlTemplate.url" placeholder="{{\'https://www.google.co.uk/#q={\' + \'{gquery}\' + \'}\' }}"   class="form-control col-sm-12">\n              <span ng-if="suggestTemplateFix"><i tooltip="Kibana URL pasted" class="text-color-warning fa fa-warning"></i>This looks like a Kibana URL. Would you like us to convert it to a template for you? <a ng-click="replaceKibanaUrlParam()">yes</a> / <a ng-click="rejectKibanaUrlSuggestion()">no</a></span>\n              <p class="help-block" ng-non-bindable>Define template URLs using {{gquery}} where the selected vertex terms are inserted</p>\n            </div>\n          </div>\n          <div class="form-group" >\n            <div class="col-sm-1 control-label">\n              <label for="urlDescription">Title</label>\n            </div>\n            <div class="col-sm-5">\n              <input id="urlDescription" type="text" autocomplete="off" ng-model="newUrlTemplate.description" placeholder="Search on Google" class="form-control" >\n            </div>\n            <div class="col-sm-2 control-label">\n              <label for="encoder">URL parameter type</label>\n            </div>\n            <div class="col-sm-4">\n              <select class="form-control" name="encoder"\n                ng-options="option.title for option in outlinkEncoders"\n                ng-model="newUrlTemplate.encoder">\n              </select>\n              <p class="help-block">{{newUrlTemplate.encoder.description}}</p>\n            </div>\n          </div>\n\n          <div class="form-group">\n            <div class="col-sm-1 control-label">\n              <label for="encoder">Toolbar icon</label>\n            </div>\n\n            <div class="col-sm-9">\n                <span class="legend-value-icon-picker">\n                  <i ng-repeat="i in drillDownIconChoices"  ng-click="toggleDrillDownIcon(newUrlTemplate,i)" ng-class="{selectedNode:i==newUrlTemplate.icon}" class="fa icon noUserSelect">\n                                      {{i.code}}</i>\n                </span>\n            </div>\n\n            <div class="col-sm-2">\n              <div class="pull-right kuiButtonGroup">\n                <button\n                  type="reset"\n                  ng-disabled="!newUrlTemplate.url&&!newUrlTemplate.description&&!newUrlTemplate.icon"\n                  class="kuiButton kuiButton--basic"\n                  ng-click="resetNewUrlTemplate()"\n                >\n                  Reset\n                </button>\n\n                <button\n                  type="submit"\n                  ng-disabled="!newUrlTemplate.url||!newUrlTemplate.description"\n                  class="kuiButton kuiButton--primary"\n                  aria-label="Save drill-down"\n                >\n                  Save\n                </button>\n              </div>\n            </div>\n          </div>\n        </form>\n\n\n        <div class="scrollable-list">\n          <ul  class="li-striped list-group list-group-menu">\n            <li class="list-group-item" ng-repeat="urlTemplate in urlTemplates">\n              <i ng-if="urlTemplate.icon"  class="fa icon noUserSelect">\n                                  {{urlTemplate.icon.code}}</i>\n\n                {{urlTemplate.description}}\n              <span class="pull-right">\n                <button\n                  ng-click="editUrlTemplate(urlTemplate)"\n                  class="kuiButton kuiButton--basic kuiButton--iconText kuiButton--small"\n                  aria-label="Edit"\n                >\n                  <span aria-hidden="true" class="kuiIcon fa-pencil"></span>\n                </button>\n\n                <button\n                  ng-click="removeUrlTemplate(urlTemplate)"\n                  class="kuiButton kuiButton--danger kuiButton--iconText kuiButton--small"\n                  aria-label="Remove"\n                >\n                  <span aria-hidden="true" class="kuiIcon fa-trash"></span>\n                </button>\n              </span>\n            </li>\n          </ul>\n        </div>\n      </div>\n      \x3c!-- ====== end drilldowns ======== --\x3e\n\n\n\n      \x3c!-- ======== begin explore settings ======= --\x3e\n      <div class="list-group-item list-group-item--noBorder" ng-if="(selectedIndex !== null)&&(configPanel === \'settings\')">\n\n        <form class="form-horizontal">\n\n\n          <div class="form-group form-group-sm small-graph-form">\n            <label for="qIndexSampleSize" class="col-sm-4 control-label">Sample size</label>\n            <div class="col-sm-6">\n              <input type="number" class="form-control input-sm" min="1" max="500000" step="1000" id="qIndexSampleSize" ng-model="exploreControls.sampleSize">\n              <div class="help-block">Terms are identified from samples of the most relevant documents. Bigger is not necessarily better - can be slower and less relevant.\n              </div>\n            </div>\n          </div>\n\n\n          <div class="form-group">\n            <div class="col-sm-offset-4 col-sm-8">\n              <div class="checkbox">\n                <label>\n                  <input type="checkbox" id="isSignifChk2" ng-model="exploreControls.useSignificance"> Significant links\n                </label>\n              </div>\n              <span class="help-block">Identify terms that are "significant" rather than simply popular</span>\n            </div>\n          </div>\n\n          <div class="form-group form-group-sm small-graph-form">\n            <label for="minDocCount" class="col-sm-4 control-label">Certainty</label>\n            <div class="col-sm-6 ">\n              <input type="number" class="form-control input-sm" min="1" max="500000" step="1" id="minDocCount" ng-model="exploreControls.minDocCount">\n              <div class="help-block">The min number of documents that are required as evidence before introducing a related term</div>\n            </div>\n          </div>\n\n          <div class="form-group form-group-sm small-graph-form">\n            <label for="qDiversityField" class="col-sm-4 control-label">Diversity field</label>\n            <div class="col-sm-6 ">\n              <select name="qDiversityField" id="qDiversityField" ng-options="field.name for field in allFields" ng-model="exploreControls.sampleDiversityField">\n                <option value="">[No diversification]</option>\n              </select>\n              <span class="help-block">To avoid document samples being dominated by a single voice, pick the field that helps identify the source of bias.\n                <em>This must be a single-term field or searches will be rejected with an error</em>\n              </span>\n\n            </div>\n          </div>\n          <div class="form-group form-group-sm small-graph-form" ng-show="exploreControls.sampleDiversityField">\n            <label for="qMaxValuesPerDoc" class="col-sm-4 control-label">Max docs per field</label>\n            <div class="col-sm-6 ">\n              <input type="number" class="form-control input-sm" min="1" max="500000" step="1" id="qMaxValuesPerDoc" ng-model="exploreControls.maxValuesPerDoc">\n              <span class="help-block">Max number of documents in a sample that can contain the same value for the\n                <em>{{selectedDiversityField.name}}</em> field</span>\n            </div>\n          </div>\n\n\n          <div class="form-group form-group-sm small-graph-form">\n            <label for="qTimeoutMillis" class="col-sm-4 control-label">Timeout (ms)</label>\n            <div class="col-sm-6 ">\n              <input type="number" class="form-control input-sm" min="1" max="500000" step="1" id="qTimeoutMillis" ng-model="exploreControls.timeoutMillis">\n              <span class="help-block">Max time in milliseconds a request can run</span>\n            </div>\n          </div>\n\n          \x3c!--\n                      TODO - could add a "guiding query" search term here - would, for example, allow\n                      exploration of weblog entries from selected IP addresses etc BUT always where\n                      status==404. There\'s usually a desire to allow exploration to expand and move\n                      away from the seed query but sometimes a guiding hand is needed across all\n                      expand steps to stay "on topic". The search term would be added to all graph\n                      explore calls automatically.\n                --\x3e\n\n        </form>\n\n      </div>\n\n      \x3c!-- ========== end explore settings =========== --\x3e\n\n\n\n    </div>\n\n\x3c!--========= End config =========== --\x3e\n'}},[4173]);