/*! Copyright Elasticsearch B.V. and/or license to Elasticsearch B.V. under one or more contributor license agreements
 * Licensed under the Elastic License; you may not use this file except in compliance with the Elastic License. */
webpackJsonp([4],{143:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _base_controller=__webpack_require__(4382);Object.defineProperty(exports,"MonitoringViewBaseController",{enumerable:true,get:function get(){return _base_controller.MonitoringViewBaseController}});var _base_table_controller=__webpack_require__(4384);Object.defineProperty(exports,"MonitoringViewBaseTableController",{enumerable:true,get:function get(){return _base_table_controller.MonitoringViewBaseTableController}})},1495:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.extractIp=extractIp;function extractIp(transport){if("string"!==typeof transport)return null;var matches=transport.match(/inet\[[^\/]*\/([^\/\]]+)\]/);if(matches)return matches[1];return transport}},1496:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.MonitoringTimeseries=MonitoringTimeseries;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _lodash=__webpack_require__(1);var _numeral=__webpack_require__(88);var _numeral2=_interopRequireDefault(_numeral);var _get_color=__webpack_require__(4203);var _timeseries_visualization=__webpack_require__(4204);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function formatTicksFor(series){var format=(0,_lodash.get)(series,".metric.format","0,0.0");var units=(0,_lodash.get)(series,".metric.units","");return function formatTicks(val){var formatted=(0,_numeral2.default)(val).format(format);"B"!==units&&""!==units&&(formatted+=" "+units);return formatted}}function MonitoringTimeseries(_ref){var series=_ref.series,onBrush=_ref.onBrush;var dataset=series.map(function(s,index){return{color:(0,_get_color.getColor)(s.metric.app,index),data:s.data,label:s.metric.label}});var firstSeries=(0,_lodash.first)(series);var timeRange=(0,_lodash.get)(firstSeries,"timeRange");var formatTicks=formatTicksFor(firstSeries);return _react2.default.createElement(_timeseries_visualization.TimeseriesVisualization,{series:dataset,timeRange:timeRange,tickFormatter:formatTicks,onBrush:onBrush})}},1501:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.InfoTooltip=InfoTooltip;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _lodash=__webpack_require__(1);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function InfoTooltip(_ref){var series=_ref.series;var bucketSize=(0,_lodash.get)((0,_lodash.first)(series),"bucket_size");var tableRows=series.map(function(item,index){return _react2.default.createElement("tr",{key:"chart-tooltip-"+index,"data-debug-metric-agg":item.metric.metricAgg,"data-debug-metric-field":item.metric.field,"data-debug-metric-is-derivative":item.metric.isDerivative,"data-debug-metric-has-calculation":item.metric.hasCalculation},_react2.default.createElement("td",{className:"monitoring-chart-tooltip__label"},item.metric.label),_react2.default.createElement("td",{className:"monitoring-chart-tooltip__value"},item.metric.description))});return _react2.default.createElement("table",{className:"monitoring-chart-tooltip"},_react2.default.createElement("tbody",null,_react2.default.createElement("tr",null,_react2.default.createElement("td",{className:"monitoring-chart-tooltip__label"},"Interval"),_react2.default.createElement("td",{className:"monitoring-chart-tooltip__value"},bucketSize)),tableRows))}},1502:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.getTitle=getTitle;var _lodash=__webpack_require__(1);function getTitle(){var series=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[];return(0,_lodash.chain)(series.map(function(s){return s.metric.title||s.metric.label})).first().value()}},1503:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.getUnits=getUnits;var _lodash=__webpack_require__(1);var _numeral=__webpack_require__(88);var _numeral2=_interopRequireDefault(_numeral);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function getUnits(series){var units=(0,_lodash.get)(series,"[0].metric.units");if("B"===units){var maxLastBytes=0;(0,_lodash.forEach)(series,function(s){var lastDataPoint=(0,_lodash.last)(s.data)||[null,0];maxLastBytes=Math.max(maxLastBytes,lastDataPoint[1])});units=(0,_numeral2.default)(maxLastBytes).byteUnits()}return units}},1509:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.FormattedMessage=FormattedMessage;var _momentTimezone=__webpack_require__(125);var _momentTimezone2=_interopRequireDefault(_momentTimezone);__webpack_require__(650);var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _format_timestamp_to_duration=__webpack_require__(653);var _constants=__webpack_require__(64);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function FormattedMessage(_ref){var prefix=_ref.prefix,suffix=_ref.suffix,message=_ref.message,metadata=_ref.metadata,changeUrl=_ref.changeUrl;var formattedMessage=function(){if(metadata&&metadata.link){if(metadata.link.startsWith("https"))return _react2.default.createElement(_eui.EuiLink,{href:metadata.link,target:"_blank","data-test-subj":"alertAction"},message);var goToLink=function goToLink(){return changeUrl("/"+metadata.link)};return _react2.default.createElement(_eui.EuiLink,{onClick:goToLink,"data-test-subj":"alertAction"},message)}return message}();if(metadata&&metadata.time){prefix=prefix.replace(/{{#relativeTime}}metadata\.([\w\.]+){{\/relativeTime}}/,function(_match,field){return(0,_format_timestamp_to_duration.formatTimestampToDuration)(metadata[field],_constants.CALCULATE_DURATION_UNTIL)});prefix=prefix.replace(/{{#absoluteTime}}metadata\.([\w\.]+){{\/absoluteTime}}/,function(_match,field){return _momentTimezone2.default.tz(metadata[field],_momentTimezone2.default.tz.guess()).format("LLL z")})}var formattedPrefix=prefix?prefix+" ":null;var formattedSuffix=suffix?" "+suffix:null;return _react2.default.createElement("span",{"data-test-subj":"alertText"},formattedPrefix,formattedMessage,formattedSuffix)}},1510:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _status_icon=__webpack_require__(4264);Object.defineProperty(exports,"NodeStatusIcon",{enumerable:true,get:function get(){return _status_icon.NodeStatusIcon}})},1511:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.decorateShards=decorateShards;var _lodash=__webpack_require__(1);function decorateShards(shards,nodes){function getTooltipMessage(shard){var isRelocating=function isRelocating(node){return(0,_lodash.includes)(node.node_ids,shard.relocating_node)};var nodeName=(0,_lodash.get)((0,_lodash.find)(nodes,function(n){return isRelocating(n)}),"name");if(nodeName){if("INITIALIZING"===shard.state)return"Relocating from "+nodeName;if("RELOCATING"===shard.state)return"Relocating to "+nodeName}return(0,_lodash.capitalize)(shard.state.toLowerCase())}return shards.map(function(shard){var node=nodes[shard.node];shard.nodeName=node&&node.name||null;shard.type="shard";shard.tooltip_message=getTooltipMessage(shard);return shard})}},1512:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.Shard=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _calculateClass=__webpack_require__(1513);var _vents=__webpack_require__(4278);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}var Shard=exports.Shard=function(_React$Component){_inherits(Shard,_React$Component);function Shard(){var _ref;var _temp,_this,_ret;_classCallCheck(this,Shard);for(var _len=arguments.length,args=Array(_len),_key=0;_key<_len;_key++)args[_key]=arguments[_key];return _ret=(_temp=(_this=_possibleConstructorReturn(this,(_ref=Shard.__proto__||Object.getPrototypeOf(Shard)).call.apply(_ref,[this].concat(args))),_this),_this.state={tooltipVisible:false},_this.generateKey=function(relocating){var shard=_this.props.shard;var shardType=shard.primary?"primary":"replica";var additionId="UNASSIGNED"===shard.state?Math.random():"";var node=relocating?shard.relocating_node:shard.node;return shard.index+"."+node+"."+shardType+"."+shard.shard+additionId},_this.toggle=function(event){if(_this.props.shard.tooltip_message){var action="mouseenter"===event.type?"show":"hide";var key=_this.generateKey(true);_this.setState({tooltipVisible:"show"===action});_vents.vents.trigger(key,action)}},_temp),_possibleConstructorReturn(_this,_ret)}_createClass(Shard,[{key:"componentDidMount",value:function componentDidMount(){var key=void 0;var shard=this.props.shard;var self=this;if(shard.tooltip_message){key=this.generateKey();_vents.vents.on(key,function(action){self.setState({tooltipVisible:"show"===action})})}}},{key:"componentWillUnmount",value:function componentWillUnmount(){var key=void 0;var shard=this.props.shard;if(shard.tooltip_message){key=this.generateKey();_vents.vents.clear(key)}}},{key:"render",value:function render(){var shard=this.props.shard;var tooltip=void 0;this.state.tooltipVisible&&(tooltip=_react2.default.createElement("div",{className:"shard-tooltip","data-test-subj":"shardTooltip","data-tooltip-content":this.props.shard.tooltip_message},this.props.shard.tooltip_message));var classes=(0,_calculateClass.calculateClass)(shard);var classification=classes+" "+shard.shard;return _react2.default.createElement("div",{onMouseEnter:this.toggle,onMouseLeave:this.toggle,className:classes,"data-shard-tooltip":this.props.shard.tooltip_message,"data-shard-classification":classification,"data-test-subj":"shardIcon"},tooltip,shard.shard)}}]);return Shard}(_react2.default.Component);Shard.displayName="Shard"},1513:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.calculateClass=calculateClass;function calculateClass(item,initial){var classes=[item.type];initial&&classes.push(initial);if("shard"===item.type){classes.push(item.primary?"primary":"replica");classes.push(item.state.toLowerCase());"UNASSIGNED"===item.state&&item.primary&&classes.push("emergency")}item.master&&classes.push("master");return classes.join(" ")}},1514:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.StatementListHeading=StatementListHeading;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _propTypes=__webpack_require__(6);var _propTypes2=_interopRequireDefault(_propTypes);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function StatementListHeading(_ref){var iconType=_ref.iconType,title=_ref.title;return _react2.default.createElement(_eui.EuiFlexGroup,{gutterSize:"s",responsive:false,alignItems:"baseline"},_react2.default.createElement(_eui.EuiFlexItem,{grow:false},_react2.default.createElement(_eui.EuiIcon,{type:iconType})),_react2.default.createElement(_eui.EuiFlexItem,{grow:false},_react2.default.createElement(_eui.EuiTitle,{size:"s"},_react2.default.createElement("h4",null,title))))}StatementListHeading.propTypes={iconType:_propTypes2.default.string.isRequired,title:_propTypes2.default.string.isRequired}},1515:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.PluginStatement=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _statement=__webpack_require__(900);var _plugin_element=__webpack_require__(4295);function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}exports.PluginStatement=function(_Statement){_inherits(PluginStatement,_Statement);function PluginStatement(vertex){_classCallCheck(this,PluginStatement);var _this=_possibleConstructorReturn(this,(PluginStatement.__proto__||Object.getPrototypeOf(PluginStatement)).call(this,vertex));var pluginType=vertex.pluginType,name=vertex.name;_this.pluginType=pluginType;_this.name=name;return _this}_createClass(PluginStatement,[{key:"toList",value:function toList(depth,parentId){return[new _plugin_element.PluginElement(this,depth,parentId)]}}],[{key:"fromPipelineGraphVertex",value:function fromPipelineGraphVertex(pluginVertex){return new PluginStatement(pluginVertex)}}]);return PluginStatement}(_statement.Statement)},1516:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.IfElement=void 0;var _element=__webpack_require__(901);function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}exports.IfElement=function(_Element){_inherits(IfElement,_Element);function IfElement(statement,depth,parentId){_classCallCheck(this,IfElement);var id=statement.id;return _possibleConstructorReturn(this,(IfElement.__proto__||Object.getPrototypeOf(IfElement)).call(this,id,statement,depth,parentId))}return IfElement}(_element.Element)},1517:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.makeStatement=makeStatement;var _plugin_statement=__webpack_require__(1515);var _if_statement=__webpack_require__(4301);var _queue=__webpack_require__(4303);function makeStatement(pipelineGraphVertex,pipelineStage){var klass=pipelineGraphVertex.constructor.name;switch(klass){case"PluginVertex":return _plugin_statement.PluginStatement.fromPipelineGraphVertex(pipelineGraphVertex,pipelineStage);case"IfVertex":return _if_statement.IfStatement.fromPipelineGraphVertex(pipelineGraphVertex,pipelineStage);case"QueueVertex":return _queue.Queue.fromPipelineGraphVertex(pipelineGraphVertex,pipelineStage);default:throw new Error("Unknown vertex class: "+klass)}}},1518:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.isVertexPipelineStage=isVertexPipelineStage;function isVertexPipelineStage(vertex,pipelineStage){return vertex&&vertex.pipelineStage===pipelineStage}},1519:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.PluginVertex=exports.SLOWNESS_STANDARD_DEVIATIONS_ABOVE_THE_MEAN=exports.TIME_CONSUMING_PROCESSOR_THRESHOLD_COEFFICIENT=void 0;var _slicedToArray=function(){function sliceIterator(arr,i){var _arr=[];var _n=true;var _d=false;var _e=void 0;try{for(var _s,_i=arr[Symbol.iterator]();!(_n=(_s=_i.next()).done);_n=true){_arr.push(_s.value);if(i&&_arr.length===i)break}}catch(err){_d=true;_e=err}finally{try{!_n&&_i["return"]&&_i["return"]()}finally{if(_d)throw _e}}return _arr}return function(arr,i){if(Array.isArray(arr))return arr;if(Symbol.iterator in Object(arr))return sliceIterator(arr,i);throw new TypeError("Invalid attempt to destructure non-iterable instance")}}();var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source)Object.prototype.hasOwnProperty.call(source,key)&&(target[key]=source[key])}return target};var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _lodash=__webpack_require__(1);var _vertex=__webpack_require__(903);function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}var TIME_CONSUMING_PROCESSOR_THRESHOLD_COEFFICIENT=exports.TIME_CONSUMING_PROCESSOR_THRESHOLD_COEFFICIENT=2;var SLOWNESS_STANDARD_DEVIATIONS_ABOVE_THE_MEAN=exports.SLOWNESS_STANDARD_DEVIATIONS_ABOVE_THE_MEAN=2;exports.PluginVertex=function(_Vertex){_inherits(PluginVertex,_Vertex);function PluginVertex(){_classCallCheck(this,PluginVertex);return _possibleConstructorReturn(this,(PluginVertex.__proto__||Object.getPrototypeOf(PluginVertex)).apply(this,arguments))}_createClass(PluginVertex,[{key:"isTimeConsuming",value:function isTimeConsuming(){var expectedPercentOfTotalProcessorTime=1/this.graph.processorVertices.length;var threshold=TIME_CONSUMING_PROCESSOR_THRESHOLD_COEFFICIENT*expectedPercentOfTotalProcessorTime;return this.percentOfTotalProcessorTime>threshold}},{key:"isSlow",value:function isSlow(){var totalProcessorVertices=this.graph.processorVertices.length;if(0===totalProcessorVertices)return 0;var meanmillisPerEvent=this.graph.processorVertices.reduce(function(acc,v){return acc+v.latestMillisPerEvent||0},0)/totalProcessorVertices;var variance=this.graph.processorVertices.reduce(function(acc,v){var difference=(v.latestMillisPerEvent||0)-meanmillisPerEvent;var square=difference*difference;return acc+square},0)/totalProcessorVertices;var stdDeviation=Math.sqrt(variance);var slowness=(this.latestMillisPerEvent-meanmillisPerEvent)/stdDeviation;return slowness>SLOWNESS_STANDARD_DEVIATIONS_ABOVE_THE_MEAN}},{key:"typeString",get:function get(){return"plugin"}},{key:"name",get:function get(){return this.json.config_name}},{key:"title",get:function get(){return this.name}},{key:"pluginType",get:function get(){return this.json.plugin_type}},{key:"isInput",get:function get(){return"input"===this.pluginType}},{key:"isFilter",get:function get(){return"filter"===this.pluginType}},{key:"isOutput",get:function get(){return"output"===this.pluginType}},{key:"isProcessor",get:function get(){return this.isFilter||this.isOutput}},{key:"latestMillisPerEvent",get:function get(){var latestMillisPerEventBucket=(0,_lodash.last)((0,_lodash.get)(this.stats,"millis_per_event.data",[]))||[];return latestMillisPerEventBucket[1]}},{key:"percentOfTotalProcessorTime",get:function get(){var latestPercentOfTotalProcessorDurationBucket=(0,_lodash.last)((0,_lodash.get)(this.stats,"percent_of_total_processor_duration.data",[]))||[];return latestPercentOfTotalProcessorDurationBucket[1]}},{key:"eventsPerSecond",get:function get(){var eventsPerMillisecond=this.isInput?this.stats.events_out_per_millisecond:this.stats.events_in_per_millisecond;return _extends({},(0,_lodash.omit)(eventsPerMillisecond,"data"),{data:(0,_lodash.get)(eventsPerMillisecond,"data",[]).map(function(_ref){var _ref2=_slicedToArray(_ref,2),x=_ref2[0],y=_ref2[1];return[x,1e3*y]})})}},{key:"latestEventsPerSecond",get:function get(){var latestBucket=(0,_lodash.last)((0,_lodash.get)(this.eventsPerSecond,"data",[]))||[];return latestBucket[1]}},{key:"iconType",get:function get(){switch(this.pluginType){case"input":return"logstashInput";case"filter":return"logstashFilter";case"output":return"logstashOutput";default:throw new Error("Unknown plugin type "+this.pluginType+"! This shouldn't happen!")}}},{key:"next",get:function get(){var firstOutgoingEdge=this.outgoingEdges[0]||{};return firstOutgoingEdge.to}}]);return PluginVertex}(_vertex.Vertex)},1520:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}exports.Edge=function(){function Edge(graph,json){_classCallCheck(this,Edge);this.graph=graph;this.update(json)}_createClass(Edge,[{key:"update",value:function update(json){this.json=json}},{key:"id",get:function get(){return this.json.id}},{key:"from",get:function get(){return this.graph.verticesById[this.fromId]}},{key:"fromId",get:function get(){return this.json.from}},{key:"to",get:function get(){return this.graph.verticesById[this.toId]}},{key:"toId",get:function get(){return this.json.to}}]);return Edge}()},1521:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _stats=__webpack_require__(4326);Object.defineProperty(exports,"Stats",{enumerable:true,get:function get(){return _stats.Stats}})},1522:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();function _asyncToGenerator(fn){return function(){var gen=fn.apply(this,arguments);return new Promise(function(resolve,reject){function step(key,arg){try{var info=gen[key](arg);var value=info.value}catch(error){reject(error);return}if(!info.done)return Promise.resolve(value).then(function(value){step("next",value)},function(err){step("throw",err)});resolve(value)}return step("next")})}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}exports.SettingsChecker=function(){function SettingsChecker($http){_classCallCheck(this,SettingsChecker);this.$http=$http;this.message=null;this.api=null;this.next=null}_createClass(SettingsChecker,[{key:"setApi",value:function setApi(api){this.api=api}},{key:"setMessage",value:function setMessage(message){this.message=message}},{key:"getApi",value:function getApi(){return this.api}},{key:"getMessage",value:function getMessage(){return this.message}},{key:"hasNext",value:function hasNext(){return null!==this.next}},{key:"setNext",value:function setNext(checker){this.next=checker}},{key:"getNext",value:function getNext(){return this.next}},{key:"executeCheck",value:function(){var _ref=_asyncToGenerator(regeneratorRuntime.mark(function _callee(){var _ref2,data,found,reason,_data;return regeneratorRuntime.wrap(function _callee$(_context){while(1)switch(_context.prev=_context.next){case 0:_context.prev=0;_context.next=3;return this.$http.get(this.getApi());case 3:_ref2=_context.sent;data=_ref2.data;found=data.found,reason=data.reason;return _context.abrupt("return",{found:found,reason:reason});case 9:_context.prev=9;_context.t0=_context["catch"](0);_data=_context.t0.data;return _context.abrupt("return",{error:true,found:false,errorReason:_data});case 13:case"end":return _context.stop()}},_callee,this,[[0,9]])}));function executeCheck(){return _ref.apply(this,arguments)}return executeCheck}()}]);return SettingsChecker}()},1523:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _license_status=__webpack_require__(1524);Object.defineProperty(exports,"LicenseStatus",{enumerable:true,get:function get(){return _license_status.LicenseStatus}});var _add_license=__webpack_require__(1525);Object.defineProperty(exports,"AddLicense",{enumerable:true,get:function get(){return _add_license.AddLicense}});var _constants=__webpack_require__(514);Object.defineProperty(exports,"MANAGEMENT_BASE_PATH",{enumerable:true,get:function get(){return _constants.BASE_PATH}})},1526:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.isPipelineMonitoringSupportedInVersion=isPipelineMonitoringSupportedInVersion;var _semver=__webpack_require__(866);var _semver2=_interopRequireDefault(_semver);var _constants=__webpack_require__(64);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function isPipelineMonitoringSupportedInVersion(logstashVersion){var major=_semver2.default.major(logstashVersion);return major>=_constants.LOGSTASH.MAJOR_VER_REQD_FOR_PIPELINES}},256:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _table=__webpack_require__(4243);Object.defineProperty(exports,"MonitoringTable",{enumerable:true,get:function get(){return _table.MonitoringTable}});var _storage=__webpack_require__(4247);Object.defineProperty(exports,"tableStorageGetter",{enumerable:true,get:function get(){return _storage.tableStorageGetter}});Object.defineProperty(exports,"tableStorageSetter",{enumerable:true,get:function get(){return _storage.tableStorageSetter}})},375:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.LARGE_ABBREVIATED=exports.SMALL_BYTES=exports.LARGE_BYTES=exports.SMALL_FLOAT=exports.LARGE_FLOAT=void 0;exports.formatDateTimeLocal=formatDateTimeLocal;exports.shortenPipelineHash=shortenPipelineHash;var _momentTimezone=__webpack_require__(125);var _momentTimezone2=_interopRequireDefault(_momentTimezone);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}exports.LARGE_FLOAT="0,0.[00]";exports.SMALL_FLOAT="0.[00]";exports.LARGE_BYTES="0,0.0 b";exports.SMALL_BYTES="0.0 b";exports.LARGE_ABBREVIATED="0,0.[0]a";function formatDateTimeLocal(date){return _momentTimezone2.default.tz(date,_momentTimezone2.default.tz.guess()).format("LL LTS")}function shortenPipelineHash(hash){return hash.substr(0,6)}},376:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.Tooltip=void 0;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _tooltip=__webpack_require__(509);var _overlayTrigger=__webpack_require__(510);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var Tooltip=exports.Tooltip=function Tooltip(props){var tooltip=_react2.default.createElement(_tooltip.Tooltip,null,props.text);return _react2.default.createElement(_overlayTrigger.OverlayTrigger,{placement:props.placement,trigger:props.trigger,overlay:tooltip},_react2.default.createElement("span",{className:"overlay-trigger"},_react2.default.createElement("span",{className:"monitoring-tooltip__trigger"},props.children)))};Tooltip.defaultProps={placement:"top",trigger:"click"}},4187:function(module,exports,__webpack_require__){"use strict";__webpack_require__(150);__webpack_require__(153);__webpack_require__(154);__webpack_require__(155);__webpack_require__(156);__webpack_require__(157);__webpack_require__(158);__webpack_require__(159);__webpack_require__(160);__webpack_require__(161);__webpack_require__(162);__webpack_require__(163);__webpack_require__(164);__webpack_require__(165);__webpack_require__(166);__webpack_require__(167);__webpack_require__(168);__webpack_require__(169);__webpack_require__(170);__webpack_require__(171);__webpack_require__(172);__webpack_require__(173);__webpack_require__(174);__webpack_require__(175);__webpack_require__(176);__webpack_require__(177);__webpack_require__(178);__webpack_require__(179);__webpack_require__(180);__webpack_require__(181);__webpack_require__(182);__webpack_require__(183);__webpack_require__(184);__webpack_require__(185);__webpack_require__(186);__webpack_require__(187);__webpack_require__(188);__webpack_require__(189);__webpack_require__(190);__webpack_require__(191);__webpack_require__(192);__webpack_require__(193);__webpack_require__(194);__webpack_require__(195);__webpack_require__(196);__webpack_require__(197);__webpack_require__(198);__webpack_require__(199);__webpack_require__(200);__webpack_require__(201);__webpack_require__(202);__webpack_require__(123);__webpack_require__(203);__webpack_require__(204);__webpack_require__(205);__webpack_require__(206);__webpack_require__(207);__webpack_require__(208);__webpack_require__(209);__webpack_require__(210);__webpack_require__(211);__webpack_require__(212);__webpack_require__(213);__webpack_require__(214);__webpack_require__(215);__webpack_require__(216);__webpack_require__(217);__webpack_require__(218);__webpack_require__(219);__webpack_require__(220);__webpack_require__(221);__webpack_require__(222);__webpack_require__(223);__webpack_require__(224);__webpack_require__(225);__webpack_require__(226);__webpack_require__(227);__webpack_require__(228);__webpack_require__(229);__webpack_require__(230);__webpack_require__(231);__webpack_require__(232);__webpack_require__(233);__webpack_require__(234);__webpack_require__(235);__webpack_require__(236);__webpack_require__(237);__webpack_require__(238);__webpack_require__(239);__webpack_require__(240);var _kibanaCore__=__webpack_require__(241);new _kibanaCore__.CoreSystem({injectedMetadata:JSON.parse(document.querySelector("kbn-injected-metadata").getAttribute("data")),rootDomElement:document.body,requireLegacyFiles:function requireLegacyFiles(){__webpack_require__(4188)}}).start()},4188:function(module,exports,__webpack_require__){"use strict";var _momentTimezone=__webpack_require__(125);var _momentTimezone2=_interopRequireDefault(_momentTimezone);var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _chrome=__webpack_require__(8);var _chrome2=_interopRequireDefault(_chrome);__webpack_require__(296);__webpack_require__(4189);__webpack_require__(4190);__webpack_require__(4191);__webpack_require__(4192);__webpack_require__(4193);__webpack_require__(4195);__webpack_require__(4196);__webpack_require__(4197);__webpack_require__(4199);__webpack_require__(4331);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var uiSettings=_chrome2.default.getUiSettingsClient();_momentTimezone2.default.tz.setDefault(uiSettings.get("dateFormat:tz"));uiSettings.overrideLocalDefault("timepicker:timeDefaults",JSON.stringify({from:"now-1h",to:"now",mode:"quick"}));uiSettings.overrideLocalDefault("timepicker:refreshIntervalDefaults",JSON.stringify({display:"10 seconds",pause:false,value:1e4}));_routes2.default.enable()},4189:function(module,exports){},4190:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _modules=__webpack_require__(2);var _format_number=__webpack_require__(59);var _extract_ip=__webpack_require__(1495);var uiModule=_modules.uiModules.get("monitoring/filters",[]);uiModule.filter("capitalize",function(){return function(input){return(0,_lodash.capitalize)(input.toLowerCase())}});uiModule.filter("formatNumber",function(){return _format_number.formatNumber});uiModule.filter("formatMetric",function(){return _format_number.formatMetric});uiModule.filter("extractIp",function(){return _extract_ip.extractIp})},4191:function(module,exports,__webpack_require__){"use strict";var _modules=__webpack_require__(2);var _ajax_error_handler=__webpack_require__(63);var _timefilter=__webpack_require__(14);var uiModule=_modules.uiModules.get("monitoring/clusters");uiModule.service("monitoringClusters",function($injector){return function(clusterUuid,ccs){var _timefilter$getBounds=_timefilter.timefilter.getBounds(),min=_timefilter$getBounds.min,max=_timefilter$getBounds.max;var url="../api/monitoring/v1/clusters";clusterUuid&&(url+="/"+clusterUuid);var $http=$injector.get("$http");return $http.post(url,{ccs:ccs,timeRange:{min:min.toISOString(),max:max.toISOString()}}).then(function(response){return response.data}).then(function(data){if(clusterUuid)return data[0];return data}).catch(function(err){var Private=$injector.get("Private");var ajaxErrorHandlers=Private(_ajax_error_handler.ajaxErrorHandlersProvider);return ajaxErrorHandlers(err)})}})},4192:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _lodash2=_interopRequireDefault(_lodash);var _modules=__webpack_require__(2);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var uiModule=_modules.uiModules.get("monitoring/features",[]);uiModule.service("features",function($window){function getData(){var returnData={};var monitoringData=$window.localStorage.getItem("xpack.monitoring.data");try{returnData=monitoringData&&JSON.parse(monitoringData)||{}}catch(e){console.error("Monitoring UI: error parsing locally stored monitoring data",e)}return returnData}function update(featureName,value){var monitoringDataObj=getData();monitoringDataObj[featureName]=value;$window.localStorage.setItem("xpack.monitoring.data",JSON.stringify(monitoringDataObj))}function isEnabled(featureName,defaultSetting){var monitoringDataObj=getData();if(_lodash2.default.has(monitoringDataObj,featureName))return monitoringDataObj[featureName];if(_lodash2.default.isUndefined(defaultSetting))return false;return defaultSetting}return{isEnabled:isEnabled,update:update}})},4193:function(module,exports,__webpack_require__){"use strict";var _modules=__webpack_require__(2);var _executor_provider=__webpack_require__(4194);var uiModule=_modules.uiModules.get("monitoring/executor",[]);uiModule.service("$executor",_executor_provider.executorProvider)},4194:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.executorProvider=executorProvider;var _timefilter=__webpack_require__(14);function executorProvider(Promise,$timeout){var queue=[];var executionTimer=void 0;var ignorePaused=false;function reset(){cancel();_start()}function killTimer(){executionTimer&&$timeout.cancel(executionTimer)}function cancel(){killTimer()}function register(service){queue.push(service)}function destroy(){cancel();ignorePaused=false;queue.splice(0,queue.length)}function run(){var noop=function noop(){return Promise.resolve()};return Promise.all(queue.map(function(service){return service.execute().then(service.handleResponse||noop).catch(service.handleError||noop)})).finally(reset)}function reFetch(_changes){cancel();run()}function killIfPaused(){_timefilter.timefilter.getRefreshInterval().pause&&killTimer()}function _start(){(ignorePaused||false===_timefilter.timefilter.getRefreshInterval().pause)&&_timefilter.timefilter.getRefreshInterval().value>0&&(executionTimer=$timeout(run,_timefilter.timefilter.getRefreshInterval().value))}return{register:register,start:function start($scope){$scope.$listenAndDigestAsync(_timefilter.timefilter,"fetch",reFetch);$scope.$listenAndDigestAsync(_timefilter.timefilter,"refreshIntervalUpdate",killIfPaused);_start()},run:run,destroy:destroy,reset:reset,cancel:cancel}}},4195:function(module,exports,__webpack_require__){"use strict";var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _lodash=__webpack_require__(1);var _modules=__webpack_require__(2);var _constants=__webpack_require__(64);function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}var uiModule=_modules.uiModules.get("monitoring/license",[]);uiModule.service("license",function(){return new(function(){function LicenseService(){_classCallCheck(this,LicenseService);this.license={type:null,expiry_date_in_millis:-Infinity}}_createClass(LicenseService,[{key:"setLicense",value:function setLicense(license){this.license=license}},{key:"isBasic",value:function isBasic(){return"basic"===this.license.type}},{key:"mlIsSupported",value:function mlIsSupported(){return(0,_lodash.contains)(_constants.ML_SUPPORTED_LICENSES,this.license.type)}},{key:"doesExpire",value:function doesExpire(){var expiryDateInMillis=this.license.expiry_date_in_millis;return void 0!==expiryDateInMillis}},{key:"isActive",value:function isActive(){var expiryDateInMillis=this.license.expiry_date_in_millis;return(new Date).getTime()<expiryDateInMillis}},{key:"isExpired",value:function isExpired(){if(this.doesExpire()){var expiryDateInMillis=this.license.expiry_date_in_millis;return(new Date).getTime()>=expiryDateInMillis}return false}}]);return LicenseService}())})},4196:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _lodash2=_interopRequireDefault(_lodash);var _modules=__webpack_require__(2);var _doc_title=__webpack_require__(368);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var uiModule=_modules.uiModules.get("monitoring/title",[]);uiModule.service("title",function(Private){var docTitle=Private(_doc_title.DocTitleProvider);return function changeTitle(cluster,suffix){var clusterName=_lodash2.default.get(cluster,"cluster_name");clusterName=clusterName?"- "+clusterName:"";suffix=suffix?"- "+suffix:"";docTitle.change("Monitoring "+clusterName+" "+suffix,true)}})},4197:function(module,exports,__webpack_require__){"use strict";var _modules=__webpack_require__(2);var _breadcrumbs_provider=__webpack_require__(4198);var uiModule=_modules.uiModules.get("monitoring/breadcrumbs",[]);uiModule.service("breadcrumbs",_breadcrumbs_provider.breadcrumbsProvider)},4198:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.breadcrumbsProvider=breadcrumbsProvider;var createCrumb=function createCrumb(url,label,testSubj){var crumb={url:url,label:label};testSubj&&(crumb.testSubj=testSubj);return crumb};function getElasticsearchBreadcrumbs(mainInstance){var breadcrumbs=[];if(mainInstance.instance){breadcrumbs.push(createCrumb("#/elasticsearch","Elasticsearch"));"indices"===mainInstance.name?breadcrumbs.push(createCrumb("#/elasticsearch/indices","Indices","breadcrumbEsIndices")):"nodes"===mainInstance.name?breadcrumbs.push(createCrumb("#/elasticsearch/nodes","Nodes","breadcrumbEsNodes")):"ml"===mainInstance.name&&breadcrumbs.push(createCrumb("#/elasticsearch/ml_jobs","Jobs"));breadcrumbs.push(createCrumb(null,mainInstance.instance))}else breadcrumbs.push(createCrumb(null,"Elasticsearch"));return breadcrumbs}function getKibanaBreadcrumbs(mainInstance){var breadcrumbs=[];if(mainInstance.instance){breadcrumbs.push(createCrumb("#/kibana","Kibana"));breadcrumbs.push(createCrumb("#/kibana/instances","Instances"))}else breadcrumbs.push(createCrumb(null,"Kibana"));return breadcrumbs}function getLogstashBreadcrumbs(mainInstance){var breadcrumbs=[];if(mainInstance.instance){breadcrumbs.push(createCrumb("#/logstash","Logstash"));"nodes"===mainInstance.name&&breadcrumbs.push(createCrumb("#/logstash/nodes","Nodes"));breadcrumbs.push(createCrumb(null,mainInstance.instance))}else if("pipeline"===mainInstance.page){breadcrumbs.push(createCrumb("#/logstash","Logstash"));breadcrumbs.push(createCrumb("#/logstash/pipelines","Pipelines"))}else breadcrumbs.push(createCrumb(null,"Logstash"));return breadcrumbs}function getBeatsBreadcrumbs(mainInstance){var breadcrumbs=[];if(mainInstance.instance){breadcrumbs.push(createCrumb("#/beats","Beats"));breadcrumbs.push(createCrumb("#/beats/beats","Instances"));breadcrumbs.push(createCrumb(null,mainInstance.instance))}else breadcrumbs.push(createCrumb(null,"Beats"));return breadcrumbs}function breadcrumbsProvider(){return function createBreadcrumbs(clusterName,mainInstance){var breadcrumbs=[createCrumb("#/home","Clusters","breadcrumbClusters")];!mainInstance.inOverview&&clusterName&&breadcrumbs.push(createCrumb("#/overview",clusterName));mainInstance.inElasticsearch&&(breadcrumbs=breadcrumbs.concat(getElasticsearchBreadcrumbs(mainInstance)));mainInstance.inKibana&&(breadcrumbs=breadcrumbs.concat(getKibanaBreadcrumbs(mainInstance)));mainInstance.inLogstash&&(breadcrumbs=breadcrumbs.concat(getLogstashBreadcrumbs(mainInstance)));mainInstance.inBeats&&(breadcrumbs=breadcrumbs.concat(getBeatsBreadcrumbs(mainInstance)));return breadcrumbs}}},4199:function(module,exports,__webpack_require__){"use strict";__webpack_require__(4200);__webpack_require__(4202);__webpack_require__(4240);__webpack_require__(4242);__webpack_require__(4248);__webpack_require__(4256);__webpack_require__(4258);__webpack_require__(4260);__webpack_require__(4262);__webpack_require__(4265);__webpack_require__(4267);__webpack_require__(4273);__webpack_require__(4281);__webpack_require__(4283);__webpack_require__(4284);__webpack_require__(4286);__webpack_require__(4314);__webpack_require__(4315);__webpack_require__(4317);__webpack_require__(4318);__webpack_require__(4320);__webpack_require__(4327);__webpack_require__(4328)},4200:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.MonitoringMainController=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _lodash=__webpack_require__(1);var _modules=__webpack_require__(2);var _index=__webpack_require__(4201);var _index2=_interopRequireDefault(_index);var _formatting=__webpack_require__(375);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}var MonitoringMainController=exports.MonitoringMainController=function(){function MonitoringMainController(){_classCallCheck(this,MonitoringMainController);this.inListing=false;this.inAlerts=false;this.inOverview=false;this.inElasticsearch=false;this.inKibana=false;this.inLogstash=false;this.inBeats=false}_createClass(MonitoringMainController,[{key:"setup",value:function setup(options){var _this=this;this._licenseService=options.licenseService;this._breadcrumbsService=options.breadcrumbsService;this._kbnUrlService=options.kbnUrlService;Object.assign(this,options.attributes);if(this.product){this.inElasticsearch="elasticsearch"===this.product;this.inKibana="kibana"===this.product;this.inLogstash="logstash"===this.product;this.inBeats="beats"===this.product}else{this.inOverview="overview"===this.name;this.inAlerts="alerts"===this.name;this.inListing="listing"===this.name||"no-data"===this.name}this.inListing||(this.breadcrumbs=this._breadcrumbsService(options.clusterName,this));if(this.pipelineHash){this.pipelineHashShort=(0,_formatting.shortenPipelineHash)(this.pipelineHash);this.onChangePipelineHash=function(){return _this._kbnUrlService.changePath("/logstash/pipelines/"+_this.pipelineId+"/"+_this.pipelineHash)}}}},{key:"isActiveTab",value:function isActiveTab(testPath){return this.name===testPath}},{key:"isMlSupported",value:function isMlSupported(){return this._licenseService.mlIsSupported()}}]);return MonitoringMainController}();var uiModule=_modules.uiModules.get("plugins/monitoring/directives",[]);uiModule.directive("monitoringMain",function(breadcrumbs,license,kbnUrl){return{restrict:"E",transclude:true,template:_index2.default,controller:MonitoringMainController,controllerAs:"monitoringMain",bindToController:true,link:function link(scope,_element,attributes,controller){controller.setup({licenseService:license,breadcrumbsService:breadcrumbs,kbnUrlService:kbnUrl,attributes:{name:attributes.name,product:attributes.product,instance:attributes.instance,resolver:attributes.resolver,page:attributes.page,tabIconClass:attributes.tabIconClass,tabIconLabel:attributes.tabIconLabel,pipelineId:attributes.pipelineId,pipelineHash:attributes.pipelineHash,pipelineVersions:(0,_lodash.get)(scope,"pageData.versions")},clusterName:(0,_lodash.get)(scope,"cluster.cluster_name")})}}})},4201:function(module,exports){module.exports='<div class="app-container">\n  <kbn-top-nav name="{{ monitoringMain.name }}-nav">\n    \x3c!-- Transcluded elements. --\x3e\n    <div data-transclude-slots>\n      \x3c!-- Breadcrumbs. --\x3e\n      \x3c!-- NOTE: The KBN breadCrumbs directive does not work for Monitoring usecase.\n      Breadcrumbs can\'t be automatically derived because the directive doesn\'t\n      automatically know to show the Clusters breadcrumb. We recreate the\n      structure and styles manually --\x3e\n      <div data-transclude-slot="topLeftCorner" class="kuiLocalBreadcrumbs">\n        <div ng-repeat="crumb in monitoringMain.breadcrumbs" class="kuiLocalBreadcrumb">\n          <a\n            ng-if="crumb.url"\n            kbn-href="{{ crumb.url }}"\n            class="kuiLocalBreadcrumb__link"\n            data-test-subj="{{ crumb.testSubj }}"\n          >\n            {{ crumb.label }}\n          </a>\n\n          <span ng-if="!crumb.url">\n            {{ crumb.label }}\n          </span>\n        </div>\n      </div>\n\n      \x3c!-- Tabs --\x3e\n      <div data-transclude-slot="bottomRow">\n        <div ng-if="monitoringMain.inElasticsearch" class="kuiLocalTabs" role="navigation">\n          <a ng-if="!monitoringMain.instance" kbn-href="#/elasticsearch" class="kuiLocalTab" ng-class="{\'kuiLocalTab-isSelected\': monitoringMain.isActiveTab(\'overview\')}">Overview</a>\n          <a ng-if="!monitoringMain.instance" kbn-href="#/elasticsearch/nodes" class="kuiLocalTab" ng-class="{\'kuiLocalTab-isSelected\': monitoringMain.isActiveTab(\'nodes\')}">Nodes</a>\n          <a ng-if="!monitoringMain.instance" kbn-href="#/elasticsearch/indices" class="kuiLocalTab" ng-class="{\'kuiLocalTab-isSelected\': monitoringMain.isActiveTab(\'indices\')}">Indices</a>\n          <a ng-if="!monitoringMain.instance && monitoringMain.isMlSupported()" kbn-href="#/elasticsearch/ml_jobs" class="kuiLocalTab" ng-class="{\'kuiLocalTab-isSelected\': monitoringMain.isActiveTab(\'ml\')}">Jobs</a>\n          <a\n            ng-if="monitoringMain.instance && (monitoringMain.name === \'nodes\' || monitoringMain.name === \'indices\')"\n            kbn-href="#/elasticsearch/{{ monitoringMain.name }}/{{ monitoringMain.resolver }}"\n            class="kuiLocalTab"\n            ng-class="{\'kuiLocalTab-isSelected\': monitoringMain.page === \'overview\'}"\n          >\n            <span ng-if="monitoringMain.tabIconClass" class="fa {{ monitoringMain.tabIconClass }}" title="{{ monitoringMain.tabIconLabel }}"></span>\n            Overview\n          </a>\n          <a\n            ng-if="monitoringMain.instance && (monitoringMain.name === \'nodes\' || monitoringMain.name === \'indices\')"\n            kbn-href="#/elasticsearch/{{ monitoringMain.name }}/{{ monitoringMain.resolver }}/advanced"\n            class="kuiLocalTab"\n            ng-class="{\'kuiLocalTab-isSelected\': monitoringMain.page === \'advanced\'}"\n          >\n            Advanced\n          </a>\n            \x3c!-- ML Instance (for use later) --\x3e\n          <a\n            ng-if="monitoringMain.instance && monitoringMain.name !== \'nodes\' && monitoringMain.name !== \'indices\'"\n            class="kuiLocalTab">{{ monitoringMain.instance }}</a>\n        </div>\n\n        <div ng-if="monitoringMain.inKibana" class="kuiLocalTabs" role="navigation">\n          <a ng-if="!monitoringMain.instance" kbn-href="#/kibana" class="kuiLocalTab" ng-class="{\'kuiLocalTab-isSelected\': monitoringMain.isActiveTab(\'overview\')}">Overview</a>\n          <a ng-if="!monitoringMain.instance" kbn-href="#/kibana/instances" class="kuiLocalTab" ng-class="{\'kuiLocalTab-isSelected\': monitoringMain.isActiveTab(\'kibanas\')}">Instances</a>\n          <a ng-if="monitoringMain.instance" class="kuiLocalTab">{{ monitoringMain.instance }}</a>\n        </div>\n\n        <div ng-if="monitoringMain.inBeats" class="kuiLocalTabs" role="navigation">\n          <a\n            ng-if="!monitoringMain.instance"\n            kbn-href="#/beats"\n            class="kuiLocalTab"\n            ng-class="{\'kuiLocalTab-isSelected\':\n            monitoringMain.isActiveTab(\'overview\')}"\n          >\n            Overview\n          </a>\n          <a\n            ng-if="!monitoringMain.instance"\n            kbn-href="#/beats/beats"\n            class="kuiLocalTab"\n            ng-class="{\'kuiLocalTab-isSelected\': monitoringMain.isActiveTab(\'beats\')}"\n          >\n            Instances\n          </a>\n          <a\n            ng-if="monitoringMain.instance"\n            kbn-href="#/beats/beat/{{ monitoringMain.resolver }}"\n            class="kuiLocalTab"\n            ng-class="{\'kuiLocalTab-isSelected\': monitoringMain.page === \'overview\'}"\n          >\n            Overview\n          </a>\n        </div>\n\n        <div ng-if="monitoringMain.inLogstash" class="kuiLocalTabs" role="navigation">\n          <a\n            ng-if="!monitoringMain.instance && !monitoringMain.pipelineId"\n            kbn-href="#/logstash"\n            class="kuiLocalTab"\n            ng-class="{\'kuiLocalTab-isSelected\': monitoringMain.isActiveTab(\'overview\')}"\n          >\n            Overview\n          </a>\n          <a\n            ng-if="!monitoringMain.instance && !monitoringMain.pipelineId"\n            kbn-href="#/logstash/nodes"\n            class="kuiLocalTab"\n            ng-class="{\'kuiLocalTab-isSelected\': monitoringMain.isActiveTab(\'nodes\')}"\n          >\n            Nodes\n          </a>\n          <a\n            ng-if="!monitoringMain.instance && !monitoringMain.pipelineId"\n            kbn-href="#/logstash/pipelines"\n            class="kuiLocalTab"\n            ng-class="{\'kuiLocalTab-isSelected\': monitoringMain.isActiveTab(\'pipelines\')}"\n          >\n            <span class="kuiIcon fa-flask betaIcon" tooltip="Beta Feature" />\n            Pipelines\n          </a>\n          <a\n            ng-if="monitoringMain.instance"\n            kbn-href="#/logstash/node/{{ monitoringMain.resolver }}"\n            class="kuiLocalTab"\n            ng-class="{\'kuiLocalTab-isSelected\': monitoringMain.page === \'overview\'}"\n          >\n            Overview\n          </a>\n          <a\n            ng-if="monitoringMain.instance"\n            kbn-href="#/logstash/node/{{ monitoringMain.resolver }}/pipelines"\n            class="kuiLocalTab"\n            ng-class="{\'kuiLocalTab-isSelected\': monitoringMain.page === \'pipelines\'}"\n          >\n            <span class="kuiIcon fa-flask betaIcon" tooltip="Beta Feature" />\n            Pipelines\n          </a>\n          <a\n            ng-if="monitoringMain.instance"\n            kbn-href="#/logstash/node/{{ monitoringMain.resolver }}/advanced"\n            class="kuiLocalTab"\n            ng-class="{\'kuiLocalTab-isSelected\': monitoringMain.page === \'advanced\'}"\n          >\n            Advanced\n          </a>\n          <div\n            ng-if="monitoringMain.pipelineVersions"\n            class="kuiFlexGroup kuiFlexGroup--gutterMedium"\n          >\n            <h1 class="kuiTitle kuiFlexItem">{{ monitoringMain.pipelineId }}</h1>\n            <select\n              ng-model="monitoringMain.pipelineHash"\n              class="kuiSelect kuiFlexItem"\n              ng-change="monitoringMain.onChangePipelineHash()"\n            >\n              <option\n                ng-repeat="version in monitoringMain.pipelineVersions"\n                ng-value="version.hash"\n              >\n                Version active {{ version.relativeLastSeen }} and first seen {{ version.relativeFirstSeen }}\n              </option>\n            </select>\n          </div>\n        </div>\n\n        <div ng-if="monitoringMain.inOverview" class="kuiLocalTabs" role="navigation">\n          <a class="kuiLocalTab" data-test-subj="clusterName">{{ cluster.cluster_name }}</a>\n        </div>\n\n        <div ng-if="monitoringMain.inAlerts" class="kuiLocalTabs" role="navigation">\n          <a class="kuiLocalTab" data-test-subj="clusterAlertsListingPage">Cluster Alerts</a>\n        </div>\n\n        <div ng-if="monitoringMain.inListing" class="kuiLocalTabs" role="navigation">\n         <a class="kuiLocalTab">Clusters</a>\n       </div>\n      </div>\n    </div>\n  </kbn-top-nav>\n  <div ng-transclude></div>\n</div>\n'},4202:function(module,exports,__webpack_require__){"use strict";var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _reactDom=__webpack_require__(15);var _moment=__webpack_require__(10);var _moment2=_interopRequireDefault(_moment);var _modules=__webpack_require__(2);var _chart=__webpack_require__(651);var _tooltip=__webpack_require__(509);var _overlayTrigger=__webpack_require__(510);var _components=__webpack_require__(32);var _timefilter=__webpack_require__(14);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var uiModule=_modules.uiModules.get("plugins/monitoring/directives",[]);uiModule.directive("monitoringChart",function(){return{restrict:"E",scope:{series:"="},link:function link(scope,$elem){var series=scope.series;var units=(0,_chart.getUnits)(series);function onBrush(_ref){var xaxis=_ref.xaxis;_timefilter.timefilter.setTime({from:(0,_moment2.default)(xaxis.from),to:(0,_moment2.default)(xaxis.to),mode:"absolute"})}scope.$watch("series",function(series){(0,_reactDom.render)(_react2.default.createElement("div",{className:"monitoring-chart__container"},_react2.default.createElement("h2",{className:"euiTitle"},(0,_chart.getTitle)(series),units?" ("+units+")":"",_react2.default.createElement(_overlayTrigger.OverlayTrigger,{placement:"left",trigger:"click",overlay:_react2.default.createElement(_tooltip.Tooltip,null,_react2.default.createElement(_chart.InfoTooltip,{series:series}))},_react2.default.createElement("span",{className:"monitoring-chart-tooltip__trigger overlay-trigger"},_react2.default.createElement(_components.KuiInfoButton,null)))),_react2.default.createElement(_chart.MonitoringTimeseries,{series:series,onBrush:onBrush})),$elem[0])})}}})},4203:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.getColor=getColor;function getColor(app,index){var seriesColors=void 0;seriesColors="elasticsearch"===app?["#3ebeb0","#3b73ac","#f08656","#6c478f"]:["#e8488b","#3b73ac","#3cab63","#6c478f"];if(seriesColors[index])return seriesColors[index];return"#000"}},4204:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.TimeseriesVisualization=void 0;var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source)Object.prototype.hasOwnProperty.call(source,key)&&(target[key]=source[key])}return target};var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _lodash=__webpack_require__(1);var _lodash2=_interopRequireDefault(_lodash);var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _get_last_value=__webpack_require__(4205);var _timeseries_container=__webpack_require__(4206);var _horizontal_legend=__webpack_require__(4210);var _get_values_for_legend=__webpack_require__(4211);var _constants=__webpack_require__(64);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}var TimeseriesVisualization=exports.TimeseriesVisualization=function(_React$Component){_inherits(TimeseriesVisualization,_React$Component);function TimeseriesVisualization(props){_classCallCheck(this,TimeseriesVisualization);var _this=_possibleConstructorReturn(this,(TimeseriesVisualization.__proto__||Object.getPrototypeOf(TimeseriesVisualization)).call(this,props));_this.debouncedUpdateLegend=_lodash2.default.debounce(_this.updateLegend,_constants.DEBOUNCE_SLOW_MS);_this.debouncedUpdateLegend=_this.debouncedUpdateLegend.bind(_this);_this.toggleFilter=_this.toggleFilter.bind(_this);var values=_this.getLastValues(props);_this.state={values:{},seriesToShow:_lodash2.default.keys(values),ignoreVisibilityUpdates:false};return _this}_createClass(TimeseriesVisualization,[{key:"filterLegend",value:function filterLegend(id){if(!_lodash2.default.has(this.state.values,id))return[];var notAllShown=_lodash2.default.keys(this.state.values).length!==this.state.seriesToShow.length;var isCurrentlyShown=_lodash2.default.includes(this.state.seriesToShow,id);var seriesToShow=[];if(notAllShown&&isCurrentlyShown)this.setState({ignoreVisibilityUpdates:false,seriesToShow:Object.keys(this.state.values)});else{seriesToShow.push(id);this.setState({ignoreVisibilityUpdates:true,seriesToShow:[id]})}return seriesToShow}},{key:"toggleFilter",value:function toggleFilter(_event,id){var seriesToShow=this.filterLegend(id);_lodash2.default.isFunction(this.props.onFilter)&&this.props.onFilter(seriesToShow)}},{key:"getLastValues",value:function getLastValues(props){props=props||this.props;var values={};props.series.forEach(function(row){row.id||(row.id=row.label);values[row.id]=(0,_get_last_value.getLastValue)(row.data)});return values}},{key:"updateLegend",value:function updateLegend(pos,item){var values={};if(pos){var setValueCallback=function setValueCallback(seriesId,value){values[seriesId]=value};item?(0,_get_values_for_legend.getValuesForSeriesIndex)(this.props.series,item.dataIndex,setValueCallback):(0,_get_values_for_legend.getValuesByX)(this.props.series,pos.x,setValueCallback)}else _lodash2.default.assign(values,this.getLastValues());this.setState({values:values})}},{key:"componentWillReceiveProps",value:function componentWillReceiveProps(props){var values=this.getLastValues(props);var currentKeys=_lodash2.default.keys(this.state.values);var keys=_lodash2.default.keys(values);var diff=_lodash2.default.difference(keys,currentKeys);var nextState={values:values};diff.length&&!this.state.ignoreVisibilityUpdates&&(nextState.seriesToShow=keys);this.setState(nextState)}},{key:"render",value:function render(){var className="rhythm_chart";var style={flexDirection:"column"};var legend=this.props.hasLegend?_react2.default.createElement(_horizontal_legend.HorizontalLegend,_extends({seriesFilter:this.state.seriesToShow,seriesValues:this.state.values,onToggle:this.toggleFilter},this.props)):null;return _react2.default.createElement("div",{className:className},_react2.default.createElement("div",{style:style,className:"rhythm_chart__content"},_react2.default.createElement("div",{className:"rhythm_chart__visualization"},_react2.default.createElement(_timeseries_container.TimeseriesContainer,_extends({seriesToShow:this.state.seriesToShow,updateLegend:this.debouncedUpdateLegend},this.props))),legend))}}]);return TimeseriesVisualization}(_react2.default.Component);TimeseriesVisualization.defaultProps={hasLegend:true}},4205:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.getLastValue=getLastValue;var _lodash=__webpack_require__(1);function getLastValue(data){if((0,_lodash.isNumber)(data))return data;if(!Array.isArray(data))return null;var lastValue=(0,_lodash.get)((0,_lodash.last)(data),"[1]");if((0,_lodash.isNumber)(lastValue))return lastValue;return null}},4206:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.TimeseriesContainer=TimeseriesContainer;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _chart_target=__webpack_require__(4207);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function TimeseriesContainer(props){var container={display:"flex",rowDirection:"column",flex:"1 0 auto",position:"relative"};return _react2.default.createElement("div",{style:container},_react2.default.createElement(_chart_target.ChartTarget,props))}},4207:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.ChartTarget=void 0;var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source)Object.prototype.hasOwnProperty.call(source,key)&&(target[key]=source[key])}return target};var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _lodash=__webpack_require__(1);var _lodash2=_interopRequireDefault(_lodash);var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _jqueryFlot=__webpack_require__(893);var _jqueryFlot2=_interopRequireDefault(_jqueryFlot);var _event_bus=__webpack_require__(4208);var _get_chart_options=__webpack_require__(4209);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}exports.ChartTarget=function(_React$Component){_inherits(ChartTarget,_React$Component);function ChartTarget(){_classCallCheck(this,ChartTarget);return _possibleConstructorReturn(this,(ChartTarget.__proto__||Object.getPrototypeOf(ChartTarget)).apply(this,arguments))}_createClass(ChartTarget,[{key:"shouldComponentUpdate",value:function shouldComponentUpdate(){return!this.plot}},{key:"shutdownChart",value:function shutdownChart(){if(!this.plot)return;var target=this.refs.target;(0,_jqueryFlot2.default)(target).off("plothover");(0,_jqueryFlot2.default)(target).off("mouseleave");(0,_jqueryFlot2.default)(target).off("plotselected");(0,_jqueryFlot2.default)(target).off("plotselecting");this.plot.shutdown();_event_bus.eventBus.off("thorPlotHover");_event_bus.eventBus.off("thorPlotLeave");_event_bus.eventBus.off("thorPlotSelecting");_event_bus.eventBus.off("thorPlotBrush")}},{key:"componentWillUnmount",value:function componentWillUnmount(){this.shutdownChart();window.removeEventListener("resize",this._handleResize)}},{key:"filterByShow",value:function filterByShow(seriesToShow){if(seriesToShow)return function(metric){return seriesToShow.some(function(id){return _lodash2.default.startsWith(id,metric.id)})};return function(_metric){return true}}},{key:"componentWillReceiveProps",value:function componentWillReceiveProps(newProps){if(this.plot&&!_lodash2.default.isEqual(newProps,this.props)){var series=newProps.series,timeRange=newProps.timeRange;var xaxisOptions=this.plot.getAxes().xaxis.options;xaxisOptions.min=_lodash2.default.get(timeRange,"min");xaxisOptions.max=_lodash2.default.get(timeRange,"max");this.plot.setData(this.filterData(series,newProps.seriesToShow));this.plot.setupGrid();this.plot.draw()}}},{key:"componentDidMount",value:function componentDidMount(){this.renderChart();window.addEventListener("resize",this._handleResize,false)}},{key:"componentDidUpdate",value:function componentDidUpdate(){this.shutdownChart();this.renderChart()}},{key:"filterData",value:function filterData(data,seriesToShow){return(0,_lodash2.default)(data).filter(this.filterByShow(seriesToShow)).value()}},{key:"getOptions",value:function getOptions(){var opts=(0,_get_chart_options.getChartOptions)({yaxis:{tickFormatter:this.props.tickFormatter},xaxis:this.props.timeRange});return _extends({},opts,this.props.options)}},{key:"renderChart",value:function renderChart(){var _this2=this;var target=this.refs.target;var series=this.props.series;var data=this.filterData(series,this.props.seriesToShow);this.plot=_jqueryFlot2.default.plot(target,data,this.getOptions());this._handleResize=function(){if(!_this2.plot)return;try{_this2.plot.resize();_this2.plot.setupGrid();_this2.plot.draw()}catch(e){}};this.handleMouseLeave=function(){_event_bus.eventBus.trigger("thorPlotLeave",[])};this.handlePlotHover=function(_event,pos,item){_event_bus.eventBus.trigger("thorPlotHover",[pos,item,_this2.plot])};this.handleThorPlotHover=function(_event,pos,item,originalPlot){_this2.plot!==originalPlot&&_this2.plot.setCrosshair({x:_lodash2.default.get(pos,"x")});_this2.props.updateLegend(pos,item)};this.handleThorPlotLeave=function(){_this2.plot.clearCrosshair();_this2.props.updateLegend()};this.handleThorPlotSelecting=function(_event,xaxis,originalPlot){if(_this2.plot!==originalPlot){var preventEvent=true;_this2.plot.setSelection({xaxis:xaxis},preventEvent)}};this.handleThorPlotBrush=function(){_this2.plot.clearSelection()};this.selectingChart=function(_event,ranges){if(ranges){var xaxis=ranges.xaxis;_event_bus.eventBus.trigger("thorPlotSelecting",[xaxis,_this2.plot])}};this.brushChart=function(_event,ranges){_this2.props.onBrush(ranges);_event_bus.eventBus.trigger("thorPlotBrush")};(0,_jqueryFlot2.default)(target).on("plothover",this.handlePlotHover);(0,_jqueryFlot2.default)(target).on("mouseleave",this.handleMouseLeave);(0,_jqueryFlot2.default)(target).on("plotselected",this.brushChart);(0,_jqueryFlot2.default)(target).on("plotselecting",this.selectingChart);_event_bus.eventBus.on("thorPlotHover",this.handleThorPlotHover);_event_bus.eventBus.on("thorPlotLeave",this.handleThorPlotLeave);_event_bus.eventBus.on("thorPlotSelecting",this.handleThorPlotSelecting);_event_bus.eventBus.on("thorPlotBrush",this.handleThorPlotBrush)}},{key:"render",value:function render(){var style={position:"relative",display:"flex",rowDirection:"column",flex:"1 0 auto"};return _react2.default.createElement("div",{ref:"target",style:style})}}]);return ChartTarget}(_react2.default.Component)},4208:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.eventBus=void 0;var _jquery=__webpack_require__(13);var _jquery2=_interopRequireDefault(_jquery);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}exports.eventBus=(0,_jquery2.default)({})},4209:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.getChartOptions=getChartOptions;var _lodash=__webpack_require__(1);var _constants=__webpack_require__(64);function getChartOptions(axisOptions){var opts={legend:{show:false},xaxis:{color:_constants.CHART_LINE_COLOR,timezone:"browser",mode:"time",font:{color:_constants.CHART_TEXT_COLOR}},yaxis:{color:_constants.CHART_LINE_COLOR,font:{color:_constants.CHART_TEXT_COLOR}},series:{points:{show:true,radius:1},lines:{show:true,lineWidth:2},shadowSize:0},grid:{margin:0,borderWidth:1,borderColor:_constants.CHART_LINE_COLOR,hoverable:true},crosshair:{mode:"x",color:"#c66",lineWidth:2},selection:{mode:"x",color:_constants.CHART_TEXT_COLOR}};return(0,_lodash.merge)(opts,axisOptions)}},4210:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.HorizontalLegend=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _lodash=__webpack_require__(1);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}exports.HorizontalLegend=function(_React$Component){_inherits(HorizontalLegend,_React$Component);function HorizontalLegend(){_classCallCheck(this,HorizontalLegend);var _this=_possibleConstructorReturn(this,(HorizontalLegend.__proto__||Object.getPrototypeOf(HorizontalLegend)).call(this));_this.formatter=_this.formatter.bind(_this);_this.createSeries=_this.createSeries.bind(_this);return _this}_createClass(HorizontalLegend,[{key:"formatter",value:function formatter(value){if(null===value)return"N/A";if((0,_lodash.isFunction)(this.props.tickFormatter))return this.props.tickFormatter(value);return value}},{key:"createSeries",value:function createSeries(row,rowIdx){var _this2=this;var formatter=row.tickFormatter||this.formatter;var value=formatter(this.props.seriesValues[row.id]);var classes=["col-md-4 col-xs-6 rhythm_chart__legend-item"];(0,_lodash.includes)(this.props.seriesFilter,row.id)||classes.push("disabled");if(!row.label||false===row.legend)return _react2.default.createElement("div",{key:rowIdx,style:{display:"none"}});return _react2.default.createElement(_eui.EuiKeyboardAccessible,{key:rowIdx},_react2.default.createElement("div",{className:classes.join(" "),onClick:function onClick(event){return _this2.props.onToggle(event,row.id)}},_react2.default.createElement("span",{className:"rhythm_chart__legend-label"},_react2.default.createElement("span",{className:"fa fa-circle rhythm_chart__legend-indicator",style:{color:row.color},"aria-label":"toggle button"})," "+row.label),_react2.default.createElement("span",{className:"rhythm_chart__legend-value"}," "+value)))}},{key:"render",value:function render(){var rows=this.props.series.map(this.createSeries);return _react2.default.createElement("div",{className:"rhythm_chart__legend-horizontal"},_react2.default.createElement("div",{className:"row rhythm_chart__legend-series"},rows))}}]);return HorizontalLegend}(_react2.default.Component)},4211:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.getValuesForSeriesIndex=getValuesForSeriesIndex;exports.getValuesByX=getValuesByX;exports.findIndexByX=findIndexByX;function getValuesForSeriesIndex(datasets,index,callback){for(var i=0;i<datasets.length;i++){var series=datasets[i];var data=series.data;var y=null;data.length>index&&data[index]&&(y=data[index][1]);callback(series.id,y)}}function getValuesByX(datasets,x,callback){for(var i=0;i<datasets.length;i++){var index=findIndexByX(datasets[i].data,x);if(-1!==index){getValuesForSeriesIndex(datasets,index,callback);break}}}function findIndexByX(data,x){var length=data.length;if(1===length)return 0;if(0!==length){var prev=null;data[0]&&(prev=0);for(var j=1;j<length;++j)if(data[j]){if(data[j][0]>x){var currentDistance=data[j][0]-x;if(null!==prev&&currentDistance>Math.abs(x-data[prev][0]))return prev;return j}prev=j}}return length-1}},4212:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.MonitoringTimeseriesContainer=MonitoringTimeseriesContainer;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _tooltip=__webpack_require__(509);var _overlayTrigger=__webpack_require__(510);var _components=__webpack_require__(32);var _get_title=__webpack_require__(1502);var _get_units=__webpack_require__(1503);var _monitoring_timeseries=__webpack_require__(1496);var _info_tooltip=__webpack_require__(1501);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function MonitoringTimeseriesContainer(_ref){var series=_ref.series,onBrush=_ref.onBrush;if(void 0===series)return null;var units=(0,_get_units.getUnits)(series);return _react2.default.createElement("div",{className:"monitoring-chart__container"},_react2.default.createElement("h2",{className:"euiTitle"},(0,_get_title.getTitle)(series),units?" ("+units+")":"",_react2.default.createElement(_overlayTrigger.OverlayTrigger,{placement:"left",trigger:"click",overlay:_react2.default.createElement(_tooltip.Tooltip,null,_react2.default.createElement(_info_tooltip.InfoTooltip,{series:series}))},_react2.default.createElement("span",{className:"monitoring-chart-tooltip__trigger overlay-trigger"},_react2.default.createElement(_components.KuiInfoButton,null)))),_react2.default.createElement(_monitoring_timeseries.MonitoringTimeseries,{series:series,onBrush:onBrush}))}},4240:function(module,exports,__webpack_require__){"use strict";var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _reactDom=__webpack_require__(15);var _reactDom2=_interopRequireDefault(_reactDom);var _modules=__webpack_require__(2);var _sparkline=__webpack_require__(897);var _moment=__webpack_require__(10);var _moment2=_interopRequireDefault(_moment);var _format_number=__webpack_require__(59);var _timefilter=__webpack_require__(14);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var uiModule=_modules.uiModules.get("plugins/monitoring/directives",[]);uiModule.directive("sparkline",function($injector){var config=$injector.get("config");var dateFormat=config.get("dateFormat");return{restrict:"E",scope:{series:"="},link:function link(scope,$elem){function onBrush(xaxis){_timefilter.timefilter.setTime({from:(0,_moment2.default)(xaxis.from),to:(0,_moment2.default)(xaxis.to),mode:"absolute"})}function tooltipXValueFormatter(xValue){return(0,_moment2.default)(xValue).format(dateFormat)}function tooltipYValueFormatter(yValue){return(0,_format_number.formatMetric)(yValue,scope.series.metric.format,scope.series.metric.units)}scope.$watch("series",function(series){var options={xaxis:series.timeRange};_reactDom2.default.render(_react2.default.createElement(_sparkline.Sparkline,{series:series.data,onBrush:onBrush,options:options,tooltip:{xValueFormatter:tooltipXValueFormatter,yValueFormatter:tooltipYValueFormatter}}),$elem[0])},true);scope.$on("$destroy",function(){return _reactDom2.default.unmountComponentAtNode($elem[0])})}}})},4241:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.SparklineFlotChart=void 0;var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source)Object.prototype.hasOwnProperty.call(source,key)&&(target[key]=source[key])}return target};var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _lodash=__webpack_require__(1);var _jqueryFlot=__webpack_require__(893);var _jqueryFlot2=_interopRequireDefault(_jqueryFlot);var _constants=__webpack_require__(64);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}var flotOptions={grid:{show:false,margin:4,hoverable:true},colors:["#3b73ac"],series:{shadowSize:0,lines:{lineWidth:2},highlightColor:"#3b73ac",points:{radius:2}}};function makeData(){var series=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[];var data=[];data.push(series);data.push({data:[(0,_lodash.last)(series)],points:{show:true,radius:2,fill:1,fillColor:false}});return data}exports.SparklineFlotChart=function(){function SparklineFlotChart(containerElem,initialSeries,onBrush,onHover,overrideOptions){_classCallCheck(this,SparklineFlotChart);_initialiseProps.call(this);this.containerElem=containerElem;this.data=makeData(initialSeries);this.options=_extends({},flotOptions,overrideOptions);(0,_lodash.isFunction)(onBrush)&&this.setupBrushHandling(onBrush);(0,_lodash.isFunction)(onHover)&&this.setupHoverHandling(onHover);this.render();window.addEventListener("resize",this.render)}_createClass(SparklineFlotChart,[{key:"update",value:function update(series){this.flotChart.setData(makeData(series));this.flotChart.setupGrid();this.flotChart.draw()}},{key:"shutdown",value:function shutdown(){this.flotChart.shutdown();var container=(0,_jqueryFlot2.default)(this.containerElem);container.off("plotselected");container.off("plothover");window.removeEventListener("resize",this.render)}}]);return SparklineFlotChart}();var _initialiseProps=function _initialiseProps(){var _this=this;this.render=function(){_this.flotChart=_jqueryFlot2.default.plot(_this.containerElem,_this.data,_this.options)};this.setupBrushHandling=function(onBrush){_this.options.selection={mode:"x",color:"#9c9c9c"};(0,_jqueryFlot2.default)(_this.containerElem).off("plotselected");(0,_jqueryFlot2.default)(_this.containerElem).on("plotselected",function(_event,range){onBrush(range.xaxis);_this.flotChart.clearSelection()})};this.setupHoverHandling=function(onHover){var container=(0,_jqueryFlot2.default)(_this.containerElem);var debouncedOnHover=(0,_lodash.debounce)(function(_event,_range,item){if(null===item)return onHover();onHover({xValue:item.datapoint[0],yValue:item.datapoint[1],xPosition:item.pageX-window.pageXOffset,yPosition:item.pageY-window.pageYOffset,plotTop:container.offset().top,plotLeft:container.offset().left,plotHeight:container.height(),plotWidth:container.width()})},_constants.DEBOUNCE_FAST_MS,{leading:true});container.off("plothover");container.on("plothover",debouncedOnHover)}}},4242:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _reactDom=__webpack_require__(15);var _eui=__webpack_require__(3);var _modules=__webpack_require__(2);var _components=__webpack_require__(32);var _table=__webpack_require__(256);var _constants=__webpack_require__(64);var _tooltip=__webpack_require__(376);var _formatted_message=__webpack_require__(1509);var _map_severity=__webpack_require__(898);var _format_timestamp_to_duration=__webpack_require__(653);var _formatting=__webpack_require__(375);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var linkToCategories={"elasticsearch/nodes":"Elasticsearch Nodes","elasticsearch/indices":"Elasticsearch Indices","kibana/instances":"Kibana Instances","logstash/instances":"Logstash Nodes"};var filterFields=["message","severity_group","prefix","suffix","metadata.link","since","timestamp","update_timestamp"];var columns=[{title:"Status",sortKey:"metadata.severity",sortOrder:_constants.SORT_DESCENDING},{title:"Resolved",sortKey:"resolved_timestamp"},{title:"Message",sortKey:"message"},{title:"Category",sortKey:"metadata.link"},{title:"Last Checked",sortKey:"update_timestamp"},{title:"Triggered",sortKey:"timestamp"}];var alertRowFactory=function alertRowFactory(scope,kbnUrl){return function(props){var changeUrl=function changeUrl(target){scope.$evalAsync(function(){kbnUrl.changePath(target)})};var severityIcon=(0,_map_severity.mapSeverity)(props.metadata.severity);var resolution={icon:null,text:"Not Resolved"};props.resolved_timestamp?resolution.text=(0,_format_timestamp_to_duration.formatTimestampToDuration)(props.resolved_timestamp,_constants.CALCULATE_DURATION_SINCE)+" ago":resolution.icon=_react2.default.createElement(_eui.EuiIcon,{type:"alert",size:"m","aria-label":"Not Resolved"});return _react2.default.createElement(_components.KuiTableRow,null,_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement(_tooltip.Tooltip,{text:severityIcon.title,placement:"bottom",trigger:"hover"},_react2.default.createElement(_eui.EuiHealth,{color:severityIcon.color,"data-test-subj":"alertIcon","aria-label":severityIcon.title},(0,_lodash.capitalize)(severityIcon.value)))),_react2.default.createElement(_components.KuiTableRowCell,null,resolution.icon," ",resolution.text),_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement(_formatted_message.FormattedMessage,{prefix:props.prefix,suffix:props.suffix,message:props.message,metadata:props.metadata,changeUrl:changeUrl})),_react2.default.createElement(_components.KuiTableRowCell,null,linkToCategories[props.metadata.link]?linkToCategories[props.metadata.link]:"General"),_react2.default.createElement(_components.KuiTableRowCell,null,(0,_formatting.formatDateTimeLocal)(props.update_timestamp)),_react2.default.createElement(_components.KuiTableRowCell,null,(0,_format_timestamp_to_duration.formatTimestampToDuration)(props.timestamp,_constants.CALCULATE_DURATION_SINCE)," ago"))}};var uiModule=_modules.uiModules.get("monitoring/directives",[]);uiModule.directive("monitoringClusterAlertsListing",function(kbnUrl){return{restrict:"E",scope:{alerts:"="},link:function link(scope,$el){scope.$watch("alerts",function(){var alerts=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[];var alertsTable=_react2.default.createElement(_table.MonitoringTable,{className:"alertsTable",rows:alerts,placeholder:"Filter Alerts...",filterFields:filterFields,columns:columns,rowComponent:alertRowFactory(scope,kbnUrl)});(0,_reactDom.render)(alertsTable,$el[0])})}}})},4243:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.MonitoringTable=void 0;var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source)Object.prototype.hasOwnProperty.call(source,key)&&(target[key]=source[key])}return target};var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _lodash=__webpack_require__(1);var _constants=__webpack_require__(64);var _components=__webpack_require__(32);var _toolbar=__webpack_require__(4244);var _no_data=__webpack_require__(4245);var _footer=__webpack_require__(4246);var _classnames=__webpack_require__(5);var _classnames2=_interopRequireDefault(_classnames);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}var MonitoringTable=exports.MonitoringTable=function(_React$Component){_inherits(MonitoringTable,_React$Component);function MonitoringTable(props){_classCallCheck(this,MonitoringTable);var _this=_possibleConstructorReturn(this,(MonitoringTable.__proto__||Object.getPrototypeOf(MonitoringTable)).call(this,props));var sortKey=props.sortKey;var sortOrder=props.sortOrder;if(void 0===props.sortKey||void 0===props.sortOrder){var defaultSortColumn=props.columns.find(function(c){return c.hasOwnProperty("sortOrder")});sortKey=defaultSortColumn?defaultSortColumn.sortKey:null;sortOrder=defaultSortColumn?defaultSortColumn.sortOrder:null}var secondarySortColumn=props.columns.find(function(c){return c.hasOwnProperty("secondarySortOrder")});var secondarySortKey=secondarySortColumn?secondarySortColumn.sortKey:null;var secondarySortOrder=secondarySortColumn?secondarySortColumn.secondarySortOrder:null;_this.state={rows:props.rows,sortKey:sortKey,sortOrder:sortOrder,secondarySortKey:secondarySortKey,secondarySortOrder:secondarySortOrder,filterText:props.filterText||"",pageIndex:props.pageIndex||1};_this.paginationOnPrevious=_this.paginationOnPrevious.bind(_this);_this.paginationOnNext=_this.paginationOnNext.bind(_this);_this.onFilterChange=_this.onFilterChange.bind(_this);_this.dispatchTableAction=_this.dispatchTableAction.bind(_this);return _this}_createClass(MonitoringTable,[{key:"setFilter",value:function setFilter(filterText){var _this2=this;this.setState(function(prevState){var newState=_extends({},prevState,{pageIndex:1,filterText:filterText});_this2.onNewState(newState);return newState})}},{key:"resetPaging",value:function resetPaging(){var _this3=this;this.setState(function(prevState){var newState=_extends({},prevState,{pageIndex:1});_this3.onNewState(newState);return newState})}},{key:"dispatchTableAction",value:function dispatchTableAction(action,value){switch(action){case _constants.TABLE_ACTION_UPDATE_FILTER:this.setFilter(value);break;case _constants.TABLE_ACTION_RESET_PAGING:this.resetPaging();break;default:throw new Error("Unknown table action type "+action+"! This shouldn't happen!")}}},{key:"onNewState",value:function onNewState(newState){this.props.onNewState&&this.props.onNewState(newState)}},{key:"shouldComponentUpdate",value:function shouldComponentUpdate(nextProps,nextState){var diffRows=!(0,_lodash.isEqual)(nextProps.rows,this.props.rows);var diffState=!(0,_lodash.isEqual)(nextState,this.state);if(diffRows||diffState)return true;return false}},{key:"componentWillReceiveProps",value:function componentWillReceiveProps(_ref){var rows=_ref.rows;this.setState({rows:rows})}},{key:"checkRowFilterMatch",value:function checkRowFilterMatch(row){var values=this.props.filterFields.map(function(field){return(0,_lodash.get)(row,field)});return(0,_lodash.includes)(values.join(" ").toLowerCase(),this.state.filterText.toLowerCase())}},{key:"getFilteredRows",value:function getFilteredRows(){var _this4=this;var rows=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[];if(!this.state.filterText)return rows;return rows.filter(function(row){return _this4.checkRowFilterMatch(row)})}},{key:"onFilterChange",value:function onFilterChange(filterText){this.setFilter(filterText)}},{key:"paginationHasPrevious",value:function paginationHasPrevious(){return this.state.pageIndex>1}},{key:"paginationOnPrevious",value:function paginationOnPrevious(){var _this5=this;this.setState(function(prevState){var newState=_extends({},prevState,{pageIndex:prevState.pageIndex-1});_this5.onNewState(newState);return newState})}},{key:"paginationHasNext",value:function paginationHasNext(numAvailableRows){var pageIndex=this.state.pageIndex;var numPages=Math.ceil(numAvailableRows/this.props.rowsPerPage);return pageIndex<numPages}},{key:"paginationOnNext",value:function paginationOnNext(){var _this6=this;this.setState(function(prevState){var newState=_extends({},prevState,{pageIndex:prevState.pageIndex+1});_this6.onNewState(newState);return newState})}},{key:"getPaginationControls",value:function getPaginationControls(numAvailableRows,alwaysShowPageControls){var shouldShow=false;(this.isPaginationRequired(numAvailableRows)||alwaysShowPageControls)&&(shouldShow=true);if(!shouldShow)return null;var hasPrevious=this.paginationHasPrevious();var hasNext=this.paginationHasNext(numAvailableRows);return _react2.default.createElement(_components.KuiPagerButtonGroup,{hasNext:hasNext,hasPrevious:hasPrevious,onPrevious:this.paginationOnPrevious,onNext:this.paginationOnNext})}},{key:"calculateFirstRow",value:function calculateFirstRow(){return this.state.pageIndex*this.props.rowsPerPage-this.props.rowsPerPage}},{key:"getToolBar",value:function getToolBar(numVisibleRows,numAvailableRows){var firstRow=this.calculateFirstRow();return _react2.default.createElement(_toolbar.MonitoringTableToolBar,_extends({showSearchBox:this.isSearchBoxShown(),pageIndexFirstRow:numVisibleRows?firstRow+1:0,pageIndexLastRow:numVisibleRows?numVisibleRows+firstRow:0,rowsFiltered:numAvailableRows,filterText:this.state.filterText,paginationControls:this.getPaginationControls(numAvailableRows,this.props.alwaysShowPageControls),onFilterChange:this.onFilterChange,dispatchTableAction:this.dispatchTableAction},this.props))}},{key:"setSortColumn",value:function setSortColumn(_ref2){var _this7=this;var sortKey=_ref2.sortKey;this.setState(function(prevState){var newSortOrder=void 0;newSortOrder=sortKey===_this7.state.sortKey?-1*prevState.sortOrder:1;var newState=_extends({},prevState,{sortOrder:newSortOrder,sortKey:sortKey});_this7.onNewState(newState);return newState})}},{key:"getTableHeader",value:function getTableHeader(){var _this8=this;return this.props.columns.map(function(col){var headerCellProps={};col.headerCellProps&&Object.assign(headerCellProps,col.headerCellProps);var colKey=(0,_lodash.camelCase)(col.title);return _react2.default.createElement(_components.KuiTableHeaderCell,_extends({key:"kuiTableHeaderCell-"+colKey,onSort:null!==col.sortKey?_this8.setSortColumn.bind(_this8,col):null,isSorted:_this8.state.sortKey===col.sortKey,isSortAscending:_this8.state.sortKey!==col.sortKey||_this8.state.sortOrder>0,"data-test-subj":"tableHeaderCell-"+colKey},headerCellProps),col.title)})}},{key:"getFooter",value:function getFooter(numVisibleRows,numAvailableRows,alwaysShowPageControls){if(!this.isPaginationRequired(numAvailableRows))return null;var firstRow=this.calculateFirstRow();return _react2.default.createElement(_footer.MonitoringTableFooter,{pageIndexFirstRow:numVisibleRows?firstRow+1:0,pageIndexLastRow:numVisibleRows?numVisibleRows+firstRow:0,rowsFiltered:numAvailableRows,paginationControls:this.getPaginationControls(numAvailableRows,alwaysShowPageControls)})}},{key:"sortRows",value:function sortRows(){var rows=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[];if(!this.state.sortKey)return rows;var _sortOrder=this.state.sortOrder>0?"asc":"desc";var _secondarySortOrder=void 0;this.state.secondarySortOrder&&(_secondarySortOrder=this.state.secondarySortOrder>0?"asc":"desc");return(0,_lodash.sortByOrder)(rows,[this.state.sortKey,this.state.secondarySortKey],[_sortOrder,_secondarySortOrder])}},{key:"getVisibleRows",value:function getVisibleRows(rows){var filteredRows=this.getFilteredRows(rows);var numAvailableRows=filteredRows.length;var sortedRows=this.sortRows(filteredRows);var firstRow=this.calculateFirstRow();var visibleRows=sortedRows.slice(firstRow,firstRow+this.props.rowsPerPage)||[];return{numAvailableRows:numAvailableRows,visibleRows:visibleRows}}},{key:"isPaginationRequired",value:function isPaginationRequired(numAvailableRows){var hasPrevious=this.paginationHasPrevious();var hasNext=this.paginationHasNext(numAvailableRows);return hasPrevious||hasNext}},{key:"isSearchBoxShown",value:function isSearchBoxShown(){return Boolean(this.props.filterFields)&&this.props.filterFields.length>0}},{key:"render",value:function render(){var _this9=this;var classes=(0,_classnames2.default)(this.props.className,"monitoringTable");var table=void 0;var _getVisibleRows=this.getVisibleRows(this.state.rows||[]),visibleRows=_getVisibleRows.visibleRows,numAvailableRows=_getVisibleRows.numAvailableRows;var numVisibleRows=visibleRows.length;if(null===this.state.rows)table=_react2.default.createElement(_no_data.MonitoringTableNoData,{message:"Loading..."});else if(numVisibleRows>0){var RowComponent=this.props.rowComponent;var tBody=visibleRows.map(function(rowData,rowIndex){return _react2.default.createElement(RowComponent,_extends({},rowData,{key:"rowData-"+rowIndex,dispatchTableAction:_this9.dispatchTableAction}))});table=_react2.default.createElement(_components.KuiTable,{shrinkToContent:true},_react2.default.createElement("thead",null,_react2.default.createElement("tr",null,this.getTableHeader())),_react2.default.createElement("tbody",{"data-test-subj":this.props.className+"Body"},tBody))}else table=_react2.default.createElement(_no_data.MonitoringTableNoData,{message:this.props.getNoDataMessage(this.state.filterText)});return _react2.default.createElement(_components.KuiControlledTable,{className:classes,"data-test-subj":this.props.className+"Container"},this.getToolBar(numVisibleRows,numAvailableRows),table,this.getFooter(numVisibleRows,numAvailableRows,this.props.alwaysShowPageControls))}}]);return MonitoringTable}(_react2.default.Component);var defaultGetNoDataMessage=function defaultGetNoDataMessage(filterText){if(filterText)return _constants.DEFAULT_NO_DATA_MESSAGE_WITH_FILTER.replace("{{FILTER}}",filterText.trim());return _constants.DEFAULT_NO_DATA_MESSAGE};MonitoringTable.defaultProps={rows:[],filterFields:[],getNoDataMessage:defaultGetNoDataMessage,alwaysShowPageControls:false,rowsPerPage:20}},4244:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.MonitoringTableToolBar=MonitoringTableToolBar;var _lodash=__webpack_require__(1);var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _components=__webpack_require__(32);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function MonitoringTableToolBar(props){var searchBox=props.showSearchBox?_react2.default.createElement(_components.KuiToolBarSearchBox,{defaultValue:props.filterText,onFilter:props.onFilterChange,placeholder:props.placeholder,"data-test-subj":"monitoringTableToolBar"}):null;var paginationSection=Boolean(props.paginationControls)?_react2.default.createElement(_components.KuiToolBarSection,null,_react2.default.createElement(_components.KuiToolBarText,null,props.pageIndexFirstRow," – ",props.pageIndexLastRow," of ",props.rowsFiltered),props.paginationControls):null;return _react2.default.createElement(_components.KuiToolBar,null,searchBox,props.renderToolBarSections(props),paginationSection)}MonitoringTableToolBar.defaultProps={renderToolBarSections:_lodash.noop,showSearchBox:true}},4245:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.MonitoringTableNoData=MonitoringTableNoData;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _components=__webpack_require__(32);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function MonitoringTableNoData(_ref){var message=_ref.message;return _react2.default.createElement(_components.KuiEmptyTablePromptPanel,{"data-test-subj":"monitoringTableNoData"},_react2.default.createElement(_components.KuiTableInfo,null,message))}},4246:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.MonitoringTableFooter=MonitoringTableFooter;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _components=__webpack_require__(32);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function MonitoringTableFooter(_ref){var pageIndexFirstRow=_ref.pageIndexFirstRow,pageIndexLastRow=_ref.pageIndexLastRow,rowsFiltered=_ref.rowsFiltered,paginationControls=_ref.paginationControls;return _react2.default.createElement(_components.KuiToolBarFooter,null,_react2.default.createElement(_components.KuiToolBarFooterSection,null,_react2.default.createElement(_components.KuiToolBarText,null,pageIndexFirstRow," – ",pageIndexLastRow," of ",rowsFiltered),paginationControls))}},4247:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.tableStorageSetter=exports.tableStorageGetter=void 0;var _lodash=__webpack_require__(1);var _constants=__webpack_require__(64);exports.tableStorageGetter=function tableStorageGetter(keyPrefix){return function(storage){var localStorageData=storage.get(_constants.STORAGE_KEY)||{};var filterText=(0,_lodash.get)(localStorageData,[keyPrefix,"filterText"]);var pageIndex=(0,_lodash.get)(localStorageData,[keyPrefix,"pageIndex"]);var sortKey=(0,_lodash.get)(localStorageData,[keyPrefix,"sortKey"]);var sortOrder=(0,_lodash.get)(localStorageData,[keyPrefix,"sortOrder"]);return{pageIndex:pageIndex,filterText:filterText,sortKey:sortKey,sortOrder:sortOrder}}};exports.tableStorageSetter=function tableStorageSetter(keyPrefix){return function(storage,_ref){var filterText=_ref.filterText,pageIndex=_ref.pageIndex,sortKey=_ref.sortKey,sortOrder=_ref.sortOrder;var localStorageData=storage.get(_constants.STORAGE_KEY)||{};(0,_lodash.set)(localStorageData,[keyPrefix,"filterText"],filterText||void 0);(0,_lodash.set)(localStorageData,[keyPrefix,"pageIndex"],pageIndex||void 0);(0,_lodash.set)(localStorageData,[keyPrefix,"sortKey"],sortKey||void 0);(0,_lodash.set)(localStorageData,[keyPrefix,"sortOrder"],sortOrder||void 0);storage.set(_constants.STORAGE_KEY,localStorageData);return localStorageData}}},4248:function(module,exports,__webpack_require__){"use strict";var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _reactDom=__webpack_require__(15);var _reactDom2=_interopRequireDefault(_reactDom);var _overview=__webpack_require__(4249);var _modules=__webpack_require__(2);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var uiModule=_modules.uiModules.get("monitoring/directives",[]);uiModule.directive("monitoringClusterOverview",function(kbnUrl,showLicenseExpiration){return{restrict:"E",scope:{cluster:"="},link:function link(scope,$el){var changeUrl=function changeUrl(target){scope.$evalAsync(function(){kbnUrl.changePath(target)})};scope.$watch("cluster",function(cluster){_reactDom2.default.render(_react2.default.createElement(_overview.Overview,{cluster:cluster,changeUrl:changeUrl,showLicenseExpiration:showLicenseExpiration}),$el[0])})}}})},4249:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source)Object.prototype.hasOwnProperty.call(source,key)&&(target[key]=source[key])}return target};exports.Overview=Overview;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _elasticsearch_panel=__webpack_require__(4250);var _kibana_panel=__webpack_require__(4252);var _logstash_panel=__webpack_require__(4253);var _alerts_panel=__webpack_require__(4254);var _beats_panel=__webpack_require__(4255);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function Overview(props){return _react2.default.createElement(_eui.EuiPage,null,_react2.default.createElement(_eui.EuiPageBody,null,_react2.default.createElement(_alerts_panel.AlertsPanel,{alerts:props.cluster.alerts,changeUrl:props.changeUrl}),_react2.default.createElement(_elasticsearch_panel.ElasticsearchPanel,_extends({},props.cluster.elasticsearch,{version:props.cluster.version,ml:props.cluster.ml,changeUrl:props.changeUrl,license:props.cluster.license,showLicenseExpiration:props.showLicenseExpiration})),_react2.default.createElement(_kibana_panel.KibanaPanel,_extends({},props.cluster.kibana,{changeUrl:props.changeUrl})),_react2.default.createElement(_logstash_panel.LogstashPanel,_extends({},props.cluster.logstash,{changeUrl:props.changeUrl})),_react2.default.createElement(_beats_panel.BeatsPanel,_extends({},props.cluster.beats,{changeUrl:props.changeUrl}))))}},4250:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source)Object.prototype.hasOwnProperty.call(source,key)&&(target[key]=source[key])}return target};exports.ElasticsearchPanel=ElasticsearchPanel;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _lodash=__webpack_require__(1);var _format_number=__webpack_require__(59);var _helpers=__webpack_require__(654);var _eui=__webpack_require__(3);var _license_text=__webpack_require__(4251);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var calculateShards=function calculateShards(shards){var total=(0,_lodash.get)(shards,"total",0);var primaries=(0,_lodash.get)(shards,"primaries","N/A");var replicas="N/A";if("N/A"!==primaries){replicas=(0,_format_number.formatNumber)(total-primaries,"int_commas");primaries=(0,_format_number.formatNumber)(primaries,"int_commas")}return{primaries:primaries,replicas:replicas}};function ElasticsearchPanel(props){var clusterStats=props.cluster_stats||{};var nodes=clusterStats.nodes;var indices=clusterStats.indices;var goToElasticsearch=function goToElasticsearch(){return props.changeUrl("elasticsearch")};var goToNodes=function goToNodes(){return props.changeUrl("elasticsearch/nodes")};var goToIndices=function goToIndices(){return props.changeUrl("elasticsearch/indices")};var _calculateShards=calculateShards((0,_lodash.get)(props,"cluster_stats.indices.shards",{})),primaries=_calculateShards.primaries,replicas=_calculateShards.replicas;var statusIndicator=_react2.default.createElement(_helpers.HealthStatusIndicator,{status:clusterStats.status});var showMlJobs=function showMlJobs(){if(props.ml)return[_react2.default.createElement(_eui.EuiDescriptionListTitle,{key:"mlJobsListTitle"},"Jobs"),_react2.default.createElement(_eui.EuiDescriptionListDescription,{key:"mlJobsCount","data-test-subj":"esMlJobs"},props.ml.jobs)];return null};var licenseText=_react2.default.createElement(_license_text.LicenseText,{license:props.license,showLicenseExpiration:props.showLicenseExpiration});return _react2.default.createElement(_helpers.ClusterItemContainer,_extends({},props,{statusIndicator:statusIndicator,url:"elasticsearch",title:"Elasticsearch",extras:licenseText}),_react2.default.createElement(_eui.EuiFlexGrid,{columns:3},_react2.default.createElement(_eui.EuiFlexItem,null,_react2.default.createElement(_eui.EuiPanel,{paddingSize:"m"},_react2.default.createElement(_eui.EuiTitle,{size:"s"},_react2.default.createElement("h3",null,_react2.default.createElement(_eui.EuiLink,{onClick:goToElasticsearch,"aria-label":"Elasticsearch Overview","data-test-subj":"esOverview"},"Overview"))),_react2.default.createElement(_eui.EuiHorizontalRule,{margin:"m"}),_react2.default.createElement(_eui.EuiDescriptionList,{type:"column"},_react2.default.createElement(_eui.EuiDescriptionListTitle,null,"Version"),_react2.default.createElement(_eui.EuiDescriptionListDescription,{"data-test-subj":"esVersion"},props.version||"N/A"),_react2.default.createElement(_eui.EuiDescriptionListTitle,null,"Uptime"),_react2.default.createElement(_eui.EuiDescriptionListDescription,{"data-test-subj":"esUptime"},(0,_format_number.formatNumber)((0,_lodash.get)(nodes,"jvm.max_uptime_in_millis"),"time_since")),showMlJobs()))),_react2.default.createElement(_eui.EuiFlexItem,null,_react2.default.createElement(_eui.EuiPanel,{paddingSize:"m"},_react2.default.createElement(_eui.EuiTitle,{size:"s"},_react2.default.createElement("h3",null,_react2.default.createElement(_eui.EuiLink,{"data-test-subj":"esNumberOfNodes",onClick:goToNodes},"Nodes: ",(0,_format_number.formatNumber)((0,_lodash.get)(nodes,"count.total"),"int_commas")))),_react2.default.createElement(_eui.EuiHorizontalRule,{margin:"m"}),_react2.default.createElement(_eui.EuiDescriptionList,{type:"column"},_react2.default.createElement(_eui.EuiDescriptionListTitle,null,"Disk Available"),_react2.default.createElement(_eui.EuiDescriptionListDescription,{"data-test-subj":"esDiskAvailable"},_react2.default.createElement(_helpers.BytesUsage,{usedBytes:(0,_lodash.get)(nodes,"fs.available_in_bytes"),maxBytes:(0,_lodash.get)(nodes,"fs.total_in_bytes")})),_react2.default.createElement(_eui.EuiDescriptionListTitle,null,"JVM Heap"),_react2.default.createElement(_eui.EuiDescriptionListDescription,{"data-test-subj":"esJvmHeap"},_react2.default.createElement(_helpers.BytesPercentageUsage,{usedBytes:(0,_lodash.get)(nodes,"jvm.mem.heap_used_in_bytes"),maxBytes:(0,_lodash.get)(nodes,"jvm.mem.heap_max_in_bytes")}))))),_react2.default.createElement(_eui.EuiFlexItem,null,_react2.default.createElement(_eui.EuiPanel,{paddingSize:"m"},_react2.default.createElement(_eui.EuiTitle,{size:"s"},_react2.default.createElement("h3",null,_react2.default.createElement(_eui.EuiLink,{onClick:goToIndices,"data-test-subj":"esNumberOfIndices","aria-label":"Elasticsearch Indices: "+(0,_format_number.formatNumber)((0,_lodash.get)(indices,"count"),"int_commas")},"Indices: ",(0,_format_number.formatNumber)((0,_lodash.get)(indices,"count"),"int_commas")))),_react2.default.createElement(_eui.EuiHorizontalRule,{margin:"m"}),_react2.default.createElement(_eui.EuiDescriptionList,{type:"column"},_react2.default.createElement(_eui.EuiDescriptionListTitle,null,"Documents"),_react2.default.createElement(_eui.EuiDescriptionListDescription,{"data-test-subj":"esDocumentsCount"},(0,_format_number.formatNumber)((0,_lodash.get)(indices,"docs.count"),"int_commas")),_react2.default.createElement(_eui.EuiDescriptionListTitle,null,"Disk Usage"),_react2.default.createElement(_eui.EuiDescriptionListDescription,{"data-test-subj":"esDiskUsage"},(0,_format_number.formatNumber)((0,_lodash.get)(indices,"store.size_in_bytes"),"byte")),_react2.default.createElement(_eui.EuiDescriptionListTitle,null,"Primary Shards"),_react2.default.createElement(_eui.EuiDescriptionListDescription,{"data-test-subj":"esPrimaryShards"},primaries),_react2.default.createElement(_eui.EuiDescriptionListTitle,null,"Replica Shards"),_react2.default.createElement(_eui.EuiDescriptionListDescription,{"data-test-subj":"esReplicaShards"},replicas))))))}},4251:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.LicenseText=LicenseText;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _momentTimezone=__webpack_require__(125);var _momentTimezone2=_interopRequireDefault(_momentTimezone);var _lodash=__webpack_require__(1);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var formatDateLocal=function formatDateLocal(input){return _momentTimezone2.default.tz(input,_momentTimezone2.default.tz.guess()).format("LL")};var WillExpireOn=function WillExpireOn(_ref){var expiryDate=_ref.expiryDate;if(void 0===expiryDate)return null;return _react2.default.createElement(_react.Fragment,null," will expire on ",formatDateLocal(expiryDate))};function LicenseText(_ref2){var license=_ref2.license,showLicenseExpiration=_ref2.showLicenseExpiration;if(!showLicenseExpiration)return null;return _react2.default.createElement(_eui.EuiLink,{href:"#/license"},(0,_lodash.capitalize)(license.type)," license ",_react2.default.createElement(WillExpireOn,{expiryDate:license.expiry_date_in_millis}))}},4252:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source)Object.prototype.hasOwnProperty.call(source,key)&&(target[key]=source[key])}return target};exports.KibanaPanel=KibanaPanel;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _format_number=__webpack_require__(59);var _helpers=__webpack_require__(654);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function KibanaPanel(props){if(!props.count)return null;var statusIndicator=_react2.default.createElement(_helpers.HealthStatusIndicator,{status:props.status});var goToKibana=function goToKibana(){return props.changeUrl("kibana")};var goToInstances=function goToInstances(){return props.changeUrl("kibana/instances")};return _react2.default.createElement(_helpers.ClusterItemContainer,_extends({},props,{statusIndicator:statusIndicator,url:"kibana",title:"Kibana"}),_react2.default.createElement(_eui.EuiFlexGrid,{columns:2},_react2.default.createElement(_eui.EuiFlexItem,null,_react2.default.createElement(_eui.EuiPanel,{paddingSize:"m"},_react2.default.createElement(_eui.EuiTitle,{size:"s"},_react2.default.createElement("h3",null,_react2.default.createElement(_eui.EuiLink,{onClick:goToKibana,"aria-label":"Kibana Overview","data-test-subj":"kbnOverview"},"Overview"))),_react2.default.createElement(_eui.EuiHorizontalRule,{margin:"m"}),_react2.default.createElement(_eui.EuiDescriptionList,{type:"column","data-test-subj":"kibana_overview","data-overview-status":props.status},_react2.default.createElement(_eui.EuiDescriptionListTitle,null,"Requests"),_react2.default.createElement(_eui.EuiDescriptionListDescription,{"data-test-subj":"kbnRequests"},props.requests_total),_react2.default.createElement(_eui.EuiDescriptionListTitle,null,"Max. Response Time"),_react2.default.createElement(_eui.EuiDescriptionListDescription,{"data-test-subj":"kbnMaxResponseTime"},props.response_time_max," ms")))),_react2.default.createElement(_eui.EuiFlexItem,null,_react2.default.createElement(_eui.EuiPanel,{paddingSize:"m"},_react2.default.createElement(_eui.EuiTitle,{size:"s"},_react2.default.createElement("h3",null,_react2.default.createElement(_eui.EuiLink,{onClick:goToInstances,"data-test-subj":"kbnInstances","aria-label":"Kibana Instances: "+props.count},"Instances: ",_react2.default.createElement("span",{"data-test-subj":"number_of_kibana_instances"},props.count)))),_react2.default.createElement(_eui.EuiHorizontalRule,{margin:"m"}),_react2.default.createElement(_eui.EuiDescriptionList,{type:"column"},_react2.default.createElement(_eui.EuiDescriptionListTitle,null,"Connections"),_react2.default.createElement(_eui.EuiDescriptionListDescription,{"data-test-subj":"kbnConnections"},(0,_format_number.formatNumber)(props.concurrent_connections,"int_commas")),_react2.default.createElement(_eui.EuiDescriptionListTitle,null,"Memory Usage"),_react2.default.createElement(_eui.EuiDescriptionListDescription,{"data-test-subj":"kbnMemoryUsage"},_react2.default.createElement(_helpers.BytesPercentageUsage,{usedBytes:props.memory_size,maxBytes:props.memory_limit})))))))}},4253:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source)Object.prototype.hasOwnProperty.call(source,key)&&(target[key]=source[key])}return target};exports.LogstashPanel=LogstashPanel;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _format_number=__webpack_require__(59);var _helpers=__webpack_require__(654);var _tooltip=__webpack_require__(376);var _constants=__webpack_require__(64);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function LogstashPanel(props){if(!props.node_count)return null;var goToLogstash=function goToLogstash(){return props.changeUrl("logstash")};var goToNodes=function goToNodes(){return props.changeUrl("logstash/nodes")};var goToPipelines=function goToPipelines(){return props.changeUrl("logstash/pipelines")};return _react2.default.createElement(_helpers.ClusterItemContainer,_extends({},props,{url:"logstash",title:"Logstash"}),_react2.default.createElement(_eui.EuiFlexGrid,{columns:3},_react2.default.createElement(_eui.EuiFlexItem,null,_react2.default.createElement(_eui.EuiPanel,{paddingSize:"m"},_react2.default.createElement(_eui.EuiTitle,{size:"s"},_react2.default.createElement("h3",null,_react2.default.createElement(_eui.EuiLink,{onClick:goToLogstash,"aria-label":"Logstash Overview"},"Overview"))),_react2.default.createElement(_eui.EuiHorizontalRule,{margin:"m"}),_react2.default.createElement(_eui.EuiDescriptionList,{type:"column","data-test-subj":"logstash_overview"},_react2.default.createElement(_eui.EuiDescriptionListTitle,null,"Events Received"),_react2.default.createElement(_eui.EuiDescriptionListDescription,{"data-test-subj":"lsEventsReceived"},(0,_format_number.formatNumber)(props.events_in_total,"0.[0]a")),_react2.default.createElement(_eui.EuiDescriptionListTitle,null,"Events Emitted"),_react2.default.createElement(_eui.EuiDescriptionListDescription,{"data-test-subj":"lsEventsEmitted"},(0,_format_number.formatNumber)(props.events_out_total,"0.[0]a"))))),_react2.default.createElement(_eui.EuiFlexItem,null,_react2.default.createElement(_eui.EuiPanel,{paddingSize:"m"},_react2.default.createElement(_eui.EuiTitle,{size:"s"},_react2.default.createElement("h3",null,_react2.default.createElement(_eui.EuiLink,{onClick:goToNodes,"data-test-subj":"lsNodes","aria-label":"Logstash Nodes: "+props.node_count},"Nodes: ",_react2.default.createElement("span",{"data-test-subj":"number_of_logstash_instances"},props.node_count)))),_react2.default.createElement(_eui.EuiHorizontalRule,{margin:"m"}),_react2.default.createElement(_eui.EuiDescriptionList,{type:"column"},_react2.default.createElement(_eui.EuiDescriptionListTitle,null,"Uptime"),_react2.default.createElement(_eui.EuiDescriptionListDescription,{"data-test-subj":"lsUptime"},(0,_format_number.formatNumber)(props.max_uptime,"time_since")),_react2.default.createElement(_eui.EuiDescriptionListTitle,null,"JVM Heap"),_react2.default.createElement(_eui.EuiDescriptionListDescription,{"data-test-subj":"lsJvmHeap"},_react2.default.createElement(_helpers.BytesPercentageUsage,{usedBytes:props.avg_memory_used,maxBytes:props.avg_memory}))))),_react2.default.createElement(_eui.EuiFlexItem,null,_react2.default.createElement(_eui.EuiPanel,{paddingSize:"m"},_react2.default.createElement(_eui.EuiTitle,{size:"s"},_react2.default.createElement("h3",null,_react2.default.createElement(_eui.EuiLink,{onClick:goToPipelines,"data-test-subj":"lsPipelines","aria-label":"Logstash Pipelines (beta feature): "+props.pipeline_count},_react2.default.createElement(_tooltip.Tooltip,{text:"Beta Feature",placement:"bottom",trigger:"hover"},_react2.default.createElement("span",{className:"kuiIcon fa-flask betaIcon"})),"Pipelines: ",_react2.default.createElement("span",{"data-test-subj":"number_of_logstash_pipelines"},props.pipeline_count)))),_react2.default.createElement(_eui.EuiHorizontalRule,{margin:"m"}),_react2.default.createElement(_eui.EuiDescriptionList,{type:"column"},_react2.default.createElement(_eui.EuiDescriptionListTitle,null,"With Memory Queues"),_react2.default.createElement(_eui.EuiDescriptionListDescription,null,props.queue_types[_constants.LOGSTASH.QUEUE_TYPES.MEMORY]),_react2.default.createElement(_eui.EuiDescriptionListTitle,null,"With Persistent Queues"),_react2.default.createElement(_eui.EuiDescriptionListDescription,null,props.queue_types[_constants.LOGSTASH.QUEUE_TYPES.PERSISTED]))))))}},4254:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.AlertsPanel=AlertsPanel;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _formatted_message=__webpack_require__(1509);var _map_severity=__webpack_require__(898);var _format_timestamp_to_duration=__webpack_require__(653);var _constants=__webpack_require__(64);var _formatting=__webpack_require__(375);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function AlertsPanel(_ref){var alerts=_ref.alerts,changeUrl=_ref.changeUrl;var goToAlerts=function goToAlerts(){return changeUrl("/alerts")};if(!alerts||!alerts.length)return null;function TopAlertItem(_ref2){var item=_ref2.item,index=_ref2.index;var severityIcon=(0,_map_severity.mapSeverity)(item.metadata.severity);if(item.resolved_timestamp){severityIcon.title=severityIcon.title+" (resolved "+(0,_format_timestamp_to_duration.formatTimestampToDuration)(item.resolved_timestamp,_constants.CALCULATE_DURATION_SINCE)+" ago)";severityIcon.color="success";severityIcon.iconType="check"}return _react2.default.createElement(_eui.EuiCallOut,{key:"alert-item-"+index,"data-test-subj":"topAlertItem",className:"kuiVerticalRhythm",iconType:severityIcon.iconType,color:severityIcon.color,title:severityIcon.title},_react2.default.createElement(_formatted_message.FormattedMessage,{prefix:item.prefix,suffix:item.suffix,message:item.message,metadata:item.metadata,changeUrl:changeUrl}),_react2.default.createElement(_eui.EuiText,{size:"xs"},_react2.default.createElement("p",{"data-test-subj":"alertMeta"},_react2.default.createElement(_eui.EuiTextColor,{color:"subdued"},"Last checked ",(0,_formatting.formatDateTimeLocal)(item.update_timestamp)," (triggered ",(0,_format_timestamp_to_duration.formatTimestampToDuration)(item.timestamp,_constants.CALCULATE_DURATION_SINCE)," ago)"))))}var topAlertItems=alerts.map(function(item,index){return _react2.default.createElement(TopAlertItem,{item:item,key:"top-alert-item-"+index,index:index})});return _react2.default.createElement("div",{"data-test-subj":"clusterAlertsContainer"},_react2.default.createElement(_eui.EuiFlexGroup,{justifyContent:"spaceBetween"},_react2.default.createElement(_eui.EuiFlexItem,{grow:false},_react2.default.createElement(_eui.EuiTitle,null,_react2.default.createElement("h2",null,"Top cluster alerts"))),_react2.default.createElement(_eui.EuiFlexItem,{grow:false},_react2.default.createElement(_eui.EuiButton,{size:"s",onClick:goToAlerts,"data-test-subj":"viewAllAlerts"},"View all alerts"))),_react2.default.createElement(_eui.EuiSpacer,{size:"m"}),topAlertItems,_react2.default.createElement(_eui.EuiSpacer,{size:"xxl"}))}},4255:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source)Object.prototype.hasOwnProperty.call(source,key)&&(target[key]=source[key])}return target};exports.BeatsPanel=BeatsPanel;var _lodash=__webpack_require__(1);var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _format_number=__webpack_require__(59);var _eui=__webpack_require__(3);var _helpers=__webpack_require__(654);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function BeatsPanel(props){if(!(0,_lodash.get)(props,"beats.total",0)>0)return null;var goToBeats=function goToBeats(){return props.changeUrl("beats")};var goToInstances=function goToInstances(){return props.changeUrl("beats/beats")};var beatTypes=props.beats.types.map(function(beat,index){return[_react2.default.createElement(_eui.EuiDescriptionListTitle,{key:"beat-types-type-"+index,"data-test-subj":"beatTypeCount","data-test-beat-type-count":beat.type+":"+beat.count},beat.type),_react2.default.createElement(_eui.EuiDescriptionListDescription,{key:"beat-types-count-"+index},beat.count)]});return _react2.default.createElement(_helpers.ClusterItemContainer,_extends({},props,{url:"beats",title:"Beats"}),_react2.default.createElement(_eui.EuiFlexGrid,{columns:2},_react2.default.createElement(_eui.EuiFlexItem,null,_react2.default.createElement(_eui.EuiPanel,{paddingSize:"m"},_react2.default.createElement(_eui.EuiTitle,{size:"s"},_react2.default.createElement("h3",null,_react2.default.createElement(_eui.EuiLink,{onClick:goToBeats,"aria-label":"Beats Overview","data-test-subj":"beatsOverview"},"Overview"))),_react2.default.createElement(_eui.EuiHorizontalRule,{margin:"m"}),_react2.default.createElement(_eui.EuiDescriptionList,{type:"column"},_react2.default.createElement(_eui.EuiDescriptionListTitle,null,"Total Events"),_react2.default.createElement(_eui.EuiDescriptionListDescription,{"data-test-subj":"beatsTotalEvents"},(0,_format_number.formatMetric)(props.totalEvents,"0.[0]a")),_react2.default.createElement(_eui.EuiDescriptionListTitle,null,"Bytes Sent"),_react2.default.createElement(_eui.EuiDescriptionListDescription,{"data-test-subj":"beatsBytesSent"},(0,_format_number.formatMetric)(props.bytesSent,"byte"))))),_react2.default.createElement(_eui.EuiFlexItem,null,_react2.default.createElement(_eui.EuiPanel,{paddingSize:"m"},_react2.default.createElement(_eui.EuiTitle,{size:"s"},_react2.default.createElement("h3",null,_react2.default.createElement(_eui.EuiLink,{onClick:goToInstances,"aria-label":"Beats Instances: "+props.beats.total,"data-test-subj":"beatsListing"},"Beats: ",_react2.default.createElement("span",{"data-test-subj":"beatsTotal"},props.beats.total)))),_react2.default.createElement(_eui.EuiHorizontalRule,{margin:"m"}),_react2.default.createElement(_eui.EuiDescriptionList,{type:"column"},beatTypes)))))}},4256:function(module,exports,__webpack_require__){"use strict";var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _reactDom=__webpack_require__(15);var _lodash=__webpack_require__(1);var _moment=__webpack_require__(10);var _moment2=_interopRequireDefault(_moment);var _numeral=__webpack_require__(88);var _numeral2=_interopRequireDefault(_numeral);var _modules=__webpack_require__(2);var _chrome=__webpack_require__(8);var _chrome2=_interopRequireDefault(_chrome);var _components=__webpack_require__(32);var _eui=__webpack_require__(3);var _notify=__webpack_require__(9);var _table=__webpack_require__(256);var _tooltip=__webpack_require__(376);var _alerts_indicator=__webpack_require__(4257);var _constants=__webpack_require__(64);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}var filterFields=["cluster_name","status","license.type"];var columns=[{title:"Name",sortKey:"cluster_name",sortOrder:_constants.SORT_ASCENDING},{title:"Status",sortKey:"status"},{title:"Nodes",sortKey:"elasticsearch.cluster_stats.nodes.count.total"},{title:"Indices",sortKey:"elasticsearch.cluster_stats.indices.count"},{title:"Data",sortKey:"elasticsearch.cluster_stats.indices.store.size_in_bytes"},{title:"Logstash",sortKey:"logstash.node_count"},{title:"Kibana",sortKey:"kibana.count"},{title:"License",sortKey:"license.type"}];var clusterRowFactory=function clusterRowFactory(scope,globalState,kbnUrl,showLicenseExpiration){return function(_React$Component){_inherits(ClusterRow,_React$Component);function ClusterRow(props){_classCallCheck(this,ClusterRow);return _possibleConstructorReturn(this,(ClusterRow.__proto__||Object.getPrototypeOf(ClusterRow)).call(this,props))}_createClass(ClusterRow,[{key:"changeCluster",value:function changeCluster(){var _this2=this;scope.$evalAsync(function(){globalState.cluster_uuid=_this2.props.cluster_uuid;globalState.ccs=_this2.props.ccs;globalState.save();kbnUrl.changePath("/overview")})}},{key:"licenseWarning",value:function licenseWarning(_ref){var title=_ref.title,text=_ref.text;scope.$evalAsync(function(){_notify.toastNotifications.addWarning({title:title,text:text,"data-test-subj":"monitoringLicenseWarning"})})}},{key:"handleClickIncompatibleLicense",value:function handleClickIncompatibleLicense(){this.licenseWarning({title:"You can't view the \""+this.props.cluster_name+'" cluster',text:_react2.default.createElement(_react.Fragment,null,_react2.default.createElement("p",null,"The Basic license does not support multi-cluster monitoring."),_react2.default.createElement("p",null,"Need to monitor multiple clusters?"," ",_react2.default.createElement("a",{href:"https://www.elastic.co/subscriptions/xpack",target:"_blank"},"Get a license with full functionality")," ","to enjoy multi-cluster monitoring."))})}},{key:"handleClickInvalidLicense",value:function handleClickInvalidLicense(){var licensingPath=_chrome2.default.getBasePath()+"/app/kibana#/management/elasticsearch/license_management/home";this.licenseWarning({title:"You can't view the \""+this.props.cluster_name+'" cluster',text:_react2.default.createElement(_react.Fragment,null,_react2.default.createElement("p",null,"The license information is invalid."),_react2.default.createElement("p",null,"Need a license?"," ",_react2.default.createElement("a",{href:licensingPath},"Get a free Basic license")," or"," ",_react2.default.createElement("a",{href:"https://www.elastic.co/subscriptions/xpack",target:"_blank"},"get a license with full functionality")," ","to enjoy multi-cluster monitoring."))})}},{key:"getClusterAction",value:function getClusterAction(){if(this.props.isSupported)return _react2.default.createElement(_eui.EuiLink,{onClick:this.changeCluster.bind(this),"data-test-subj":"clusterLink"},this.props.cluster_name);if(this.props.license)return _react2.default.createElement(_eui.EuiLink,{onClick:this.handleClickIncompatibleLicense.bind(this),"data-test-subj":"clusterLink"},this.props.cluster_name);return _react2.default.createElement(_eui.EuiLink,{onClick:this.handleClickInvalidLicense.bind(this),"data-test-subj":"clusterLink"},this.props.cluster_name)}},{key:"getLicenseInfo",value:function getLicenseInfo(){var _this3=this;if(this.props.license){var licenseExpiry=function licenseExpiry(){if(_this3.props.license.expiry_date_in_millis<(0,_moment2.default)().valueOf())return _react2.default.createElement("span",{className:"monitoringTableCell__ClusterCell__expired"},"Expired");return _react2.default.createElement("span",null,"Expires ",(0,_moment2.default)(_this3.props.license.expiry_date_in_millis).format("D MMM YY"))};return _react2.default.createElement("div",null,_react2.default.createElement("div",{className:"monitoringTableCell__ClusterCell__license"},(0,_lodash.capitalize)(this.props.license.type)),_react2.default.createElement("div",{className:"monitoringTableCell__ClusterCell__expiration"},showLicenseExpiration?licenseExpiry():null))}return _react2.default.createElement(_eui.EuiLink,{onClick:this.handleClickInvalidLicense.bind(this)},_react2.default.createElement(_eui.EuiHealth,{color:"subdued","data-test-subj":"alertIcon"},"N/A"))}},{key:"render",value:function render(){var isSupported=this.props.isSupported;var isClusterSupportedFactory=function isClusterSupportedFactory(){return function(props){if(isSupported)return _react2.default.createElement("span",null,props.children);return _react2.default.createElement("span",null,"-")}};var IsClusterSupported=isClusterSupportedFactory(isSupported);var classes=[];isSupported||classes.push("basic");var IsAlertsSupported=function IsAlertsSupported(props){var _props$cluster$alerts=props.cluster.alerts,_props$cluster$alerts2=_props$cluster$alerts.alertsMeta,alertsMeta=void 0===_props$cluster$alerts2?{enabled:true}:_props$cluster$alerts2,_props$cluster$alerts3=_props$cluster$alerts.clusterMeta,clusterMeta=void 0===_props$cluster$alerts3?{enabled:true}:_props$cluster$alerts3;if(alertsMeta.enabled&&clusterMeta.enabled)return _react2.default.createElement("span",null,props.children);var message=alertsMeta.message||clusterMeta.message;return _react2.default.createElement(_tooltip.Tooltip,{text:message,placement:"bottom",trigger:"hover"},_react2.default.createElement(_eui.EuiHealth,{color:"subdued","data-test-subj":"alertIcon"},"N/A"))};return _react2.default.createElement(_components.KuiTableRow,{"data-test-subj":"clusterRow_"+this.props.cluster_uuid},_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement("span",{className:"monitoringTableCell__name"},this.getClusterAction())),_react2.default.createElement(_components.KuiTableRowCell,{"data-test-subj":"alertsStatus"},_react2.default.createElement(IsClusterSupported,null,_react2.default.createElement(IsAlertsSupported,{cluster:this.props},_react2.default.createElement(_alerts_indicator.AlertsIndicator,{alerts:this.props.alerts})))),_react2.default.createElement(_components.KuiTableRowCell,{"data-test-subj":"nodesCount"},_react2.default.createElement(IsClusterSupported,null,(0,_numeral2.default)((0,_lodash.get)(this.props,"elasticsearch.cluster_stats.nodes.count.total")).format("0,0"))),_react2.default.createElement(_components.KuiTableRowCell,{"data-test-subj":"indicesCount"},_react2.default.createElement(IsClusterSupported,null,(0,_numeral2.default)((0,_lodash.get)(this.props,"elasticsearch.cluster_stats.indices.count")).format("0,0"))),_react2.default.createElement(_components.KuiTableRowCell,{"data-test-subj":"dataSize"},_react2.default.createElement(IsClusterSupported,null,(0,_numeral2.default)((0,_lodash.get)(this.props,"elasticsearch.cluster_stats.indices.store.size_in_bytes")).format("0,0[.]0 b"))),_react2.default.createElement(_components.KuiTableRowCell,{"data-test-subj":"logstashCount"},_react2.default.createElement(IsClusterSupported,null,(0,_numeral2.default)((0,_lodash.get)(this.props,"logstash.node_count")).format("0,0"))),_react2.default.createElement(_components.KuiTableRowCell,{"data-test-subj":"kibanaCount"},_react2.default.createElement(IsClusterSupported,null,(0,_numeral2.default)((0,_lodash.get)(this.props,"kibana.count")).format("0,0"))),_react2.default.createElement(_components.KuiTableRowCell,{"data-test-subj":"clusterLicense"},this.getLicenseInfo()))}}]);return ClusterRow}(_react2.default.Component)};var uiModule=_modules.uiModules.get("monitoring/directives",[]);uiModule.directive("monitoringClusterListing",function($injector){return{restrict:"E",scope:{clusters:"=",pageIndex:"=",filterText:"=",sortKey:"=",sortOrder:"=",onNewState:"="},link:function link(scope,$el){var globalState=$injector.get("globalState");var kbnUrl=$injector.get("kbnUrl");var showLicenseExpiration=$injector.get("showLicenseExpiration");scope.$watch("clusters",function(){var clusters=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[];var clusterTable=_react2.default.createElement(_table.MonitoringTable,{className:"clusterTable",rows:clusters,pageIndex:scope.pageIndex,filterText:scope.filterText,sortKey:scope.sortKey,sortOrder:scope.sortOrder,onNewState:scope.onNewState,placeholder:"Filter Clusters...",filterFields:filterFields,columns:columns,rowComponent:clusterRowFactory(scope,globalState,kbnUrl,showLicenseExpiration)});(0,_reactDom.render)(clusterTable,$el[0])})}}})},4257:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.AlertsIndicator=AlertsIndicator;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _tooltip=__webpack_require__(376);var _map_severity=__webpack_require__(898);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var HIGH_SEVERITY=2e3;var MEDIUM_SEVERITY=1e3;var LOW_SEVERITY=0;function AlertsIndicator(_ref){var alerts=_ref.alerts;if(alerts&&alerts.count>0){var severity=function(){if(alerts.high>0)return HIGH_SEVERITY;if(alerts.medium>0)return MEDIUM_SEVERITY;return LOW_SEVERITY}();var severityIcon=(0,_map_severity.mapSeverity)(severity);var tooltipText=function(){switch(severity){case HIGH_SEVERITY:return"There are some critical cluster issues that require your immediate attention!";case MEDIUM_SEVERITY:return"There are some issues that might have impact on your cluster.";default:return"There are some low-severity cluster issues"}}();return _react2.default.createElement(_tooltip.Tooltip,{text:tooltipText,placement:"bottom",trigger:"hover"},_react2.default.createElement(_eui.EuiHealth,{color:severityIcon.color,"data-test-subj":"alertIcon"},"Alerts"))}return _react2.default.createElement(_tooltip.Tooltip,{text:"Cluster status is clear!",placement:"bottom",trigger:"hover"},_react2.default.createElement(_eui.EuiHealth,{color:"success","data-test-subj":"alertIcon"},"Clear"))}},4258:function(module,exports,__webpack_require__){"use strict";var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _reactDom=__webpack_require__(15);var _modules=__webpack_require__(2);var _cluster_status=__webpack_require__(655);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var uiModule=_modules.uiModules.get("monitoring/directives",[]);uiModule.directive("monitoringClusterStatusElasticsearch",function(){return{restrict:"E",scope:{status:"="},link:function link(scope,$el){scope.$watch("status",function(status){(0,_reactDom.render)(_react2.default.createElement(_cluster_status.ClusterStatus,{stats:status}),$el[0])})}}})},4259:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source)Object.prototype.hasOwnProperty.call(source,key)&&(target[key]=source[key])}return target};exports.SummaryStatus=SummaryStatus;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _propTypes=__webpack_require__(6);var _propTypes2=_interopRequireDefault(_propTypes);var _lodash=__webpack_require__(1);var _eui=__webpack_require__(3);var _status_icon=__webpack_require__(512);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _objectWithoutProperties(obj,keys){var target={};for(var i in obj){if(keys.indexOf(i)>=0)continue;if(!Object.prototype.hasOwnProperty.call(obj,i))continue;target[i]=obj[i]}return target}var wrapChild=function wrapChild(_ref,index){var label=_ref.label,value=_ref.value,dataTestSubj=_ref.dataTestSubj;return _react2.default.createElement(_eui.EuiFlexItem,{key:"summary-status-item-"+index,grow:false,className:"monitoring-summary-status__eui-content","data-test-subj":dataTestSubj},label?label+": ":null,_react2.default.createElement("strong",null,value))};var DefaultIconComponent=function DefaultIconComponent(_ref2){var status=_ref2.status;return _react2.default.createElement(_react.Fragment,null,"Status: ",_react2.default.createElement(_status_icon.StatusIcon,{type:status.toUpperCase(),label:"Status: "+status}))};var StatusIndicator=function StatusIndicator(_ref3){var status=_ref3.status,isOnline=_ref3.isOnline,IconComponent=_ref3.IconComponent;if((0,_lodash.isEmpty)(status))return null;return _react2.default.createElement("div",{className:"monitoring-summary-status__status-indicator"},_react2.default.createElement(IconComponent,{status:status,isOnline:isOnline})," ",(0,_lodash.capitalize)(status))};function SummaryStatus(_ref4){var metrics=_ref4.metrics,status=_ref4.status,isOnline=_ref4.isOnline,_ref4$IconComponent=_ref4.IconComponent,IconComponent=void 0===_ref4$IconComponent?DefaultIconComponent:_ref4$IconComponent,props=_objectWithoutProperties(_ref4,["metrics","status","isOnline","IconComponent"]);return _react2.default.createElement("div",{className:"monitoring-summary-status",role:"status"},_react2.default.createElement("div",_extends({className:"monitoring-summary-status__content"},props),_react2.default.createElement(_eui.EuiFlexGroup,{gutterSize:"xs",alignItems:"center"},metrics.map(wrapChild),_react2.default.createElement(_eui.EuiFlexItem,{grow:true,className:"monitoring-summary-status__eui-content"},_react2.default.createElement(StatusIndicator,{status:status,IconComponent:IconComponent,isOnline:isOnline})))))}SummaryStatus.propTypes={metrics:_propTypes2.default.array.isRequired}},4260:function(module,exports,__webpack_require__){"use strict";var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _reactDom=__webpack_require__(15);var _modules=__webpack_require__(2);var _index_detail_status=__webpack_require__(4261);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var uiModule=_modules.uiModules.get("monitoring/directives",[]);uiModule.directive("monitoringIndexSummary",function(){return{restrict:"E",scope:{summary:"="},link:function link(scope,$el){scope.$watch("summary",function(summary){(0,_reactDom.render)(_react2.default.createElement(_index_detail_status.IndexDetailStatus,{stats:summary}),$el[0])})}}})},4261:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.IndexDetailStatus=IndexDetailStatus;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _summary_status=__webpack_require__(511);var _status_icon=__webpack_require__(899);var _format_number=__webpack_require__(59);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function IndexDetailStatus(_ref){var stats=_ref.stats;var dataSize=stats.dataSize,documentCount=stats.documents,totalShards=stats.totalShards,unassignedShards=stats.unassignedShards,status=stats.status;var metrics=[{label:"Total",value:(0,_format_number.formatMetric)(dataSize.total,"0.0 b"),dataTestSubj:"dataSize"},{label:"Primaries",value:(0,_format_number.formatMetric)(dataSize.primaries,"0.0 b"),dataTestSubj:"dataSizePrimaries"},{label:"Documents",value:(0,_format_number.formatMetric)(documentCount,"0.[0]a"),dataTestSubj:"documentCount"},{label:"Total Shards",value:(0,_format_number.formatMetric)(totalShards,"int_commas"),dataTestSubj:"totalShards"},{label:"Unassigned Shards",value:(0,_format_number.formatMetric)(unassignedShards,"int_commas"),dataTestSubj:"unassignedShards"}];var IconComponent=function IconComponent(_ref2){var status=_ref2.status;return _react2.default.createElement(_react.Fragment,null,"Health: ",_react2.default.createElement(_status_icon.ElasticsearchStatusIcon,{status:status}))};return _react2.default.createElement(_summary_status.SummaryStatus,{metrics:metrics,status:status,IconComponent:IconComponent,"data-test-subj":"elasticsearchIndexDetailStatus"})}},4262:function(module,exports,__webpack_require__){"use strict";var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _reactDom=__webpack_require__(15);var _modules=__webpack_require__(2);var _node_detail_status=__webpack_require__(4263);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var uiModule=_modules.uiModules.get("monitoring/directives",[]);uiModule.directive("monitoringNodeSummary",function(){return{restrict:"E",scope:{node:"="},link:function link(scope,$el){scope.$watch("node",function(node){(0,_reactDom.render)(_react2.default.createElement(_node_detail_status.NodeDetailStatus,{stats:node}),$el[0])})}}})},4263:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.NodeDetailStatus=NodeDetailStatus;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _summary_status=__webpack_require__(511);var _node=__webpack_require__(1510);var _format_number=__webpack_require__(59);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function NodeDetailStatus(_ref){var stats=_ref.stats;var transportAddress=stats.transport_address,usedHeap=stats.usedHeap,freeSpace=stats.freeSpace,documents=stats.documents,dataSize=stats.dataSize,indexCount=stats.indexCount,totalShards=stats.totalShards,nodeTypeLabel=stats.nodeTypeLabel,status=stats.status,isOnline=stats.isOnline;var metrics=[{value:transportAddress,dataTestSubj:"transportAddress"},{label:"JVM Heap",value:(0,_format_number.formatMetric)(usedHeap,"0,0.[00]","%",{prependSpace:false}),dataTestSubj:"jvmHeap"},{label:"Free Disk Space",value:(0,_format_number.formatMetric)(freeSpace,"0.0 b"),dataTestSubj:"freeDiskSpace"},{label:"Documents",value:(0,_format_number.formatMetric)(documents,"0.[0]a"),dataTestSubj:"documentCount"},{label:"Data",value:(0,_format_number.formatMetric)(dataSize,"0.0 b"),dataTestSubj:"dataSize"},{label:"Indices",value:(0,_format_number.formatMetric)(indexCount,"int_commas"),dataTestSubj:"indicesCount"},{label:"Shards",value:(0,_format_number.formatMetric)(totalShards,"int_commas"),dataTestSubj:"shardsCount"},{label:"Type",value:nodeTypeLabel,dataTestSubj:"nodeType"}];var IconComponent=function IconComponent(_ref2){var status=_ref2.status,isOnline=_ref2.isOnline;return _react2.default.createElement(_react.Fragment,null,"Status: ",_react2.default.createElement(_node.NodeStatusIcon,{status:status,isOnline:isOnline}))};return _react2.default.createElement(_summary_status.SummaryStatus,{metrics:metrics,status:status,isOnline:isOnline,IconComponent:IconComponent,"data-test-subj":"elasticsearchNodeDetailStatus"})}},4264:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.NodeStatusIcon=NodeStatusIcon;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _status_icon=__webpack_require__(512);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function NodeStatusIcon(_ref){var isOnline=_ref.isOnline,status=_ref.status;var type=isOnline?_status_icon.StatusIcon.TYPES.GREEN:_status_icon.StatusIcon.TYPES.GRAY;return _react2.default.createElement(_status_icon.StatusIcon,{type:type,label:"Status: "+status})}},4265:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _numeral=__webpack_require__(88);var _numeral2=_interopRequireDefault(_numeral);var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _reactDom=__webpack_require__(15);var _modules=__webpack_require__(2);var _components=__webpack_require__(32);var _table=__webpack_require__(256);var _status_icon=__webpack_require__(4266);var _constants=__webpack_require__(64);var _formatting=__webpack_require__(375);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var filterFields=["job_id","state","node.name"];var columns=[{title:"Job ID",sortKey:"job_id",sortOrder:_constants.SORT_ASCENDING},{title:"State",sortKey:"state"},{title:"Processed Records",sortKey:"data_counts.processed_record_count"},{title:"Model Size",sortKey:"model_size_stats.model_bytes"},{title:"Forecasts",sortKey:"forecasts_stats.total"},{title:"Node",sortKey:"node.name"}];var jobRowFactory=function jobRowFactory(scope,kbnUrl){var goToNode=function goToNode(nodeId){scope.$evalAsync(function(){return kbnUrl.changePath("/elasticsearch/nodes/"+nodeId)})};var getNode=function getNode(node){if(node)return _react2.default.createElement(_eui.EuiLink,{onClick:goToNode.bind(null,node.id)},node.name);return"N/A"};return function JobRow(props){return _react2.default.createElement(_components.KuiTableRow,null,_react2.default.createElement(_components.KuiTableRowCell,null,props.job_id),_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement(_status_icon.MachineLearningJobStatusIcon,{status:props.state})," ",(0,_lodash.capitalize)(props.state)),_react2.default.createElement(_components.KuiTableRowCell,null,(0,_numeral2.default)(props.data_counts.processed_record_count).format(_formatting.LARGE_ABBREVIATED)),_react2.default.createElement(_components.KuiTableRowCell,null,(0,_numeral2.default)(props.model_size_stats.model_bytes).format(_formatting.LARGE_BYTES)),_react2.default.createElement(_components.KuiTableRowCell,null,(0,_numeral2.default)(props.forecasts_stats.total).format(_formatting.LARGE_ABBREVIATED)),_react2.default.createElement(_components.KuiTableRowCell,null,getNode(props.node)))}};var uiModule=_modules.uiModules.get("monitoring/directives",[]);uiModule.directive("monitoringMlListing",function(kbnUrl){return{restrict:"E",scope:{jobs:"=",pageIndex:"=",filterText:"=",sortKey:"=",sortOrder:"=",onNewState:"="},link:function link(scope,$el){var getNoDataMessage=function getNoDataMessage(filterText){if(filterText)return"There are no Machine Learning Jobs that match the filter ["+filterText.trim()+"] or the time range.\nTry changing the filter or time range.";return"There are no Machine Learning Jobs that match your query. Try changing the time range selection."};scope.$watch("jobs",function(){var jobs=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[];var mlTable=_react2.default.createElement(_table.MonitoringTable,{className:"mlJobsTable",rows:jobs,pageIndex:scope.pageIndex,filterText:scope.filterText,sortKey:scope.sortKey,sortOrder:scope.sortOrder,onNewState:scope.onNewState,placeholder:"Filter Jobs...",filterFields:filterFields,columns:columns,rowComponent:jobRowFactory(scope,kbnUrl),getNoDataMessage:getNoDataMessage});(0,_reactDom.render)(mlTable,$el[0])})}}})},4266:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.MachineLearningJobStatusIcon=MachineLearningJobStatusIcon;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _status_icon=__webpack_require__(512);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function MachineLearningJobStatusIcon(_ref){var status=_ref.status;var type=function(){var statusKey=status.toUpperCase();if("OPENED"===statusKey)return _status_icon.StatusIcon.TYPES.GREEN;if("CLOSED"===statusKey)return _status_icon.StatusIcon.TYPES.GRAY;if("FAILED"===statusKey)return _status_icon.StatusIcon.TYPES.RED;return _status_icon.StatusIcon.TYPES.YELLOW}();return _react2.default.createElement(_status_icon.StatusIcon,{type:type,label:"Job Status: "+status})}},4267:function(module,exports,__webpack_require__){"use strict";var _modules=__webpack_require__(2);var _labels=__webpack_require__(4268);var _indices_by_nodes=__webpack_require__(4269);var _nodes_by_indices=__webpack_require__(4270);var _index=__webpack_require__(4272);var _index2=_interopRequireDefault(_index);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var uiModule=_modules.uiModules.get("monitoring/directives",[]);uiModule.directive("monitoringShardAllocation",function(){return{restrict:"E",template:_index2.default,scope:{view:"@",shards:"=",nodes:"=",shardStats:"=",showSystemIndices:"=",toggleShowSystemIndices:"="},link:function link(scope){var isIndexView="index"===scope.view;var transformer=isIndexView?(0,_indices_by_nodes.indicesByNodes)():(0,_nodes_by_indices.nodesByIndices)();scope.isIndexView=isIndexView;scope.$watch("shards",function(shards){var view=scope.view;scope.totalCount=shards.length;scope.showing=transformer(shards,scope.nodes);isIndexView&&shards.some(function(shard){return"UNASSIGNED"===shard.state})&&(view="indexWithUnassigned");scope.labels=_labels.labels[view]})}}})},4268:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.labels={index:[{content:"Nodes"}],indexWithUnassigned:[{content:"Unassigned"},{content:"Nodes"}],node:[{content:"Indices",showToggleSystemIndicesComponent:true}]}},4269:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.indicesByNodes=indicesByNodes;var _lodash=__webpack_require__(1);var _lodash2=_interopRequireDefault(_lodash);var _decorate_shards=__webpack_require__(1511);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function indicesByNodes(){return function indicesByNodesFn(shards,nodes){function createIndex(obj,shard){var id=shard.index;if(obj[id])return obj;obj[id]={id:id,name:id,children:[],unassigned:[],unassignedPrimaries:false,type:"index"};return obj}function createNodeAddShard(obj,shard){var node=shard.node,index=shard.index;if(null===shard.node){obj[index].unassigned.push(shard);shard.primary&&(obj[index].unassignedPrimaries=true);return obj}var nodeObj=_lodash2.default.find(obj[index].children,{id:node});if(!nodeObj){nodeObj={id:node,type:"node",name:nodes[node].name,node_type:nodes[node].type,ip_port:nodes[node].transport_address,children:[]};obj[index].children.push(nodeObj)}nodeObj.children.push(shard);return obj}var data=_lodash2.default.reduce((0,_decorate_shards.decorateShards)(shards,nodes),function(obj,shard){obj=createIndex(obj,shard);obj=createNodeAddShard(obj,shard);return obj},{});return(0,_lodash2.default)(data).values().sortBy(function(index){return[!index.unassignedPrimaries,/^\./.test(index.name),index.name]}).value()}}},4270:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.nodesByIndices=nodesByIndices;var _lodash=__webpack_require__(1);var _lodash2=_interopRequireDefault(_lodash);var _hasPrimaryChildren=__webpack_require__(4271);var _decorate_shards=__webpack_require__(1511);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function nodesByIndices(){return function nodesByIndicesFn(shards,nodes){var getNodeType=function getNodeType(node){var attrs=node.attributes||{};return"true"===attrs.master?"master":"normal"};function createNode(obj,node,id){node.type="node";node.children=[];var nodeType=getNodeType(node);"normal"!==nodeType&&"data"!==nodeType||(obj[id]=node);return obj}function createIndexAddShard(obj,shard){var node=shard.node||"unassigned";var index=shard.index;obj[node]||createNode(obj,nodes[node],node);var indexObj=_lodash2.default.find(obj[node].children,{id:index});if(!indexObj){indexObj={id:index,name:index,type:"index",children:[]};obj[node].children.push(indexObj)}indexObj.children.push(shard);return obj}function isUnassigned(shard){return"UNASSIGNED"===shard.state}var data={};_lodash2.default.some(shards,isUnassigned)&&(data.unassigned={name:"Unassigned",master:false,type:"node",children:[]});data=_lodash2.default.reduce((0,_decorate_shards.decorateShards)(shards,nodes),createIndexAddShard,data);return(0,_lodash2.default)(data).values().sortBy(function(node){return["Unassigned"!==node.name,!node.master,node.name]}).map(function(node){"Unassigned"===node.name&&(node.unassignedPrimaries=node.children.some(_hasPrimaryChildren.hasPrimaryChildren));return node}).value()}}},4271:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.hasPrimaryChildren=hasPrimaryChildren;var _lodash=__webpack_require__(1);var _lodash2=_interopRequireDefault(_lodash);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function hasPrimaryChildren(item){return _lodash2.default.some(item.children,{primary:true})}},4272:function(module,exports){module.exports='<div class="page-row">\n  <div class="monitoring-cluster-view">\n    <h1 class="monitoring-cluster-view-title">Shard Legend</h1>\n    <div class="legend">\n      <span class="shard">&nbsp;</span>\n      <span class="shard-label">Primary</span>\n      <span class="shard replica">&nbsp;</span>\n      <span class="shard-label">Replica</span>\n      <span class="shard relocating">&nbsp;</span>\n      <span class="shard-label">Relocating</span>\n      <span class="shard initializing">&nbsp;</span>\n      <span class="shard-label">Initializing</span>\n      <span class="shard emergency" ng-if="isIndexView">&nbsp;</span>\n      <span class="shard-label" ng-if="isIndexView">Unassigned Primary</span>\n      <span class="shard unassigned replica" ng-if="isIndexView">&nbsp;</span>\n      <span class="shard-label" ng-if="isIndexView">Unassigned Replica</span>\n    </div>\n    <cluster-view\n      shard-stats="shardStats"\n      total-count="totalCount"\n      labels="labels"\n      showing="showing"\n      show-system-indices="showSystemIndices"\n      toggle-show-system-indices="toggleShowSystemIndices"\n    ></cluster-view>\n  </div>\n</div>\n'},4273:function(module,exports,__webpack_require__){"use strict";var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _reactDom=__webpack_require__(15);var _reactDom2=_interopRequireDefault(_reactDom);var _clusterView=__webpack_require__(4274);var _modules=__webpack_require__(2);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var uiModule=_modules.uiModules.get("monitoring/directives",[]);uiModule.directive("clusterView",function(kbnUrl){return{restrict:"E",scope:{totalCount:"=",filter:"=",showing:"=",labels:"=",shardStats:"=",showSystemIndices:"=",toggleShowSystemIndices:"="},link:function link(scope,element){_reactDom2.default.render(_react2.default.createElement(_clusterView.ClusterView,{scope:scope,kbnUrl:kbnUrl,showSystemIndices:scope.showSystemIndices,toggleShowSystemIndices:scope.toggleShowSystemIndices}),element[0])}}})},4274:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.ClusterView=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _tableHead=__webpack_require__(4275);var _tableBody=__webpack_require__(4276);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}var ClusterView=exports.ClusterView=function(_React$Component){_inherits(ClusterView,_React$Component);function ClusterView(props){_classCallCheck(this,ClusterView);var _this=_possibleConstructorReturn(this,(ClusterView.__proto__||Object.getPrototypeOf(ClusterView)).call(this,props));_this.setShowing=function(data){data&&_this.setState({showing:data})};_this.setShardStats=function(stats){_this.setState({shardStats:stats})};_this.hasUnassigned=function(){return _this.state.showing.length&&_this.state.showing[0].unassigned&&_this.state.showing[0].unassigned.length};var scope=props.scope;var kbnChangePath=props.kbnUrl.changePath;_this.state={labels:props.scope.labels||[],showing:props.scope.showing||[],shardStats:props.shardStats,showSystemIndices:props.showSystemIndices,toggleShowSystemIndices:props.toggleShowSystemIndices,angularChangeUrl:function angularChangeUrl(url){scope.$evalAsync(function(){return kbnChangePath(url)})}};return _this}_createClass(ClusterView,[{key:"componentWillMount",value:function componentWillMount(){this.props.scope.$watch("showing",this.setShowing);this.props.scope.$watch("shardStats",this.setShardStats)}},{key:"render",value:function render(){return _react2.default.createElement("table",{cellPadding:"0",cellSpacing:"0",className:"table"},_react2.default.createElement(_tableHead.TableHead,{hasUnassigned:this.hasUnassigned(),scope:this.props.scope,toggleShowSystemIndices:this.state.toggleShowSystemIndices}),_react2.default.createElement(_tableBody.TableBody,{filter:this.props.scope.filter,totalCount:this.props.scope.totalCount,rows:this.state.showing,cols:this.state.labels.length,shardStats:this.state.shardStats,changeUrl:this.state.angularChangeUrl}))}}]);return ClusterView}(_react2.default.Component);ClusterView.displayName="ClusterView"},4275:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.TableHead=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}var IndexLabel=function(_React$Component){_inherits(IndexLabel,_React$Component);function IndexLabel(props){_classCallCheck(this,IndexLabel);var _this=_possibleConstructorReturn(this,(IndexLabel.__proto__||Object.getPrototypeOf(IndexLabel)).call(this,props));_this.state={showSystemIndices:props.scope.showSystemIndices};_this.toggleShowSystemIndicesState=_this.toggleShowSystemIndicesState.bind(_this);return _this}_createClass(IndexLabel,[{key:"toggleShowSystemIndicesState",value:function toggleShowSystemIndicesState(e){var _this2=this;var isChecked=e.target.checked;this.setState({showSystemIndices:isChecked});this.props.scope.$evalAsync(function(){_this2.props.toggleShowSystemIndices(isChecked)})}},{key:"render",value:function render(){return _react2.default.createElement(_eui.EuiFlexGroup,null,_react2.default.createElement(_eui.EuiFlexItem,{grow:false},"Indices"),_react2.default.createElement(_eui.EuiFlexItem,null,_react2.default.createElement(_eui.EuiSwitch,{label:"System indices",onChange:this.toggleShowSystemIndicesState,checked:this.state.showSystemIndices,"data-test-subj":"shardShowSystemIndices"})))}}]);return IndexLabel}(_react2.default.Component);exports.TableHead=function(_React$Component2){_inherits(TableHead,_React$Component2);function TableHead(props){_classCallCheck(this,TableHead);return _possibleConstructorReturn(this,(TableHead.__proto__||Object.getPrototypeOf(TableHead)).call(this,props))}_createClass(TableHead,[{key:"createColumn",value:function createColumn(_ref){var key=_ref.key,content=_ref.content;return _react2.default.createElement("th",{scope:"col",key:key,colSpan:1},content)}},{key:"render",value:function render(){var _this4=this;var propLabels=this.props.scope.labels||[];var labelColumns=propLabels.map(function(label){var column={key:label.content.toLowerCase()};label.showToggleSystemIndicesComponent?column.content=_react2.default.createElement(IndexLabel,{scope:_this4.props.scope,toggleShowSystemIndices:_this4.props.toggleShowSystemIndices}):column.content=label.content;return column}).map(this.createColumn);return _react2.default.createElement("thead",null,_react2.default.createElement("tr",null,labelColumns))}}]);return TableHead}(_react2.default.Component)},4276:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.TableBody=void 0;var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source)Object.prototype.hasOwnProperty.call(source,key)&&(target[key]=source[key])}return target};var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _unassigned=__webpack_require__(4277);var _assigned=__webpack_require__(4279);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}var ShardRow=function ShardRow(props){var unassigned=void 0;props.data.unassigned&&props.data.unassigned.length?unassigned=_react2.default.createElement(_unassigned.Unassigned,{shards:props.data.unassigned}):3===props.cols&&(unassigned=_react2.default.createElement("td",null));return _react2.default.createElement("tr",null,unassigned,_react2.default.createElement(_assigned.Assigned,{shardStats:props.shardStats,data:props.data.children,changeUrl:props.changeUrl}))};var TableBody=exports.TableBody=function(_React$Component){_inherits(TableBody,_React$Component);function TableBody(){var _ref;var _temp,_this,_ret;_classCallCheck(this,TableBody);for(var _len=arguments.length,args=Array(_len),_key=0;_key<_len;_key++)args[_key]=arguments[_key];return _ret=(_temp=(_this=_possibleConstructorReturn(this,(_ref=TableBody.__proto__||Object.getPrototypeOf(TableBody)).call.apply(_ref,[this].concat(args))),_this),_this.createRow=function(data,index){return _react2.default.createElement(ShardRow,_extends({key:"shardRow-"+index,data:data},_this.props,{changeUrl:_this.props.changeUrl}))},_temp),_possibleConstructorReturn(_this,_ret)}_createClass(TableBody,[{key:"render",value:function render(){if(0===this.props.totalCount)return _react2.default.createElement("tbody",null,_react2.default.createElement("tr",null,_react2.default.createElement("td",{colSpan:this.props.cols},_react2.default.createElement("div",null,_react2.default.createElement("p",{style:{margin:"10px 0"},className:"text-center lead"},"There are no shards allocated.")))));if(this.props.shardStats&&this.props.rows.length)return _react2.default.createElement("tbody",null,this.props.rows.map(this.createRow));return _react2.default.createElement("tbody",null,_react2.default.createElement("tr",null,_react2.default.createElement("td",{colSpan:this.props.cols})))}}]);return TableBody}(_react2.default.Component);TableBody.displayName="TableBody"},4277:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.Unassigned=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _lodash=__webpack_require__(1);var _lodash2=_interopRequireDefault(_lodash);var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _shard=__webpack_require__(1512);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}var Unassigned=exports.Unassigned=function(_React$Component){_inherits(Unassigned,_React$Component);function Unassigned(){var _ref;var _temp,_this,_ret;_classCallCheck(this,Unassigned);for(var _len=arguments.length,args=Array(_len),_key=0;_key<_len;_key++)args[_key]=arguments[_key];return _ret=(_temp=(_this=_possibleConstructorReturn(this,(_ref=Unassigned.__proto__||Object.getPrototypeOf(Unassigned)).call.apply(_ref,[this].concat(args))),_this),_this.createShard=function(shard){var type=shard.primary?"primary":"replica";var additionId="UNASSIGNED"===shard.state?Math.random():"";var key=shard.index+"."+shard.node+"."+type+"."+shard.state+"."+shard.shard+additionId;return _react2.default.createElement(_shard.Shard,{shard:shard,key:key})},_temp),_possibleConstructorReturn(_this,_ret)}_createClass(Unassigned,[{key:"render",value:function render(){var shards=_lodash2.default.sortBy(this.props.shards,"shard").map(this.createShard);return _react2.default.createElement("td",{className:"unassigned","data-test-subj":"clusterView-Unassigned"},_react2.default.createElement("div",{className:"children"},shards))}}]);return Unassigned}(_react2.default.Component);Unassigned.displayName="Unassigned"},4278:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.vents=exports._vents=void 0;var _lodash=__webpack_require__(1);var _lodash2=_interopRequireDefault(_lodash);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var _vents=exports._vents={};exports.vents={vents:_vents,on:function on(id,cb){_lodash2.default.isArray(_vents[id])||(_vents[id]=[]);_vents[id].push(cb)},clear:function clear(id){delete _vents[id]},trigger:function trigger(){var args=Array.prototype.slice.call(arguments);var id=args.shift();_vents[id]&&_lodash2.default.each(_vents[id],function(cb){cb.apply(null,args)})}}},4279:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.Assigned=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _lodash=__webpack_require__(1);var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _shard=__webpack_require__(1512);var _calculateClass=__webpack_require__(1513);var _generateQueryAndLink=__webpack_require__(4280);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}function sortByName(item){if("node"===item.type)return[!item.master,item.name];return[item.name]}exports.Assigned=function(_React$Component){_inherits(Assigned,_React$Component);function Assigned(){var _ref;var _temp,_this,_ret;_classCallCheck(this,Assigned);for(var _len=arguments.length,args=Array(_len),_key=0;_key<_len;_key++)args[_key]=arguments[_key];return _ret=(_temp=(_this=_possibleConstructorReturn(this,(_ref=Assigned.__proto__||Object.getPrototypeOf(Assigned)).call.apply(_ref,[this].concat(args))),_this),_this.createShard=function(shard){var type=shard.primary?"primary":"replica";var key=shard.index+"."+shard.node+"."+type+"."+shard.state+"."+shard.shard;return _react2.default.createElement(_shard.Shard,{shard:shard,key:key})},_this.createChild=function(data){var key=data.id;var initialClasses=["child"];var shardStats=(0,_lodash.get)(_this.props.shardStats.indices,key);shardStats&&initialClasses.push(shardStats.status);var changeUrl=function changeUrl(){_this.props.changeUrl((0,_generateQueryAndLink.generateQueryAndLink)(data))};var name=_react2.default.createElement(_eui.EuiKeyboardAccessible,null,_react2.default.createElement("a",{onClick:changeUrl},_react2.default.createElement("span",null,data.name)));var master="master"===data.node_type?_react2.default.createElement("span",{className:"fa fa-star"}):null;var shards=(0,_lodash.sortBy)(data.children,"shard").map(_this.createShard);return _react2.default.createElement("div",{className:(0,_calculateClass.calculateClass)(data,initialClasses.join(" ")),key:key,"data-test-subj":"clusterView-Assigned-"+key,"data-status":shardStats&&shardStats.status},_react2.default.createElement("div",{className:"title"},name,master),shards)},_temp),_possibleConstructorReturn(_this,_ret)}_createClass(Assigned,[{key:"render",value:function render(){var data=(0,_lodash.sortBy)(this.props.data,sortByName).map(this.createChild);return _react2.default.createElement("td",null,_react2.default.createElement("div",{className:"children"},data))}}]);return Assigned}(_react2.default.Component)},4280:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.generateQueryAndLink=generateQueryAndLink;function generateQueryAndLink(data){var type="indices";var ident=data.name;if("node"===data.type){type="nodes";ident=data.id}return"/elasticsearch/"+type+"/"+ident}},4281:function(module,exports,__webpack_require__){"use strict";var _modules=__webpack_require__(2);var _index=__webpack_require__(4282);var _index2=_interopRequireDefault(_index);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var uiModule=_modules.uiModules.get("monitoring/directives",[]);uiModule.directive("monitoringClusterStatusLogstash",function(){return{restrict:"E",template:_index2.default,scope:{status:"="}}})},4282:function(module,exports){module.exports='<div class="monitoring-summary-status" role="status">\n  <div\n    class="monitoring-summary-status__content"\n    data-test-subj="logstashSummaryStatus"\n  >\n    <div>Nodes:\n      <strong data-test-subj="node_count">{{ status.node_count }}</strong>\n    </div>\n    <div>Memory:\n      <strong data-test-subj="memory_used">{{ status.avg_memory_used|formatNumber:\'byte\' }} / {{ status.avg_memory|formatNumber:\'byte\' }}</strong>\n    </div>\n    <div>Events Received:\n      <strong data-test-subj="events_in_total">{{ status.events_in_total|formatNumber:\'0.[0]a\' }}</strong>\n    </div>\n    <div>Events Emitted:\n      <strong data-test-subj="events_out_total">{{ status.events_out_total|formatNumber:\'0.[0]a\' }}</strong>\n    </div>\n  </div>\n</div>\n'},4283:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _reactDom=__webpack_require__(15);var _modules=__webpack_require__(2);var _components=__webpack_require__(32);var _eui=__webpack_require__(3);var _table=__webpack_require__(256);var _constants=__webpack_require__(64);var _format_number=__webpack_require__(59);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var filterFields=["logstash.name","logstash.host","logstash.http_address"];var columns=[{title:"Name",sortKey:"logstash.name",sortOrder:_constants.SORT_ASCENDING},{title:"CPU Usage",sortKey:"process.cpu.percent"},{title:"Load Average",sortKey:"os.cpu.load_average.1m"},{title:"JVM Heap Used",sortKey:"jvm.mem.heap_used_percent"},{title:"Events Ingested",sortKey:"events.out"},{title:"Config Reloads"},{title:"Version",sortKey:"logstash.version"}];var nodeRowFactory=function nodeRowFactory(scope,kbnUrl){var goToNode=function goToNode(uuid){scope.$evalAsync(function(){kbnUrl.changePath("/logstash/node/"+uuid)})};return function NodeRow(props){return _react2.default.createElement(_components.KuiTableRow,null,_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement("div",{className:"monitoringTableCell__name"},_react2.default.createElement(_eui.EuiLink,{onClick:goToNode.bind(null,(0,_lodash.get)(props,"logstash.uuid"))},(0,_lodash.get)(props,"logstash.name"))),_react2.default.createElement("div",{className:"monitoringTableCell__transportAddress"},(0,_lodash.get)(props,"logstash.http_address"))),_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement("div",{className:"monitoringTableCell__number"},(0,_format_number.formatPercentageUsage)(props.process.cpu.percent,100))),_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement("div",{className:"monitoringTableCell__number"},(0,_format_number.formatNumber)((0,_lodash.get)(props,'os.cpu.load_average["1m"]'),"0.00"))),_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement("div",{className:"monitoringTableCell__number"},(0,_format_number.formatPercentageUsage)(props.jvm.mem.heap_used_percent,100))),_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement("div",{className:"monitoringTableCell__number"},(0,_format_number.formatNumber)(props.events.out,"0.[0]a"))),_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement("div",{className:"monitoringTableCell__splitNumber"},props.reloads.successes," successes"),_react2.default.createElement("div",{className:"monitoringTableCell__splitNumber"},props.reloads.failures," failures")),_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement("div",{className:"monitoringTableCell__version"},(0,_format_number.formatNumber)((0,_lodash.get)(props,"logstash.version")))))}};var uiModule=_modules.uiModules.get("monitoring/directives",[]);uiModule.directive("monitoringLogstashNodeListing",function(kbnUrl){return{restrict:"E",scope:{nodes:"=",pageIndex:"=",filterText:"=",sortKey:"=",sortOrder:"=",onNewState:"="},link:function link(scope,$el){scope.$watch("nodes",function(){var nodes=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[];var nodesTable=_react2.default.createElement(_table.MonitoringTable,{className:"logstashNodesTable",rows:nodes,pageIndex:scope.pageIndex,filterText:scope.filterText,sortKey:scope.sortKey,sortOrder:scope.sortOrder,onNewState:scope.onNewState,placeholder:"Filter Nodes...",filterFields:filterFields,columns:columns,rowComponent:nodeRowFactory(scope,kbnUrl)});(0,_reactDom.render)(nodesTable,$el[0])})}}})},4284:function(module,exports,__webpack_require__){"use strict";var _index=__webpack_require__(4285);var _index2=_interopRequireDefault(_index);var _modules=__webpack_require__(2);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var uiModule=_modules.uiModules.get("monitoring/directives",[]);uiModule.directive("monitoringLogstashNodeSummary",function(){return{restrict:"E",template:_index2.default,scope:{logstash:"="}}})},4285:function(module,exports){module.exports='<div class="monitoring-summary-status" role="status">\n  <div class="monitoring-summary-status__content">\n    <div>\n      <strong data-test-subj="httpAddress">{{ logstash.http_address }}</strong>\n    </div>\n    <div>Events Received:\n      <strong data-test-subj="eventsIn">{{ logstash.events.in|formatNumber:\'0.[0]a\' }}</strong>\n    </div>\n    <div>Events Emitted:\n      <strong data-test-subj="eventsOut">{{ logstash.events.out|formatNumber:\'0.[0]a\' }}</strong>\n    </div>\n    <div>Config Reloads:\n      <strong data-test-subj="numReloads">{{ logstash.reloads.successes }}</strong>\n    </div>\n    <div>Pipeline Workers:\n      <strong data-test-subj="pipelineWorkers">{{ logstash.pipeline.workers }}</strong>\n    </div>\n    <div>Batch Size:\n      <strong data-test-subj="pipelineBatchSize">{{ logstash.pipeline.batch_size }}</strong>\n    </div>\n    <div ng-show="logstash.queue_type">Queue Type:\n      <strong data-test-subj="queueType">{{ logstash.queue_type }}</strong>\n    </div>\n    <div>Logstash:\n      <strong data-test-subj="version">{{ logstash.version }}</strong>\n    </div>\n    <div>Uptime:\n      <strong data-test-subj="uptime">{{ logstash.uptime|formatNumber:\'time_since\' }}</strong>\n    </div>\n  </div>\n</div>\n'},4286:function(module,exports,__webpack_require__){"use strict";var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _reactDom=__webpack_require__(15);var _moment=__webpack_require__(10);var _moment2=_interopRequireDefault(_moment);var _modules=__webpack_require__(2);var _pipeline_viewer=__webpack_require__(4287);var _pipeline=__webpack_require__(4299);var _list=__webpack_require__(4304);var _pipeline_state=__webpack_require__(4307);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var uiModule=_modules.uiModules.get("monitoring/directives",[]);uiModule.directive("monitoringLogstashPipelineViewer",function($injector){var config=$injector.get("config");var dateFormat=config.get("dateFormat");var timeseriesTooltipXValueFormatter=function timeseriesTooltipXValueFormatter(xValue){return(0,_moment2.default)(xValue).format(dateFormat)};return{restrict:"E",scope:{pipeline:"="},link:function link(scope,$el){var pipelineState=new _pipeline_state.PipelineState(scope.pipeline);scope.$watch("pipeline",function(updatedPipeline){pipelineState.update(updatedPipeline);(0,_reactDom.render)(_react2.default.createElement(_pipeline_viewer.PipelineViewer,{pipeline:_list.List.fromPipeline(_pipeline.Pipeline.fromPipelineGraph(pipelineState.config.graph)),timeseriesTooltipXValueFormatter:timeseriesTooltipXValueFormatter}),$el[0])})}}})},4287:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _views=__webpack_require__(4288);Object.defineProperty(exports,"PipelineViewer",{enumerable:true,get:function get(){return _views.PipelineViewer}})},4288:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _pipeline_viewer=__webpack_require__(4289);Object.defineProperty(exports,"PipelineViewer",{enumerable:true,get:function get(){return _pipeline_viewer.PipelineViewer}})},4289:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.PipelineViewer=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _propTypes=__webpack_require__(6);var _propTypes2=_interopRequireDefault(_propTypes);var _detail_drawer=__webpack_require__(4290);var _queue=__webpack_require__(4291);var _statement_section=__webpack_require__(4292);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}var PipelineViewer=exports.PipelineViewer=function(_React$Component){_inherits(PipelineViewer,_React$Component);function PipelineViewer(){_classCallCheck(this,PipelineViewer);var _this=_possibleConstructorReturn(this,(PipelineViewer.__proto__||Object.getPrototypeOf(PipelineViewer)).call(this));_this.onShowVertexDetails=function(vertex){vertex===_this.state.detailDrawer.vertex?_this.onHideVertexDetails():_this.setState({detailDrawer:{vertex:vertex}})};_this.onHideVertexDetails=function(){_this.setState({detailDrawer:{vertex:null}})};_this.renderDetailDrawer=function(){if(!_this.state.detailDrawer.vertex)return null;return _react2.default.createElement(_detail_drawer.DetailDrawer,{vertex:_this.state.detailDrawer.vertex,onHide:_this.onHideVertexDetails,timeseriesTooltipXValueFormatter:_this.props.timeseriesTooltipXValueFormatter})};_this.state={detailDrawer:{vertex:null}};return _this}_createClass(PipelineViewer,[{key:"render",value:function render(){var _props$pipeline=this.props.pipeline,inputs=_props$pipeline.inputs,filters=_props$pipeline.filters,outputs=_props$pipeline.outputs,queue=_props$pipeline.queue;return _react2.default.createElement(_eui.EuiPage,null,_react2.default.createElement(_eui.EuiPageBody,null,_react2.default.createElement(_eui.EuiPageContent,{verticalPosition:"center",horizontalPosition:"center",className:"pipelineViewer"},_react2.default.createElement(_statement_section.StatementSection,{iconType:"logstashInput",headingText:"Inputs",elements:inputs,onShowVertexDetails:this.onShowVertexDetails,detailVertex:this.state.detailDrawer.vertex}),_react2.default.createElement(_eui.EuiSpacer,null),_react2.default.createElement(_queue.Queue,{queue:queue}),_react2.default.createElement(_eui.EuiSpacer,null),_react2.default.createElement(_statement_section.StatementSection,{iconType:"logstashFilter",headingText:"Filters",elements:filters,onShowVertexDetails:this.onShowVertexDetails,detailVertex:this.state.detailDrawer.vertex}),_react2.default.createElement(_eui.EuiSpacer,null),_react2.default.createElement(_statement_section.StatementSection,{iconType:"logstashOutput",headingText:"Outputs",elements:outputs,onShowVertexDetails:this.onShowVertexDetails,detailVertex:this.state.detailDrawer.vertex}),this.renderDetailDrawer())))}}]);return PipelineViewer}(_react2.default.Component);PipelineViewer.propTypes={pipeline:_propTypes2.default.shape({inputs:_propTypes2.default.array.isRequired,filters:_propTypes2.default.array.isRequired,outputs:_propTypes2.default.array.isRequired,queue:_propTypes2.default.object.isRequired}).isRequired}},4290:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.DetailDrawer=DetailDrawer;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _lodash=__webpack_require__(1);var _eui=__webpack_require__(3);var _sparkline=__webpack_require__(897);var _format_number=__webpack_require__(59);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function renderIcon(vertex){return _react2.default.createElement(_eui.EuiIcon,{type:vertex.iconType,className:"lspvDetailDrawerIcon"})}function renderPluginBasicStats(vertex,timeseriesTooltipXValueFormatter){var eventsLatencyValueFormatter=function eventsLatencyValueFormatter(value){return(0,_format_number.formatMetric)(value,"0.[00]a","ms/e")};var latestEventsLatency=Array.isArray(vertex.stats.millis_per_event.data)&&vertex.stats.millis_per_event.data.length>0?(0,_lodash.last)(vertex.stats.millis_per_event.data)[1]:null;var eventsLatencyRow="input"===vertex.pluginType?null:_react2.default.createElement(_eui.EuiTableRow,{key:"events_latency"},_react2.default.createElement(_eui.EuiTableRowCell,null,"Events Latency"),_react2.default.createElement(_eui.EuiTableRowCell,null,_react2.default.createElement("div",{className:"lspvDetailDrawerSparklineContainer"},_react2.default.createElement(_sparkline.Sparkline,{series:vertex.stats.millis_per_event.data,options:{xaxis:vertex.stats.millis_per_event.timeRange},tooltip:{enabled:true,xValueFormatter:timeseriesTooltipXValueFormatter,yValueFormatter:eventsLatencyValueFormatter}}))),_react2.default.createElement(_eui.EuiTableRowCell,null,eventsLatencyValueFormatter(latestEventsLatency)));var eventsOutRateValueFormatter=function eventsOutRateValueFormatter(value){return(0,_format_number.formatMetric)(value,"0.[0]a","e/s")};var eventsOutRateRow=_react2.default.createElement(_eui.EuiTableRow,{key:"events_out_rate"},_react2.default.createElement(_eui.EuiTableRowCell,null,"Events Emitted Rate"),_react2.default.createElement(_eui.EuiTableRowCell,null,_react2.default.createElement("div",{className:"lspvDetailDrawerSparklineContainer"},_react2.default.createElement(_sparkline.Sparkline,{series:vertex.eventsPerSecond.data,options:{xaxis:vertex.eventsPerSecond.timeRange},tooltip:{enabled:true,xValueFormatter:timeseriesTooltipXValueFormatter,yValueFormatter:eventsOutRateValueFormatter}}))),_react2.default.createElement(_eui.EuiTableRowCell,null,eventsOutRateValueFormatter(vertex.latestEventsPerSecond)));var eventsInValueFormatter=function eventsInValueFormatter(value){return(0,_format_number.formatMetric)(value,"0a","events")};var latestEventsIn=Array.isArray(vertex.stats.events_in.data)&&vertex.stats.events_in.data.length>0?(0,_lodash.last)(vertex.stats.events_in.data)[1]:null;var eventsInRow="input"===vertex.pluginType?null:_react2.default.createElement(_eui.EuiTableRow,{key:"events_in"},_react2.default.createElement(_eui.EuiTableRowCell,null,"Events Received"),_react2.default.createElement(_eui.EuiTableRowCell,null,_react2.default.createElement("div",{className:"lspvDetailDrawerSparklineContainer"},_react2.default.createElement(_sparkline.Sparkline,{series:vertex.stats.events_in.data,options:{xaxis:vertex.stats.events_in.timeRange},tooltip:{enabled:true,xValueFormatter:timeseriesTooltipXValueFormatter,yValueFormatter:eventsInValueFormatter}}))),_react2.default.createElement(_eui.EuiTableRowCell,null,eventsInValueFormatter(latestEventsIn)));var eventsOutValueFormatter=eventsInValueFormatter;var latestEventsOut=Array.isArray(vertex.stats.events_out.data)&&vertex.stats.events_out.data.length>0?(0,_lodash.last)(vertex.stats.events_out.data)[1]:null;var eventsOutRow=_react2.default.createElement(_eui.EuiTableRow,{key:"events_out"},_react2.default.createElement(_eui.EuiTableRowCell,null,"Events Emitted"),_react2.default.createElement(_eui.EuiTableRowCell,null,_react2.default.createElement("div",{className:"lspvDetailDrawerSparklineContainer"},_react2.default.createElement(_sparkline.Sparkline,{series:vertex.stats.events_out.data,options:{xaxis:vertex.stats.events_out.timeRange},tooltip:{enabled:true,xValueFormatter:timeseriesTooltipXValueFormatter,yValueFormatter:eventsOutValueFormatter}}))),_react2.default.createElement(_eui.EuiTableRowCell,null,eventsOutValueFormatter(latestEventsOut)));return _react2.default.createElement(_eui.EuiTable,null,_react2.default.createElement(_eui.EuiTableBody,null,eventsLatencyRow,eventsOutRateRow,eventsInRow,eventsOutRow))}function renderIfBasicStats(_vertex){return _react2.default.createElement("p",null,"There are currently no metrics to show for this if condition.")}function renderQueueBasicStats(_vertex){return _react2.default.createElement("p",null,"There are currently no metrics to show for the queue.")}function renderBasicStats(vertex,timeseriesTooltipXValueFormatter){switch(vertex.typeString){case"plugin":return renderPluginBasicStats(vertex,timeseriesTooltipXValueFormatter);case"if":return renderIfBasicStats(vertex,timeseriesTooltipXValueFormatter);case"queue":return renderQueueBasicStats(vertex,timeseriesTooltipXValueFormatter)}}function renderPluginBasicInfo(vertex){if(vertex.hasExplicitId)return _react2.default.createElement("p",null,"This ",vertex.typeString,"'s ID is ",_react2.default.createElement(_eui.EuiBadge,null,vertex.id),".");return _react2.default.createElement("div",null,_react2.default.createElement("p",null,"This ",vertex.typeString," does not have an ID explicitly specified. Specifying an ID allows you to track differences across pipeline changes. You can explicitly specify an ID for this plugin like so:"),_react2.default.createElement(_eui.EuiCodeBlock,null,vertex.name," ",'{\n  id => "mySpecialId"\n}'),_react2.default.createElement(_eui.EuiSpacer,null))}function renderIfBasicInfo(vertex){var ifCode="if ("+vertex.subtitle+") {\n  ...\n}";return _react2.default.createElement("div",null,_react2.default.createElement("p",null,"This is a conditional statement in your pipeline."),_react2.default.createElement(_eui.EuiCodeBlock,null,ifCode),_react2.default.createElement(_eui.EuiSpacer,null))}function renderQueueBasicInfo(_vertex){return _react2.default.createElement("p",null,"This is an internal structure used by Logstash to buffer events between inputs and the rest of the pipeline.")}function renderBasicInfo(vertex){switch(vertex.typeString){case"plugin":return renderPluginBasicInfo(vertex);case"if":return renderIfBasicInfo(vertex);case"queue":return renderQueueBasicInfo(vertex)}}function renderTitle(vertex){switch(vertex.typeString){case"plugin":return vertex.title+" "+vertex.pluginType;case"if":case"queue":return vertex.title}}function DetailDrawer(_ref){var vertex=_ref.vertex,onHide=_ref.onHide,timeseriesTooltipXValueFormatter=_ref.timeseriesTooltipXValueFormatter;return _react2.default.createElement(_eui.EuiFlyout,{size:"s",onClose:onHide},_react2.default.createElement(_eui.EuiFlyoutHeader,null,_react2.default.createElement(_eui.EuiFlexGroup,{alignItems:"baseline",gutterSize:"s"},_react2.default.createElement(_eui.EuiFlexItem,{grow:false},renderIcon(vertex)),_react2.default.createElement(_eui.EuiFlexItem,null,_react2.default.createElement(_eui.EuiTitle,null,_react2.default.createElement("h2",null,renderTitle(vertex)))))),_react2.default.createElement(_eui.EuiFlyoutBody,null,_react2.default.createElement(_eui.EuiText,null,renderBasicInfo(vertex),renderBasicStats(vertex,timeseriesTooltipXValueFormatter))))}},4291:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.Queue=Queue;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _statement_list_heading=__webpack_require__(1514);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function Queue(){return _react2.default.createElement("div",null,_react2.default.createElement(_statement_list_heading.StatementListHeading,{iconType:"logstashQueue",title:"Queue"}),_react2.default.createElement(_eui.EuiSpacer,{size:"s"}),_react2.default.createElement(_eui.EuiText,{className:"pipelineViewer__queueMessage"},"Queue metrics not available"))}},4292:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.StatementSection=StatementSection;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _propTypes=__webpack_require__(6);var _propTypes2=_interopRequireDefault(_propTypes);var _statement_list_heading=__webpack_require__(1514);var _eui=__webpack_require__(3);var _statement_list=__webpack_require__(4293);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function StatementSection(_ref){var iconType=_ref.iconType,headingText=_ref.headingText,elements=_ref.elements,onShowVertexDetails=_ref.onShowVertexDetails;if(!elements.length)return null;return _react2.default.createElement("div",null,_react2.default.createElement(_statement_list_heading.StatementListHeading,{iconType:iconType,title:headingText}),_react2.default.createElement(_eui.EuiSpacer,{size:"s"}),_react2.default.createElement(_statement_list.StatementList,{elements:elements,onShowVertexDetails:onShowVertexDetails}))}StatementSection.propTypes={elements:_propTypes2.default.arrayOf(_propTypes2.default.shape({id:_propTypes2.default.string.isRequired,parentId:_propTypes2.default.string})).isRequired,headingText:_propTypes2.default.string.isRequired,iconType:_propTypes2.default.string.isRequired,onShowVertexDetails:_propTypes2.default.func.isRequired}},4293:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.StatementList=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _propTypes=__webpack_require__(6);var _propTypes2=_interopRequireDefault(_propTypes);var _statement=__webpack_require__(4294);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}function getCollapsedChildIds(elements,collapsedIds){var collapsedChildIds=new Set;elements.forEach(function(_ref){var id=_ref.id,parentId=_ref.parentId;(collapsedIds.has(parentId)||collapsedChildIds.has(parentId))&&collapsedChildIds.add(id)});return collapsedChildIds}var StatementList=exports.StatementList=function(_React$PureComponent){_inherits(StatementList,_React$PureComponent);function StatementList(props){_classCallCheck(this,StatementList);var _this=_possibleConstructorReturn(this,(StatementList.__proto__||Object.getPrototypeOf(StatementList)).call(this,props));_this.expand=function(elementId){var collapsedIds=new Set(_this.state.collapsedIds);collapsedIds.delete(elementId);_this.updateCollapsedElement(collapsedIds)};_this.collapse=function(elementId){var collapsedIds=new Set(_this.state.collapsedIds);collapsedIds.add(elementId);_this.updateCollapsedElement(collapsedIds)};_this.updateCollapsedElement=function(collapsedIds){var elements=_this.props.elements;var collapsedChildIds=getCollapsedChildIds(elements,collapsedIds);_this.setState({collapsedIds:collapsedIds,collapsedChildIds:collapsedChildIds})};_this.elementIsCollapsed=function(elementId){return _this.state.collapsedIds.has(elementId)};_this.renderStatement=function(element){var id=element.id,parentId=element.parentId;var onShowVertexDetails=_this.props.onShowVertexDetails;return _this.state.collapsedIds.has(parentId)||_this.state.collapsedChildIds.has(parentId)?null:_react2.default.createElement(_statement.Statement,{key:id,element:element,collapse:_this.collapse,expand:_this.expand,isCollapsed:_this.elementIsCollapsed(id),onShowVertexDetails:onShowVertexDetails})};_this.state={collapsedIds:new Set,collapsedChildIds:new Set};return _this}_createClass(StatementList,[{key:"render",value:function render(){var elements=this.props.elements;return _react2.default.createElement("ul",{className:"pipelineViewer__list"},elements.map(this.renderStatement))}}]);return StatementList}(_react2.default.PureComponent);StatementList.propTypes={elements:_propTypes2.default.arrayOf(_propTypes2.default.shape({id:_propTypes2.default.string.isRequired,parentId:_propTypes2.default.string})).isRequired,onShowVertexDetails:_propTypes2.default.func.isRequired}},4294:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.Statement=Statement;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _propTypes=__webpack_require__(6);var _propTypes2=_interopRequireDefault(_propTypes);var _eui=__webpack_require__(3);var _plugin_statement=__webpack_require__(1515);var _collapsible_statement=__webpack_require__(4296);var _if_element=__webpack_require__(1516);var _plugin_statement2=__webpack_require__(4297);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function renderStatementName(name,onVertexSelected){return _react2.default.createElement(_eui.EuiFlexItem,{grow:false,key:"statementName"},_react2.default.createElement(_eui.EuiButtonEmpty,{color:"text",size:"xs",onClick:onVertexSelected,flush:"left"},_react2.default.createElement("span",{className:"pipelineViewer__conditional"},name)))}function renderIfStatement(_ref,onVertexSelected){var condition=_ref.condition;return[renderStatementName("if",onVertexSelected),_react2.default.createElement(_eui.EuiFlexItem,{key:"ifContent",grow:false},_react2.default.createElement(_eui.EuiCodeBlock,{fontSize:"s",paddingSize:"none",transparentBackground:true},condition))]}function getStatementBody(isIf,statement,vertex,onShowVertexDetails){var showVertexDetailsClicked=function showVertexDetailsClicked(){onShowVertexDetails(vertex)};return isIf?renderIfStatement(statement,showVertexDetailsClicked):renderStatementName("else",showVertexDetailsClicked)}function renderNestingSpacers(depth){var spacers=[];for(var i=0;i<depth;i+=1)spacers.push(_react2.default.createElement("div",{key:"spacer_"+i,className:"pipelineViewer__spacer"}));return spacers}function renderStatement(_ref2){var collapse=_ref2.collapse,element=_ref2.element,_ref2$element=_ref2.element,id=_ref2$element.id,statement=_ref2$element.statement,vertex=_ref2$element.statement.vertex,expand=_ref2.expand,isCollapsed=_ref2.isCollapsed,onShowVertexDetails=_ref2.onShowVertexDetails;if(statement instanceof _plugin_statement.PluginStatement)return _react2.default.createElement(_plugin_statement2.PluginStatement,{statement:statement,onShowVertexDetails:onShowVertexDetails});var statementBody=getStatementBody(element instanceof _if_element.IfElement,statement,vertex,onShowVertexDetails);return _react2.default.createElement(_collapsible_statement.CollapsibleStatement,{expand:expand,collapse:collapse,isCollapsed:isCollapsed,id:id},statementBody)}function Statement(props){var depth=props.element.depth;return _react2.default.createElement("li",{className:"pipelineViewer__listItem"},_react2.default.createElement("div",{className:"pipelineViewer__spaceContainer"},renderNestingSpacers(depth)),renderStatement(props))}Statement.propTypes={collapse:_propTypes2.default.func.isRequired,element:_propTypes2.default.shape({depth:_propTypes2.default.number.isRequired,id:_propTypes2.default.string.isRequired,statement:_propTypes2.default.object.isRequired}).isRequired,expand:_propTypes2.default.func.isRequired,isCollapsed:_propTypes2.default.bool.isRequired,onShowVertexDetails:_propTypes2.default.func.isRequired}},4295:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.PluginElement=void 0;var _element=__webpack_require__(901);function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}exports.PluginElement=function(_Element){_inherits(PluginElement,_Element);function PluginElement(statement,depth,parentId){_classCallCheck(this,PluginElement);var id=statement.id;return _possibleConstructorReturn(this,(PluginElement.__proto__||Object.getPrototypeOf(PluginElement)).call(this,id,statement,depth,parentId))}return PluginElement}(_element.Element)},4296:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.CollapsibleStatement=CollapsibleStatement;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _propTypes=__webpack_require__(6);var _propTypes2=_interopRequireDefault(_propTypes);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function getToggleIconType(isCollapsed){return isCollapsed?"arrowRight":"arrowDown"}function CollapsibleStatement(props){var collapse=props.collapse,expand=props.expand,id=props.id,isCollapsed=props.isCollapsed;var toggleClicked=function toggleClicked(){isCollapsed?expand(id):collapse(id)};return _react2.default.createElement(_eui.EuiFlexGroup,{responsive:false,gutterSize:"none",alignItems:"center",className:"pipelineViewer__statement"},_react2.default.createElement(_eui.EuiFlexItem,{key:id,grow:false},_react2.default.createElement(_eui.EuiButtonIcon,{"aria-label":true,color:"text",iconType:getToggleIconType(isCollapsed),onClick:toggleClicked,size:"s"})),props.children)}CollapsibleStatement.propTypes={collapse:_propTypes2.default.func.isRequired,expand:_propTypes2.default.func.isRequired,id:_propTypes2.default.string.isRequired,isCollapsed:_propTypes2.default.bool.isRequired}},4297:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.PluginStatement=PluginStatement;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _propTypes=__webpack_require__(6);var _propTypes2=_interopRequireDefault(_propTypes);var _eui=__webpack_require__(3);var _format_number=__webpack_require__(59);var _metric=__webpack_require__(4298);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function getInputStatementMetrics(_ref){var latestEventsPerSecond=_ref.latestEventsPerSecond;return[_react2.default.createElement(_metric.Metric,{key:"eventsEmitted",className:"pipelineViewer__metric--eventsEmitted",value:(0,_format_number.formatMetric)(latestEventsPerSecond,"0.[00]a","e/s emitted")})]}function getProcessorStatementMetrics(processorVertex){var latestMillisPerEvent=processorVertex.latestMillisPerEvent,latestEventsPerSecond=processorVertex.latestEventsPerSecond,percentOfTotalProcessorTime=processorVertex.percentOfTotalProcessorTime;return[_react2.default.createElement(_metric.Metric,{key:"cpuMetric",className:"pipelineViewer__metric--cpuTime",warning:processorVertex.isTimeConsuming(),value:(0,_format_number.formatMetric)(Math.round(percentOfTotalProcessorTime||0),"0","%",{prependSpace:false})}),_react2.default.createElement(_metric.Metric,{key:"eventMillis",className:"pipelineViewer__metric--eventMillis",warning:processorVertex.isSlow(),value:(0,_format_number.formatMetric)(latestMillisPerEvent,"0.[00]a","ms/e")}),_react2.default.createElement(_metric.Metric,{key:"eventsReceived",className:"pipelineViewer__metric--events",value:(0,_format_number.formatMetric)(latestEventsPerSecond,"0.[00]a","e/s received")})]}function renderPluginStatementMetrics(pluginType,vertex){return"input"===pluginType?getInputStatementMetrics(vertex):getProcessorStatementMetrics(vertex)}function PluginStatement(_ref2){var _ref2$statement=_ref2.statement,hasExplicitId=_ref2$statement.hasExplicitId,id=_ref2$statement.id,name=_ref2$statement.name,pluginType=_ref2$statement.pluginType,vertex=_ref2$statement.vertex,onShowVertexDetails=_ref2.onShowVertexDetails;var statementMetrics=renderPluginStatementMetrics(pluginType,vertex);var onNameButtonClick=function onNameButtonClick(){onShowVertexDetails(vertex)};return _react2.default.createElement(_eui.EuiFlexGroup,{alignItems:"center",className:"pipelineViewer__statement",gutterSize:"none",justifyContent:"spaceBetween"},_react2.default.createElement(_eui.EuiFlexItem,{grow:false},_react2.default.createElement(_eui.EuiFlexGroup,{alignItems:"center",gutterSize:"xs",responsive:false},_react2.default.createElement(_eui.EuiFlexItem,{grow:false},_react2.default.createElement(_eui.EuiButtonEmpty,{className:"pipelineViewer__plugin",color:"primary",flush:"left",iconType:"dot",onClick:onNameButtonClick,size:"xs"},_react2.default.createElement("span",null,name))),hasExplicitId&&_react2.default.createElement(_eui.EuiFlexItem,{grow:false},_react2.default.createElement(_eui.EuiBadge,{onClick:onNameButtonClick,onClickAriaLabel:"View details"},id)))),statementMetrics&&_react2.default.createElement(_eui.EuiFlexItem,{grow:false},_react2.default.createElement(_eui.EuiFlexGroup,{gutterSize:"s"},statementMetrics)))}PluginStatement.propTypes={onShowVertexDetails:_propTypes2.default.func.isRequired,statement:_propTypes2.default.shape({hasExplicitId:_propTypes2.default.bool.isRequired,id:_propTypes2.default.string.isRequired,name:_propTypes2.default.string.isRequired,pluginType:_propTypes2.default.string.isRequired,vertex:_propTypes2.default.shape({latestEventsPerSecond:_propTypes2.default.number.isRequired,latestMillisPerEvent:_propTypes2.default.number,percentOfTotalProcessorTime:_propTypes2.default.number}).isRequired}).isRequired}},4298:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.Metric=Metric;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _propTypes=__webpack_require__(6);var _propTypes2=_interopRequireDefault(_propTypes);var _eui=__webpack_require__(3);var _classnames=__webpack_require__(5);var _classnames2=_interopRequireDefault(_classnames);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function Metric(_ref){var className=_ref.className,warning=_ref.warning,value=_ref.value;var classes=(0,_classnames2.default)("pipelineViewer__metric",className);var stylizedValue=void 0;stylizedValue=warning?_react2.default.createElement(_eui.EuiBadge,{color:"warning",className:className},value):_react2.default.createElement(_eui.EuiText,{size:"s",color:"subdued",className:classes},_react2.default.createElement("span",null,value));return _react2.default.createElement(_eui.EuiFlexItem,{className:"pipelineViewer__metricFlexItem",grow:false},stylizedValue)}Metric.propTypes={className:_propTypes2.default.string.isRequired,value:_propTypes2.default.string.isRequired,warning:_propTypes2.default.bool}},4299:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _pipeline=__webpack_require__(4300);Object.defineProperty(exports,"Pipeline",{enumerable:true,get:function get(){return _pipeline.Pipeline}})},4300:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.Pipeline=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _make_statement=__webpack_require__(1517);var _queue_vertex=__webpack_require__(902);var _utils=__webpack_require__(1518);function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function getInputStatements(pipelineGraph){return pipelineGraph.getVertices().filter(function(v){return"input"===v.pipelineStage}).map(_make_statement.makeStatement)}function isFilterStageVertex(vertex){return"filter"===vertex.pipelineStage}function isVertexOrphan(vertex){return 0===vertex.incomingVertices.length}function isVertexChildOfQueue(vertex){return vertex.incomingVertices.every(function(p){return p instanceof _queue_vertex.QueueVertex})}function getFilterStatements(pipelineGraph){var allVertices=pipelineGraph.getVertices();var allFilterVertices=allVertices.filter(function(v){return isFilterStageVertex(v)});var startFilterVertex=pipelineGraph.hasQueueVertex?allFilterVertices.find(function(v){return isVertexChildOfQueue(v)}):allFilterVertices.find(function(v){return isVertexOrphan(v)});if(!startFilterVertex)return[];var filterStatements=[];var currentVertex=startFilterVertex;while((0,_utils.isVertexPipelineStage)(currentVertex,"filter")){filterStatements.push((0,_make_statement.makeStatement)(currentVertex,"filter"));currentVertex=currentVertex.next}return filterStatements}function getQueue(pipelineGraph){return pipelineGraph.hasQueueVertex?(0,_make_statement.makeStatement)(pipelineGraph.queueVertex):null}function getOutputStatements(pipelineGraph){return pipelineGraph.getVertices().filter(function(v){return"output"===v.pipelineStage&&!v.incomingVertices.some(function(p){return"output"===p.pipelineStage})}).map(function(v){return(0,_make_statement.makeStatement)(v,"output")})}exports.Pipeline=function(){function Pipeline(inputStatements,filterStatements,outputStatements,queue){_classCallCheck(this,Pipeline);this.inputStatements=inputStatements;this.filterStatements=filterStatements;this.outputStatements=outputStatements;this.queue=queue}_createClass(Pipeline,null,[{key:"fromPipelineGraph",value:function fromPipelineGraph(pipelineGraph){var inputStatements=getInputStatements(pipelineGraph);var filterStatements=getFilterStatements(pipelineGraph);var outputStatements=getOutputStatements(pipelineGraph);var queue=getQueue(pipelineGraph);return new Pipeline(inputStatements,filterStatements,outputStatements,queue)}}]);return Pipeline}()},4301:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.IfStatement=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _statement=__webpack_require__(900);var _make_statement=__webpack_require__(1517);var _utils=__webpack_require__(1518);var _if_element=__webpack_require__(1516);var _else_element=__webpack_require__(4302);function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}function _toConsumableArray(arr){if(Array.isArray(arr)){for(var i=0,arr2=Array(arr.length);i<arr.length;i++)arr2[i]=arr[i];return arr2}return Array.from(arr)}function makeStatementsForOutgoingVertices(outgoingVertices,statements,next,pipelineStage){outgoingVertices.forEach(function(vertex){var currentVertex=vertex;while((0,_utils.isVertexPipelineStage)(currentVertex,pipelineStage)&&currentVertex!==next){statements.push((0,_make_statement.makeStatement)(currentVertex,pipelineStage));currentVertex=currentVertex.next}})}function addStatementsToList(list,statements,depth,id){statements.forEach(function(statement){list.push.apply(list,_toConsumableArray(statement.toList(depth,id)))})}exports.IfStatement=function(_Statement){_inherits(IfStatement,_Statement);function IfStatement(vertex,trueStatements,elseStatements){_classCallCheck(this,IfStatement);var _this=_possibleConstructorReturn(this,(IfStatement.__proto__||Object.getPrototypeOf(IfStatement)).call(this,vertex));var name=vertex.name;_this.condition=name;_this.trueStatements=trueStatements;_this.elseStatements=elseStatements;return _this}_createClass(IfStatement,[{key:"toList",value:function toList(depth,parentId){var list=[];var ifElement=new _if_element.IfElement(this,depth,parentId);list.push(ifElement);var nestedElementDepth=depth+1;addStatementsToList(list,this.trueStatements,nestedElementDepth,ifElement.id);if(this.elseStatements.length){var elseElement=new _else_element.ElseElement(this,depth,parentId);list.push(elseElement);addStatementsToList(list,this.elseStatements,nestedElementDepth,elseElement.id)}return list}}],[{key:"fromPipelineGraphVertex",value:function fromPipelineGraphVertex(ifVertex,pipelineStage){var trueStatements=[];var elseStatements=[];var trueOutgoingVertices=ifVertex.trueOutgoingVertices,falseOutgoingVertices=ifVertex.falseOutgoingVertices;var next=ifVertex.next;makeStatementsForOutgoingVertices(trueOutgoingVertices,trueStatements,next,pipelineStage);makeStatementsForOutgoingVertices(falseOutgoingVertices,elseStatements,next,pipelineStage);return new IfStatement(ifVertex,trueStatements,elseStatements)}}]);return IfStatement}(_statement.Statement)},4302:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.ElseElement=void 0;var _element=__webpack_require__(901);function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}exports.ElseElement=function(_Element){_inherits(ElseElement,_Element);function ElseElement(statement,depth,parentId){_classCallCheck(this,ElseElement);var id=statement.id;return _possibleConstructorReturn(this,(ElseElement.__proto__||Object.getPrototypeOf(ElseElement)).call(this,id+"_else",statement,depth,parentId))}return ElseElement}(_element.Element)},4303:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.Queue=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _statement=__webpack_require__(900);function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}exports.Queue=function(_Statement){_inherits(Queue,_Statement);function Queue(){_classCallCheck(this,Queue);return _possibleConstructorReturn(this,(Queue.__proto__||Object.getPrototypeOf(Queue)).apply(this,arguments))}_createClass(Queue,null,[{key:"fromPipelineGraphVertex",value:function fromPipelineGraphVertex(queueVertex){return new Queue(queueVertex)}}]);return Queue}(_statement.Statement)},4304:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _list=__webpack_require__(4305);Object.defineProperty(exports,"List",{enumerable:true,get:function get(){return _list.List}})},4305:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.List=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _flatten_pipeline_section=__webpack_require__(4306);function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}exports.List=function(){function List(inputs,filters,outputs,queue){_classCallCheck(this,List);this.inputs=inputs;this.filters=filters;this.outputs=outputs;this.queue=queue}_createClass(List,null,[{key:"fromPipeline",value:function fromPipeline(pipeline){var inputStatements=pipeline.inputStatements,filterStatements=pipeline.filterStatements,outputStatements=pipeline.outputStatements,queue=pipeline.queue;return new List((0,_flatten_pipeline_section.flattenPipelineSection)(inputStatements),(0,_flatten_pipeline_section.flattenPipelineSection)(filterStatements),(0,_flatten_pipeline_section.flattenPipelineSection)(outputStatements),queue)}}]);return List}()},4306:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.flattenPipelineSection=flattenPipelineSection;function _toConsumableArray(arr){if(Array.isArray(arr)){for(var i=0,arr2=Array(arr.length);i<arr.length;i++)arr2[i]=arr[i];return arr2}return Array.from(arr)}function flattenPipelineSection(pipelineSection){var depth=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0;var parentId=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;var list=[];pipelineSection.forEach(function(statement){list.push.apply(list,_toConsumableArray(statement.toList(depth,parentId)))});return list}},4307:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.PipelineState=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _config=__webpack_require__(4308);function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}exports.PipelineState=function(){function PipelineState(pipelineState){_classCallCheck(this,PipelineState);this.config=new _config.Config;this.update(pipelineState)}_createClass(PipelineState,[{key:"update",value:function update(pipelineJson){this.config.update(pipelineJson.representation)}}]);return PipelineState}()},4308:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.Config=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _graph=__webpack_require__(4309);function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}exports.Config=function(){function Config(){_classCallCheck(this,Config);this.graph=new _graph.Graph}_createClass(Config,[{key:"update",value:function update(configJson){this.json=configJson;this.graph.update(configJson.graph)}}]);return Config}()},4309:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.Graph=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _vertex_factory=__webpack_require__(4310);var _edge_factory=__webpack_require__(4312);var _queue_vertex=__webpack_require__(902);var _plugin_vertex=__webpack_require__(1519);function _toConsumableArray(arr){if(Array.isArray(arr)){for(var i=0,arr2=Array(arr.length);i<arr.length;i++)arr2[i]=arr[i];return arr2}return Array.from(arr)}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}exports.Graph=function(){function Graph(){_classCallCheck(this,Graph);this.json=null;this.verticesById={};this.edgesById={};this.edgesByFrom={};this.edgesByTo={}}_createClass(Graph,[{key:"getVertexById",value:function getVertexById(id){return this.verticesById[id]}},{key:"getVertices",value:function getVertices(){void 0===this.vertexCache&&(this.vertexCache=Object.values(this.verticesById));return this.vertexCache}},{key:"update",value:function update(jsonRepresentation){var _this=this;this.json=jsonRepresentation;jsonRepresentation.vertices.forEach(function(vJson){var existingVertex=_this.verticesById[vJson.id];if(void 0!==existingVertex)existingVertex.update(vJson);else{var newVertex=(0,_vertex_factory.vertexFactory)(_this,vJson);_this.verticesById[vJson.id]=newVertex}});jsonRepresentation.edges.forEach(function(eJson){var existingEdge=_this.edgesById[eJson.id];if(void 0!==existingEdge)existingEdge.update(eJson);else{var newEdge=(0,_edge_factory.edgeFactory)(_this,eJson);_this.edgesById[eJson.id]=newEdge;void 0===_this.edgesByFrom[newEdge.from.json.id]&&(_this.edgesByFrom[newEdge.from.json.id]=[]);_this.edgesByFrom[newEdge.from.json.id].push(newEdge);void 0===_this.edgesByTo[newEdge.to.json.id]&&(_this.edgesByTo[newEdge.to.json.id]=[]);_this.edgesByTo[newEdge.to.json.id].push(newEdge)}});this.annotateVerticesWithStages()}},{key:"annotateVerticesWithStages",value:function annotateVerticesWithStages(){this.annotateInputStageVertices();this.annotateOutputStageVertices();this.annotateFilterStageVertices()}},{key:"annotateInputStageVertices",value:function annotateInputStageVertices(){if(!this.hasQueueVertex)return;this.startVertices.forEach(function(v){return v.pipelineStage="input"})}},{key:"annotateOutputStageVertices",value:function annotateOutputStageVertices(){if(1===this.endVertices.length&&this.endVertices[0]instanceof _queue_vertex.QueueVertex)return;if(this.endVertices.every(function(v){return"filter"===v.pluginType}))return;var pending=[].concat(_toConsumableArray(this.endVertices));while(pending.length>0){var currentVertex=pending.shift();var parents=currentVertex.incomingVertices;var isParentFilterPluginVertex=parents.some(function(p){return p instanceof _plugin_vertex.PluginVertex&&"filter"===p.pluginType});var isParentQueueVertex=parents.some(function(p){return p instanceof _queue_vertex.QueueVertex});var isParentNothing=0===parents.length;var isParentOutputStageVertex=!(isParentFilterPluginVertex||isParentQueueVertex||isParentNothing);if(isParentOutputStageVertex)pending.push.apply(pending,_toConsumableArray(parents));else{currentVertex.pipelineStage="output";var descendantVertices=currentVertex.descendants().vertices;descendantVertices.forEach(function(v){return v.pipelineStage="output"})}}}},{key:"annotateFilterStageVertices",value:function annotateFilterStageVertices(){var pending=[];this.hasQueueVertex?pending.push.apply(pending,_toConsumableArray(this.queueVertex.outgoingVertices)):pending.push.apply(pending,_toConsumableArray(this.startVertices));while(pending.length>0){var currentVertex=pending.shift();if(!currentVertex.pipelineStage){currentVertex.pipelineStage="filter";pending.push.apply(pending,_toConsumableArray(currentVertex.outgoingVertices))}}}},{key:"queueVertex",get:function get(){return this.getVertices().find(function(v){return v instanceof _queue_vertex.QueueVertex})}},{key:"processorVertices",get:function get(){return this.getVertices().filter(function(v){return v.isProcessor})}},{key:"edges",get:function get(){return Object.values(this.edgesById)}},{key:"startVertices",get:function get(){return this.getVertices().filter(function(v){return 0===v.incomingEdges.length})}},{key:"endVertices",get:function get(){return this.getVertices().filter(function(v){return 0===v.outgoingEdges.length})}},{key:"hasQueueVertex",get:function get(){return!!this.queueVertex}}]);return Graph}()},4310:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.vertexFactory=vertexFactory;var _plugin_vertex=__webpack_require__(1519);var _if_vertex=__webpack_require__(4311);var _queue_vertex=__webpack_require__(902);function vertexFactory(graph,vertexJson){var type=vertexJson.type;switch(type){case"plugin":return new _plugin_vertex.PluginVertex(graph,vertexJson);case"if":return new _if_vertex.IfVertex(graph,vertexJson);case"queue":return new _queue_vertex.QueueVertex(graph,vertexJson);default:throw new Error("Unknown vertex type "+type+"! This shouldn't happen!")}}},4311:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.IfVertex=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _lodash=__webpack_require__(1);var _vertex=__webpack_require__(903);function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}exports.IfVertex=function(_Vertex){_inherits(IfVertex,_Vertex);function IfVertex(){_classCallCheck(this,IfVertex);return _possibleConstructorReturn(this,(IfVertex.__proto__||Object.getPrototypeOf(IfVertex)).apply(this,arguments))}_createClass(IfVertex,[{key:"typeString",get:function get(){return"if"}},{key:"name",get:function get(){return this.json.condition}},{key:"iconType",get:function get(){return"logstashIf"}},{key:"title",get:function get(){return"if"}},{key:"subtitle",get:function get(){return this.name}},{key:"trueEdge",get:function get(){return this.outgoingEdges.find(function(e){return true===e.when})}},{key:"trueEdges",get:function get(){return this.outgoingEdges.filter(function(e){return true===e.when})}},{key:"falseEdge",get:function get(){return this.outgoingEdges.find(function(e){return false===e.when})}},{key:"falseEdges",get:function get(){return this.outgoingEdges.filter(function(e){return false===e.when})}},{key:"trueOutgoingVertex",get:function get(){return this.trueEdge?this.trueEdge.to:null}},{key:"trueOutgoingVertices",get:function get(){return this.trueEdges.map(function(e){return e.to})}},{key:"falseOutgoingVertex",get:function get(){return this.falseEdge?this.falseEdge.to:null}},{key:"falseOutgoingVertices",get:function get(){return this.falseEdges.map(function(e){return e.to})}},{key:"next",get:function get(){var trueDescendants=this.trueOutgoingVertex?this.trueOutgoingVertex.descendants().vertices:[];var falseDescendants=this.falseOutgoingVertex?this.falseOutgoingVertex.descendants().vertices:[];trueDescendants.unshift(this.trueOutgoingVertex);falseDescendants.unshift(this.falseOutgoingVertex);return(0,_lodash.intersection)(trueDescendants,falseDescendants)[0]}}]);return IfVertex}(_vertex.Vertex)},4312:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.edgeFactory=edgeFactory;var _edge=__webpack_require__(1520);var _boolean_edge=__webpack_require__(4313);function edgeFactory(graph,edgeJson){var type=edgeJson.type;switch(type){case"plain":return new _edge.Edge(graph,edgeJson);case"boolean":return new _boolean_edge.BooleanEdge(graph,edgeJson);default:throw new Error("Unknown edge type "+type+"! This shouldn't happen!")}}},4313:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.BooleanEdge=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _edge=__webpack_require__(1520);function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}exports.BooleanEdge=function(_Edge){_inherits(BooleanEdge,_Edge);function BooleanEdge(){_classCallCheck(this,BooleanEdge);return _possibleConstructorReturn(this,(BooleanEdge.__proto__||Object.getPrototypeOf(BooleanEdge)).apply(this,arguments))}_createClass(BooleanEdge,[{key:"when",get:function get(){return this.json.when}},{key:"isTrue",get:function get(){return true===this.when}},{key:"isFalse",get:function get(){return false===this.when}}]);return BooleanEdge}(_edge.Edge)},4314:function(module,exports,__webpack_require__){"use strict";var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _reactDom=__webpack_require__(15);var _moment=__webpack_require__(10);var _moment2=_interopRequireDefault(_moment);var _lodash=__webpack_require__(1);var _modules=__webpack_require__(2);var _components=__webpack_require__(32);var _eui=__webpack_require__(3);var _table=__webpack_require__(256);var _sparkline=__webpack_require__(897);var _constants=__webpack_require__(64);var _format_number=__webpack_require__(59);var _timefilter=__webpack_require__(14);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var filterFields=["id"];var columns=[{title:"ID",sortKey:"id",sortOrder:_constants.SORT_ASCENDING},{title:"Events Emitted Rate",sortKey:"latestThroughput"},{title:"Number of Nodes",sortKey:"latestNodesCount"}];var pipelineRowFactory=function pipelineRowFactory(onPipelineClick,onBrush,tooltipXValueFormatter,tooltipYValueFormatter){return function PipelineRow(_ref){var id=_ref.id,metrics=_ref.metrics,latestThroughput=_ref.latestThroughput,latestNodesCount=_ref.latestNodesCount;var throughputMetric=metrics.throughput;var nodesCountMetric=metrics.nodesCount;return _react2.default.createElement(_components.KuiTableRow,null,_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement("div",{className:"monitoringTableCell__name"},_react2.default.createElement(_eui.EuiLink,{onClick:onPipelineClick.bind(null,id),"data-test-subj":"id"},id))),_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement(_components.KuiFlexGroup,{gutterSize:"none",alignItems:"center"},_react2.default.createElement(_components.KuiFlexItem,null,_react2.default.createElement(_sparkline.Sparkline,{series:throughputMetric.data,onBrush:onBrush,tooltip:{xValueFormatter:tooltipXValueFormatter,yValueFormatter:(0,_lodash.partialRight)(tooltipYValueFormatter,throughputMetric.metric.format,throughputMetric.metric.units)},options:{xaxis:throughputMetric.timeRange}})),_react2.default.createElement(_components.KuiFlexItem,{className:"monitoringTableCell__number","data-test-subj":"eventsEmittedRate"},(0,_format_number.formatMetric)(latestThroughput,"0.[0]a",throughputMetric.metric.units)))),_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement(_components.KuiFlexGroup,{gutterSize:"none",alignItems:"center"},_react2.default.createElement(_components.KuiFlexItem,null,_react2.default.createElement(_sparkline.Sparkline,{series:nodesCountMetric.data,onBrush:onBrush,tooltip:{xValueFormatter:tooltipXValueFormatter,yValueFormatter:(0,_lodash.partialRight)(tooltipYValueFormatter,nodesCountMetric.metric.format,nodesCountMetric.metric.units)},options:{xaxis:nodesCountMetric.timeRange}})),_react2.default.createElement(_components.KuiFlexItem,{className:"monitoringTableCell__number","data-test-subj":"nodeCount"},(0,_format_number.formatMetric)(latestNodesCount,"0a")))))}};var uiModule=_modules.uiModules.get("monitoring/directives",[]);uiModule.directive("monitoringLogstashPipelineListing",function($injector){var kbnUrl=$injector.get("kbnUrl");var config=$injector.get("config");var dateFormat=config.get("dateFormat");return{restrict:"E",scope:{pipelines:"=",pageIndex:"=",filterText:"=",sortKey:"=",sortOrder:"=",onNewState:"=",upgradeMessage:"@"},link:function link(scope,$el){function onBrush(xaxis){_timefilter.timefilter.setTime({from:(0,_moment2.default)(xaxis.from),to:(0,_moment2.default)(xaxis.to),mode:"absolute"})}function onPipelineClick(id){var url="/logstash/pipelines/"+id;scope.$evalAsync(function(){return kbnUrl.changePath(url)})}function tooltipXValueFormatter(xValue){return(0,_moment2.default)(xValue).format(dateFormat)}function tooltipYValueFormatter(yValue,format,units){return(0,_format_number.formatMetric)(yValue,format,units)}scope.$watch("pipelines",function(){var pipelines=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[];if(scope.upgradeMessage){(0,_reactDom.render)(_react2.default.createElement(_components.KuiEmptyTablePrompt,{message:scope.upgradeMessage}),$el[0]);return}var pipelinesTable=_react2.default.createElement(_table.MonitoringTable,{className:"logstashPipelinesTable",rows:pipelines,pageIndex:scope.pageIndex,filterText:scope.filterText,sortKey:scope.sortKey,sortOrder:scope.sortOrder,onNewState:scope.onNewState,placeholder:"Filter Pipelines...",filterFields:filterFields,columns:columns,rowComponent:pipelineRowFactory(onPipelineClick,onBrush,tooltipXValueFormatter,tooltipYValueFormatter)});(0,_reactDom.render)(pipelinesTable,$el[0])});scope.$on("$destroy",function(){return(0,_reactDom.unmountComponentAtNode)($el[0])})}}})},4315:function(module,exports,__webpack_require__){"use strict";var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _reactDom=__webpack_require__(15);var _modules=__webpack_require__(2);var _cluster_status=__webpack_require__(4316);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var uiModule=_modules.uiModules.get("monitoring/directives",[]);uiModule.directive("monitoringClusterStatusKibana",function(){return{restrict:"E",scope:{status:"="},link:function link(scope,$el){scope.$watch("status",function(status){(0,_reactDom.render)(_react2.default.createElement(_cluster_status.ClusterStatus,{stats:status}),$el[0])})}}})},4316:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.ClusterStatus=ClusterStatus;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _summary_status=__webpack_require__(511);var _status_icon=__webpack_require__(904);var _format_number=__webpack_require__(59);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function ClusterStatus(_ref){var stats=_ref.stats;var connections=stats.concurrent_connections,instances=stats.count,memLimit=stats.memory_limit,memSize=stats.memory_size,requests=stats.requests_total,maxResponseTime=stats.response_time_max,status=stats.status;var metrics=[{label:"Instances",value:instances,dataTestSubj:"instances"},{label:"Memory",value:(0,_format_number.formatMetric)(memSize,"byte")+" / "+(0,_format_number.formatMetric)(memLimit,"byte"),dataTestSubj:"memory"},{label:"Requests",value:requests,dataTestSubj:"requests"},{label:"Connections",value:connections,dataTestSubj:"connections"},{label:"Max. Response Time",value:(0,_format_number.formatMetric)(maxResponseTime,"0","ms"),dataTestSubj:"maxResponseTime"}];var IconComponent=function IconComponent(_ref2){var status=_ref2.status;return _react2.default.createElement(_react.Fragment,null,"Status: ",_react2.default.createElement(_status_icon.KibanaStatusIcon,{status:status}))};return _react2.default.createElement(_summary_status.SummaryStatus,{metrics:metrics,status:status,IconComponent:IconComponent,"data-test-subj":"kibanaClusterStatus"})}},4317:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _reactDom=__webpack_require__(15);var _modules=__webpack_require__(2);var _components=__webpack_require__(32);var _status_icon=__webpack_require__(904);var _table=__webpack_require__(256);var _constants=__webpack_require__(64);var _format_number=__webpack_require__(59);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var filterFields=["kibana.name","kibana.host","kibana.status","kibana.transport_address"];var columns=[{title:"Name",sortKey:"kibana.name",sortOrder:_constants.SORT_ASCENDING},{title:"Status",sortKey:"kibana.status"},{title:"Load Average",sortKey:"os.load.1m"},{title:"Memory Size",sortKey:"process.memory.resident_set_size_in_bytes"},{title:"Requests",sortKey:"requests.total"},{title:"Response Times",sortKey:"response_times.average"}];var instanceRowFactory=function instanceRowFactory(scope,kbnUrl){var goToInstance=function goToInstance(uuid){scope.$evalAsync(function(){kbnUrl.changePath("/kibana/instances/"+uuid)})};return function KibanaRow(props){return _react2.default.createElement(_components.KuiTableRow,null,_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement("div",{className:"monitoringTableCell__name"},_react2.default.createElement(_eui.EuiLink,{onClick:goToInstance.bind(null,(0,_lodash.get)(props,"kibana.uuid")),"data-test-subj":"kibanaLink-"+props.kibana.name},props.kibana.name)),_react2.default.createElement("div",{className:"monitoringTableCell__transportAddress"},(0,_lodash.get)(props,"kibana.transport_address"))),_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement("div",{title:"Instance status: "+props.kibana.status,className:"monitoringTableCell__status"},_react2.default.createElement(_status_icon.KibanaStatusIcon,{status:props.kibana.status,availability:props.availability})," ",props.availability?(0,_lodash.capitalize)(props.kibana.status):"Offline")),_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement("div",{className:"monitoringTableCell__number"},(0,_format_number.formatMetric)((0,_lodash.get)(props,'os.load["1m"]'),"0.00"))),_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement("div",{className:"monitoringTableCell__number"},(0,_format_number.formatNumber)(props.process.memory.resident_set_size_in_bytes,"byte"))),_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement("div",{className:"monitoringTableCell__number"},(0,_format_number.formatNumber)(props.requests.total,"int_commas"))),_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement("div",{className:"monitoringTableCell__splitNumber"},props.response_times.average&&(0,_format_number.formatNumber)(props.response_times.average,"int_commas")+" ms avg"),_react2.default.createElement("div",{className:"monitoringTableCell__splitNumber"},(0,_format_number.formatNumber)(props.response_times.max,"int_commas")," ms max")))}};var uiModule=_modules.uiModules.get("monitoring/directives",[]);uiModule.directive("monitoringKibanaListing",function(kbnUrl){return{restrict:"E",scope:{instances:"=",pageIndex:"=",filterText:"=",sortKey:"=",sortOrder:"=",onNewState:"="},link:function link(scope,$el){scope.$watch("instances",function(){var instances=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[];var kibanasTable=_react2.default.createElement(_table.MonitoringTable,{className:"kibanaInstancesTable",rows:instances,pageIndex:scope.pageIndex,filterText:scope.filterText,sortKey:scope.sortKey,sortOrder:scope.sortOrder,onNewState:scope.onNewState,placeholder:"Filter Instances...",filterFields:filterFields,columns:columns,rowComponent:instanceRowFactory(scope,kbnUrl)});(0,_reactDom.render)(kibanasTable,$el[0])})}}})},4318:function(module,exports,__webpack_require__){"use strict";var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _reactDom=__webpack_require__(15);var _modules=__webpack_require__(2);var _detail_status=__webpack_require__(4319);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var uiModule=_modules.uiModules.get("monitoring/directives",[]);uiModule.directive("monitoringKibanaSummary",function(){return{restrict:"E",scope:{kibana:"="},link:function link(scope,$el){scope.$watch("kibana",function(kibana){(0,_reactDom.render)(_react2.default.createElement(_detail_status.DetailStatus,{stats:kibana}),$el[0])})}}})},4319:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.DetailStatus=DetailStatus;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _summary_status=__webpack_require__(511);var _status_icon=__webpack_require__(904);var _format_number=__webpack_require__(59);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function DetailStatus(_ref){var stats=_ref.stats;var transportAddress=stats.transport_address,osFreeMemory=stats.os_memory_free,version=stats.version,uptime=stats.uptime,status=stats.status;var metrics=[{value:transportAddress,dataTestSubj:"transportAddress"},{label:"OS Free Memory",value:(0,_format_number.formatMetric)(osFreeMemory,"byte"),dataTestSubj:"osFreeMemory"},{label:"Version",value:version,dataTestSubj:"version"},{label:"Uptime",value:(0,_format_number.formatMetric)(uptime,"time_since"),dataTestSubj:"uptime"}];var IconComponent=function IconComponent(_ref2){var status=_ref2.status;return _react2.default.createElement(_react.Fragment,null,"Status: ",_react2.default.createElement(_status_icon.KibanaStatusIcon,{status:status}))};return _react2.default.createElement(_summary_status.SummaryStatus,{metrics:metrics,status:status,IconComponent:IconComponent,"data-test-subj":"kibanaDetailStatus"})}},4320:function(module,exports,__webpack_require__){"use strict";var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source)Object.prototype.hasOwnProperty.call(source,key)&&(target[key]=source[key])}return target};var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _moment=__webpack_require__(10);var _moment2=_interopRequireDefault(_moment);var _reactDom=__webpack_require__(15);var _modules=__webpack_require__(2);var _overview=__webpack_require__(4321);var _timefilter=__webpack_require__(14);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var uiModule=_modules.uiModules.get("monitoring/directives",[]);uiModule.directive("monitoringBeatsOverview",function(){return{restrict:"E",scope:{data:"="},link:function link(scope,$el){function onBrush(_ref){var xaxis=_ref.xaxis;_timefilter.timefilter.setTime({from:(0,_moment2.default)(xaxis.from),to:(0,_moment2.default)(xaxis.to),mode:"absolute"})}scope.$watch("data",function(){var data=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};(0,_reactDom.render)(_react2.default.createElement(_overview.BeatsOverview,_extends({},data,{onBrush:onBrush})),$el[0])})}}})},4321:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _overview=__webpack_require__(4322);Object.defineProperty(exports,"BeatsOverview",{enumerable:true,get:function get(){return _overview.BeatsOverview}})},4322:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source)Object.prototype.hasOwnProperty.call(source,key)&&(target[key]=source[key])}return target};exports.BeatsOverview=BeatsOverview;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _latest_active=__webpack_require__(4323);var _latest_versions=__webpack_require__(4324);var _latest_types=__webpack_require__(4325);var _=__webpack_require__(1521);var _chart=__webpack_require__(651);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _objectWithoutProperties(obj,keys){var target={};for(var i in obj){if(keys.indexOf(i)>=0)continue;if(!Object.prototype.hasOwnProperty.call(obj,i))continue;target[i]=obj[i]}return target}function renderLatestActive(latestActive,latestTypes,latestVersions){if(latestTypes&&latestTypes.length>0)return _react2.default.createElement("div",{className:"page-row"},_react2.default.createElement("div",{className:"row"},_react2.default.createElement("div",{className:"col-md-4"},_react2.default.createElement("h2",{className:"euiTitle"},"Active Beats in Last Day"),_react2.default.createElement(_latest_active.LatestActive,{latestActive:latestActive})),_react2.default.createElement("div",{className:"col-md-4"},_react2.default.createElement("h2",{className:"euiTitle"},"Top 5 Beat Types in Last Day"),_react2.default.createElement(_latest_types.LatestTypes,{latestTypes:latestTypes})),_react2.default.createElement("div",{className:"col-md-4"},_react2.default.createElement("h2",{className:"euiTitle"},"Top 5 Versions in Last Day"),_react2.default.createElement(_latest_versions.LatestVersions,{latestVersions:latestVersions}))));var calloutMsg="Hi there! This area is where your latest Beats activity would show\nup, but you don't seem to have any activity within the last day.";return _react2.default.createElement(_eui.EuiCallOut,{title:calloutMsg,iconType:"gear","data-test-subj":"noRecentActivityMessage"})}function BeatsOverview(_ref){var latestActive=_ref.latestActive,latestTypes=_ref.latestTypes,latestVersions=_ref.latestVersions,stats=_ref.stats,metrics=_ref.metrics,props=_objectWithoutProperties(_ref,["latestActive","latestTypes","latestVersions","stats","metrics"]);return _react2.default.createElement("div",null,renderLatestActive(latestActive,latestTypes,latestVersions),_react2.default.createElement(_.Stats,{stats:stats}),_react2.default.createElement("div",{className:"page-row"},_react2.default.createElement("div",{className:"row"},_react2.default.createElement("div",{className:"col-md-6"},_react2.default.createElement(_chart.MonitoringTimeseriesContainer,_extends({series:metrics.beat_event_rates},props))),_react2.default.createElement("div",{className:"col-md-6"},_react2.default.createElement(_chart.MonitoringTimeseriesContainer,_extends({series:metrics.beat_fail_rates},props))),_react2.default.createElement("div",{className:"col-md-6"},_react2.default.createElement(_chart.MonitoringTimeseriesContainer,_extends({series:metrics.beat_throughput_rates},props))),_react2.default.createElement("div",{className:"col-md-6"},_react2.default.createElement(_chart.MonitoringTimeseriesContainer,_extends({series:metrics.beat_output_errors},props))))))}},4323:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.LatestActive=LatestActive;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _components=__webpack_require__(32);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function LatestActive(_ref){var latestActive=_ref.latestActive;var rangeMap={last1m:"Last 1 minute",last5m:"Last 5 minutes",last20m:"Last 20 minutes",last1h:"Last 1 hour",last1d:"Last 1 day"};var activity=latestActive.map(function(_ref2,index){var range=_ref2.range,count=_ref2.count;return _react2.default.createElement(_components.KuiTableRow,{key:"latest-active-"+index},_react2.default.createElement(_components.KuiTableRowCell,null,rangeMap[range]),_react2.default.createElement(_components.KuiTableRowCell,{align:"right"},count))});return _react2.default.createElement(_components.KuiTable,null,_react2.default.createElement(_components.KuiTableBody,null,activity))}},4324:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.LatestVersions=LatestVersions;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _components=__webpack_require__(32);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function LatestVersions(_ref){var latestVersions=_ref.latestVersions;var versions=latestVersions.map(function(_ref2,index){var version=_ref2.version,count=_ref2.count;return _react2.default.createElement(_components.KuiTableRow,{key:"latest-version-"+index},_react2.default.createElement(_components.KuiTableRowCell,null,version),_react2.default.createElement(_components.KuiTableRowCell,{align:"right"},count))});return _react2.default.createElement(_components.KuiTable,null,_react2.default.createElement(_components.KuiTableBody,null,versions))}},4325:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.LatestTypes=LatestTypes;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _components=__webpack_require__(32);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function LatestTypes(_ref){var latestTypes=_ref.latestTypes;var types=latestTypes.map(function(_ref2,index){var type=_ref2.type,count=_ref2.count;return _react2.default.createElement(_components.KuiTableRow,{key:"latest-types-"+index},_react2.default.createElement(_components.KuiTableRowCell,null,type),_react2.default.createElement(_components.KuiTableRowCell,{align:"right"},count))});return _react2.default.createElement(_components.KuiTable,null,_react2.default.createElement(_components.KuiTableBody,null,types))}},4326:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.Stats=Stats;var _lodash=__webpack_require__(1);var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _format_number=__webpack_require__(59);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function Stats(_ref){var stats=_ref.stats;var types=stats.types.map(function(_ref2,index){var type=_ref2.type,count=_ref2.count;return _react2.default.createElement("div",{key:"type-"+index,"data-test-subj":"typeCount","data-test-type-count":type+":"+count},type,": ",_react2.default.createElement("strong",null,(0,_format_number.formatMetric)(count,"int_commas")))});return _react2.default.createElement("div",{className:"monitoring-summary-status",role:"status"},_react2.default.createElement("div",{className:"monitoring-summary-status__content","data-test-subj":"beatsSummaryStatus"},_react2.default.createElement("div",null,"Total Beats: ",_react2.default.createElement("strong",{"data-test-subj":"totalBeats"},(0,_format_number.formatMetric)((0,_lodash.get)(stats,"total"),"int_commas"))),types,_react2.default.createElement("div",null,"Total Events: ",_react2.default.createElement("strong",{"data-test-subj":"totalEvents"},(0,_format_number.formatMetric)((0,_lodash.get)(stats,"stats.totalEvents"),"0.[0]a"))),_react2.default.createElement("div",null,"Bytes Sent: ",_react2.default.createElement("strong",{"data-test-subj":"bytesSent"},(0,_format_number.formatMetric)((0,_lodash.get)(stats,"stats.bytesSent"),"byte")))))}},4327:function(module,exports,__webpack_require__){"use strict";var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _reactDom=__webpack_require__(15);var _modules=__webpack_require__(2);var _beats=__webpack_require__(1521);var _format_number=__webpack_require__(59);var _constants=__webpack_require__(64);var _components=__webpack_require__(32);var _table=__webpack_require__(256);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var filterFields=["name","type","version","output"];var columns=[{title:"Name",sortKey:"name",sortOrder:_constants.SORT_ASCENDING},{title:"Type",sortKey:"type"},{title:"Output Enabled",sortKey:"output"},{title:"Total Events Rate",sortKey:"total_events_rate",secondarySortOrder:_constants.SORT_DESCENDING},{title:"Bytes Sent Rate",sortKey:"bytes_sent_rate"},{title:"Output Errors",sortKey:"errors"},{title:"Allocated Memory",sortKey:"memory"},{title:"Version",sortKey:"version"}];var beatRowFactory=function beatRowFactory(scope,kbnUrl){return function(props){var goToBeat=function goToBeat(uuid){return function(){scope.$evalAsync(function(){kbnUrl.changePath("/beats/beat/"+uuid)})}};var applyFiltering=function applyFiltering(filterText){return function(){props.dispatchTableAction(_constants.TABLE_ACTION_UPDATE_FILTER,filterText)}};return _react2.default.createElement(_components.KuiTableRow,null,_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement("div",{className:"monitoringTableCell__name"},_react2.default.createElement(_eui.EuiLink,{onClick:goToBeat(props.uuid),"data-test-subj":"beatLink-"+props.name},props.name))),_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement(_eui.EuiLink,{onClick:applyFiltering(props.type)},props.type)),_react2.default.createElement(_components.KuiTableRowCell,null,props.output),_react2.default.createElement(_components.KuiTableRowCell,null,(0,_format_number.formatMetric)(props.total_events_rate,"","/s")),_react2.default.createElement(_components.KuiTableRowCell,null,(0,_format_number.formatMetric)(props.bytes_sent_rate,"byte","/s")),_react2.default.createElement(_components.KuiTableRowCell,null,(0,_format_number.formatMetric)(props.errors,"0")),_react2.default.createElement(_components.KuiTableRowCell,null,(0,_format_number.formatMetric)(props.memory,"byte")),_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement(_eui.EuiLink,{onClick:applyFiltering(props.version)},props.version)))}};var uiModule=_modules.uiModules.get("monitoring/directives",[]);uiModule.directive("monitoringBeatsListing",function(kbnUrl){return{restrict:"E",scope:{data:"=",pageIndex:"=",filterText:"=",sortKey:"=",sortOrder:"=",onNewState:"="},link:function link(scope,$el){scope.$watch("data",function(){var data=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};(0,_reactDom.render)(_react2.default.createElement("div",null,_react2.default.createElement(_beats.Stats,{stats:data.stats}),_react2.default.createElement("div",{className:"page-row"},_react2.default.createElement(_table.MonitoringTable,{className:"beatsTable",rows:data.listing,pageIndex:scope.pageIndex,filterText:scope.filterText,sortKey:scope.sortKey,sortOrder:scope.sortOrder,onNewState:scope.onNewState,placeholder:"Filter Beats...",filterFields:filterFields,columns:columns,rowComponent:beatRowFactory(scope,kbnUrl)}))),$el[0])})}}})},4328:function(module,exports,__webpack_require__){"use strict";var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _moment=__webpack_require__(10);var _moment2=_interopRequireDefault(_moment);var _reactDom=__webpack_require__(15);var _modules=__webpack_require__(2);var _beat=__webpack_require__(4329);var _timefilter=__webpack_require__(14);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var uiModule=_modules.uiModules.get("monitoring/directives",[]);uiModule.directive("monitoringBeatsBeat",function(){return{restrict:"E",scope:{data:"="},link:function link(scope,$el){function onBrush(_ref){var xaxis=_ref.xaxis;_timefilter.timefilter.setTime({from:(0,_moment2.default)(xaxis.from),to:(0,_moment2.default)(xaxis.to),mode:"absolute"})}scope.$watch("data",function(){var data=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};(0,_reactDom.render)(_react2.default.createElement(_beat.Beat,{summary:data.summary,metrics:data.metrics,onBrush:onBrush}),$el[0])})}}})},4329:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _beat=__webpack_require__(4330);Object.defineProperty(exports,"Beat",{enumerable:true,get:function get(){return _beat.Beat}})},4330:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source)Object.prototype.hasOwnProperty.call(source,key)&&(target[key]=source[key])}return target};exports.Beat=Beat;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _chart=__webpack_require__(651);var _format_number=__webpack_require__(59);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _objectWithoutProperties(obj,keys){var target={};for(var i in obj){if(keys.indexOf(i)>=0)continue;if(!Object.prototype.hasOwnProperty.call(obj,i))continue;target[i]=obj[i]}return target}function renderTransportAddress(summary){var output=null;summary.name!==summary.transportAddress&&(output=_react2.default.createElement(_react.Fragment,null,"Host: ",_react2.default.createElement("strong",{"data-test-subj":"host"},summary.transportAddress)));return output}function Beat(_ref){var summary=_ref.summary,metrics=_ref.metrics,props=_objectWithoutProperties(_ref,["summary","metrics"]);return _react2.default.createElement("div",null,_react2.default.createElement("div",{role:"status"},_react2.default.createElement("div",{className:"monitoring-summary-status"},_react2.default.createElement("div",{className:"monitoring-summary-status__content","data-test-subj":"beatSummaryStatus01"},_react2.default.createElement("div",null,_react2.default.createElement("strong",{"data-test-subj":"name"},summary.name)),_react2.default.createElement("div",null,"Version:"," ",_react2.default.createElement("strong",{"data-test-subj":"version"},summary.version)),_react2.default.createElement("div",null,"Beat Type: ",_react2.default.createElement("strong",{"data-test-subj":"type"},summary.type)),renderTransportAddress(summary),_react2.default.createElement("div",null,"Output: ",_react2.default.createElement("strong",{"data-test-subj":"output"},summary.output)),_react2.default.createElement("div",null,"Config Reloads:"," ",_react2.default.createElement("strong",{"data-test-subj":"configReloads"},(0,_format_number.formatMetric)(summary.configReloads,"int_commas"))),_react2.default.createElement("div",null,"Uptime:"," ",_react2.default.createElement("strong",{"data-test-subj":"uptime"},(0,_format_number.formatMetric)(summary.uptime,"time_since"))))),_react2.default.createElement("div",{className:"monitoring-summary-status",role:"status"},_react2.default.createElement("div",{className:"monitoring-summary-status__content","data-test-subj":"beatSummaryStatus02"},_react2.default.createElement("div",null,"Events Total:"," ",_react2.default.createElement("strong",{"data-test-subj":"eventsTotal"},(0,_format_number.formatMetric)(summary.eventsTotal,"int_commas"))),_react2.default.createElement("div",null,"Events Emitted:"," ",_react2.default.createElement("strong",{"data-test-subj":"eventsEmitted"},(0,_format_number.formatMetric)(summary.eventsEmitted,"int_commas"))),_react2.default.createElement("div",null,"Events Dropped:"," ",_react2.default.createElement("strong",{"data-test-subj":"eventsDropped"},(0,_format_number.formatMetric)(summary.eventsDropped,"int_commas"))),_react2.default.createElement("div",null,"Bytes Sent:"," ",_react2.default.createElement("strong",{"data-test-subj":"bytesWritten"},(0,_format_number.formatMetric)(summary.bytesWritten,"byte")))))),_react2.default.createElement("div",{className:"page-row"},_react2.default.createElement("div",{className:"row"},_react2.default.createElement("div",{className:"col-md-6"},_react2.default.createElement(_chart.MonitoringTimeseriesContainer,_extends({series:metrics.beat_event_rates},props))),_react2.default.createElement("div",{className:"col-md-6"},_react2.default.createElement(_chart.MonitoringTimeseriesContainer,_extends({series:metrics.beat_fail_rates},props))),_react2.default.createElement("div",{className:"col-md-6"},_react2.default.createElement(_chart.MonitoringTimeseriesContainer,_extends({series:metrics.beat_throughput_rates},props))),_react2.default.createElement("div",{className:"col-md-6"},_react2.default.createElement(_chart.MonitoringTimeseriesContainer,_extends({series:metrics.beat_output_errors},props))),_react2.default.createElement("div",{className:"col-md-6"},_react2.default.createElement(_chart.MonitoringTimeseriesContainer,_extends({series:metrics.beat_memory},props))),_react2.default.createElement("div",{className:"col-md-6"},_react2.default.createElement(_chart.MonitoringTimeseriesContainer,_extends({series:metrics.beat_cpu_utilization},props))),_react2.default.createElement("div",{className:"col-md-6"},_react2.default.createElement(_chart.MonitoringTimeseriesContainer,_extends({series:metrics.beat_os_load},props))))))}},4331:function(module,exports,__webpack_require__){"use strict";__webpack_require__(4332);__webpack_require__(4378);__webpack_require__(4380);__webpack_require__(4385);__webpack_require__(4388);__webpack_require__(4390);__webpack_require__(4392);__webpack_require__(4395);__webpack_require__(4397);__webpack_require__(4399);__webpack_require__(4401);__webpack_require__(4403);__webpack_require__(4406);__webpack_require__(4408);__webpack_require__(4411);__webpack_require__(4413);__webpack_require__(4416);__webpack_require__(4418);__webpack_require__(4420);__webpack_require__(4423);__webpack_require__(4425);__webpack_require__(4427);__webpack_require__(4429);__webpack_require__(4431);__webpack_require__(4433);__webpack_require__(4436);__webpack_require__(4439)},4332:function(module,exports,__webpack_require__){"use strict";var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _index=__webpack_require__(4333);var _index2=_interopRequireDefault(_index);var _controller=__webpack_require__(4334);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}_routes2.default.when("/no-data",{template:_index2.default,resolve:{clusters:function clusters($injector){var monitoringClusters=$injector.get("monitoringClusters");var kbnUrl=$injector.get("kbnUrl");return monitoringClusters().then(function(clusters){if(clusters&&clusters.length){kbnUrl.changePath("/home");return Promise.reject()}return Promise.resolve()})}},controller:_controller.NoDataController}).otherwise({redirectTo:"/home"})},4333:function(module,exports){module.exports='<monitoring-main name="no-data">\n  <div class="page-row" data-test-subj="noDataContainer">\n    <div id="noDataReact"></div>\n  </div>\n</monitoring-main>\n'},4334:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.NoDataController=void 0;var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source)Object.prototype.hasOwnProperty.call(source,key)&&(target[key]=source[key])}return target};var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _elasticsearch_settings=__webpack_require__(4335);var _model_updater=__webpack_require__(4340);var _reactDom=__webpack_require__(15);var _components=__webpack_require__(434);var _timefilter=__webpack_require__(14);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}var REACT_NODE_ID_NO_DATA="noDataReact";exports.NoDataController=function(){function NoDataController($injector,$scope){_classCallCheck(this,NoDataController);var $executor=$injector.get("$executor");this.enableTimefilter($executor,$scope);this.registerCleanup($scope,$executor);Object.assign(this,this.getDefaultModel());this.start($scope,$injector,$executor)}_createClass(NoDataController,[{key:"getDefaultModel",value:function getDefaultModel(){return{hasData:false,errors:[],checkMessage:null,isLoading:true,isCollectionEnabledUpdating:false,isCollectionEnabledUpdated:false,isCollectionIntervalUpdating:false,isCollectionIntervalUpdated:false}}},{key:"start",value:function start($scope,$injector,$executor){var model=this;var $http=$injector.get("$http");var kbnUrl=$injector.get("kbnUrl");var monitoringClusters=$injector.get("monitoringClusters");var _ref=new _model_updater.ModelUpdater($scope,model),updateModel=_ref.updateModel;var checkers=[new _elasticsearch_settings.ClusterSettingsChecker($http),new _elasticsearch_settings.NodeSettingsChecker($http)];var enabler=new _elasticsearch_settings.Enabler($http,updateModel);$scope.$$postDigest(function(){(0,_elasticsearch_settings.startChecks)(checkers,updateModel)});$scope.$watch(function(){return model},function(props){(0,_reactDom.render)(_react2.default.createElement(_components.NoData,_extends({},props,{enabler:enabler})),document.getElementById(REACT_NODE_ID_NO_DATA))},true);$scope.$watch(function(){return model.hasData},function(hasData){hasData&&kbnUrl.redirect("/home")});$executor.register({execute:function execute(){return monitoringClusters()},handleResponse:function handleResponse(clusters){clusters.length&&(model.hasData=true)}});$executor.start($scope)}},{key:"enableTimefilter",value:function enableTimefilter($executor,$scope){_timefilter.timefilter.enableTimeRangeSelector();_timefilter.timefilter.enableAutoRefreshSelector();$scope.$listen(_timefilter.timefilter,"timeUpdate",function(){return $executor.run()})}},{key:"registerCleanup",value:function registerCleanup($scope,$executor){$scope.$on("$destroy",function(){$executor.destroy();(0,_reactDom.unmountComponentAtNode)(document.getElementById(REACT_NODE_ID_NO_DATA))})}}]);return NoDataController}()},4335:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _enabler=__webpack_require__(4336);Object.defineProperty(exports,"Enabler",{enumerable:true,get:function get(){return _enabler.Enabler}});var _cluster_settings=__webpack_require__(4337);Object.defineProperty(exports,"ClusterSettingsChecker",{enumerable:true,get:function get(){return _cluster_settings.ClusterSettingsChecker}});var _node_settings=__webpack_require__(4338);Object.defineProperty(exports,"NodeSettingsChecker",{enumerable:true,get:function get(){return _node_settings.NodeSettingsChecker}});var _start_checks=__webpack_require__(4339);Object.defineProperty(exports,"startChecks",{enumerable:true,get:function get(){return _start_checks.startChecks}})},4336:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();function _asyncToGenerator(fn){return function(){var gen=fn.apply(this,arguments);return new Promise(function(resolve,reject){function step(key,arg){try{var info=gen[key](arg);var value=info.value}catch(error){reject(error);return}if(!info.done)return Promise.resolve(value).then(function(value){step("next",value)},function(err){step("throw",err)});resolve(value)}return step("next")})}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}exports.Enabler=function(){function Enabler($http,updateModel){_classCallCheck(this,Enabler);this.$http=$http;this.updateModel=updateModel;this.enableCollectionEnabled=this.enableCollectionEnabled.bind(this);this.enableCollectionInterval=this.enableCollectionInterval.bind(this)}_createClass(Enabler,[{key:"enableCollectionInterval",value:function(){var _ref=_asyncToGenerator(regeneratorRuntime.mark(function _callee(){return regeneratorRuntime.wrap(function _callee$(_context){while(1)switch(_context.prev=_context.next){case 0:_context.prev=0;this.updateModel({isCollectionIntervalUpdating:true});_context.next=4;return this.$http.put("../api/monitoring/v1/elasticsearch_settings/set/collection_interval");case 4:this.updateModel({isCollectionIntervalUpdated:true,isCollectionIntervalUpdating:false});_context.next=10;break;case 7:_context.prev=7;_context.t0=_context["catch"](0);this.updateModel({errors:_context.t0.data,isCollectionIntervalUpdated:false,isCollectionIntervalUpdating:false});case 10:case"end":return _context.stop()}},_callee,this,[[0,7]])}));function enableCollectionInterval(){return _ref.apply(this,arguments)}return enableCollectionInterval}()},{key:"enableCollectionEnabled",value:function(){var _ref2=_asyncToGenerator(regeneratorRuntime.mark(function _callee2(){return regeneratorRuntime.wrap(function _callee2$(_context2){while(1)switch(_context2.prev=_context2.next){case 0:_context2.prev=0;this.updateModel({isCollectionEnabledUpdating:true});_context2.next=4;return this.$http.put("../api/monitoring/v1/elasticsearch_settings/set/collection_enabled");case 4:this.updateModel({isCollectionEnabledUpdated:true,isCollectionEnabledUpdating:false});_context2.next=10;break;case 7:_context2.prev=7;_context2.t0=_context2["catch"](0);this.updateModel({errors:_context2.t0.data,isCollectionEnabledUpdated:false,isCollectionEnabledUpdating:false});case 10:case"end":return _context2.stop()}},_callee2,this,[[0,7]])}));function enableCollectionEnabled(){return _ref2.apply(this,arguments)}return enableCollectionEnabled}()}]);return Enabler}()},4337:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.ClusterSettingsChecker=void 0;var _settings_checker=__webpack_require__(1522);function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}exports.ClusterSettingsChecker=function(_SettingsChecker){_inherits(ClusterSettingsChecker,_SettingsChecker);function ClusterSettingsChecker(params){_classCallCheck(this,ClusterSettingsChecker);var _this=_possibleConstructorReturn(this,(ClusterSettingsChecker.__proto__||Object.getPrototypeOf(ClusterSettingsChecker)).call(this,params));_this.setApi("../api/monitoring/v1/elasticsearch_settings/check/cluster");_this.setMessage("Checking cluster settings API on production cluster");return _this}return ClusterSettingsChecker}(_settings_checker.SettingsChecker)},4338:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.NodeSettingsChecker=void 0;var _settings_checker=__webpack_require__(1522);function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}exports.NodeSettingsChecker=function(_SettingsChecker){_inherits(NodeSettingsChecker,_SettingsChecker);function NodeSettingsChecker(params){_classCallCheck(this,NodeSettingsChecker);var _this=_possibleConstructorReturn(this,(NodeSettingsChecker.__proto__||Object.getPrototypeOf(NodeSettingsChecker)).call(this,params));_this.setApi("../api/monitoring/v1/elasticsearch_settings/check/nodes");_this.setMessage("Checking nodes settings API on production cluster");return _this}return NodeSettingsChecker}(_settings_checker.SettingsChecker)},4339:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.startChecks=(_ref=_asyncToGenerator(regeneratorRuntime.mark(function _callee2(checkers,updateModel){var _this=this;var runCheck,_checkers;return regeneratorRuntime.wrap(function _callee2$(_context2){while(1)switch(_context2.prev=_context2.next){case 0:runCheck=function(){var _ref2=_asyncToGenerator(regeneratorRuntime.mark(function _callee(currentChecker){var _ref3,found,reason,error,errorReason;return regeneratorRuntime.wrap(function _callee$(_context){while(1)switch(_context.prev=_context.next){case 0:updateModel({checkMessage:currentChecker.getMessage()});_context.next=3;return currentChecker.executeCheck();case 3:_ref3=_context.sent;found=_ref3.found;reason=_ref3.reason;error=_ref3.error;errorReason=_ref3.errorReason;if(!error){_context.next=14;break}updateModel({errors:errorReason});if(!currentChecker.hasNext()){_context.next=12;break}return _context.abrupt("return",runCheck(currentChecker.getNext()));case 12:_context.next=20;break;case 14:if(!found){_context.next=18;break}return _context.abrupt("return",updateModel({reason:reason,isLoading:false,checkMessage:null}));case 18:if(!currentChecker.hasNext()){_context.next=20;break}return _context.abrupt("return",runCheck(currentChecker.getNext()));case 20:updateModel({reason:null,isLoading:false,checkMessage:null});case 21:case"end":return _context.stop()}},_callee,_this)}));return function runCheck(_x3){return _ref2.apply(this,arguments)}}();_checkers=mapCheckers(checkers);return _context2.abrupt("return",runCheck(_checkers[0]));case 3:case"end":return _context2.stop()}},_callee2,this)})),function startChecks(_x,_x2){return _ref.apply(this,arguments)});var _ref;function _asyncToGenerator(fn){return function(){var gen=fn.apply(this,arguments);return new Promise(function(resolve,reject){function step(key,arg){try{var info=gen[key](arg);var value=info.value}catch(error){reject(error);return}if(!info.done)return Promise.resolve(value).then(function(value){step("next",value)},function(err){step("throw",err)});resolve(value)}return step("next")})}}var mapCheckers=function mapCheckers(_checkers){return _checkers.map(function(current,checkerIndex){var next=_checkers[checkerIndex+1];void 0!==next&&current.setNext(next);return current})}},434:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _no_data=__webpack_require__(4341);Object.defineProperty(exports,"NoData",{enumerable:true,get:function get(){return _no_data.NoData}});var _license=__webpack_require__(4357);Object.defineProperty(exports,"License",{enumerable:true,get:function get(){return _license.License}});var _page_loading=__webpack_require__(4359);Object.defineProperty(exports,"PageLoading",{enumerable:true,get:function get(){return _page_loading.PageLoading}});var _elasticsearch=__webpack_require__(4360);Object.defineProperty(exports,"ElasticsearchOverview",{enumerable:true,get:function get(){return _elasticsearch.ElasticsearchOverview}});Object.defineProperty(exports,"ElasticsearchNodes",{enumerable:true,get:function get(){return _elasticsearch.ElasticsearchNodes}});Object.defineProperty(exports,"ElasticsearchIndices",{enumerable:true,get:function get(){return _elasticsearch.ElasticsearchIndices}})},4340:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}exports.ModelUpdater=function(){function ModelUpdater($scope,model){_classCallCheck(this,ModelUpdater);this.$scope=$scope;this.model=model;this.updateModel=this.updateModel.bind(this)}_createClass(ModelUpdater,[{key:"updateModel",value:function updateModel(properties){var $scope=this.$scope,model=this.model;var keys=Object.keys(properties);$scope.$evalAsync(function(){keys.forEach(function(key){Array.isArray(model[key])?model[key].push(properties[key]):model[key]=properties[key]})})}}]);return ModelUpdater}()},4341:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _no_data=__webpack_require__(4342);Object.defineProperty(exports,"NoData",{enumerable:true,get:function get(){return _no_data.NoData}})},4342:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.NoData=NoData;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _propTypes=__webpack_require__(6);var _propTypes2=_interopRequireDefault(_propTypes);var _eui=__webpack_require__(3);var _checking_settings=__webpack_require__(4343);var _reasons=__webpack_require__(4347);var _checker_errors=__webpack_require__(4355);__webpack_require__(4356);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function NoDataMessage(props){var isLoading=props.isLoading,reason=props.reason,checkMessage=props.checkMessage;if(isLoading&&null!==checkMessage)return _react2.default.createElement(_checking_settings.CheckingSettings,{checkMessage:checkMessage});if(reason)return _react2.default.createElement(_reasons.ReasonFound,props);return _react2.default.createElement(_reasons.WeTried,null)}function NoData(props){return _react2.default.createElement(_eui.EuiPage,null,_react2.default.createElement(_eui.EuiPageBody,null,_react2.default.createElement(_eui.EuiPageContent,{verticalPosition:"center",horizontalPosition:"center",className:"noData__content"},_react2.default.createElement(_eui.EuiIcon,{type:"monitoringApp",size:"xxl"}),_react2.default.createElement(_eui.EuiSpacer,{size:"m"}),_react2.default.createElement(NoDataMessage,props),_react2.default.createElement(_checker_errors.CheckerErrors,{errors:props.errors}))))}NoData.propTypes={isLoading:_propTypes2.default.bool.isRequired,reason:_propTypes2.default.object,checkMessage:_propTypes2.default.string}},4343:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.CheckingSettings=CheckingSettings;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _propTypes=__webpack_require__(6);var _propTypes2=_interopRequireDefault(_propTypes);var _eui=__webpack_require__(3);var _blurbs=__webpack_require__(513);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function CheckingSettings(_ref){var checkMessage=_ref.checkMessage;return _react2.default.createElement(_react.Fragment,null,_react2.default.createElement(_blurbs.LookingFor,null),_react2.default.createElement(_eui.EuiHorizontalRule,{size:"half"}),_react2.default.createElement(_eui.EuiFlexGroup,{alignItems:"center",gutterSize:"s"},_react2.default.createElement(_eui.EuiFlexItem,{grow:false},_react2.default.createElement(_eui.EuiLoadingSpinner,{size:"m"})),_react2.default.createElement(_eui.EuiFlexItem,{grow:false},checkMessage,"...")))}CheckingSettings.propTypes={checkMessage:_propTypes2.default.string.isRequired}},4344:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.LookingFor=void 0;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}exports.LookingFor=function LookingFor(){return _react2.default.createElement(_react.Fragment,null,_react2.default.createElement(_eui.EuiTitle,{size:"l"},_react2.default.createElement("h2",null,"We're looking for your monitoring data")),_react2.default.createElement(_eui.EuiTextColor,{color:"subdued"},_react2.default.createElement(_eui.EuiText,null,_react2.default.createElement("p",null,"Monitoring provides insight to your hardware performance and load."))))}},4345:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.WhatIs=void 0;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}exports.WhatIs=function WhatIs(){return _react2.default.createElement(_react.Fragment,null,_react2.default.createElement(_eui.EuiTitle,{size:"l"},_react2.default.createElement("h2",null,"Monitoring is currently off")),_react2.default.createElement(_eui.EuiTextColor,{color:"subdued"},_react2.default.createElement(_eui.EuiText,null,_react2.default.createElement("p",null,"Monitoring provides insight to your hardware performance and load."))))}},4346:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.ChangesNeeded=void 0;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}exports.ChangesNeeded=function ChangesNeeded(){return _react2.default.createElement(_react.Fragment,null,_react2.default.createElement(_eui.EuiTitle,{size:"l"},_react2.default.createElement("h2",null,"You need to make some adjustments")),_react2.default.createElement(_eui.EuiTextColor,{color:"subdued"},_react2.default.createElement(_eui.EuiText,null,_react2.default.createElement("p",null,"To run monitoring please perform the following steps"))))}},4347:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _reason_found=__webpack_require__(4348);Object.defineProperty(exports,"ReasonFound",{enumerable:true,get:function get(){return _reason_found.ReasonFound}});var _we_tried=__webpack_require__(4354);Object.defineProperty(exports,"WeTried",{enumerable:true,get:function get(){return _we_tried.WeTried}})},4348:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source)Object.prototype.hasOwnProperty.call(source,key)&&(target[key]=source[key])}return target};exports.ReasonFound=ReasonFound;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _propTypes=__webpack_require__(6);var _propTypes2=_interopRequireDefault(_propTypes);var _eui=__webpack_require__(3);var _explanations=__webpack_require__(4349);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _objectWithoutProperties(obj,keys){var target={};for(var i in obj){if(keys.indexOf(i)>=0)continue;if(!Object.prototype.hasOwnProperty.call(obj,i))continue;target[i]=obj[i]}return target}var ExplainWhyNoData=function ExplainWhyNoData(_ref){var reason=_ref.reason,props=_objectWithoutProperties(_ref,["reason"]);var property=reason.property,data=reason.data,context=reason.context;switch(property){case"xpack.monitoring.collection.enabled":return _react2.default.createElement(_explanations.ExplainCollectionEnabled,_extends({},reason,props));case"xpack.monitoring.collection.interval":return _react2.default.createElement(_explanations.ExplainCollectionInterval,_extends({},reason,props));case"xpack.monitoring.exporters":return _react2.default.createElement(_explanations.ExplainExporters,_extends({},reason,props));case"xpack.monitoring.enabled":return _react2.default.createElement(_explanations.ExplainPluginEnabled,_extends({},reason,props));default:return _react2.default.createElement(_eui.EuiText,null,_react2.default.createElement("p",null,"There is a ",_react2.default.createElement(_eui.EuiCode,null,context)," setting that has"," ",_react2.default.createElement(_eui.EuiCode,null,property)," set to ",_react2.default.createElement(_eui.EuiCode,null,data),"."))}};function ReasonFound(props){return _react2.default.createElement(_react.Fragment,null,_react2.default.createElement(ExplainWhyNoData,props))}ReasonFound.propTypes={enabler:_propTypes2.default.object.isRequired,reason:_propTypes2.default.object.isRequired}},4349:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _collection_enabled=__webpack_require__(4350);Object.defineProperty(exports,"ExplainCollectionEnabled",{enumerable:true,get:function get(){return _collection_enabled.ExplainCollectionEnabled}});var _collection_interval=__webpack_require__(4351);Object.defineProperty(exports,"ExplainCollectionInterval",{enumerable:true,get:function get(){return _collection_interval.ExplainCollectionInterval}});var _plugin_enabled=__webpack_require__(4352);Object.defineProperty(exports,"ExplainPluginEnabled",{enumerable:true,get:function get(){return _plugin_enabled.ExplainPluginEnabled}});var _exporters=__webpack_require__(4353);Object.defineProperty(exports,"ExplainExporters",{enumerable:true,get:function get(){return _exporters.ExplainExporters}})},4350:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.ExplainCollectionEnabled=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _propTypes=__webpack_require__(6);var _propTypes2=_interopRequireDefault(_propTypes);var _eui=__webpack_require__(3);var _blurbs=__webpack_require__(513);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}var ExplainCollectionEnabled=exports.ExplainCollectionEnabled=function(_React$Component){_inherits(ExplainCollectionEnabled,_React$Component);function ExplainCollectionEnabled(props){_classCallCheck(this,ExplainCollectionEnabled);var _this=_possibleConstructorReturn(this,(ExplainCollectionEnabled.__proto__||Object.getPrototypeOf(ExplainCollectionEnabled)).call(this,props));_this.handleClick=_this.handleClick.bind(_this);_this.waitedTooLongTimer=null;_this.state={waitedTooLong:false};return _this}_createClass(ExplainCollectionEnabled,[{key:"componentWillUnmount",value:function componentWillUnmount(){clearInterval(this.waitedTooLongTimer)}},{key:"handleClick",value:function handleClick(){var _this2=this;var enabler=this.props.enabler;enabler.enableCollectionEnabled();this.waitedTooLongTimer=setTimeout(function(){_this2.setState({waitedTooLong:true})},19e3)}},{key:"render",value:function render(){var _this3=this;var _props=this.props,context=_props.context,property=_props.property,data=_props.data,isCollectionEnabledUpdated=_props.isCollectionEnabledUpdated,isCollectionEnabledUpdating=_props.isCollectionEnabledUpdating;var renderButton=function renderButton(){return _react2.default.createElement(_react.Fragment,null,_react2.default.createElement(_blurbs.WhatIs,null),_react2.default.createElement(_eui.EuiHorizontalRule,{size:"half"}),_react2.default.createElement(_eui.EuiText,null,_react2.default.createElement("p",null,"We checked the ",context," settings and found that ",_react2.default.createElement(_eui.EuiCode,null,property),"is set to ",_react2.default.createElement(_eui.EuiCode,null,data),"."),_react2.default.createElement("p",null,"Would you like to turn it on?")),_react2.default.createElement(_eui.EuiSpacer,null),_react2.default.createElement(_eui.EuiFlexGroup,{alignItems:"center",justifyContent:"spaceAround",gutterSize:"s"},_react2.default.createElement(_eui.EuiFlexItem,{grow:false},_react2.default.createElement(_eui.EuiButton,{fill:true,onClick:_this3.handleClick,type:"button","data-test-subj":"enableCollectionEnabled",isLoading:isCollectionEnabledUpdating},"Turn on monitoring"))))};var stillWaiting=this.state.waitedTooLong?_react2.default.createElement("p",null,_react2.default.createElement("a",{href:"#/"},"Still waiting?")):null;var renderSuccess=function renderSuccess(){return _react2.default.createElement(_react.Fragment,null,_react2.default.createElement(_eui.EuiTitle,{size:"l","data-test-subj":"monitoringCollectionEnabledMessage"},_react2.default.createElement("h2",null,"Success! Getting your monitoring data.")),_react2.default.createElement(_eui.EuiHorizontalRule,{size:"half"}),_react2.default.createElement(_eui.EuiText,null,_react2.default.createElement("p",null,"When the data is in your cluster, your monitoring dashboard will show up here. This might take a few seconds.")),_react2.default.createElement(_eui.EuiSpacer,null),_react2.default.createElement(_eui.EuiLoadingSpinner,{size:"l"}),_react2.default.createElement(_eui.EuiSpacer,null),stillWaiting)};return _react2.default.createElement(_react.Fragment,null,isCollectionEnabledUpdated?renderSuccess():renderButton())}}]);return ExplainCollectionEnabled}(_react2.default.Component);ExplainCollectionEnabled.propTypes={enabler:_propTypes2.default.object.isRequired,context:_propTypes2.default.string.isRequired,property:_propTypes2.default.string.isRequired,data:_propTypes2.default.string.isRequired,isCollectionEnabledUpdated:_propTypes2.default.bool,isCollectionEnabledUpdating:_propTypes2.default.bool}},4351:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.ExplainCollectionInterval=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _propTypes=__webpack_require__(6);var _propTypes2=_interopRequireDefault(_propTypes);var _eui=__webpack_require__(3);var _blurbs=__webpack_require__(513);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}var ExplainCollectionInterval=exports.ExplainCollectionInterval=function(_React$Component){_inherits(ExplainCollectionInterval,_React$Component);function ExplainCollectionInterval(props){_classCallCheck(this,ExplainCollectionInterval);var _this=_possibleConstructorReturn(this,(ExplainCollectionInterval.__proto__||Object.getPrototypeOf(ExplainCollectionInterval)).call(this,props));_this.handleClick=_this.handleClick.bind(_this);return _this}_createClass(ExplainCollectionInterval,[{key:"handleClick",value:function handleClick(){var enabler=this.props.enabler;enabler.enableCollectionInterval()}},{key:"render",value:function render(){var _this2=this;var _props=this.props,context=_props.context,property=_props.property,data=_props.data,isCollectionIntervalUpdated=_props.isCollectionIntervalUpdated,isCollectionIntervalUpdating=_props.isCollectionIntervalUpdating;var renderButton=function renderButton(){return _react2.default.createElement(_react.Fragment,null,_react2.default.createElement(_blurbs.WhatIs,null),_react2.default.createElement(_eui.EuiHorizontalRule,{size:"half"}),_react2.default.createElement(_eui.EuiText,null,_react2.default.createElement("p",null,"We checked the ",context," settings and found that ",_react2.default.createElement(_eui.EuiCode,null,property),"is set to ",_react2.default.createElement(_eui.EuiCode,null,data),"."),_react2.default.createElement("p",null,"The collection interval setting needs to be a positive integer (10s is recommended) in order for the collection agents to be active."),_react2.default.createElement("p",null,"Would you like us to change it and enable monitoring?")),_react2.default.createElement(_eui.EuiSpacer,null),_react2.default.createElement(_eui.EuiFlexGroup,{alignItems:"center",justifyContent:"spaceAround",gutterSize:"s"},_react2.default.createElement(_eui.EuiFlexItem,{grow:false},_react2.default.createElement(_eui.EuiButton,{fill:true,onClick:_this2.handleClick,type:"button","data-test-subj":"enableCollectionInterval",isLoading:isCollectionIntervalUpdating},"Turn on monitoring"))))};var renderSuccess=function renderSuccess(){return _react2.default.createElement(_react.Fragment,null,_react2.default.createElement(_eui.EuiTitle,{size:"l"},_react2.default.createElement("h2",null,"Success! Wait a moment please.")),_react2.default.createElement(_eui.EuiHorizontalRule,{size:"half"}),_react2.default.createElement(_eui.EuiText,null,_react2.default.createElement("p",null,"As soon as monitoring data appears in your cluster the page will automatically refresh with your monitoring dashboard. This only takes only a few seconds.")),_react2.default.createElement(_eui.EuiSpacer,null),_react2.default.createElement(_eui.EuiLoadingSpinner,{size:"l"}))};return _react2.default.createElement(_react.Fragment,null,isCollectionIntervalUpdated?renderSuccess():renderButton())}}]);return ExplainCollectionInterval}(_react2.default.Component);ExplainCollectionInterval.propTypes={enabler:_propTypes2.default.object.isRequired,context:_propTypes2.default.string.isRequired,property:_propTypes2.default.string.isRequired,data:_propTypes2.default.string.isRequired,isCollectionIntervalUpdated:_propTypes2.default.bool,isCollectionIntervalUpdating:_propTypes2.default.bool}},4352:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.ExplainPluginEnabled=ExplainPluginEnabled;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _propTypes=__webpack_require__(6);var _propTypes2=_interopRequireDefault(_propTypes);var _eui=__webpack_require__(3);var _blurbs=__webpack_require__(513);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function ExplainPluginEnabled(_ref){var context=_ref.context,property=_ref.property,data=_ref.data;return _react2.default.createElement(_react.Fragment,null,_react2.default.createElement(_blurbs.ChangesNeeded,null),_react2.default.createElement(_eui.EuiHorizontalRule,{size:"half"}),_react2.default.createElement(_eui.EuiText,null,_react2.default.createElement("p",null,"We checked the ",context," settings and found that ",_react2.default.createElement(_eui.EuiCode,null,property)," ","is set to ",_react2.default.createElement(_eui.EuiCode,null,data)," set, which disables monitoring. Removing the ",_react2.default.createElement(_eui.EuiCode,null,"xpack.monitoring.enabled: false")," setting from your configuration will put the default into effect and enable Monitoring.")))}ExplainPluginEnabled.propTypes={property:_propTypes2.default.string.isRequired,context:_propTypes2.default.string.isRequired,data:_propTypes2.default.string.isRequired}},4353:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.ExplainExporters=ExplainExporters;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _propTypes=__webpack_require__(6);var _propTypes2=_interopRequireDefault(_propTypes);var _eui=__webpack_require__(3);var _blurbs=__webpack_require__(513);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function ExplainExporters(_ref){var context=_ref.context,property=_ref.property,data=_ref.data;return _react2.default.createElement(_react.Fragment,null,_react2.default.createElement(_blurbs.ChangesNeeded,null),_react2.default.createElement(_eui.EuiHorizontalRule,{size:"half"}),_react2.default.createElement(_eui.EuiText,{className:"noData__alignLeft"},_react2.default.createElement("p",null,"We checked the ",_react2.default.createElement(_eui.EuiCode,null,context)," settings for"," ",_react2.default.createElement(_eui.EuiCode,null,property),", and found the reason:"," ",_react2.default.createElement(_eui.EuiCode,null,data),"."),_react2.default.createElement("p",null,"Using monitoring exporters ship the monitoring data to a remote monitoring cluster is highly recommended as it keeps the integrity of the monitoring data safe no matter what the state of the production cluster. However, as this instance of Kibana could not find any monitoring data, there seems to be a problem with the"," ",_react2.default.createElement(_eui.EuiCode,null,property)," configuration, or the"," ",_react2.default.createElement(_eui.EuiCode,null,"xpack.monitoring.elasticsearch")," settings in"," ",_react2.default.createElement(_eui.EuiCode,null,"kibana.yml"),"."),_react2.default.createElement("p",null,"Check that the intended exporters are enabled for sending statistics to the monitoring cluster, and that the monitoring cluster host matches the"," ",_react2.default.createElement(_eui.EuiCode,null,"xpack.monitoring.elasticsearch")," setting in"," ",_react2.default.createElement(_eui.EuiCode,null,"kibana.yml")," to see monitoring data in this instance of Kibana.")))}ExplainExporters.propTypes={context:_propTypes2.default.string.isRequired,property:_propTypes2.default.string.isRequired,data:_propTypes2.default.string.isRequired}},4354:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.WeTried=WeTried;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function WeTried(){return _react2.default.createElement(_react.Fragment,null,_react2.default.createElement(_eui.EuiTitle,{size:"l"},_react2.default.createElement("h2",null,"We couldn't activate monitoring")),_react2.default.createElement(_eui.EuiHorizontalRule,{size:"half"}),_react2.default.createElement(_eui.EuiText,{className:"noData__alignLeft"},_react2.default.createElement("p",null,'No monitoring data found. Try setting the time filter to "Last 1 hour" or check if data is available for a different time period.'),_react2.default.createElement("p",null,"If data is in your cluster, your monitoring dashboards will show up here.")))}},4355:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.CheckerErrors=CheckerErrors;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _propTypes=__webpack_require__(6);var _propTypes2=_interopRequireDefault(_propTypes);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var ErrorList=function ErrorList(_ref){var errors=_ref.errors;return errors.map(function(error,errorIndex){var message=error.message,statusCode=error.statusCode,friendlyName=error.error;return _react2.default.createElement(_react.Fragment,{key:"checker-error-"+errorIndex},_react2.default.createElement(_eui.EuiDescriptionListTitle,null,statusCode," ",friendlyName),_react2.default.createElement(_eui.EuiDescriptionListDescription,null,message))})};function CheckerErrors(props){if(void 0===props.errors||0===props.errors.length)return null;return _react2.default.createElement(_react.Fragment,null,_react2.default.createElement(_eui.EuiSpacer,null),_react2.default.createElement(_eui.EuiCallOut,{title:"Errors found",color:"danger",className:"noData__alignLeft"},_react2.default.createElement("p",null,"There were some errors encountered in trying to check Elasticsearch settings. You need administrator rights to check the settings and, if needed, to enable the monitoring collection setting."),_react2.default.createElement(_eui.EuiDescriptionList,null,_react2.default.createElement(ErrorList,props))))}CheckerErrors.propTypes={errors:_propTypes2.default.array}},4356:function(module,exports){},4357:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.License=License;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _eui=__webpack_require__(3);var _components=__webpack_require__(1523);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var LicenseUpdateInfoForPrimary=function LicenseUpdateInfoForPrimary(_ref){var isPrimaryCluster=_ref.isPrimaryCluster,uploadLicensePath=_ref.uploadLicensePath;if(!isPrimaryCluster)return null;return _react2.default.createElement(_components.AddLicense,{uploadPath:uploadLicensePath})};var LicenseUpdateInfoForRemote=function LicenseUpdateInfoForRemote(_ref2){var isPrimaryCluster=_ref2.isPrimaryCluster;if(isPrimaryCluster)return null;return _react2.default.createElement(_eui.EuiPanel,null,_react2.default.createElement("p",null,"To update the license for this cluster, provide the license file through the Elasticsearch API:"),_react2.default.createElement(_eui.EuiSpacer,null),_react2.default.createElement(_eui.EuiCodeBlock,null,"curl -XPUT -u <user> 'https://<host>:<port>/_xpack/license' -H 'Content-Type: application/json' -d @license.json"))};function License(props){var status=props.status,type=props.type,isExpired=props.isExpired,expiryDate=props.expiryDate;return _react2.default.createElement(_eui.EuiPage,{className:"licenseManagement"},_react2.default.createElement(_eui.EuiPageBody,{className:"licenseManagement__pageBody"},_react2.default.createElement("div",{className:"licenseManagement__contain"},_react2.default.createElement(_components.LicenseStatus,{isExpired:isExpired,status:status,type:type,expiryDate:expiryDate}),_react2.default.createElement(_eui.EuiSpacer,{size:"l"}),_react2.default.createElement(LicenseUpdateInfoForPrimary,props),_react2.default.createElement(LicenseUpdateInfoForRemote,props))))}},4359:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.PageLoading=PageLoading;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function PageLoading(){return _react2.default.createElement(_eui.EuiPage,null,_react2.default.createElement(_eui.EuiPageBody,null,_react2.default.createElement(_eui.EuiPageContent,{verticalPosition:"center",horizontalPosition:"center",className:"noData__content"},_react2.default.createElement(_eui.EuiFlexGroup,{justifyContent:"spaceAround"},_react2.default.createElement(_eui.EuiFlexItem,{grow:false},_react2.default.createElement(_eui.EuiFlexGroup,{alignItems:"center",gutterSize:"s"},_react2.default.createElement(_eui.EuiFlexItem,{grow:false},_react2.default.createElement(_eui.EuiLoadingSpinner,{size:"xl"})),_react2.default.createElement(_eui.EuiFlexItem,{grow:false},"Loading...")))))))}},4360:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _overview=__webpack_require__(4361);Object.defineProperty(exports,"ElasticsearchOverview",{enumerable:true,get:function get(){return _overview.ElasticsearchOverview}});var _nodes=__webpack_require__(4372);Object.defineProperty(exports,"ElasticsearchNodes",{enumerable:true,get:function get(){return _nodes.ElasticsearchNodes}});var _indices=__webpack_require__(4375);Object.defineProperty(exports,"ElasticsearchIndices",{enumerable:true,get:function get(){return _indices.ElasticsearchIndices}})},4361:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _overview=__webpack_require__(4362);Object.defineProperty(exports,"ElasticsearchOverview",{enumerable:true,get:function get(){return _overview.ElasticsearchOverview}})},4362:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source)Object.prototype.hasOwnProperty.call(source,key)&&(target[key]=source[key])}return target};exports.ElasticsearchOverview=ElasticsearchOverview;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _cluster_status=__webpack_require__(655);var _shard_activity=__webpack_require__(4363);var _chart=__webpack_require__(651);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _objectWithoutProperties(obj,keys){var target={};for(var i in obj){if(keys.indexOf(i)>=0)continue;if(!Object.prototype.hasOwnProperty.call(obj,i))continue;target[i]=obj[i]}return target}function ElasticsearchOverview(_ref){var clusterStatus=_ref.clusterStatus,metrics=_ref.metrics,shardActivity=_ref.shardActivity,props=_objectWithoutProperties(_ref,["clusterStatus","metrics","shardActivity"]);return _react2.default.createElement(_react.Fragment,null,_react2.default.createElement(_cluster_status.ClusterStatus,{stats:clusterStatus}),_react2.default.createElement("div",{className:"page-row"},_react2.default.createElement("div",{className:"row"},_react2.default.createElement("div",{className:"col-md-6"},_react2.default.createElement(_chart.MonitoringTimeseriesContainer,_extends({series:metrics.cluster_search_request_rate},props))),_react2.default.createElement("div",{className:"col-md-6"},_react2.default.createElement(_chart.MonitoringTimeseriesContainer,_extends({series:metrics.cluster_query_latency},props))),_react2.default.createElement("div",{className:"col-md-6"},_react2.default.createElement(_chart.MonitoringTimeseriesContainer,_extends({series:metrics.cluster_index_request_rate},props))),_react2.default.createElement("div",{className:"col-md-6"},_react2.default.createElement(_chart.MonitoringTimeseriesContainer,_extends({series:metrics.cluster_index_latency},props))))),_react2.default.createElement("div",{className:"page-row"},_react2.default.createElement(_shard_activity.ShardActivity,_extends({data:shardActivity},props))))}},4363:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _shard_activity=__webpack_require__(4364);Object.defineProperty(exports,"ShardActivity",{enumerable:true,get:function get(){return _shard_activity.ShardActivity}})},4364:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.ShardActivity=void 0;var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source)Object.prototype.hasOwnProperty.call(source,key)&&(target[key]=source[key])}return target};var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _eui=__webpack_require__(3);var _components=__webpack_require__(32);var _table=__webpack_require__(256);var _recovery_index=__webpack_require__(4365);var _total_time=__webpack_require__(4367);var _source_destination=__webpack_require__(4368);var _progress=__webpack_require__(4370);var _parse_props=__webpack_require__(4371);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}var columns=[{title:"Index",sortKey:null},{title:"Stage",sortKey:null},{title:"Total Time",sortKey:null},{title:"Source / Destination",sortKey:null},{title:"Files",sortKey:null},{title:"Bytes",sortKey:null},{title:"Translog",sortKey:null}];var ActivityRow=function ActivityRow(props){return _react2.default.createElement(_components.KuiTableRow,null,_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement(_recovery_index.RecoveryIndex,props)),_react2.default.createElement(_components.KuiTableRowCell,null,props.stage),_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement(_total_time.TotalTime,props)),_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement(_source_destination.SourceDestination,props)),_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement(_progress.FilesProgress,props)),_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement(_progress.BytesProgress,props)),_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement(_progress.TranslogProgress,props)))};var ToggleCompletedSwitch=function ToggleCompletedSwitch(_ref){var toggleHistory=_ref.toggleHistory,showHistory=_ref.showHistory;return _react2.default.createElement(_components.KuiToolBarSection,null,_react2.default.createElement(_components.KuiToolBarText,null,_react2.default.createElement(_eui.EuiSwitch,{label:"Completed recoveries",onChange:toggleHistory,checked:showHistory})))};exports.ShardActivity=function(_React$Component){_inherits(ShardActivity,_React$Component);function ShardActivity(props){_classCallCheck(this,ShardActivity);var _this=_possibleConstructorReturn(this,(ShardActivity.__proto__||Object.getPrototypeOf(ShardActivity)).call(this,props));_this.getNoDataMessage=_this.getNoDataMessage.bind(_this);return _this}_createClass(ShardActivity,[{key:"getNoDataMessage",value:function getNoDataMessage(){if(this.props.showShardActivityHistory)return"There are no historical shard activity records for the selected time range.";return _react2.default.createElement(_react.Fragment,null,"There are no active shard recoveries for this cluster.",_react2.default.createElement("br",null),"Try viewing ",_react2.default.createElement(_eui.EuiLink,{onClick:this.props.toggleShardActivityHistory},"completed recoveries"),".")}},{key:"render",value:function render(){var rawData=this.props.data;if(null===rawData)return null;var rows=rawData.map(_parse_props.parseProps);var renderToolBarSection=function renderToolBarSection(props){return _react2.default.createElement(ToggleCompletedSwitch,{toggleHistory:props.toggleShardActivityHistory,showHistory:props.showShardActivityHistory})};return _react2.default.createElement(_react.Fragment,null,_react2.default.createElement(_eui.EuiText,null,_react2.default.createElement(_eui.EuiTitle,{size:"s"},_react2.default.createElement("h2",null,"Shard Activity"))),_react2.default.createElement(_eui.EuiSpacer,null),_react2.default.createElement(_table.MonitoringTable,_extends({className:"esShardActivityTable",rows:rows,renderToolBarSections:renderToolBarSection,columns:columns,rowComponent:ActivityRow,getNoDataMessage:this.getNoDataMessage,alwaysShowPageControls:true},this.props)))}}]);return ShardActivity}(_react2.default.Component)},4365:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.RecoveryIndex=void 0;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _eui=__webpack_require__(3);var _snapshot=__webpack_require__(4366);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}exports.RecoveryIndex=function RecoveryIndex(props){var name=props.name,shard=props.shard,relocationType=props.relocationType;return _react2.default.createElement(_react.Fragment,null,_react2.default.createElement(_eui.EuiLink,{href:"#/elasticsearch/indices/"+name},name),_react2.default.createElement("br",null),"Shard: ",shard,_react2.default.createElement("br",null),"Recovery type: ",relocationType,_react2.default.createElement("div",null,_react2.default.createElement(_snapshot.Snapshot,props)))}},4366:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.Snapshot=void 0;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}exports.Snapshot=function Snapshot(_ref){var isSnapshot=_ref.isSnapshot,repo=_ref.repo,snapshot=_ref.snapshot;return isSnapshot?_react2.default.createElement(_react.Fragment,null,"Repo: ",repo," / Snapshot: ",snapshot):null}},4367:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.TotalTime=void 0;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _eui=__webpack_require__(3);var _tooltip=__webpack_require__(376);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}exports.TotalTime=function TotalTime(_ref){var startTime=_ref.startTime,totalTime=_ref.totalTime;return _react2.default.createElement(_tooltip.Tooltip,{text:"Started: "+startTime,placement:"bottom",trigger:"hover"},_react2.default.createElement(_eui.EuiLink,null,totalTime))}},4368:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.SourceDestination=void 0;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _eui=__webpack_require__(3);var _tooltip=__webpack_require__(376);var _source_tooltip=__webpack_require__(4369);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}exports.SourceDestination=function SourceDestination(props){var sourceName=props.sourceName,targetName=props.targetName,targetTransportAddress=props.targetTransportAddress;return _react2.default.createElement(_eui.EuiFlexGroup,null,_react2.default.createElement(_eui.EuiFlexItem,{grow:false},_react2.default.createElement(_source_tooltip.SourceTooltip,props,sourceName)),_react2.default.createElement(_eui.EuiFlexItem,{grow:false},_react2.default.createElement(_eui.EuiIcon,{type:"arrowRight"})),_react2.default.createElement(_eui.EuiFlexItem,{grow:false},_react2.default.createElement(_tooltip.Tooltip,{text:targetTransportAddress,placement:"bottom",trigger:"hover"},_react2.default.createElement(_eui.EuiLink,null,targetName))))}},4369:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.SourceTooltip=void 0;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _eui=__webpack_require__(3);var _tooltip=__webpack_require__(376);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}exports.SourceTooltip=function SourceTooltip(_ref){var isCopiedFromPrimary=_ref.isCopiedFromPrimary,sourceTransportAddress=_ref.sourceTransportAddress,children=_ref.children;if(!sourceTransportAddress)return children;var tipText=_react2.default.createElement(_react.Fragment,null,sourceTransportAddress,_react2.default.createElement("br",null),"Copied from ",isCopiedFromPrimary?"primary":"replica"," shard");return _react2.default.createElement(_tooltip.Tooltip,{text:tipText,placement:"bottom",trigger:"hover"},_react2.default.createElement(_eui.EuiLink,null,children))}},4370:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.TranslogProgress=exports.BytesProgress=exports.FilesProgress=void 0;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}exports.FilesProgress=function FilesProgress(_ref){var filesPercent=_ref.filesPercent,filesDone=_ref.filesDone,filesTotal=_ref.filesTotal;return _react2.default.createElement(_react.Fragment,null,filesPercent,_react2.default.createElement("br",null),filesDone," / ",filesTotal)};exports.BytesProgress=function BytesProgress(_ref2){var bytesPercent=_ref2.bytesPercent,bytesDone=_ref2.bytesDone,bytesTotal=_ref2.bytesTotal;return _react2.default.createElement(_react.Fragment,null,bytesPercent,_react2.default.createElement("br",null),bytesDone," / ",bytesTotal)};exports.TranslogProgress=function TranslogProgress(_ref3){var hasTranslog=_ref3.hasTranslog,translogPercent=_ref3.translogPercent,translogDone=_ref3.translogDone,translogTotal=_ref3.translogTotal;return hasTranslog?_react2.default.createElement(_react.Fragment,null,translogPercent,_react2.default.createElement("br",null),translogDone," / ",translogTotal):"n/a"}},4371:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.parseProps=void 0;var _lodash=__webpack_require__(1);var _format_number=__webpack_require__(59);var _formatting=__webpack_require__(375);var getIpAndPort=function getIpAndPort(transport){if(void 0!==transport){var matches=transport.match(/([\d\.:]+)\]$/);if(matches)return matches[1]}return transport};var normalizeString=function normalizeString(text){return(0,_lodash.capitalize)(text.toLowerCase())};exports.parseProps=function parseProps(props){var id=props.id,stage=props.stage,index=props.index,indexName=props.index_name,isPrimary=props.primary,startTimeInMillis=props.start_time_in_millis,totalTimeInMillis=props.total_time_in_millis,source=props.source,target=props.target,translog=props.translog,type=props.type;var files=index.files,size=index.size;return{name:indexName||index.name,shard:id+" / "+(isPrimary?"Primary":"Replica"),relocationType:"PRIMARY_RELOCATION"===type?"Primary Relocation":normalizeString(type),stage:normalizeString(stage),startTime:(0,_formatting.formatDateTimeLocal)(startTimeInMillis),totalTime:(0,_format_number.formatMetric)(totalTimeInMillis/1e3,"00:00:00"),isCopiedFromPrimary:!isPrimary||"PRIMARY_RELOCATION"===type,sourceName:void 0===source.name?"n/a":source.name,targetName:target.name,sourceTransportAddress:getIpAndPort(source.transport_address),targetTransportAddress:getIpAndPort(target.transport_address),isSnapshot:"SNAPSHOT"===type,repo:source.repository,snapshot:source.snapshot,filesPercent:files.percent,filesDone:files.reused?files.reused:files.recovered,filesTotal:files.total,bytesPercent:size.percent,bytesDone:(0,_format_number.formatMetric)(size.recovered_in_bytes+size.reused_in_bytes,"byte"),bytesTotal:(0,_format_number.formatMetric)(size.total_in_bytes,"byte"),hasTranslog:translog.total>0,translogPercent:translog.percent,translogDone:translog.total,translogTotal:translog.total_on_start}}},4372:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _nodes=__webpack_require__(4373);Object.defineProperty(exports,"ElasticsearchNodes",{enumerable:true,get:function get(){return _nodes.ElasticsearchNodes}})},4373:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();exports.ElasticsearchNodes=ElasticsearchNodes;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _lodash=__webpack_require__(1);var _constants=__webpack_require__(64);var _node=__webpack_require__(1510);var _extract_ip=__webpack_require__(1495);var _cluster_status=__webpack_require__(655);var _table=__webpack_require__(256);var _cells=__webpack_require__(4374);var _eui=__webpack_require__(3);var _components=__webpack_require__(32);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _objectWithoutProperties(obj,keys){var target={};for(var i in obj){if(keys.indexOf(i)>=0)continue;if(!Object.prototype.hasOwnProperty.call(obj,i))continue;target[i]=obj[i]}return target}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}var filterFields=["name"];var getColumns=function getColumns(showCgroupMetricsElasticsearch){var cols=[];cols.push({title:"Name",sortKey:"name",sortOrder:_constants.SORT_ASCENDING});cols.push({title:"Status",sortKey:"isOnline"});if(showCgroupMetricsElasticsearch){cols.push({title:"CPU Usage",sortKey:"node_cgroup_quota"});cols.push({title:"CPU Throttling",sortKey:"node_cgroup_throttled"})}else{cols.push({title:"CPU Usage",sortKey:"node_cpu_utilization"});cols.push({title:"Load Average",sortKey:"node_load_average"})}cols.push({title:"JVM Memory",sortKey:"node_jvm_mem_percent"});cols.push({title:"Disk Free Space",sortKey:"node_free_space"});cols.push({title:"Shards",sortKey:"shardCount"});return cols};var nodeRowFactory=function nodeRowFactory(showCgroupMetricsElasticsearch){return function(_React$Component){_inherits(NodeRow,_React$Component);function NodeRow(props){_classCallCheck(this,NodeRow);return _possibleConstructorReturn(this,(NodeRow.__proto__||Object.getPrototypeOf(NodeRow)).call(this,props))}_createClass(NodeRow,[{key:"isOnline",value:function isOnline(){return true===this.props.isOnline}},{key:"getCpuComponents",value:function getCpuComponents(){var isOnline=this.isOnline();if(showCgroupMetricsElasticsearch)return[_react2.default.createElement(_cells.MetricCell,{key:"cpuCol1",isOnline:isOnline,metric:(0,_lodash.get)(this.props,"node_cgroup_quota"),isPercent:true,"data-test-subj":"cpuQuota"}),_react2.default.createElement(_cells.MetricCell,{key:"cpuCol2",isOnline:isOnline,metric:(0,_lodash.get)(this.props,"node_cgroup_throttled"),isPercent:false,"data-test-subj":"cpuThrottled"})];return[_react2.default.createElement(_cells.MetricCell,{key:"cpuCol1",isOnline:isOnline,metric:(0,_lodash.get)(this.props,"node_cpu_utilization"),isPercent:true,"data-test-subj":"cpuUsage"}),_react2.default.createElement(_cells.MetricCell,{key:"cpuCol2",isOnline:isOnline,metric:(0,_lodash.get)(this.props,"node_load_average"),isPercent:false,"data-test-subj":"loadAverage"})]}},{key:"getShardCount",value:function getShardCount(){if(this.isOnline())return _react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement("div",{className:"monitoringTableCell__number","data-test-subj":"shards"},(0,_lodash.get)(this.props,"shardCount")));return _react2.default.createElement(_cells.OfflineCell,null)}},{key:"render",value:function render(){var isOnline=this.isOnline();var status=this.props.isOnline?"Online":"Offline";return _react2.default.createElement(_components.KuiTableRow,null,_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement("div",{className:"monitoringTableCell__name"},_react2.default.createElement(_eui.EuiToolTip,{position:"bottom",content:this.props.nodeTypeLabel},_react2.default.createElement("span",{className:"fa "+this.props.nodeTypeClass}))," ",_react2.default.createElement("span",{"data-test-subj":"name"},_react2.default.createElement(_eui.EuiLink,{href:"#/elasticsearch/nodes/"+this.props.resolver,"data-test-subj":"nodeLink-"+this.props.resolver},this.props.name))),_react2.default.createElement("div",{className:"monitoringTableCell__transportAddress"},(0,_extract_ip.extractIp)(this.props.transport_address))),_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement("div",{className:"monitoringTableCell__status"},_react2.default.createElement(_node.NodeStatusIcon,{isOnline:this.props.isOnline,status:status})," ",status)),this.getCpuComponents(),_react2.default.createElement(_cells.MetricCell,{isOnline:isOnline,metric:(0,_lodash.get)(this.props,"node_jvm_mem_percent"),isPercent:true,"data-test-subj":"jvmMemory"}),_react2.default.createElement(_cells.MetricCell,{isOnline:isOnline,metric:(0,_lodash.get)(this.props,"node_free_space"),isPercent:false,"data-test-subj":"diskFreeSpace"}),this.getShardCount())}}]);return NodeRow}(_react2.default.Component)};function ElasticsearchNodes(_ref){var clusterStatus=_ref.clusterStatus,nodes=_ref.nodes,showCgroupMetricsElasticsearch=_ref.showCgroupMetricsElasticsearch,props=_objectWithoutProperties(_ref,["clusterStatus","nodes","showCgroupMetricsElasticsearch"]);var columns=getColumns(showCgroupMetricsElasticsearch);return _react2.default.createElement(_react.Fragment,null,_react2.default.createElement(_cluster_status.ClusterStatus,{stats:clusterStatus}),_react2.default.createElement(_table.MonitoringTable,{className:"elasticsearchNodesTable",rows:nodes,pageIndex:props.pageIndex,filterText:props.filterText,sortKey:props.sortKey,sortOrder:props.sortOrder,onNewState:props.onNewState,placeholder:"Filter Nodes...",filterFields:filterFields,columns:columns,rowComponent:nodeRowFactory(showCgroupMetricsElasticsearch)}))}},4374:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.MetricCell=exports.OfflineCell=void 0;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _lodash=__webpack_require__(1);var _format_number=__webpack_require__(59);var _components=__webpack_require__(32);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _objectWithoutProperties(obj,keys){var target={};for(var i in obj){if(keys.indexOf(i)>=0)continue;if(!Object.prototype.hasOwnProperty.call(obj,i))continue;target[i]=obj[i]}return target}function OfflineCell(){return _react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement("div",{className:"monitoringTableCell__number monitoringTableCell__offline"},"N/A"))}var getSlopeArrow=function getSlopeArrow(slope){if(slope||0===slope)return slope>0?"up":"down";return null};var metricVal=function metricVal(metric,format,isPercent){if(isPercent)return(0,_format_number.formatMetric)(metric,format,"%",{prependSpace:false});return(0,_format_number.formatMetric)(metric,format)};function MetricCell(_ref){var isOnline=_ref.isOnline,_ref$metric=_ref.metric,metric=void 0===_ref$metric?{}:_ref$metric,isPercent=_ref.isPercent,props=_objectWithoutProperties(_ref,["isOnline","metric","isPercent"]);if(isOnline){var _get=(0,_lodash.get)(metric,"summary",{}),lastVal=_get.lastVal,maxVal=_get.maxVal,minVal=_get.minVal,slope=_get.slope;var format=(0,_lodash.get)(metric,"metric.format");return _react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement("div",{className:"monitoringTableCell__MetricCell__metric","data-test-subj":props["data-test-subj"]},metricVal(lastVal,format,isPercent)),_react2.default.createElement("span",{className:"monitoringTableCell__MetricCell__slopeArrow fa fa-long-arrow-"+getSlopeArrow(slope)}),_react2.default.createElement("div",{className:"monitoringTableCell__MetricCell__minMax"},_react2.default.createElement("div",null,metricVal(maxVal,format,isPercent)+" max"),_react2.default.createElement("div",null,metricVal(minVal,format,isPercent)+" min")))}return _react2.default.createElement(OfflineCell,null)}exports.OfflineCell=OfflineCell;exports.MetricCell=MetricCell},4375:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _indices=__webpack_require__(4376);Object.defineProperty(exports,"ElasticsearchIndices",{enumerable:true,get:function get(){return _indices.ElasticsearchIndices}})},4376:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source)Object.prototype.hasOwnProperty.call(source,key)&&(target[key]=source[key])}return target};exports.ElasticsearchIndices=ElasticsearchIndices;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _lodash=__webpack_require__(1);var _constants=__webpack_require__(64);var _formatting=__webpack_require__(375);var _format_number=__webpack_require__(59);var _status_icon=__webpack_require__(899);var _cluster_status=__webpack_require__(655);var _table=__webpack_require__(256);var _eui=__webpack_require__(3);var _components=__webpack_require__(32);var _system_indices_checkbox=__webpack_require__(4377);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _objectWithoutProperties(obj,keys){var target={};for(var i in obj){if(keys.indexOf(i)>=0)continue;if(!Object.prototype.hasOwnProperty.call(obj,i))continue;target[i]=obj[i]}return target}var filterFields=["name","status"];var columns=[{title:"Name",sortKey:"name",secondarySortOrder:_constants.SORT_ASCENDING},{title:"Status",sortKey:"status_sort",sortOrder:_constants.SORT_DESCENDING},{title:"Document Count",sortKey:"doc_count"},{title:"Data",sortKey:"data_size"},{title:"Index Rate",sortKey:"index_rate"},{title:"Search Rate",sortKey:"search_rate"},{title:"Unassigned Shards",sortKey:"unassigned_shards"}];var IndexRow=function IndexRow(_ref){var status=_ref.status,props=_objectWithoutProperties(_ref,["status"]);return _react2.default.createElement(_components.KuiTableRow,null,_react2.default.createElement(_components.KuiTableRowCell,{"data-test-subj":"name"},_react2.default.createElement(_eui.EuiLink,{href:"#/elasticsearch/indices/"+props.name,"data-test-subj":"indexLink-"+props.name},props.name)),_react2.default.createElement(_components.KuiTableRowCell,null,_react2.default.createElement("div",{title:"Index status: "+status},_react2.default.createElement(_status_icon.ElasticsearchStatusIcon,{status:status})," ",(0,_lodash.capitalize)(status))),_react2.default.createElement(_components.KuiTableRowCell,{"data-test-subj":"documentCount"},(0,_format_number.formatMetric)((0,_lodash.get)(props,"doc_count"),_formatting.LARGE_ABBREVIATED)),_react2.default.createElement(_components.KuiTableRowCell,{"data-test-subj":"dataSize"},(0,_format_number.formatMetric)((0,_lodash.get)(props,"data_size"),_formatting.LARGE_BYTES)),_react2.default.createElement(_components.KuiTableRowCell,{"data-test-subj":"indexRate"},(0,_format_number.formatMetric)((0,_lodash.get)(props,"index_rate"),_formatting.LARGE_FLOAT,"/s")),_react2.default.createElement(_components.KuiTableRowCell,{"data-test-subj":"searchRate"},(0,_format_number.formatMetric)((0,_lodash.get)(props,"search_rate"),_formatting.LARGE_FLOAT,"/s")),_react2.default.createElement(_components.KuiTableRowCell,{"data-test-subj":"unassignedShards"},(0,_format_number.formatMetric)((0,_lodash.get)(props,"unassigned_shards"),"0")))};var getNoDataMessage=function getNoDataMessage(filterText){if(filterText)return _react2.default.createElement("div",null,_react2.default.createElement("p",null,"There are no indices that match your selection with the filter [",filterText.trim(),"]. Try changing the filter or the time range selection."),_react2.default.createElement("p",null,"If you are looking for system indices (e.g., .kibana), try checking ‘Show system indices’."));return _react2.default.createElement("div",null,_react2.default.createElement("p",null,"There are no indices that match your selections. Try changing the time range selection."),_react2.default.createElement("p",null,"If you are looking for system indices (e.g., .kibana), try checking ‘Show system indices’."))};var renderToolBarSection=function renderToolBarSection(_ref2){var showSystemIndices=_ref2.showSystemIndices,toggleShowSystemIndices=_ref2.toggleShowSystemIndices,props=_objectWithoutProperties(_ref2,["showSystemIndices","toggleShowSystemIndices"]);return _react2.default.createElement(_system_indices_checkbox.SystemIndicesCheckbox,_extends({showSystemIndices:showSystemIndices,toggleShowSystemIndices:toggleShowSystemIndices},props))};function ElasticsearchIndices(_ref3){var clusterStatus=_ref3.clusterStatus,indices=_ref3.indices,props=_objectWithoutProperties(_ref3,["clusterStatus","indices"]);return _react2.default.createElement(_react.Fragment,null,_react2.default.createElement(_cluster_status.ClusterStatus,{stats:clusterStatus}),_react2.default.createElement(_table.MonitoringTable,{className:"elasticsearchIndicesTable",rows:indices,pageIndex:props.pageIndex,filterText:props.filterText,sortKey:props.sortKey,sortOrder:props.sortOrder,onNewState:props.onNewState,placeholder:"Filter Indices...",filterFields:filterFields,renderToolBarSections:renderToolBarSection,columns:columns,rowComponent:IndexRow,getNoDataMessage:getNoDataMessage,showSystemIndices:props.showSystemIndices,toggleShowSystemIndices:props.toggleShowSystemIndices}))}},4377:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.SystemIndicesCheckbox=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _components=__webpack_require__(32);var _eui=__webpack_require__(3);var _constants=__webpack_require__(64);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}exports.SystemIndicesCheckbox=function(_React$Component){_inherits(SystemIndicesCheckbox,_React$Component);function SystemIndicesCheckbox(props){_classCallCheck(this,SystemIndicesCheckbox);var _this=_possibleConstructorReturn(this,(SystemIndicesCheckbox.__proto__||Object.getPrototypeOf(SystemIndicesCheckbox)).call(this,props));_this.state={showSystemIndices:props.showSystemIndices};_this.toggleShowSystemIndices=_this.toggleShowSystemIndices.bind(_this);return _this}_createClass(SystemIndicesCheckbox,[{key:"toggleShowSystemIndices",value:function toggleShowSystemIndices(e){var isChecked=Boolean(e.target.checked);this.setState({showSystemIndices:isChecked});this.props.toggleShowSystemIndices(isChecked);this.props.dispatchTableAction(_constants.TABLE_ACTION_RESET_PAGING)}},{key:"render",value:function render(){return _react2.default.createElement(_components.KuiToolBarSection,null,_react2.default.createElement(_components.KuiToolBarText,null,_react2.default.createElement(_eui.EuiSwitch,{label:"System indices",onChange:this.toggleShowSystemIndices,checked:this.state.showSystemIndices})))}}]);return SystemIndicesCheckbox}(_react2.default.Component)},4378:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _chrome=__webpack_require__(8);var _chrome2=_interopRequireDefault(_chrome);var _index=__webpack_require__(4379);var _index2=_interopRequireDefault(_index);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var tryPrivilege=function tryPrivilege($http,kbnUrl){return $http.get("../api/monitoring/v1/check_access").then(function(){return kbnUrl.redirect("/home")}).catch(_lodash.noop)};_routes2.default.when("/access-denied",{template:_index2.default,resolve:{initialCheck:function initialCheck($http,kbnUrl){return tryPrivilege($http,kbnUrl)}},controllerAs:"accessDenied",controller:function controller($scope,$injector){var $window=$injector.get("$window");var kbnBaseUrl=$injector.get("kbnBaseUrl");var $http=$injector.get("$http");var kbnUrl=$injector.get("kbnUrl");var $interval=$injector.get("$interval");this.goToKibana=function(){$window.location.href=_chrome2.default.getBasePath()+kbnBaseUrl};var accessPoller=$interval(function(){return tryPrivilege($http,kbnUrl)},5e3);$scope.$on("$destroy",function(){return $interval.cancel(accessPoller)})}})},4379:function(module,exports){module.exports='<div class="kuiViewContent kuiViewContent--constrainedWidth kuiViewContentItem">\n  <div class="kuiInfoPanel kuiInfoPanel--error">\n    <div class="kuiInfoPanelHeader">\n      <span class="kuiInfoPanelHeader__icon kuiIcon kuiIcon--error fa-warning"></span>\n      <span class="kuiInfoPanelHeader__title" data-test-subj="accessDeniedTitle">\n        Access Denied\n      </span>\n    </div>\n\n    <div class="kuiInfoPanelBody">\n      <div class="kuiInfoPanelBody__message">\n        You are not authorized to access Monitoring. To use Monitoring, you\n        need the privileges granted by both the `kibana_user` and\n        `monitoring_user` roles.\n      </div>\n\n      <div class="kuiInfoPanelBody__message">\n        If you are attempting to access a dedicated monitoring cluster, this\n        might be because you are logged in as a user that is not configured on\n        the monitoring cluster.\n      </div>\n\n      <div class="kuiInfoPanelBody__message">\n        <div class="kuiButtonGroup">\n          <button\n            ng-click="accessDenied.goToKibana();"\n            class="kuiButton kuiButton--primary"\n          >\n            Back to Kibana\n          </button>\n        </div>\n      </div>\n    </div>\n  </div>\n</div>\n'},4380:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _index=__webpack_require__(4381);var _index2=_interopRequireDefault(_index);var _views=__webpack_require__(143);var _route_init=__webpack_require__(51);var _ajax_error_handler=__webpack_require__(63);var _timefilter=__webpack_require__(14);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}function getPageData($injector){var globalState=$injector.get("globalState");var $http=$injector.get("$http");var Private=$injector.get("Private");var url="../api/monitoring/v1/clusters/"+globalState.cluster_uuid+"/alerts";var timeBounds=_timefilter.timefilter.getBounds();return $http.post(url,{ccs:globalState.ccs,timeRange:{min:timeBounds.min.toISOString(),max:timeBounds.max.toISOString()}}).then(function(response){return(0,_lodash.get)(response,"data",[])}).catch(function(err){var ajaxErrorHandlers=Private(_ajax_error_handler.ajaxErrorHandlersProvider);return ajaxErrorHandlers(err)})}_routes2.default.when("/alerts",{template:_index2.default,resolve:{clusters:function clusters(Private){var routeInit=Private(_route_init.routeInitProvider);return routeInit()},alerts:getPageData},controllerAs:"alerts",controller:function(_MonitoringViewBaseCo){_inherits(AlertsView,_MonitoringViewBaseCo);function AlertsView($injector,$scope){_classCallCheck(this,AlertsView);var $route=$injector.get("$route");var globalState=$injector.get("globalState");$scope.cluster=(0,_lodash.find)($route.current.locals.clusters,{cluster_uuid:globalState.cluster_uuid});var _this=_possibleConstructorReturn(this,(AlertsView.__proto__||Object.getPrototypeOf(AlertsView)).call(this,{title:"Cluster Alerts",getPageData:getPageData,$scope:$scope,$injector:$injector}));_this.data=$route.current.locals.alerts;return _this}return AlertsView}(_views.MonitoringViewBaseController)})},4381:function(module,exports){module.exports='<monitoring-main name="alerts">\n  <div class="page-row">\n    <p ng-if="alerts.data.message">\n      {{ alerts.data.message }}\n    </p>\n  </div>\n\n  <div class="page-row">\n    <h3 class="kuiScreenReaderOnly">Alerts</h3>\n    <monitoring-cluster-alerts-listing alerts="alerts.data"></monitoring-cluster-alerts-listing>\n  </div>\n\n  <div class="page-row">\n    <p>\n      <a kbn-href="#/overview">« Cluster Overview</a>\n    </p>\n  </div>\n</monitoring-main>\n'},4382:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.MonitoringViewBaseController=void 0;var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source)Object.prototype.hasOwnProperty.call(source,key)&&(target[key]=source[key])}return target};var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _moment=__webpack_require__(10);var _moment2=_interopRequireDefault(_moment);var _reactDom=__webpack_require__(15);var _get_page_data=__webpack_require__(4383);var _components=__webpack_require__(434);var _timefilter=__webpack_require__(14);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}exports.MonitoringViewBaseController=function(){function MonitoringViewBaseController(_ref){var _this=this;var _ref$title=_ref.title,title=void 0===_ref$title?"":_ref$title,_ref$api=_ref.api,api=void 0===_ref$api?"":_ref$api,apiUrlFn=_ref.apiUrlFn,_ref$getPageData=_ref.getPageData,_getPageData=void 0===_ref$getPageData?_get_page_data.getPageData:_ref$getPageData,defaultData=_ref.defaultData,_ref$reactNodeId=_ref.reactNodeId,reactNodeId=void 0===_ref$reactNodeId?null:_ref$reactNodeId,$scope=_ref.$scope,$injector=_ref.$injector,_ref$options=_ref.options,options=void 0===_ref$options?{}:_ref$options;_classCallCheck(this,MonitoringViewBaseController);var titleService=$injector.get("title");var $executor=$injector.get("$executor");titleService($scope.cluster,title);this.data=_extends({},defaultData);this._isDataInitialized=false;this.reactNodeId=reactNodeId;var _options$enableTimeFi=options.enableTimeFilter,enableTimeFilter=void 0===_options$enableTimeFi||_options$enableTimeFi,_options$enableAutoRe=options.enableAutoRefresh,enableAutoRefresh=void 0===_options$enableAutoRe||_options$enableAutoRe;false===enableTimeFilter?_timefilter.timefilter.disableTimeRangeSelector():_timefilter.timefilter.enableTimeRangeSelector();false===enableAutoRefresh?_timefilter.timefilter.disableAutoRefreshSelector():_timefilter.timefilter.enableAutoRefreshSelector();this.updateData=function(){var _api=apiUrlFn?apiUrlFn():api;return _getPageData($injector,_api).then(function(pageData){_this._isDataInitialized=true;_this.data=pageData})};this.updateData();$executor.register({execute:function execute(){return _this.updateData()}});$executor.start($scope);$scope.$on("$destroy",function(){_this.reactNodeId&&(0,_reactDom.unmountComponentAtNode)(document.getElementById(_this.reactNodeId));$executor.destroy()});this.onBrush=function(_ref2){var xaxis=_ref2.xaxis;var to=xaxis.to,from=xaxis.from;_timefilter.timefilter.setTime({from:(0,_moment2.default)(from),to:(0,_moment2.default)(to),mode:"absolute"})}}_createClass(MonitoringViewBaseController,[{key:"renderReact",value:function renderReact(component){false===this._isDataInitialized?(0,_reactDom.render)(_react2.default.createElement(_components.PageLoading,null),document.getElementById(this.reactNodeId)):(0,_reactDom.render)(component,document.getElementById(this.reactNodeId))}}]);return MonitoringViewBaseController}()},4383:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.getPageData=getPageData;var _ajax_error_handler=__webpack_require__(63);var _timefilter=__webpack_require__(14);function getPageData($injector,api){var $http=$injector.get("$http");var globalState=$injector.get("globalState");var timeBounds=_timefilter.timefilter.getBounds();return $http.post(api,{ccs:globalState.ccs,timeRange:{min:timeBounds.min.toISOString(),max:timeBounds.max.toISOString()}}).then(function(response){return response.data}).catch(function(err){var Private=$injector.get("Private");var ajaxErrorHandlers=Private(_ajax_error_handler.ajaxErrorHandlersProvider);return ajaxErrorHandlers(err)})}},4384:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.MonitoringViewBaseTableController=void 0;var _=__webpack_require__(143);var _table=__webpack_require__(256);function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}exports.MonitoringViewBaseTableController=function(_MonitoringViewBaseCo){_inherits(MonitoringViewBaseTableController,_MonitoringViewBaseCo);function MonitoringViewBaseTableController(args){_classCallCheck(this,MonitoringViewBaseTableController);var _this=_possibleConstructorReturn(this,(MonitoringViewBaseTableController.__proto__||Object.getPrototypeOf(MonitoringViewBaseTableController)).call(this,args));var storageKey=args.storageKey,$injector=args.$injector;var storage=$injector.get("localStorage");var getLocalStorageData=(0,_table.tableStorageGetter)(storageKey);var setLocalStorageData=(0,_table.tableStorageSetter)(storageKey);var _getLocalStorageData=getLocalStorageData(storage),pageIndex=_getLocalStorageData.pageIndex,filterText=_getLocalStorageData.filterText,sortKey=_getLocalStorageData.sortKey,sortOrder=_getLocalStorageData.sortOrder;_this.pageIndex=pageIndex;_this.filterText=filterText;_this.sortKey=sortKey;_this.sortOrder=sortOrder;_this.onNewState=function(newState){setLocalStorageData(storage,newState)};return _this}return MonitoringViewBaseTableController}(_.MonitoringViewBaseController)},4385:function(module,exports,__webpack_require__){"use strict";var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _route_init=__webpack_require__(51);var _index=__webpack_require__(4386);var _index2=_interopRequireDefault(_index);var _controller=__webpack_require__(4387);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}_routes2.default.when("/license",{template:_index2.default,resolve:{clusters:function clusters(Private){var routeInit=Private(_route_init.routeInitProvider);return routeInit()}},controllerAs:"licenseView",controller:_controller.LicenseViewController})},4386:function(module,exports){module.exports='<monitoring-main data-test-subj="xpackLicensePage">\n  <div id="licenseReact" class="licenseFeature"></div>\n</monitoring-main>\n'},4387:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.LicenseViewController=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _lodash=__webpack_require__(1);var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _reactDom=__webpack_require__(15);var _chrome=__webpack_require__(8);var _chrome2=_interopRequireDefault(_chrome);var _formatting=__webpack_require__(375);var _components=__webpack_require__(1523);var _components2=__webpack_require__(434);var _timefilter=__webpack_require__(14);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}var REACT_NODE_ID="licenseReact";exports.LicenseViewController=function(){function LicenseViewController($injector,$scope){_classCallCheck(this,LicenseViewController);_timefilter.timefilter.disableTimeRangeSelector();_timefilter.timefilter.disableAutoRefreshSelector();$scope.$on("$destroy",function(){(0,_reactDom.unmountComponentAtNode)(document.getElementById(REACT_NODE_ID))});this.init($injector,$scope)}_createClass(LicenseViewController,[{key:"init",value:function init($injector,$scope){var globalState=$injector.get("globalState");var title=$injector.get("title");var $route=$injector.get("$route");var cluster=(0,_lodash.find)($route.current.locals.clusters,{cluster_uuid:globalState.cluster_uuid});$scope.cluster=cluster;title($scope.cluster,"License");this.license=cluster.license;this.isExpired=Date.now()>(0,_lodash.get)(cluster,"license.expiry_date_in_millis");this.isPrimaryCluster=cluster.isPrimary;var basePath=_chrome2.default.getBasePath();this.uploadLicensePath=basePath+"/app/kibana#"+_components.MANAGEMENT_BASE_PATH+"upload_license";this.renderReact($scope)}},{key:"renderReact",value:function renderReact($scope){var _this=this;$scope.$evalAsync(function(){var isPrimaryCluster=_this.isPrimaryCluster,license=_this.license,isExpired=_this.isExpired,uploadLicensePath=_this.uploadLicensePath;var expiryDate=license.expiry_date_in_millis;void 0!==license.expiry_date_in_millis&&(expiryDate=(0,_formatting.formatDateTimeLocal)(license.expiry_date_in_millis));(0,_reactDom.render)(_react2.default.createElement(_components2.License,{isPrimaryCluster:isPrimaryCluster,status:license.status,type:license.type,isExpired:isExpired,expiryDate:expiryDate,uploadLicensePath:uploadLicensePath}),document.getElementById(REACT_NODE_ID))})}}]);return LicenseViewController}()},4388:function(module,exports,__webpack_require__){"use strict";var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _route_init=__webpack_require__(51);var _=__webpack_require__(143);var _index=__webpack_require__(4389);var _index2=_interopRequireDefault(_index);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}var getPageData=function getPageData($injector){var monitoringClusters=$injector.get("monitoringClusters");return monitoringClusters()};_routes2.default.when("/home",{template:_index2.default,resolve:{clusters:function clusters(Private,kbnUrl){var routeInit=Private(_route_init.routeInitProvider);return routeInit().then(function(clusters){if(!clusters||!clusters.length){kbnUrl.changePath("/no-data");return Promise.reject()}if(1===clusters.length){kbnUrl.changePath("/overview");return Promise.reject()}return clusters})}},controllerAs:"clusters",controller:function(_MonitoringViewBaseTa){_inherits(ClustersList,_MonitoringViewBaseTa);function ClustersList($injector,$scope){_classCallCheck(this,ClustersList);var _this=_possibleConstructorReturn(this,(ClustersList.__proto__||Object.getPrototypeOf(ClustersList)).call(this,{storageKey:"clusters",getPageData:getPageData,$scope:$scope,$injector:$injector}));var $route=$injector.get("$route");_this.data=$route.current.locals.clusters;return _this}return ClustersList}(_.MonitoringViewBaseTableController)}).otherwise({redirectTo:"/no-data"})},4389:function(module,exports){module.exports='<monitoring-main name="listing">\n  <div class="page-row">\n    <h3 class="kuiScreenReaderOnly">Clusters</h3>\n    <monitoring-cluster-listing\n      page-index="clusters.pageIndex"\n      filter-text="clusters.filterText"\n      sort-key="clusters.sortKey"\n      sort-order="clusters.sortOrder"\n      on-new-state="clusters.onNewState"\n      clusters="clusters.data"\n    ></monitoring-cluster-listing>\n  </div>\n</monitoring-main>\n'},4390:function(module,exports,__webpack_require__){"use strict";var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _route_init=__webpack_require__(51);var _index=__webpack_require__(4391);var _index2=_interopRequireDefault(_index);var _timefilter=__webpack_require__(14);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}_routes2.default.when("/overview",{template:_index2.default,resolve:{clusters:function clusters(Private){var routeInit=Private(_route_init.routeInitProvider);return routeInit()},cluster:function cluster(monitoringClusters,globalState){return monitoringClusters(globalState.cluster_uuid,globalState.ccs)}},controller:function controller($injector,$scope){_timefilter.timefilter.enableTimeRangeSelector();_timefilter.timefilter.enableAutoRefreshSelector();var $route=$injector.get("$route");$scope.cluster=$route.current.locals.cluster;var title=$injector.get("title");title($scope.cluster,"Overview");var $executor=$injector.get("$executor");var monitoringClusters=$injector.get("monitoringClusters");var globalState=$injector.get("globalState");$executor.register({execute:function execute(){return monitoringClusters(globalState.cluster_uuid,globalState.ccs)},handleResponse:function handleResponse(cluster){$scope.cluster=cluster}});$executor.start($scope);$scope.$on("$destroy",$executor.destroy)}})},4391:function(module,exports){module.exports='<monitoring-main name="overview" data-test-subj="clusterOverviewContainer">\n  <monitoring-cluster-overview cluster="cluster"></monitoring-cluster-overview>\n</monitoring-main>\n'},4392:function(module,exports,__webpack_require__){"use strict";var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _route_init=__webpack_require__(51);var _index=__webpack_require__(4393);var _index2=_interopRequireDefault(_index);var _controller=__webpack_require__(4394);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}_routes2.default.when("/elasticsearch",{template:_index2.default,resolve:{clusters:function clusters(Private){var routeInit=Private(_route_init.routeInitProvider);return routeInit()}},controllerAs:"elasticsearchOverview",controller:_controller.ElasticsearchOverviewController})},4393:function(module,exports){module.exports='<monitoring-main\n  product="elasticsearch"\n  name="overview"\n  data-test-subj="elasticsearchOverviewPage"\n>\n  <div id="elasticsearchOverviewReact"></div>\n</monitoring-main>\n'},4394:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.ElasticsearchOverviewController=void 0;var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source)Object.prototype.hasOwnProperty.call(source,key)&&(target[key]=source[key])}return target};var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _get=function get(object,property,receiver){null===object&&(object=Function.prototype);var desc=Object.getOwnPropertyDescriptor(object,property);if(void 0===desc){var parent=Object.getPrototypeOf(object);return null===parent?void 0:get(parent,property,receiver)}if("value"in desc)return desc.value;var getter=desc.get;if(void 0===getter)return;return getter.call(receiver)};var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _lodash=__webpack_require__(1);var _=__webpack_require__(143);var _components=__webpack_require__(434);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}exports.ElasticsearchOverviewController=function(_MonitoringViewBaseCo){_inherits(ElasticsearchOverviewController,_MonitoringViewBaseCo);function ElasticsearchOverviewController($injector,$scope){_classCallCheck(this,ElasticsearchOverviewController);var $route=$injector.get("$route");var globalState=$injector.get("globalState");$scope.cluster=(0,_lodash.find)($route.current.locals.clusters,{cluster_uuid:globalState.cluster_uuid});var _this=_possibleConstructorReturn(this,(ElasticsearchOverviewController.__proto__||Object.getPrototypeOf(ElasticsearchOverviewController)).call(this,{title:"Elasticsearch",api:"../api/monitoring/v1/clusters/"+globalState.cluster_uuid+"/elasticsearch",defaultData:{clusterStatus:{status:""},metrics:null,shardActivity:null},reactNodeId:"elasticsearchOverviewReact",$scope:$scope,$injector:$injector}));_this.showShardActivityHistory=false;_this.toggleShardActivityHistory=function(){_this.showShardActivityHistory=!_this.showShardActivityHistory;$scope.$evalAsync(function(){_this.renderReact(_this.data)})};_this.initScope($scope);return _this}_createClass(ElasticsearchOverviewController,[{key:"initScope",value:function initScope($scope){var _this2=this;$scope.$watch(function(){return _this2.data},function(data){_this2.renderReact(data)});$scope.$watch(function(){return _this2.showShardActivityHistory},function(){var data=_this2.data;var dataWithShardActivityLoading=_extends({},data,{shardActivity:null});_this2.renderReact(dataWithShardActivityLoading);_this2.renderReact(data)})}},{key:"filterShardActivityData",value:function filterShardActivityData(shardActivity){var _this3=this;return shardActivity.filter(function(row){return _this3.showShardActivityHistory||"DONE"!==row.stage})}},{key:"renderReact",value:function renderReact(data){var clusterStatus=data.clusterStatus,metrics=data.metrics,shardActivity=data.shardActivity;var shardActivityData=shardActivity&&this.filterShardActivityData(shardActivity);var component=_react2.default.createElement(_components.ElasticsearchOverview,{clusterStatus:clusterStatus,metrics:metrics,shardActivity:shardActivityData,onBrush:this.onBrush,showShardActivityHistory:this.showShardActivityHistory,toggleShardActivityHistory:this.toggleShardActivityHistory});_get(ElasticsearchOverviewController.prototype.__proto__||Object.getPrototypeOf(ElasticsearchOverviewController.prototype),"renderReact",this).call(this,component)}}]);return ElasticsearchOverviewController}(_.MonitoringViewBaseController)},4395:function(module,exports,__webpack_require__){"use strict";var _get=function get(object,property,receiver){null===object&&(object=Function.prototype);var desc=Object.getOwnPropertyDescriptor(object,property);if(void 0===desc){var parent=Object.getPrototypeOf(object);return null===parent?void 0:get(parent,property,receiver)}if("value"in desc)return desc.value;var getter=desc.get;if(void 0===getter)return;return getter.call(receiver)};var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _lodash=__webpack_require__(1);var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _route_init=__webpack_require__(51);var _=__webpack_require__(143);var _components=__webpack_require__(434);var _index=__webpack_require__(4396);var _index2=_interopRequireDefault(_index);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _defineProperty(obj,key,value){key in obj?Object.defineProperty(obj,key,{value:value,enumerable:true,configurable:true,writable:true}):obj[key]=value;return obj}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}_routes2.default.when("/elasticsearch/indices",{template:_index2.default,resolve:{clusters:function clusters(Private){var routeInit=Private(_route_init.routeInitProvider);return routeInit()}},controllerAs:"elasticsearchIndices",controller:function(_MonitoringViewBaseTa){_inherits(ElasticsearchIndicesController,_MonitoringViewBaseTa);function ElasticsearchIndicesController($injector,$scope){var _call;_classCallCheck(this,ElasticsearchIndicesController);var $route=$injector.get("$route");var globalState=$injector.get("globalState");var features=$injector.get("features");var clusterUuid=globalState.cluster_uuid;$scope.cluster=(0,_lodash.find)($route.current.locals.clusters,{cluster_uuid:clusterUuid});var showSystemIndices=features.isEnabled("showSystemIndices",false);var _this=_possibleConstructorReturn(this,(ElasticsearchIndicesController.__proto__||Object.getPrototypeOf(ElasticsearchIndicesController)).call(this,(_call={title:"Elasticsearch - Indices",storageKey:"elasticsearch.indices",apiUrlFn:function apiUrlFn(){return"../api/monitoring/v1/clusters/"+clusterUuid+"/elasticsearch/indices?show_system_indices="+showSystemIndices},reactNodeId:"elasticsearchIndicesReact",defaultData:{},$scope:$scope,$injector:$injector},_defineProperty(_call,"$scope",$scope),_defineProperty(_call,"$injector",$injector),_call)));var toggleShowSystemIndices=function toggleShowSystemIndices(isChecked){showSystemIndices=isChecked;features.update("showSystemIndices",isChecked);_this.updateData()};$scope.$watch(function(){return _this.data},function(data){_this.renderReact(data)});_this.renderReact=function(_ref){var clusterStatus=_ref.clusterStatus,indices=_ref.indices;_get(ElasticsearchIndicesController.prototype.__proto__||Object.getPrototypeOf(ElasticsearchIndicesController.prototype),"renderReact",_this).call(_this,_react2.default.createElement(_components.ElasticsearchIndices,{clusterStatus:clusterStatus,indices:indices,showSystemIndices:showSystemIndices,toggleShowSystemIndices:toggleShowSystemIndices}))};return _this}return ElasticsearchIndicesController}(_.MonitoringViewBaseTableController)})},4396:function(module,exports){module.exports='<monitoring-main\n  product="elasticsearch"\n  name="indices"\n  data-test-subj="elasticsearchIndicesListingPage"\n>\n  <div id="elasticsearchIndicesReact"></div>\n</monitoring-main>\n'},4397:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _route_init=__webpack_require__(51);var _ajax_error_handler=__webpack_require__(63);var _index=__webpack_require__(4398);var _index2=_interopRequireDefault(_index);var _timefilter=__webpack_require__(14);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function getPageData($injector){var $http=$injector.get("$http");var $route=$injector.get("$route");var globalState=$injector.get("globalState");var url="../api/monitoring/v1/clusters/"+globalState.cluster_uuid+"/elasticsearch/indices/"+$route.current.params.index;var timeBounds=_timefilter.timefilter.getBounds();return $http.post(url,{ccs:globalState.ccs,timeRange:{min:timeBounds.min.toISOString(),max:timeBounds.max.toISOString()},is_advanced:false}).then(function(response){return response.data}).catch(function(err){var Private=$injector.get("Private");var ajaxErrorHandlers=Private(_ajax_error_handler.ajaxErrorHandlersProvider);return ajaxErrorHandlers(err)})}_routes2.default.when("/elasticsearch/indices/:index",{template:_index2.default,resolve:{clusters:function clusters(Private){var routeInit=Private(_route_init.routeInitProvider);return routeInit()},pageData:getPageData},controller:function controller($injector,$scope){_timefilter.timefilter.enableTimeRangeSelector();_timefilter.timefilter.enableAutoRefreshSelector();var $route=$injector.get("$route");var globalState=$injector.get("globalState");$scope.cluster=(0,_lodash.find)($route.current.locals.clusters,{cluster_uuid:globalState.cluster_uuid});$scope.pageData=$route.current.locals.pageData;$scope.indexName=$route.current.params.index;var title=$injector.get("title");title($scope.cluster,"Elasticsearch - Indices - "+$scope.indexName+" - Overview");var $executor=$injector.get("$executor");$executor.register({execute:function execute(){return getPageData($injector)},handleResponse:function handleResponse(response){return $scope.pageData=response}});$executor.start($scope);$scope.$on("$destroy",$executor.destroy)}})},4398:function(module,exports){module.exports='<monitoring-main\n  product="elasticsearch"\n  name="indices"\n  instance="{{ indexName }}"\n  resolver="{{ indexName }}"\n  page="overview"\n>\n  <monitoring-index-summary summary="pageData.indexSummary"></monitoring-index-summary>\n\n  <div class="page-row">\n    <div class="row" ng-if="pageData.metrics">\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.index_mem"></monitoring-chart></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.index_size"></monitoring-chart></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.index_search_request_rate"></monitoring-chart></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.index_request_rate"></monitoring-chart></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.index_segment_count"></monitoring-chart></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.index_document_count"></monitoring-chart></div>\n    </div>\n  </div>\n\n  <monitoring-shard-allocation\n    id="indexName"\n    view="index"\n    nodes="pageData.nodes"\n    shards="pageData.shards"\n    shard-stats="pageData.shardStats"\n  ></monitoring-shard-allocation>\n</monitoring-main>\n'},4399:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _ajax_error_handler=__webpack_require__(63);var _route_init=__webpack_require__(51);var _index=__webpack_require__(4400);var _index2=_interopRequireDefault(_index);var _timefilter=__webpack_require__(14);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function getPageData($injector){var globalState=$injector.get("globalState");var $route=$injector.get("$route");var url="../api/monitoring/v1/clusters/"+globalState.cluster_uuid+"/elasticsearch/indices/"+$route.current.params.index;var $http=$injector.get("$http");var timeBounds=_timefilter.timefilter.getBounds();return $http.post(url,{ccs:globalState.ccs,timeRange:{min:timeBounds.min.toISOString(),max:timeBounds.max.toISOString()},is_advanced:true}).then(function(response){return response.data}).catch(function(err){var Private=$injector.get("Private");var ajaxErrorHandlers=Private(_ajax_error_handler.ajaxErrorHandlersProvider);return ajaxErrorHandlers(err)})}_routes2.default.when("/elasticsearch/indices/:index/advanced",{template:_index2.default,resolve:{clusters:function clusters(Private){var routeInit=Private(_route_init.routeInitProvider);return routeInit()},pageData:getPageData},controller:function controller($injector,$scope){_timefilter.timefilter.enableTimeRangeSelector();_timefilter.timefilter.enableAutoRefreshSelector();var $route=$injector.get("$route");var globalState=$injector.get("globalState");$scope.cluster=(0,_lodash.find)($route.current.locals.clusters,{cluster_uuid:globalState.cluster_uuid});$scope.indexName=$route.current.params.index;$scope.pageData=$route.current.locals.pageData;var title=$injector.get("title");title($scope.cluster,"Elasticsearch - Indices - "+$scope.indexName+" - Advanced");var $executor=$injector.get("$executor");$executor.register({execute:function execute(){return getPageData($injector)},handleResponse:function handleResponse(response){return $scope.pageData=response}});$executor.start($scope);$scope.$on("$destroy",$executor.destroy)}})},4400:function(module,exports){module.exports='<monitoring-main\n  product="elasticsearch" name="indices"\n  instance="{{ indexName }}"\n  resolver="{{ indexName }}"\n  page="advanced"\n>\n  <monitoring-index-summary summary="pageData.indexSummary"></monitoring-index-summary>\n\n  <div class="page-row">\n    <div class="row" ng-if="pageData.metrics">\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.index_1"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.index_2"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.index_3"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.index_4"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.index_total"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.index_time"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.index_refresh"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.index_throttling"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.index_disk"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.index_segment_count"/></div>\n    </div>\n  </div>\n</monitoring-main>\n'},4401:function(module,exports,__webpack_require__){"use strict";var _get=function get(object,property,receiver){null===object&&(object=Function.prototype);var desc=Object.getOwnPropertyDescriptor(object,property);if(void 0===desc){var parent=Object.getPrototypeOf(object);return null===parent?void 0:get(parent,property,receiver)}if("value"in desc)return desc.value;var getter=desc.get;if(void 0===getter)return;return getter.call(receiver)};var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _lodash=__webpack_require__(1);var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _index=__webpack_require__(4402);var _index2=_interopRequireDefault(_index);var _route_init=__webpack_require__(51);var _=__webpack_require__(143);var _components=__webpack_require__(434);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}_routes2.default.when("/elasticsearch/nodes",{template:_index2.default,resolve:{clusters:function clusters(Private){var routeInit=Private(_route_init.routeInitProvider);return routeInit()}},controllerAs:"elasticsearchNodes",controller:function(_MonitoringViewBaseTa){_inherits(ElasticsearchNodesController,_MonitoringViewBaseTa);function ElasticsearchNodesController($injector,$scope){_classCallCheck(this,ElasticsearchNodesController);var $route=$injector.get("$route");var globalState=$injector.get("globalState");var showCgroupMetricsElasticsearch=$injector.get("showCgroupMetricsElasticsearch");$scope.cluster=(0,_lodash.find)($route.current.locals.clusters,{cluster_uuid:globalState.cluster_uuid});var _this=_possibleConstructorReturn(this,(ElasticsearchNodesController.__proto__||Object.getPrototypeOf(ElasticsearchNodesController)).call(this,{title:"Elasticsearch - Nodes",storageKey:"elasticsearch.nodes",api:"../api/monitoring/v1/clusters/"+globalState.cluster_uuid+"/elasticsearch/nodes",reactNodeId:"elasticsearchNodesReact",defaultData:{},$scope:$scope,$injector:$injector}));$scope.$watch(function(){return _this.data},function(data){_this.renderReact(data)});_this.renderReact=function(_ref){var clusterStatus=_ref.clusterStatus,nodes=_ref.nodes;_get(ElasticsearchNodesController.prototype.__proto__||Object.getPrototypeOf(ElasticsearchNodesController.prototype),"renderReact",_this).call(_this,_react2.default.createElement(_components.ElasticsearchNodes,{clusterStatus:clusterStatus,nodes:nodes,showCgroupMetricsElasticsearch:showCgroupMetricsElasticsearch}))};return _this}return ElasticsearchNodesController}(_.MonitoringViewBaseTableController)})},4402:function(module,exports){module.exports='<monitoring-main\n  product="elasticsearch"\n  name="nodes"\n  data-test-subj="elasticsearchNodesListingPage"\n>\n  <div id="elasticsearchNodesReact"></div>\n</monitoring-main>\n'},4403:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _route_init=__webpack_require__(51);var _get_page_data=__webpack_require__(4404);var _index=__webpack_require__(4405);var _index2=_interopRequireDefault(_index);var _timefilter=__webpack_require__(14);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}_routes2.default.when("/elasticsearch/nodes/:node",{template:_index2.default,resolve:{clusters:function clusters(Private){var routeInit=Private(_route_init.routeInitProvider);return routeInit()},pageData:_get_page_data.getPageData},controller:function controller($injector,$scope){_timefilter.timefilter.enableTimeRangeSelector();_timefilter.timefilter.enableAutoRefreshSelector();var $route=$injector.get("$route");var globalState=$injector.get("globalState");$scope.cluster=(0,_lodash.find)($route.current.locals.clusters,{cluster_uuid:globalState.cluster_uuid});$scope.pageData=$route.current.locals.pageData;var title=$injector.get("title");title($scope.cluster,"Elasticsearch - Nodes - "+$scope.pageData.nodeSummary.name+" - Overview");var features=$injector.get("features");var callPageData=(0,_lodash.partial)(_get_page_data.getPageData,$injector);$scope.showSystemIndices=features.isEnabled("showSystemIndices",false);$scope.toggleShowSystemIndices=function(isChecked){$scope.showSystemIndices=isChecked;features.update("showSystemIndices",isChecked);callPageData().then(function(pageData){return $scope.pageData=pageData})};var $executor=$injector.get("$executor");$executor.register({execute:function execute(){return callPageData()},handleResponse:function handleResponse(response){$scope.pageData=response}});$executor.start($scope);$scope.$on("$destroy",$executor.destroy)}})},4404:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.getPageData=getPageData;var _ajax_error_handler=__webpack_require__(63);var _timefilter=__webpack_require__(14);function getPageData($injector){var $http=$injector.get("$http");var globalState=$injector.get("globalState");var $route=$injector.get("$route");var url="../api/monitoring/v1/clusters/"+globalState.cluster_uuid+"/elasticsearch/nodes/"+$route.current.params.node;var features=$injector.get("features");var showSystemIndices=features.isEnabled("showSystemIndices",false);var timeBounds=_timefilter.timefilter.getBounds();return $http.post(url,{showSystemIndices:showSystemIndices,ccs:globalState.ccs,timeRange:{min:timeBounds.min.toISOString(),max:timeBounds.max.toISOString()},is_advanced:false}).then(function(response){return response.data}).catch(function(err){var Private=$injector.get("Private");var ajaxErrorHandlers=Private(_ajax_error_handler.ajaxErrorHandlersProvider);return ajaxErrorHandlers(err)})}},4405:function(module,exports){module.exports='<monitoring-main\n  product="elasticsearch"\n  name="nodes"\n  instance="{{ pageData.nodeSummary.name }}"\n  resolver="{{ pageData.nodeSummary.resolver }}"\n  page="overview"\n  tab-icon-class="{{ pageData.nodeSummary.nodeTypeClass }}"\n  tab-icon-class="{{ pageData.nodeSummary.nodeTypeLabel }}"\n>\n  <monitoring-node-summary node="pageData.nodeSummary"></monitoring-node-summary>\n\n  <div class="page-row">\n    <div class="row" ng-if="pageData.metrics">\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.node_jvm_mem"></monitoring-chart></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.node_mem"></monitoring-chart></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.node_cpu_metric"></monitoring-chart></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.node_load_average"></monitoring-chart></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.node_latency"></monitoring-chart></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.node_segment_count"></monitoring-chart></div>\n    </div>\n  </div>\n\n  <monitoring-shard-allocation\n    view="node"\n    nodes="pageData.nodes"\n    shards="pageData.shards"\n    shard-stats="pageData.shardStats"\n    show-system-indices="showSystemIndices"\n    toggle-show-system-indices="toggleShowSystemIndices"\n  ></monitoring-shard-allocation>\n</monitoring-main>\n'},4406:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _ajax_error_handler=__webpack_require__(63);var _route_init=__webpack_require__(51);var _index=__webpack_require__(4407);var _index2=_interopRequireDefault(_index);var _timefilter=__webpack_require__(14);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function getPageData($injector){var $http=$injector.get("$http");var globalState=$injector.get("globalState");var $route=$injector.get("$route");var timeBounds=_timefilter.timefilter.getBounds();var url="../api/monitoring/v1/clusters/"+globalState.cluster_uuid+"/elasticsearch/nodes/"+$route.current.params.node;return $http.post(url,{ccs:globalState.ccs,timeRange:{min:timeBounds.min.toISOString(),max:timeBounds.max.toISOString()},is_advanced:true}).then(function(response){return response.data}).catch(function(err){var Private=$injector.get("Private");var ajaxErrorHandlers=Private(_ajax_error_handler.ajaxErrorHandlersProvider);return ajaxErrorHandlers(err)})}_routes2.default.when("/elasticsearch/nodes/:node/advanced",{template:_index2.default,resolve:{clusters:function clusters(Private){var routeInit=Private(_route_init.routeInitProvider);return routeInit()},pageData:getPageData},controller:function controller($injector,$scope){_timefilter.timefilter.enableTimeRangeSelector();_timefilter.timefilter.enableAutoRefreshSelector();var $route=$injector.get("$route");var globalState=$injector.get("globalState");$scope.cluster=(0,_lodash.find)($route.current.locals.clusters,{cluster_uuid:globalState.cluster_uuid});$scope.pageData=$route.current.locals.pageData;var title=$injector.get("title");title($scope.cluster,"Elasticsearch - Nodes - "+$scope.pageData.nodeSummary.name+" - Advanced");var $executor=$injector.get("$executor");$executor.register({execute:function execute(){return getPageData($injector)},handleResponse:function handleResponse(response){$scope.pageData=response}});$executor.start($scope);$scope.$on("$destroy",$executor.destroy)}})},4407:function(module,exports){module.exports='<monitoring-main\n  product="elasticsearch"\n  name="nodes"\n  instance="{{ pageData.nodeSummary.name }}"\n  resolver="{{ pageData.nodeSummary.resolver }}"\n  page="advanced"\n  tab-icon-class="{{ pageData.nodeSummary.nodeTypeClass }}"\n  tab-icon-class="{{ pageData.nodeSummary.nodeTypeLabel }}"\n>\n  <monitoring-node-summary node="pageData.nodeSummary"></monitoring-node-summary>\n\n  <div class="page-row">\n    <div class="row" ng-if="pageData.metrics">\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.node_gc"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.node_gc_time"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.node_jvm_mem"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.node_cpu_utilization"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.node_index_1"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.node_index_2"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.node_index_3"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.node_index_4"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.node_index_time"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.node_request_total"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.node_index_threads"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.node_read_threads"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.node_cgroup_cpu"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.node_cgroup_stats"/></div>\n    </div>\n  </div>\n</monitoring-main>\n'},4408:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _route_init=__webpack_require__(51);var _=__webpack_require__(143);var _get_page_data=__webpack_require__(4409);var _index=__webpack_require__(4410);var _index2=_interopRequireDefault(_index);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}_routes2.default.when("/elasticsearch/ml_jobs",{template:_index2.default,resolve:{clusters:function clusters(Private){var routeInit=Private(_route_init.routeInitProvider);return routeInit()},pageData:_get_page_data.getPageData},controllerAs:"mlJobs",controller:function(_MonitoringViewBaseTa){_inherits(MlJobsList,_MonitoringViewBaseTa);function MlJobsList($injector,$scope){_classCallCheck(this,MlJobsList);var _this=_possibleConstructorReturn(this,(MlJobsList.__proto__||Object.getPrototypeOf(MlJobsList)).call(this,{title:"Elasticsearch - Machine Learning Jobs",storageKey:"elasticsearch.mlJobs",getPageData:_get_page_data.getPageData,$scope:$scope,$injector:$injector}));var $route=$injector.get("$route");_this.data=$route.current.locals.pageData;var globalState=$injector.get("globalState");$scope.cluster=(0,_lodash.find)($route.current.locals.clusters,{cluster_uuid:globalState.cluster_uuid});return _this}return MlJobsList}(_.MonitoringViewBaseTableController)})},4409:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.getPageData=getPageData;var _ajax_error_handler=__webpack_require__(63);var _timefilter=__webpack_require__(14);function getPageData($injector){var $http=$injector.get("$http");var globalState=$injector.get("globalState");var url="../api/monitoring/v1/clusters/"+globalState.cluster_uuid+"/elasticsearch/ml_jobs";var timeBounds=_timefilter.timefilter.getBounds();return $http.post(url,{ccs:globalState.ccs,timeRange:{min:timeBounds.min.toISOString(),max:timeBounds.max.toISOString()}}).then(function(response){return response.data}).catch(function(err){var Private=$injector.get("Private");var ajaxErrorHandlers=Private(_ajax_error_handler.ajaxErrorHandlersProvider);return ajaxErrorHandlers(err)})}},4410:function(module,exports){module.exports='<monitoring-main product="elasticsearch" name="ml">\n  <monitoring-cluster-status-elasticsearch status="mlJobs.data.clusterStatus"></monitoring-cluster-status-elasticsearch>\n  <div class="page-row">\n    <h3 class="kuiScreenReaderOnly">Machine Learning Jobs</h3>\n    <monitoring-ml-listing\n      page-index="mlJobs.pageIndex"\n      filter-text="mlJobs.filterText"\n      sort-key="mlJobs.sortKey"\n      sort-order="mlJobs.sortOrder"\n      on-new-state="mlJobs.onNewState"\n      jobs="mlJobs.data.rows"\n    ></monitoring-ml-listing>\n  </div>\n</monitoring-main>\n'},4411:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _ajax_error_handler=__webpack_require__(63);var _route_init=__webpack_require__(51);var _index=__webpack_require__(4412);var _index2=_interopRequireDefault(_index);var _timefilter=__webpack_require__(14);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function getPageData($injector){var $http=$injector.get("$http");var globalState=$injector.get("globalState");var url="../api/monitoring/v1/clusters/"+globalState.cluster_uuid+"/kibana";var timeBounds=_timefilter.timefilter.getBounds();return $http.post(url,{ccs:globalState.ccs,timeRange:{min:timeBounds.min.toISOString(),max:timeBounds.max.toISOString()}}).then(function(response){return response.data}).catch(function(err){var Private=$injector.get("Private");var ajaxErrorHandlers=Private(_ajax_error_handler.ajaxErrorHandlersProvider);return ajaxErrorHandlers(err)})}_routes2.default.when("/kibana",{template:_index2.default,resolve:{clusters:function clusters(Private){var routeInit=Private(_route_init.routeInitProvider);return routeInit()},pageData:getPageData},controller:function controller($injector,$scope){_timefilter.timefilter.enableTimeRangeSelector();_timefilter.timefilter.enableAutoRefreshSelector();var $route=$injector.get("$route");var globalState=$injector.get("globalState");$scope.cluster=(0,_lodash.find)($route.current.locals.clusters,{cluster_uuid:globalState.cluster_uuid});$scope.pageData=$route.current.locals.pageData;var title=$injector.get("title");title($scope.cluster,"Kibana");var $executor=$injector.get("$executor");$executor.register({execute:function execute(){return getPageData($injector)},handleResponse:function handleResponse(response){return $scope.pageData=response}});$executor.start($scope);$scope.$on("$destroy",$executor.destroy)}})},4412:function(module,exports){module.exports='<monitoring-main\n  product="kibana"\n  name="overview"\n  data-test-subj="kibanaOverviewPage"\n>\n  <monitoring-cluster-status-kibana status="pageData.clusterStatus"></monitoring-cluster-status-kibana>\n  <div class="page-row">\n    <div class="row" ng-if="pageData.metrics">\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.kibana_cluster_requests"></monitoring-chart></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.kibana_cluster_response_times"></monitoring-chart></div>\n    </div>\n  </div>\n</monitoring-main>\n'},4413:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _route_init=__webpack_require__(51);var _=__webpack_require__(143);var _get_page_data=__webpack_require__(4414);var _index=__webpack_require__(4415);var _index2=_interopRequireDefault(_index);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}_routes2.default.when("/kibana/instances",{template:_index2.default,resolve:{clusters:function clusters(Private){var routeInit=Private(_route_init.routeInitProvider);return routeInit()},pageData:_get_page_data.getPageData},controllerAs:"kibanas",controller:function(_MonitoringViewBaseTa){_inherits(KibanaInstancesList,_MonitoringViewBaseTa);function KibanaInstancesList($injector,$scope){_classCallCheck(this,KibanaInstancesList);var _this=_possibleConstructorReturn(this,(KibanaInstancesList.__proto__||Object.getPrototypeOf(KibanaInstancesList)).call(this,{title:"Kibana Instances",storageKey:"kibana.instances",getPageData:_get_page_data.getPageData,$scope:$scope,$injector:$injector}));var $route=$injector.get("$route");_this.data=$route.current.locals.pageData;var globalState=$injector.get("globalState");$scope.cluster=(0,_lodash.find)($route.current.locals.clusters,{cluster_uuid:globalState.cluster_uuid});$scope.pageData=$route.current.locals.pageData;return _this}return KibanaInstancesList}(_.MonitoringViewBaseTableController)})},4414:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.getPageData=getPageData;var _ajax_error_handler=__webpack_require__(63);var _timefilter=__webpack_require__(14);function getPageData($injector){var $http=$injector.get("$http");var globalState=$injector.get("globalState");var url="../api/monitoring/v1/clusters/"+globalState.cluster_uuid+"/kibana/instances";var timeBounds=_timefilter.timefilter.getBounds();return $http.post(url,{ccs:globalState.ccs,timeRange:{min:timeBounds.min.toISOString(),max:timeBounds.max.toISOString()}}).then(function(response){return response.data}).catch(function(err){var Private=$injector.get("Private");var ajaxErrorHandlers=Private(_ajax_error_handler.ajaxErrorHandlersProvider);return ajaxErrorHandlers(err)})}},4415:function(module,exports){module.exports='<monitoring-main\n  product="kibana"\n  name="kibanas"\n  data-test-subj="kibanaInstancesPage"\n>\n  <monitoring-cluster-status-kibana status="kibanas.data.clusterStatus"></monitoring-cluster-status-kibana>\n  <div class="page-row">\n    <h3 class="kuiScreenReaderOnly">Kibana Instances</h3>\n    <monitoring-kibana-listing\n      page-index="kibanas.pageIndex"\n      filter-text="kibanas.filterText"\n      sort-key="kibanas.sortKey"\n      sort-order="kibanas.sortOrder"\n      on-new-state="kibanas.onNewState"\n      instances="kibanas.data.kibanas"\n    ></monitoring-kibana-listing>\n  </div>\n</monitoring-main>\n'},4416:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _ajax_error_handler=__webpack_require__(63);var _route_init=__webpack_require__(51);var _index=__webpack_require__(4417);var _index2=_interopRequireDefault(_index);var _timefilter=__webpack_require__(14);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function getPageData($injector){var $http=$injector.get("$http");var globalState=$injector.get("globalState");var $route=$injector.get("$route");var url="../api/monitoring/v1/clusters/"+globalState.cluster_uuid+"/kibana/"+$route.current.params.uuid;var timeBounds=_timefilter.timefilter.getBounds();return $http.post(url,{ccs:globalState.ccs,timeRange:{min:timeBounds.min.toISOString(),max:timeBounds.max.toISOString()}}).then(function(response){return response.data}).catch(function(err){var Private=$injector.get("Private");var ajaxErrorHandlers=Private(_ajax_error_handler.ajaxErrorHandlersProvider);return ajaxErrorHandlers(err)})}_routes2.default.when("/kibana/instances/:uuid",{template:_index2.default,resolve:{clusters:function clusters(Private){var routeInit=Private(_route_init.routeInitProvider);return routeInit()},pageData:getPageData},controller:function controller($injector,$scope){_timefilter.timefilter.enableTimeRangeSelector();_timefilter.timefilter.enableAutoRefreshSelector();var $route=$injector.get("$route");var globalState=$injector.get("globalState");$scope.cluster=(0,_lodash.find)($route.current.locals.clusters,{cluster_uuid:globalState.cluster_uuid});$scope.pageData=$route.current.locals.pageData;var title=$injector.get("title");title($scope.cluster,"Kibana - "+(0,_lodash.get)($scope.pageData,"kibanaSummary.name"));var $executor=$injector.get("$executor");$executor.register({execute:function execute(){return getPageData($injector)},handleResponse:function handleResponse(response){return $scope.pageData=response}});$executor.start($scope);$scope.$on("$destroy",$executor.destroy)}})},4417:function(module,exports){module.exports='<monitoring-main\n  product="kibana"\n  name="kibana"\n  instance="{{ pageData.kibanaSummary.name }}"\n  data-test-subj="kibanaInstancePage"\n>\n  <monitoring-kibana-summary kibana="pageData.kibanaSummary"></monitoring-kibana-summary>\n  <div class="page-row">\n    <div class="row" ng-if="pageData.metrics">\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.kibana_requests"></monitoring-chart></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.kibana_response_times"></monitoring-chart></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.kibana_memory"></monitoring-chart></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.kibana_average_concurrent_connections"></monitoring-chart></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.kibana_os_load"></monitoring-chart></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.kibana_process_delay"></monitoring-chart></div>\n    </div>\n  </div>\n</monitoring-main>\n'},4418:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _ajax_error_handler=__webpack_require__(63);var _route_init=__webpack_require__(51);var _index=__webpack_require__(4419);var _index2=_interopRequireDefault(_index);var _timefilter=__webpack_require__(14);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function getPageData($injector){var $http=$injector.get("$http");var globalState=$injector.get("globalState");var url="../api/monitoring/v1/clusters/"+globalState.cluster_uuid+"/logstash";var timeBounds=_timefilter.timefilter.getBounds();return $http.post(url,{ccs:globalState.ccs,timeRange:{min:timeBounds.min.toISOString(),max:timeBounds.max.toISOString()}}).then(function(response){return response.data}).catch(function(err){var Private=$injector.get("Private");var ajaxErrorHandlers=Private(_ajax_error_handler.ajaxErrorHandlersProvider);return ajaxErrorHandlers(err)})}_routes2.default.when("/logstash",{template:_index2.default,resolve:{clusters:function clusters(Private){var routeInit=Private(_route_init.routeInitProvider);return routeInit()},pageData:getPageData},controller:function controller($injector,$scope){_timefilter.timefilter.enableTimeRangeSelector();_timefilter.timefilter.enableAutoRefreshSelector();var $route=$injector.get("$route");var globalState=$injector.get("globalState");$scope.cluster=(0,_lodash.find)($route.current.locals.clusters,{cluster_uuid:globalState.cluster_uuid});$scope.pageData=$route.current.locals.pageData;var title=$injector.get("title");title($scope.cluster,"Logstash");var $executor=$injector.get("$executor");$executor.register({execute:function execute(){return getPageData($injector)},handleResponse:function handleResponse(response){return $scope.pageData=response}});$executor.start($scope);$scope.$on("$destroy",$executor.destroy)}})},4419:function(module,exports){module.exports='<monitoring-main product="logstash" name="overview">\n  <monitoring-cluster-status-logstash status="pageData.clusterStatus"></monitoring-cluster-status-logstash>\n  <div class="page-row">\n    <div class="row" ng-if="pageData.metrics">\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.logstash_cluster_events_input_rate"></monitoring-chart></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.logstash_cluster_events_output_rate"></monitoring-chart></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.logstash_cluster_events_latency"></monitoring-chart></div>\n    </div>\n  </div>\n</monitoring-main>\n'},4420:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _route_init=__webpack_require__(51);var _=__webpack_require__(143);var _get_page_data=__webpack_require__(4421);var _index=__webpack_require__(4422);var _index2=_interopRequireDefault(_index);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}_routes2.default.when("/logstash/nodes",{template:_index2.default,resolve:{clusters:function clusters(Private){var routeInit=Private(_route_init.routeInitProvider);return routeInit()},pageData:_get_page_data.getPageData},controllerAs:"lsNodes",controller:function(_MonitoringViewBaseTa){_inherits(LsNodesList,_MonitoringViewBaseTa);function LsNodesList($injector,$scope){_classCallCheck(this,LsNodesList);var _this=_possibleConstructorReturn(this,(LsNodesList.__proto__||Object.getPrototypeOf(LsNodesList)).call(this,{title:"Logstash - Nodes",storageKey:"logstash.nodes",getPageData:_get_page_data.getPageData,$scope:$scope,$injector:$injector}));var $route=$injector.get("$route");_this.data=$route.current.locals.pageData;var globalState=$injector.get("globalState");$scope.cluster=(0,_lodash.find)($route.current.locals.clusters,{cluster_uuid:globalState.cluster_uuid});return _this}return LsNodesList}(_.MonitoringViewBaseTableController)})},4421:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.getPageData=getPageData;var _ajax_error_handler=__webpack_require__(63);var _timefilter=__webpack_require__(14);function getPageData($injector){var $http=$injector.get("$http");var globalState=$injector.get("globalState");var url="../api/monitoring/v1/clusters/"+globalState.cluster_uuid+"/logstash/nodes";var timeBounds=_timefilter.timefilter.getBounds();return $http.post(url,{ccs:globalState.ccs,timeRange:{min:timeBounds.min.toISOString(),max:timeBounds.max.toISOString()}}).then(function(response){return response.data}).catch(function(err){var Private=$injector.get("Private");var ajaxErrorHandlers=Private(_ajax_error_handler.ajaxErrorHandlersProvider);return ajaxErrorHandlers(err)})}},4422:function(module,exports){module.exports='<monitoring-main product="logstash" name="nodes">\n  <monitoring-cluster-status-logstash status="lsNodes.data.clusterStatus"></monitoring-cluster-status-logstash>\n  <div class="page-row">\n    <h3 class="kuiScreenReaderOnly">Logstash Nodes</h3>\n    <monitoring-logstash-node-listing\n      page-index="lsNodes.pageIndex"\n      filter-text="lsNodes.filterText"\n      sort-key="lsNodes.sortKey"\n      sort-order="lsNodes.sortOrder"\n      on-new-state="lsNodes.onNewState"\n      nodes="lsNodes.data.nodes"\n    ></monitoring-logstash-node-listing>\n  </div>\n</monitoring-main>\n'},4423:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _ajax_error_handler=__webpack_require__(63);var _route_init=__webpack_require__(51);var _index=__webpack_require__(4424);var _index2=_interopRequireDefault(_index);var _timefilter=__webpack_require__(14);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function getPageData($injector){var $http=$injector.get("$http");var $route=$injector.get("$route");var globalState=$injector.get("globalState");var url="../api/monitoring/v1/clusters/"+globalState.cluster_uuid+"/logstash/node/"+$route.current.params.uuid;var timeBounds=_timefilter.timefilter.getBounds();return $http.post(url,{ccs:globalState.ccs,timeRange:{min:timeBounds.min.toISOString(),max:timeBounds.max.toISOString()},is_advanced:false}).then(function(response){return response.data}).catch(function(err){var Private=$injector.get("Private");var ajaxErrorHandlers=Private(_ajax_error_handler.ajaxErrorHandlersProvider);return ajaxErrorHandlers(err)})}_routes2.default.when("/logstash/node/:uuid",{template:_index2.default,resolve:{clusters:function clusters(Private){var routeInit=Private(_route_init.routeInitProvider);return routeInit()},pageData:getPageData},controller:function controller($injector,$scope){_timefilter.timefilter.enableTimeRangeSelector();_timefilter.timefilter.enableAutoRefreshSelector();var $route=$injector.get("$route");var globalState=$injector.get("globalState");$scope.cluster=(0,_lodash.find)($route.current.locals.clusters,{cluster_uuid:globalState.cluster_uuid});$scope.pageData=$route.current.locals.pageData;var title=$injector.get("title");title($scope.cluster,"Logstash - "+$scope.pageData.nodeSummary.name);var $executor=$injector.get("$executor");$executor.register({execute:function execute(){return getPageData($injector)},handleResponse:function handleResponse(response){return $scope.pageData=response}});$executor.start($scope);$scope.$on("$destroy",$executor.destroy)}})},4424:function(module,exports){module.exports='<monitoring-main\n  product="logstash"\n  name="nodes"\n  instance="{{ pageData.nodeSummary.name }}"\n  resolver="{{ pageData.nodeSummary.uuid }}"\n  page="overview"\n>\n  <monitoring-logstash-node-summary logstash="pageData.nodeSummary"></monitoring-logstash-node-summary>\n  <div class="page-row">\n    <div class="row" ng-if="pageData.metrics">\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.logstash_events_input_rate"></monitoring-chart></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.logstash_jvm_usage"></monitoring-chart></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.logstash_events_output_rate"></monitoring-chart></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.logstash_node_cpu_metric"></monitoring-chart></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.logstash_events_latency"></monitoring-chart></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.logstash_os_load"></monitoring-chart></div>\n    </div>\n  </div>\n</monitoring-main>\n'},4425:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _ajax_error_handler=__webpack_require__(63);var _route_init=__webpack_require__(51);var _index=__webpack_require__(4426);var _index2=_interopRequireDefault(_index);var _timefilter=__webpack_require__(14);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function getPageData($injector){var $http=$injector.get("$http");var globalState=$injector.get("globalState");var $route=$injector.get("$route");var url="../api/monitoring/v1/clusters/"+globalState.cluster_uuid+"/logstash/node/"+$route.current.params.uuid;var timeBounds=_timefilter.timefilter.getBounds();return $http.post(url,{ccs:globalState.ccs,timeRange:{min:timeBounds.min.toISOString(),max:timeBounds.max.toISOString()},is_advanced:true}).then(function(response){return response.data}).catch(function(err){var Private=$injector.get("Private");var ajaxErrorHandlers=Private(_ajax_error_handler.ajaxErrorHandlersProvider);return ajaxErrorHandlers(err)})}_routes2.default.when("/logstash/node/:uuid/advanced",{template:_index2.default,resolve:{clusters:function clusters(Private){var routeInit=Private(_route_init.routeInitProvider);return routeInit()},pageData:getPageData},controller:function controller($injector,$scope){_timefilter.timefilter.enableTimeRangeSelector();_timefilter.timefilter.enableAutoRefreshSelector();var $route=$injector.get("$route");var globalState=$injector.get("globalState");$scope.cluster=(0,_lodash.find)($route.current.locals.clusters,{cluster_uuid:globalState.cluster_uuid});$scope.pageData=$route.current.locals.pageData;var title=$injector.get("title");title($scope.cluster,"Logstash - "+$scope.pageData.nodeSummary.name+" - Advanced");var $executor=$injector.get("$executor");$executor.register({execute:function execute(){return getPageData($injector)},handleResponse:function handleResponse(response){return $scope.pageData=response}});$executor.start($scope);$scope.$on("$destroy",$executor.destroy)}})},4426:function(module,exports){module.exports='<monitoring-main product="logstash" name="nodes" instance="{{ pageData.nodeSummary.name }}" resolver="{{ pageData.nodeSummary.uuid }}" page="advanced">\n  <monitoring-logstash-node-summary logstash="pageData.nodeSummary"></monitoring-logstash-node-summary>\n  <div class="page-row">\n    <div class="row" ng-if="pageData.metrics">\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.logstash_node_cpu_utilization"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.logstash_queue_events_count"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.logstash_node_cgroup_cpu"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.logstash_pipeline_queue_size"/></div>\n      <div class="col-md-6"><monitoring-chart series="pageData.metrics.logstash_node_cgroup_stats"/></div>\n    </div>\n  </div>\n</monitoring-main>\n'},4427:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _ajax_error_handler=__webpack_require__(63);var _route_init=__webpack_require__(51);var _pipelines=__webpack_require__(1526);var _index=__webpack_require__(4428);var _index2=_interopRequireDefault(_index);var _timefilter=__webpack_require__(14);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var getPageData=function getPageData($injector){var $route=$injector.get("$route");var $http=$injector.get("$http");var globalState=$injector.get("globalState");var Private=$injector.get("Private");var logstashUuid=$route.current.params.uuid;var url="../api/monitoring/v1/clusters/"+globalState.cluster_uuid+"/logstash/node/"+logstashUuid+"/pipelines";var timeBounds=_timefilter.timefilter.getBounds();return $http.post(url,{ccs:globalState.ccs,timeRange:{min:timeBounds.min.toISOString(),max:timeBounds.max.toISOString()}}).then(function(response){return response.data}).catch(function(err){var ajaxErrorHandlers=Private(_ajax_error_handler.ajaxErrorHandlersProvider);return ajaxErrorHandlers(err)})};function makeUpgradeMessage(logstashVersion){if((0,_pipelines.isPipelineMonitoringSupportedInVersion)(logstashVersion))return null;return"Pipeline monitoring is only available in Logstash version 6.0.0 or higher. This node is running version "+logstashVersion+"."}_routes2.default.when("/logstash/node/:uuid/pipelines",{template:_index2.default,resolve:{clusters:function clusters(Private){var routeInit=Private(_route_init.routeInitProvider);return routeInit()},pageData:getPageData},controller:function controller($injector,$scope){var $route=$injector.get("$route");var globalState=$injector.get("globalState");var title=$injector.get("title");var $executor=$injector.get("$executor");$scope.cluster=(0,_lodash.find)($route.current.locals.clusters,{cluster_uuid:globalState.cluster_uuid});$scope.pageData=$route.current.locals.pageData;$scope.upgradeMessage=makeUpgradeMessage($scope.pageData.nodeSummary.version);_timefilter.timefilter.enableTimeRangeSelector();_timefilter.timefilter.enableAutoRefreshSelector();title($scope.cluster,"Logstash - "+$scope.pageData.nodeSummary.name+" - Pipelines");$executor.register({execute:function execute(){return getPageData($injector)},handleResponse:function handleResponse(response){return $scope.pageData=response}});$executor.start($scope);$scope.$on("$destroy",$executor.destroy)}})},4428:function(module,exports){module.exports='<monitoring-main\n  product="logstash"\n  name="nodes" instance="{{ pageData.nodeSummary.name }}"\n  resolver="{{ pageData.nodeSummary.uuid }}"\n  page="pipelines"\n>\n  <monitoring-logstash-node-summary logstash="pageData.nodeSummary"></monitoring-logstash-node-summary>\n  <div class="page-row">\n    <monitoring-logstash-pipeline-listing\n      pipelines="pageData.pipelines"\n      upgrade-message="{{ upgradeMessage }}"\n    ></monitoring-logstash-pipeline-listing>\n  </div>\n</monitoring-main>\n'},4429:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _ajax_error_handler=__webpack_require__(63);var _route_init=__webpack_require__(51);var _pipelines=__webpack_require__(1526);var _index=__webpack_require__(4430);var _index2=_interopRequireDefault(_index);var _timefilter=__webpack_require__(14);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}var getPageData=function getPageData($injector){var $http=$injector.get("$http");var globalState=$injector.get("globalState");var Private=$injector.get("Private");var url="../api/monitoring/v1/clusters/"+globalState.cluster_uuid+"/logstash/pipelines";var timeBounds=_timefilter.timefilter.getBounds();return $http.post(url,{ccs:globalState.ccs,timeRange:{min:timeBounds.min.toISOString(),max:timeBounds.max.toISOString()}}).then(function(response){return response.data}).catch(function(err){var ajaxErrorHandlers=Private(_ajax_error_handler.ajaxErrorHandlersProvider);return ajaxErrorHandlers(err)})};function makeUpgradeMessage(logstashVersions){if(!Array.isArray(logstashVersions)||0===logstashVersions.length||logstashVersions.some(_pipelines.isPipelineMonitoringSupportedInVersion))return null;return"Pipeline monitoring is only available in Logstash version 6.0.0 or higher."}_routes2.default.when("/logstash/pipelines",{template:_index2.default,resolve:{clusters:function clusters(Private){var routeInit=Private(_route_init.routeInitProvider);return routeInit()},pageData:getPageData},controller:function controller($injector,$scope){var $route=$injector.get("$route");var globalState=$injector.get("globalState");var title=$injector.get("title");var $executor=$injector.get("$executor");$scope.cluster=(0,_lodash.find)($route.current.locals.clusters,{cluster_uuid:globalState.cluster_uuid});$scope.pageData=$route.current.locals.pageData;$scope.upgradeMessage=makeUpgradeMessage($scope.pageData.clusterStatus.versions);_timefilter.timefilter.enableTimeRangeSelector();_timefilter.timefilter.enableAutoRefreshSelector();title($scope.cluster,"Logstash Pipelines");$executor.register({execute:function execute(){return getPageData($injector)},handleResponse:function handleResponse(response){return $scope.pageData=response}});$executor.start($scope);$scope.$on("$destroy",$executor.destroy)}})},4430:function(module,exports){module.exports='<monitoring-main\n  product="logstash"\n  name="pipelines"\n  data-test-subj="logstashPipelinesListing"\n>\n  <monitoring-cluster-status-logstash status="pageData.clusterStatus"></monitoring-cluster-status-logstash>\n  <div class="page-row">\n    <monitoring-logstash-pipeline-listing\n      pipelines="pageData.pipelines"\n      upgrade-message="{{ upgradeMessage }}"\n    ></monitoring-logstash-pipeline-listing>\n  </div>\n</monitoring-main>\n'},4431:function(module,exports,__webpack_require__){"use strict";var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source)Object.prototype.hasOwnProperty.call(source,key)&&(target[key]=source[key])}return target};var _lodash=__webpack_require__(1);var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _ajax_error_handler=__webpack_require__(63);var _route_init=__webpack_require__(51);var _constants=__webpack_require__(64);var _format_timestamp_to_duration=__webpack_require__(653);var _index=__webpack_require__(4432);var _index2=_interopRequireDefault(_index);var _timefilter=__webpack_require__(14);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function getPageData($injector){var $route=$injector.get("$route");var $http=$injector.get("$http");var globalState=$injector.get("globalState");var minIntervalSeconds=$injector.get("minIntervalSeconds");var Private=$injector.get("Private");var ccs=globalState.ccs,clusterUuid=globalState.cluster_uuid;var pipelineId=$route.current.params.id;var pipelineHash=$route.current.params.hash||"";var url="../api/monitoring/v1/clusters/"+clusterUuid+"/logstash/pipeline/"+pipelineId+"/"+pipelineHash;return $http.post(url,{ccs:ccs}).then(function(response){return response.data}).then(function(data){data.versions=data.versions.map(function(version){var relativeFirstSeen=(0,_format_timestamp_to_duration.formatTimestampToDuration)(version.firstSeen,_constants.CALCULATE_DURATION_SINCE);var relativeLastSeen=(0,_format_timestamp_to_duration.formatTimestampToDuration)(version.lastSeen,_constants.CALCULATE_DURATION_SINCE);var fudgeFactorSeconds=2*minIntervalSeconds;var isLastSeenCloseToNow=Date.now()-version.lastSeen<=1e3*fudgeFactorSeconds;return _extends({},version,{relativeFirstSeen:relativeFirstSeen+" ago",relativeLastSeen:isLastSeenCloseToNow?"now":"until "+relativeLastSeen+" ago"})});return data}).catch(function(err){var ajaxErrorHandlers=Private(_ajax_error_handler.ajaxErrorHandlersProvider);return ajaxErrorHandlers(err)})}_routes2.default.when("/logstash/pipelines/:id/:hash?",{template:_index2.default,resolve:{clusters:function clusters(Private){var routeInit=Private(_route_init.routeInitProvider);return routeInit()},pageData:getPageData},controller:function controller($injector,$scope){var $route=$injector.get("$route");var $executor=$injector.get("$executor");var globalState=$injector.get("globalState");var title=$injector.get("title");_timefilter.timefilter.disableTimeRangeSelector();_timefilter.timefilter.enableAutoRefreshSelector();function setClusters(clusters){$scope.clusters=clusters;$scope.cluster=(0,_lodash.find)($scope.clusters,{cluster_uuid:globalState.cluster_uuid})}setClusters($route.current.locals.clusters);$scope.pageData=$route.current.locals.pageData;title($scope.cluster,"Logstash - Pipeline");$executor.register({execute:function execute(){return getPageData($injector)},handleResponse:function handleResponse(response){$scope.pageData=response}});$executor.start($scope);$scope.$on("$destroy",$executor.destroy)}})},4432:function(module,exports){module.exports='<monitoring-main\n  product="logstash"\n  name="node"\n  instance="{{ pageData.nodeSummary.name }}"\n  resolver="{{ pageData.nodeSummary.uuid }}"\n  page="pipeline"\n  pipeline-id="{{ pageData.pipeline.id }}"\n  pipeline-hash="{{ pageData.pipeline.hash }}"\n  pipeline-versions="pageData.versions"\n>\n  <div class="page-row">\n    <monitoring-logstash-pipeline-viewer pipeline="pageData.pipeline"></monitoring-logstash-pipeline-viewer>\n  </div>\n</monitoring-main>\n'},4433:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _route_init=__webpack_require__(51);var _=__webpack_require__(143);var _get_page_data=__webpack_require__(4434);var _index=__webpack_require__(4435);var _index2=_interopRequireDefault(_index);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}_routes2.default.when("/beats",{template:_index2.default,resolve:{clusters:function clusters(Private){var routeInit=Private(_route_init.routeInitProvider);return routeInit()},pageData:_get_page_data.getPageData},controllerAs:"beats",controller:function(_MonitoringViewBaseCo){_inherits(BeatsOverview,_MonitoringViewBaseCo);function BeatsOverview($injector,$scope){_classCallCheck(this,BeatsOverview);var $route=$injector.get("$route");var globalState=$injector.get("globalState");$scope.cluster=(0,_lodash.find)($route.current.locals.clusters,{cluster_uuid:globalState.cluster_uuid});var _this=_possibleConstructorReturn(this,(BeatsOverview.__proto__||Object.getPrototypeOf(BeatsOverview)).call(this,{title:"Beats - Overview",getPageData:_get_page_data.getPageData,$scope:$scope,$injector:$injector}));_this.data=$route.current.locals.pageData;return _this}return BeatsOverview}(_.MonitoringViewBaseController)})},4434:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.getPageData=getPageData;var _ajax_error_handler=__webpack_require__(63);var _timefilter=__webpack_require__(14);function getPageData($injector){var $http=$injector.get("$http");var globalState=$injector.get("globalState");var timeBounds=_timefilter.timefilter.getBounds();var url="../api/monitoring/v1/clusters/"+globalState.cluster_uuid+"/beats";return $http.post(url,{ccs:globalState.ccs,timeRange:{min:timeBounds.min.toISOString(),max:timeBounds.max.toISOString()}}).then(function(response){return response.data}).catch(function(err){var Private=$injector.get("Private");var ajaxErrorHandlers=Private(_ajax_error_handler.ajaxErrorHandlersProvider);return ajaxErrorHandlers(err)})}},4435:function(module,exports){module.exports='<monitoring-main\n  product="beats"\n  name="overview"\n  data-test-subj="beatsOverviewPage"\n>\n  <monitoring-beats-overview data="beats.data"></monitoring-beats-overview>\n</monitoring-main>\n'},4436:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _route_init=__webpack_require__(51);var _=__webpack_require__(143);var _get_page_data=__webpack_require__(4437);var _index=__webpack_require__(4438);var _index2=_interopRequireDefault(_index);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}_routes2.default.when("/beats/beats",{template:_index2.default,resolve:{clusters:function clusters(Private){var routeInit=Private(_route_init.routeInitProvider);return routeInit()},pageData:_get_page_data.getPageData},controllerAs:"beats",controller:function(_MonitoringViewBaseTa){_inherits(BeatsListing,_MonitoringViewBaseTa);function BeatsListing($injector,$scope){_classCallCheck(this,BeatsListing);var $route=$injector.get("$route");var globalState=$injector.get("globalState");$scope.cluster=(0,_lodash.find)($route.current.locals.clusters,{cluster_uuid:globalState.cluster_uuid});var _this=_possibleConstructorReturn(this,(BeatsListing.__proto__||Object.getPrototypeOf(BeatsListing)).call(this,{title:"Beats",storageKey:"beats.beats",getPageData:_get_page_data.getPageData,$scope:$scope,$injector:$injector}));_this.data=$route.current.locals.pageData;return _this}return BeatsListing}(_.MonitoringViewBaseTableController)})},4437:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.getPageData=getPageData;var _ajax_error_handler=__webpack_require__(63);var _timefilter=__webpack_require__(14);function getPageData($injector){var $http=$injector.get("$http");var globalState=$injector.get("globalState");var timeBounds=_timefilter.timefilter.getBounds();var url="../api/monitoring/v1/clusters/"+globalState.cluster_uuid+"/beats/beats";return $http.post(url,{ccs:globalState.ccs,timeRange:{min:timeBounds.min.toISOString(),max:timeBounds.max.toISOString()}}).then(function(response){return response.data}).catch(function(err){var Private=$injector.get("Private");var ajaxErrorHandlers=Private(_ajax_error_handler.ajaxErrorHandlersProvider);return ajaxErrorHandlers(err)})}},4438:function(module,exports){module.exports='<monitoring-main\n  product="beats"\n  name="beats"\n  data-test-subj="beatsListingPage"\n>\n  <monitoring-beats-listing\n    page-index="beats.pageIndex"\n    sort-key="beats.sortKey"\n    sort-order="beats.sortOrder"\n    on-new-state="beats.onNewState"\n    data="beats.data"\n  ></monitoring-beats-listing>\n</monitoring-main>\n'},4439:function(module,exports,__webpack_require__){"use strict";var _lodash=__webpack_require__(1);var _routes=__webpack_require__(12);var _routes2=_interopRequireDefault(_routes);var _route_init=__webpack_require__(51);var _=__webpack_require__(143);var _get_page_data=__webpack_require__(4440);var _index=__webpack_require__(4441);var _index2=_interopRequireDefault(_index);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}_routes2.default.when("/beats/beat/:beatUuid",{template:_index2.default,resolve:{clusters:function clusters(Private){var routeInit=Private(_route_init.routeInitProvider);return routeInit()},pageData:_get_page_data.getPageData},controllerAs:"beat",controller:function(_MonitoringViewBaseCo){_inherits(BeatDetail,_MonitoringViewBaseCo);function BeatDetail($injector,$scope){_classCallCheck(this,BeatDetail);var $route=$injector.get("$route");var globalState=$injector.get("globalState");$scope.cluster=(0,_lodash.find)($route.current.locals.clusters,{cluster_uuid:globalState.cluster_uuid});var pageData=$route.current.locals.pageData;var _this=_possibleConstructorReturn(this,(BeatDetail.__proto__||Object.getPrototypeOf(BeatDetail)).call(this,{title:"Beats - "+pageData.summary.name+" - Overview",getPageData:_get_page_data.getPageData,$scope:$scope,$injector:$injector}));_this.data=pageData;return _this}return BeatDetail}(_.MonitoringViewBaseController)})},4440:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.getPageData=getPageData;var _ajax_error_handler=__webpack_require__(63);var _timefilter=__webpack_require__(14);function getPageData($injector){var $http=$injector.get("$http");var $route=$injector.get("$route");var globalState=$injector.get("globalState");var url="../api/monitoring/v1/clusters/"+globalState.cluster_uuid+"/beats/beat/"+$route.current.params.beatUuid;var timeBounds=_timefilter.timefilter.getBounds();return $http.post(url,{ccs:globalState.ccs,timeRange:{min:timeBounds.min.toISOString(),max:timeBounds.max.toISOString()}}).then(function(response){return response.data}).catch(function(err){var Private=$injector.get("Private");var ajaxErrorHandlers=Private(_ajax_error_handler.ajaxErrorHandlersProvider);return ajaxErrorHandlers(err)})}},4441:function(module,exports){module.exports='<monitoring-main\n  product="beats"\n  name="detail"\n  instance="{{ beat.data.summary.name }}"\n  resolver="{{ beat.data.summary.uuid }}"\n  page="overview"\n  data-test-subj="beatDetailPage"\n>\n  <monitoring-beats-beat data="beat.data"></monitoring-beats-beat>\n</monitoring-main>\n'},51:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.routeInitProvider=routeInitProvider;var _lodash=__webpack_require__(1);var _lodash2=_interopRequireDefault(_lodash);var _ajax_error_handler=__webpack_require__(63);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function routeInitProvider(Private,monitoringClusters,globalState,license,kbnUrl){var ajaxErrorHandlers=Private(_ajax_error_handler.ajaxErrorHandlersProvider);function isOnPage(hash){return _lodash2.default.contains(window.location.hash,hash)}return function routeInit(){return monitoringClusters().then(function(clusters){var cluster=function(){var existingCurrent=_lodash2.default.find(clusters,{cluster_uuid:globalState.cluster_uuid});if(existingCurrent)return existingCurrent;var firstCluster=_lodash2.default.first(clusters);if(firstCluster&&firstCluster.cluster_uuid)return firstCluster;return null}();if(!cluster||!cluster.license)return kbnUrl.redirect("/no-data");globalState.cluster_uuid=cluster.cluster_uuid;globalState.ccs=cluster.ccs;globalState.save();license.setLicense(cluster.license);if(!(isOnPage("license")||isOnPage("home"))&&license.isExpired())return kbnUrl.redirect("/license");if(!isOnPage("home")&&!cluster.isSupported)return kbnUrl.redirect("/home");return clusters}).catch(ajaxErrorHandlers)}}},511:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _summary_status=__webpack_require__(4259);Object.defineProperty(exports,"SummaryStatus",{enumerable:true,get:function get(){return _summary_status.SummaryStatus}})},512:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.StatusIcon=StatusIcon;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _defineProperty(obj,key,value){key in obj?Object.defineProperty(obj,key,{value:value,enumerable:true,configurable:true,writable:true}):obj[key]=value;return obj}function StatusIcon(_ref){var _typeToIconMap;var type=_ref.type,label=_ref.label;var typeToIconMap=(_typeToIconMap={},_defineProperty(_typeToIconMap,StatusIcon.TYPES.RED,"health-red.svg"),_defineProperty(_typeToIconMap,StatusIcon.TYPES.YELLOW,"health-yellow.svg"),_defineProperty(_typeToIconMap,StatusIcon.TYPES.GREEN,"health-green.svg"),_defineProperty(_typeToIconMap,StatusIcon.TYPES.GRAY,"health-gray.svg"),_typeToIconMap);var icon=typeToIconMap[type];return _react2.default.createElement("span",{className:"kuiStatusText"},_react2.default.createElement("img",{src:"../plugins/monitoring/icons/"+icon,alt:label,"data-test-subj":"statusIcon"}))}StatusIcon.TYPES={RED:"RED",YELLOW:"YELLOW",GREEN:"GREEN",GRAY:"GRAY"}},513:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _looking_for=__webpack_require__(4344);Object.defineProperty(exports,"LookingFor",{enumerable:true,get:function get(){return _looking_for.LookingFor}});var _what_is=__webpack_require__(4345);Object.defineProperty(exports,"WhatIs",{enumerable:true,get:function get(){return _what_is.WhatIs}});var _changes_needed=__webpack_require__(4346);Object.defineProperty(exports,"ChangesNeeded",{enumerable:true,get:function get(){return _changes_needed.ChangesNeeded}})},59:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.formatBytesUsage=formatBytesUsage;exports.formatPercentageUsage=formatPercentageUsage;exports.formatNumber=formatNumber;exports.formatMetric=formatMetric;var _moment=__webpack_require__(10);var _moment2=_interopRequireDefault(_moment);__webpack_require__(650);var _numeral=__webpack_require__(88);var _numeral2=_interopRequireDefault(_numeral);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function formatBytesUsage(used,max){return formatNumber(used,"byte")+" / "+formatNumber(max,"byte")}function formatPercentageUsage(used,max){return formatNumber(used/max,"0.00%")}function formatNumber(num,which){var isNan=Number.isNaN(num);var format="0,0.0";if("number"!==typeof num||isNan){if(void 0!==num&&!isNan)return num;num=0;format="0"}var postfix="";switch(which){case"time_since":return(0,_moment2.default)((0,_moment2.default)()-num).from((0,_moment2.default)(),true);case"time":return(0,_moment2.default)(num).format("H:mm:ss");case"int_commas":format="0,0";break;case"byte":case"bytes":format+=" b";break;case"ms":postfix="ms";break;default:which&&(format=which)}return(0,_numeral2.default)(num).format(format)+postfix}function formatMetric(value,format,suffix){var options=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{};var _options$prependSpace=options.prependSpace,prependSpace=void 0===_options$prependSpace||_options$prependSpace;if(Boolean(value)||0===value){var _suffix="";void 0!==suffix&&(_suffix=prependSpace?" "+suffix:suffix);return formatNumber(value,format)+_suffix}return"N/A"}},63:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.formatMonitoringError=formatMonitoringError;exports.ajaxErrorHandlersProvider=ajaxErrorHandlersProvider;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _lodash=__webpack_require__(1);var _notify=__webpack_require__(9);var _lib=__webpack_require__(549);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function formatMonitoringError(err){if(err.status&&-1!==err.status&&err.data)return _react2.default.createElement(_eui.EuiText,null,_react2.default.createElement("p",null,err.data.message),_react2.default.createElement(_eui.EuiText,{size:"xs"},"HTTP ",err.status));return(0,_lib.formatMsg)(err)}function ajaxErrorHandlersProvider($injector){var kbnUrl=$injector.get("kbnUrl");var $window=$injector.get("$window");return function(err){403===err.status?kbnUrl.redirect("access-denied"):404!==err.status||(0,_lodash.contains)($window.location.hash,"no-data")?_notify.toastNotifications.addDanger({title:"Monitoring Request Error",text:formatMonitoringError(err)}):_notify.toastNotifications.addDanger({title:"Monitoring Request Failed",text:_react2.default.createElement("div",null,formatMonitoringError(err),_react2.default.createElement(_eui.EuiSpacer,null),_react2.default.createElement(_eui.EuiButton,{size:"s",color:"danger",onClick:function onClick(){return $window.location.reload()}},"Retry"))});return Promise.reject(err)}}},64:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.LOGGING_TAG="monitoring-ui";exports.KIBANA_MONITORING_LOGGING_TAG="kibana-monitoring";exports.MONITORING_SYSTEM_API_VERSION="6";exports.KIBANA_STATS_TYPE_MONITORING="kibana_stats_monitoring";exports.KIBANA_SETTINGS_TYPE="kibana_settings";exports.KIBANA_USAGE_TYPE="kibana";exports.STORAGE_KEY="xpack.monitoring.data";exports.NORMALIZED_DERIVATIVE_UNIT="1s";exports.SORT_ASCENDING=1;exports.SORT_DESCENDING=-1;exports.CHART_LINE_COLOR="#d2d2d2";exports.CHART_TEXT_COLOR="#9c9c9c";exports.CLUSTER_ALERTS_SEARCH_SIZE=3;exports.FORMAT_DURATION_TEMPLATE_LONG="M [months] d [days]";exports.FORMAT_DURATION_TEMPLATE_SHORT=" d [days] h [hrs] m [min]";exports.FORMAT_DURATION_TEMPLATE_TINY=" s [seconds]";exports.CALCULATE_DURATION_SINCE="since";exports.CALCULATE_DURATION_UNTIL="until";exports.ML_SUPPORTED_LICENSES=["trial","platinum"];exports.CLOUD_METADATA_SERVICES={AWS_URL:"http://169.254.169.254/2016-09-02/dynamic/instance-identity/document",AZURE_URL:"http://169.254.169.254/metadata/instance?api-version=2017-04-02",GCP_URL_PREFIX:"http://169.254.169.254/computeMetadata/v1/instance"};exports.LOGSTASH={MAJOR_VER_REQD_FOR_PIPELINES:6,QUEUE_TYPES:{MEMORY:"memory",PERSISTED:"persisted"}};exports.DEFAULT_NO_DATA_MESSAGE="There are no records that match your query. Try changing the time range selection.";exports.DEFAULT_NO_DATA_MESSAGE_WITH_FILTER="There are no records that match your query with the filter [{{FILTER}}]. Try changing the filter or the time range selection.";exports.TABLE_ACTION_UPDATE_FILTER="UPDATE_FILTER";exports.TABLE_ACTION_RESET_PAGING="RESET_PAGING";exports.DEBOUNCE_SLOW_MS=17;exports.DEBOUNCE_FAST_MS=10},651:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _monitoring_timeseries=__webpack_require__(1496);Object.defineProperty(exports,"MonitoringTimeseries",{enumerable:true,get:function get(){return _monitoring_timeseries.MonitoringTimeseries}});var _info_tooltip=__webpack_require__(1501);Object.defineProperty(exports,"InfoTooltip",{enumerable:true,get:function get(){return _info_tooltip.InfoTooltip}});var _get_title=__webpack_require__(1502);Object.defineProperty(exports,"getTitle",{enumerable:true,get:function get(){return _get_title.getTitle}});var _get_units=__webpack_require__(1503);Object.defineProperty(exports,"getUnits",{enumerable:true,get:function get(){return _get_units.getUnits}});var _monitoring_timeseries_container=__webpack_require__(4212);Object.defineProperty(exports,"MonitoringTimeseriesContainer",{enumerable:true,get:function get(){return _monitoring_timeseries_container.MonitoringTimeseriesContainer}})},653:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.formatTimestampToDuration=formatTimestampToDuration;var _moment=__webpack_require__(10);var _moment2=_interopRequireDefault(_moment);__webpack_require__(650);var _constants=__webpack_require__(64);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function formatTimestampToDuration(timestamp,calculationFlag,initialTime){initialTime=initialTime||(0,_moment2.default)();var timeDuration=void 0;if(calculationFlag===_constants.CALCULATE_DURATION_SINCE)timeDuration=_moment2.default.duration(initialTime-(0,_moment2.default)(timestamp));else{if(calculationFlag!==_constants.CALCULATE_DURATION_UNTIL)throw new Error('[formatTimestampToDuration] requires a [calculationFlag] parameter to specify format as "since" or "until" the given time.');timeDuration=_moment2.default.duration((0,_moment2.default)(timestamp)-initialTime)}var duration=void 0;duration=Math.abs(initialTime.diff(timestamp,"months"))>=1?_moment2.default.duration(timeDuration).format(_constants.FORMAT_DURATION_TEMPLATE_LONG):Math.abs(initialTime.diff(timestamp,"minutes"))>=1?_moment2.default.duration(timeDuration).format(_constants.FORMAT_DURATION_TEMPLATE_SHORT):_moment2.default.duration(timeDuration).format(_constants.FORMAT_DURATION_TEMPLATE_TINY);return duration.replace(/ 0 min$/,"").replace(/ 0 hrs$/,"").replace(/ 0 days$/,"")}},654:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.HealthStatusIndicator=HealthStatusIndicator;exports.ClusterItemContainer=ClusterItemContainer;exports.BytesUsage=BytesUsage;exports.BytesPercentageUsage=BytesPercentageUsage;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _format_number=__webpack_require__(59);var _eui=__webpack_require__(3);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function HealthStatusIndicator(props){var statusColorMap={green:"success",yellow:"warning",red:"danger"};var statusColor=statusColorMap[props.status];return _react2.default.createElement(_eui.EuiHealth,{color:statusColor,"data-test-subj":"statusIcon"},"Health is ",props.status)}var PanelExtras=function PanelExtras(_ref){var extras=_ref.extras;if(void 0===extras)return null;return _react2.default.createElement(_eui.EuiFlexItem,{grow:false},extras)};function ClusterItemContainer(props){var iconMap={elasticsearch:"logoElasticsearch",kibana:"logoKibana",logstash:"logoLogstash",beats:"logoBeats"};var icon=iconMap[props.url];return _react2.default.createElement("div",{"data-test-subj":"clusterItemContainer"+props.title},_react2.default.createElement(_eui.EuiFlexGroup,{gutterSize:"m",alignItems:"center"},_react2.default.createElement(_eui.EuiFlexItem,{grow:false},_react2.default.createElement(_eui.EuiFlexGroup,{gutterSize:"m",alignItems:"center"},_react2.default.createElement(_eui.EuiFlexItem,{grow:false},_react2.default.createElement(_eui.EuiIcon,{type:icon,size:"l"})),_react2.default.createElement(_eui.EuiFlexItem,{grow:false},_react2.default.createElement(_eui.EuiTitle,null,_react2.default.createElement("h2",null,props.title))))),_react2.default.createElement(_eui.EuiFlexItem,{grow:false},props.statusIndicator),_react2.default.createElement(PanelExtras,{extras:props.extras})),_react2.default.createElement(_eui.EuiSpacer,{size:"m"}),props.children,_react2.default.createElement(_eui.EuiSpacer,{size:"xxl"}))}function BytesUsage(_ref2){var usedBytes=_ref2.usedBytes,maxBytes=_ref2.maxBytes;if(usedBytes&&maxBytes)return _react2.default.createElement("span",null,_react2.default.createElement(_eui.EuiText,null,(0,_format_number.formatPercentageUsage)(usedBytes,maxBytes)),_react2.default.createElement(_eui.EuiText,{color:"subdued",size:"s"},(0,_format_number.formatBytesUsage)(usedBytes,maxBytes)));return null}function BytesPercentageUsage(_ref3){var usedBytes=_ref3.usedBytes,maxBytes=_ref3.maxBytes;if(usedBytes&&maxBytes)return _react2.default.createElement("span",null,_react2.default.createElement(_eui.EuiText,null,(0,_format_number.formatPercentageUsage)(usedBytes,maxBytes)),_react2.default.createElement(_eui.EuiText,{color:"subdued",size:"s"},(0,_format_number.formatBytesUsage)(usedBytes,maxBytes)));return null}},655:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.ClusterStatus=ClusterStatus;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _summary_status=__webpack_require__(511);var _status_icon=__webpack_require__(899);var _format_number=__webpack_require__(59);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function ClusterStatus(_ref){var stats=_ref.stats;var dataSize=stats.dataSize,nodesCount=stats.nodesCount,indicesCount=stats.indicesCount,memUsed=stats.memUsed,memMax=stats.memMax,totalShards=stats.totalShards,unassignedShards=stats.unassignedShards,documentCount=stats.documentCount,status=stats.status;var metrics=[{label:"Nodes",value:nodesCount,dataTestSubj:"nodesCount"},{label:"Indices",value:indicesCount,dataTestSubj:"indicesCount"},{label:"Memory",value:(0,_format_number.formatMetric)(memUsed,"byte")+" / "+(0,_format_number.formatMetric)(memMax,"byte"),dataTestSubj:"memory"},{label:"Total Shards",value:totalShards,dataTestSubj:"totalShards"},{label:"Unassigned Shards",value:unassignedShards,dataTestSubj:"unassignedShards"},{label:"Documents",value:(0,_format_number.formatMetric)(documentCount,"int_commas"),dataTestSubj:"documentCount"},{label:"Data",value:(0,_format_number.formatMetric)(dataSize,"byte"),dataTestSubj:"dataSize"}];var IconComponent=function IconComponent(_ref2){var status=_ref2.status;return _react2.default.createElement(_react.Fragment,null,"Health: ",_react2.default.createElement(_status_icon.ElasticsearchStatusIcon,{status:status}))};return _react2.default.createElement(_summary_status.SummaryStatus,{metrics:metrics,status:status,IconComponent:IconComponent,"data-test-subj":"elasticsearchClusterStatus"})}},897:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.Sparkline=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _lodash=__webpack_require__(1);var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _propTypes=__webpack_require__(6);var _propTypes2=_interopRequireDefault(_propTypes);var _sparkline_flot_chart=__webpack_require__(4241);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}var Sparkline=exports.Sparkline=function(_React$Component){_inherits(Sparkline,_React$Component);function Sparkline(props){_classCallCheck(this,Sparkline);var _this=_possibleConstructorReturn(this,(Sparkline.__proto__||Object.getPrototypeOf(Sparkline)).call(this,props));_this.makeSparklineFlotChart=_this.makeSparklineFlotChart.bind(_this);_this.onHover=_this.onHover.bind(_this);_this.renderTooltip=_this.renderTooltip.bind(_this);_this.handleSparklineRef=_this.handleSparklineRef.bind(_this);_this.state={tooltip:void 0};return _this}_createClass(Sparkline,[{key:"componentWillReceiveProps",value:function componentWillReceiveProps(_ref){var series=_ref.series,options=_ref.options;if(!(0,_lodash.isEqual)(options,this.props.options)){this.sparklineFlotChart.shutdown();this.makeSparklineFlotChart(options)}(0,_lodash.isEqual)(series,this.props.series)||this.sparklineFlotChart.update(series)}},{key:"makeSparklineFlotChart",value:function makeSparklineFlotChart(overrideFlotOptions){this.sparklineFlotChart=new _sparkline_flot_chart.SparklineFlotChart(this.chartElem,this.props.series,this.props.onBrush,this.onHover,overrideFlotOptions)}},{key:"onHover",value:function onHover(dataPoint){this.setState({tooltip:dataPoint})}},{key:"renderTooltip",value:function renderTooltip(){if(false===this.props.tooltip.enabled)return;if(!this.state.tooltip)return;var tooltipHeightInPx=36;var tooltipWidthInPx=220;var caretWidthInPx=6;var marginBetweenPointAndCaretInPx=10;var styles={tooltipContainer:{top:this.state.tooltip.yPosition-tooltipHeightInPx/2},tooltip:{height:tooltipHeightInPx,width:tooltipWidthInPx},leftCaret:{width:caretWidthInPx},rightCaret:{width:caretWidthInPx}};var plotMiddleX=this.state.tooltip.plotLeft+this.state.tooltip.plotWidth/2;var tooltipContainerWidthInPx=tooltipWidthInPx+caretWidthInPx;if(this.state.tooltip.xPosition>plotMiddleX){styles.rightCaret.display="block";styles.tooltipContainer.left=this.state.tooltip.xPosition-tooltipContainerWidthInPx-marginBetweenPointAndCaretInPx}else{styles.leftCaret.display="block";styles.tooltipContainer.left=this.state.tooltip.xPosition+marginBetweenPointAndCaretInPx}return _react2.default.createElement("div",{className:"sparklineTooltipContainer",style:styles.tooltipContainer},_react2.default.createElement("i",{className:"fa fa-caret-left sparklineTooltipCaret",style:styles.leftCaret}),_react2.default.createElement("div",{className:"sparklineTooltip",style:styles.tooltip},_react2.default.createElement("div",{className:"sparklineTooltip__yValue"},this.props.tooltip.yValueFormatter(this.state.tooltip.yValue)),_react2.default.createElement("div",{className:"sparklineTooltip__xValue"},this.props.tooltip.xValueFormatter(this.state.tooltip.xValue))),_react2.default.createElement("i",{className:"fa fa-caret-right sparklineTooltipCaret",style:styles.rightCaret}))}},{key:"handleSparklineRef",value:function handleSparklineRef(elem){this.chartElem=elem;this.chartElem?this.makeSparklineFlotChart(this.props.options):this.sparklineFlotChart&&this.sparklineFlotChart.shutdown()}},{key:"render",value:function render(){return _react2.default.createElement("div",null,_react2.default.createElement("div",{className:"sparkline",ref:this.handleSparklineRef}),this.renderTooltip())}}]);return Sparkline}(_react2.default.Component);Sparkline.propTypes={series:_propTypes2.default.arrayOf(_propTypes2.default.arrayOf(_propTypes2.default.number)).isRequired,tooltip:_propTypes2.default.shape({enabled:_propTypes2.default.bool,xValueFormatter:_propTypes2.default.func,yValueFormatter:_propTypes2.default.func}),options:_propTypes2.default.shape({xaxis:_propTypes2.default.shape({min:_propTypes2.default.number,max:_propTypes2.default.number})})}},898:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source)Object.prototype.hasOwnProperty.call(source,key)&&(target[key]=source[key])}return target};exports.mapSeverity=mapSeverity;var _lodash=__webpack_require__(1);function mapSeverity(severity){var floor=Math.floor(severity/1e3);var mapped=void 0;switch(floor){case 0:mapped={value:"low",color:"warning",iconType:"dot"};break;case 1:mapped={value:"medium",color:"warning",iconType:"dot"};break;default:mapped={value:"high",color:"danger",iconType:"dot"}}return _extends({title:(0,_lodash.capitalize)(mapped.value)+" severity alert"},mapped)}},899:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.ElasticsearchStatusIcon=ElasticsearchStatusIcon;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _status_icon=__webpack_require__(512);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function ElasticsearchStatusIcon(_ref){var status=_ref.status;var type=(statusKey=status.toUpperCase(),_status_icon.StatusIcon.TYPES[statusKey]||_status_icon.StatusIcon.TYPES.GRAY);var statusKey;return _react2.default.createElement(_status_icon.StatusIcon,{type:type,label:"Health: "+status})}},900:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}exports.Statement=function Statement(vertex){_classCallCheck(this,Statement);var id=vertex.id,hasExplicitId=vertex.hasExplicitId,stats=vertex.stats,meta=vertex.meta;this.id=id;this.hasExplicitId=hasExplicitId;this.stats=stats;this.meta=meta;this.vertex=vertex}},901:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}exports.Element=function Element(id,statement,depth,parentId){_classCallCheck(this,Element);this.id=id;this.statement=statement;this.depth=depth;this.parentId=parentId}},902:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.QueueVertex=void 0;var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();var _vertex=__webpack_require__(903);function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _possibleConstructorReturn(self,call){if(!self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!call||"object"!==typeof call&&"function"!==typeof call?self:call}function _inherits(subClass,superClass){if("function"!==typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function, not "+typeof superClass);subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,enumerable:false,writable:true,configurable:true}});superClass&&(Object.setPrototypeOf?Object.setPrototypeOf(subClass,superClass):subClass.__proto__=superClass)}exports.QueueVertex=function(_Vertex){_inherits(QueueVertex,_Vertex);function QueueVertex(){_classCallCheck(this,QueueVertex);return _possibleConstructorReturn(this,(QueueVertex.__proto__||Object.getPrototypeOf(QueueVertex)).apply(this,arguments))}_createClass(QueueVertex,[{key:"typeString",get:function get(){return"queue"}},{key:"title",get:function get(){return"queue"}},{key:"iconType",get:function get(){return"logstashQueue"}},{key:"next",get:function get(){return this.outgoingVertices}}]);return QueueVertex}(_vertex.Vertex)},903:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});var _createClass=function(){function defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||false;descriptor.configurable=true;"value"in descriptor&&(descriptor.writable=true);Object.defineProperty(target,descriptor.key,descriptor)}}return function(Constructor,protoProps,staticProps){protoProps&&defineProperties(Constructor.prototype,protoProps);staticProps&&defineProperties(Constructor,staticProps);return Constructor}}();function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}exports.Vertex=function(){function Vertex(graph,json){_classCallCheck(this,Vertex);this.graph=graph;this.update(json)}_createClass(Vertex,[{key:"update",value:function update(json){this.json=json}},{key:"descendants",value:function descendants(){var vertices=[];var edges=[];var pending=[this];var seen={};while(pending.length>0){var vertex=pending.pop();vertex.outgoingEdges.forEach(function(edge){edges.push(edge);var to=edge.to;if(true!==seen[to.id]){vertices.push(to);seen[to.id]=true;pending.push(to)}})}return{vertices:vertices,edges:edges}}},{key:"name",get:function get(){return this.json.config_name}},{key:"id",get:function get(){return this.json.id}},{key:"subtitle",get:function get(){return this.id}},{key:"incomingEdges",get:function get(){return this.graph.edgesByTo[this.json.id]||[]}},{key:"incomingVertices",get:function get(){return this.incomingEdges.map(function(e){return e.from})}},{key:"outgoingEdges",get:function get(){return this.graph.edgesByFrom[this.json.id]||[]}},{key:"outgoingVertices",get:function get(){return this.outgoingEdges.map(function(e){return e.to})}},{key:"meta",get:function get(){return this.json.meta}},{key:"stats",get:function get(){return this.json.stats||{}}},{key:"hasExplicitId",get:function get(){return Boolean(this.json.explicit_id)}}]);return Vertex}()},904:function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:true});exports.KibanaStatusIcon=KibanaStatusIcon;var _react=__webpack_require__(0);var _react2=_interopRequireDefault(_react);var _status_icon=__webpack_require__(512);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function KibanaStatusIcon(_ref){var status=_ref.status,_ref$availability=_ref.availability,availability=void 0===_ref$availability||_ref$availability;var type=function(){if(!availability)return _status_icon.StatusIcon.TYPES.GRAY;var statusKey=status.toUpperCase();return _status_icon.StatusIcon.TYPES[statusKey]||_status_icon.StatusIcon.TYPES.YELLOW}();return _react2.default.createElement(_status_icon.StatusIcon,{type:type,label:"Health: "+status})}}},[4187]);